#ifndef __IOCTRL_H__
#define __IOCTRL_H__ 0x0100

#define IOCTRL_VERSIONID 0x00040001

#define MARGIVXD_ID 0x382E

#define IOCTRL_ERR_OK 0                 /*No error*/
#define IOCTRL_ERR_INUSE -1             /*Hardware already in use*/
#define IOCTRL_ERR_NOT_INUSE -2         /*Hardware was not in use*/
#define IOCTRL_ERR_BADPTR -3            /*Bad pointer passed in*/
#define IOCTRL_ERR_UNK -4               /*Unknown error code*/
#define IOCTRL_ERR_NOHARDWARE -5        /*Hardware not found*/
#define IOCTRL_ERR_NOCARDSERVICES -6    /*CardServices provider not found*/


enum IOCTRL_FUNCS {
  IOCTRL_VER= 1,                /*Get VxD driver version ID*/
  IOCTRL_RES,			/*Get allocated resources (IRQ, IO)*/
  IOCTRL_ACQ,			/*Acquire control of hardware*/
  IOCTRL_REL,			/*Release control of hardware*/
  IOCTRL_VSYNC,			/*Set VSync counter location*/
  IOCTRL_SET,			/*Set resources from client*/
  IOCTRL_STARTCAP,		/*Start capturing video frames*/
  IOCTRL_STOPCAP,		/*Stop capturing video frames*/
  IOCTRL_QUERY,			/*Is card inserted?*/
  IOCTRL_UNK
};

#ifndef CTL_CODE
#define CTL_CODE( DeviceType, Function, Method, Access ) (                 \
    ((DeviceType) << 16) | ((Access) << 14) | ((Function) << 2) | (Method) \
)
#define FILE_DEVICE_UNKNOWN             0x00000022
#define METHOD_BUFFERED                 0
#define METHOD_IN_DIRECT                1
#define METHOD_OUT_DIRECT               2
#define METHOD_NEITHER                  3
#define FILE_ANY_ACCESS                 0
#endif

#define IOCTRL_MIDAS_CMD \
  CTL_CODE(FILE_DEVICE_UNKNOWN, 50, METHOD_NEITHER, FILE_ANY_ACCESS)
/*Register Event for Win32 cllback */
#define IOCTRL_REGEVENT \
  CTL_CODE(FILE_DEVICE_UNKNOWN, 51, METHOD_BUFFERED, FILE_ANY_ACCESS)



//Note that callbacks are asynchronous! By the time the client gets it, it has already happened.
//void WINAPI ApplicationCallback(DMA_CB_ARGS *pArgs);
typedef struct {
  DWORD dwHandle;
  DWORD dwMsg;
  DWORD dwArg1,dwArg2;
} DMA_CB_ARGS;

#pragma pack(1)
struct MsgInfo_s {
  DWORD dwSize;
  long Err;
  BYTE *AppBuf;
  DWORD BufSize;
  DWORD ChrWritten;
  BYTE BufferEmpty,BufferFull;
};

#define FILTER_MAXFILTER 32
struct FilterGetName_s {
  DWORD dwSize;
  WORD nFilter;
  WORD nMask;
  WORD wMaskBits;
  DWORD dwNameSize;
  char *Name;
};

#pragma pack()
#ifdef _NEC_
  #pragma pack(8)
#endif

#endif
/**EOF: IOCTRL.H**/
