#ifndef device_h
#define device_h

//
// list of stream types for initialization
//

typedef enum tagStreamType {
   InMpeg2Video = 0,
   InMpeg2Ac3,
   OutNTSCVideo,
   InMpeg2Subpicture,
   OutVideoPort,
   OutCloseCaption,
   NUMBER_OF_STREAMS
}  STREAMTYPES;

typedef struct _DEVICE_EXTENSION {
   PDEVICE_OBJECT  ClassDeviceObject;
   PDEVICE_OBJECT  PhysicalDeviceObject;
   PHW_STREAM_OBJECT pStream[NUMBER_OF_STREAMS];
   int StreamsOpened;
   KTIMER Timer;
   KDPC TimerRoutine;
   int currentStream;
   int process_data;
   PHW_STREAM_REQUEST_BLOCK currentSRB;
   PKSSTREAM_HEADER StreamHdr;
   char *buffer;
   unsigned int bufsize;
   unsigned int bufoffset;
   unsigned int HdrsToProcess;
   unsigned int TotalHdrs;
} DEVICE_EXTENSION, *PDEVICE_EXTENSION;

extern VOID STREAMAPI DeviceReceivePacket(PHW_STREAM_REQUEST_BLOCK pSrb);
extern BOOLEAN DeviceInterrupt ( PDEVICE_EXTENSION  pDevice);
extern void DeviceCancelPacket(PHW_STREAM_REQUEST_BLOCK pSrb);
extern void DeviceTimeoutPacket(PHW_STREAM_REQUEST_BLOCK pSrb);
extern void DeviceClose(PHW_STREAM_REQUEST_BLOCK pSrb);

#endif

/**EOF: DEVICE.H**/
