//Interface functions from the WDM core.
#define ININAMES_CODE 1
#define MDS_ININAMES_CODE 1
//#include <StrmIni.h>
//#include <mmsystem.h>
//#include <KsMedia.h>

#include "system.h"
#include "DbgMsg.h"
#include "Idents.h"
#include "margierr.h"

#include "DbgFltr.h"
#include "IdentCls.h"
#include "MidasApi.h"

#include "dvHwMain.h"
#include "dvHwVid.h"
#include "dvHwAud.h"
#include "dvHwSub.h"
#include "userdata.h"
#include "dvHwOsd.h"
#include "TvOut.h"
#include "Global.h"
#include "Sync.h"
#include "lsi64020.h"
#include "userdata.h"
#include "ininames.h"
#ifdef _WIN32_WCE
#include "message.h"
#endif

//#pragma message("Apientry.c: Optimizer disabled.")
//#pragma optimize("",off)

static long hwhMidasCmd(PMIDASCMD pCmd);
static long hwLoFreqCmd(PMIDASCMD pCmd);
static long hwReset(PMIDASCMD pCmd);
static long hwGetRevision(PMIDASCMD pCmd);
static long hwInitializeVideo(PMIDASCMD pCmd);
static long hwInitializeAudio(PMIDASCMD pCmd);
static long hwInitializeSub(PMIDASCMD pCmd);
static long hwPlay(PMIDASCMD pCmd);
static long hwStop(PMIDASCMD pCmd);
static long hwStep(PMIDASCMD pCmd);
static long hwPause(PMIDASCMD pCmd);
static long hwTestHw(PMIDASCMD pCmd);
static long hwTestCallback(PMIDASCMD pCmd);
static long hwLockMemory(PMIDASCMD pCmd);
static long hwUnlockMemory(PMIDASCMD pCmd);
static long hwSetVideoID(PMIDASCMD pCmd);
static long hwSetAudioID(PMIDASCMD pCmd);
static long hwSetSubID(PMIDASCMD pCmd);
static long hwStereo(PMIDASCMD pCmd);
static long hwFlushBegin(PMIDASCMD pCmd);
static long hwIsr(PMIDASCMD pCmd);
static long hwIsrComplete(PMIDASCMD pCmd);
static long hwRegisterEvent(PMIDASCMD pCmd);
static long hwUnregisterEvent(PMIDASCMD pCmd);
static long hwSP_CompositeOn(PMIDASCMD pCmd);
static long hwSP_Highlight(PMIDASCMD pCmd);
static long hwSP_Palette(PMIDASCMD pCmd);
static long hwSetTVOut(PMIDASCMD pCmd);
//static long hwSetVidOutMode(PMIDASCMD pCmd);
//static long hwSetVidOutFormat(PMIDASCMD pCmd);
static long hwSetBlankVideo(PMIDASCMD pCmd);
static long hwFlushEnd(PMIDASCMD pCmd);
static long hwSetMasterClock1(PMIDASCMD pCmd);
static long hwGetStreamTime(PMIDASCMD pCmd);
static long hwSetStreamTime(PMIDASCMD pCmd);
static long hwSetStreamTimeMode(PMIDASCMD pCmd);
static long hwUnkMsg(PMIDASCMD pCmd);
static long hwSetRate(PMIDASCMD pCmd);
static long hwGetRate(PMIDASCMD pCmd);
static long hwGetMaxRate(PMIDASCMD pCmd);
static long hwSetVPEInfo(PMIDASCMD pCmd);
static long hwSetSpdifMode(PMIDASCMD pCmd);
static long hwSetSpdifEnable(PMIDASCMD pCmd);
static long hwSetupAC3(PMIDASCMD pCmd);
static long hwSetupLPCM(PMIDASCMD pCmd);
static long hwUnkAudioType(PMIDASCMD pCmd);
static long hwDbgOutAudioInfo(PHW pHw);
static long hwDbgOutVideoInfo(PHW pHw);
static long hwTVOutGetMacroVisionLevel(PMIDASCMD pCmd);
static long hwTVOutSetMacroVisionLevel(PMIDASCMD pCmd);
static long hwTVOutGetTVOutMode(PMIDASCMD pCmd);
static long hwTVOutSetTVOutMode(PMIDASCMD pCmd);
static long hwTVOutGetBrightness(PMIDASCMD pCmd);
static long hwTVOutSetBrightness(PMIDASCMD pCmd);
static long hwTVOutGetHue(PMIDASCMD pCmd);
static long hwTVOutSetHue(PMIDASCMD pCmd);
static long hwTVOutGetSaturation(PMIDASCMD pCmd);
static long hwTVOutSetSaturation(PMIDASCMD pCmd);
static long hwLoadCPSettings(PMIDASCMD pCmd);
static long hwGetCCInfo(PMIDASCMD pCmd);
static long hwInitCC(PMIDASCMD pCmd);
static long hwResetCC(PMIDASCMD pCmd);
static long hwGetCCFIFOStatus(PMIDASCMD pCmd);
static long hwReadUserDataFIFO(PHW pHw,BOOL Reset);
static long hwRdOneByteFromUserData(PHW pHw,BYTE* pBuff);
static long hwRestoreState(PMIDASCMD pCmd);
static long hwSaveState(PMIDASCMD pCmd);
static long hwQueueData(PMIDASCMD pCmd);
static long hwCancelData(PMIDASCMD pCmd);
static long hwOsdCmd(PMIDASCMD pCmd);
static long hwEEPROMData(PMIDASCMD pCmd);

struct DbgMsgFilterName_s DbgFilterNames[]= {
  { DBG_PNPTITLE, "Plug-and-Play" },
    { DBG_PNPCFG,"Config" },
    { DBG_PNPLOAD, "Load" },
    { DBG_PNPACCESS, "Access" },
    { DBG_PNPIOCTRL, "IoCtrl" },
    { DBG_PNPUNK, "Unhandled" },
    { DBG_PNPERR, "Error" },
    { DBG_PNPMSG, "Message" },
    { DBG_PNPPOWER, "Power States" },
  { DBG_CSTITLE, "CardServices" },
    { DBG_CSEVNT, "Events" },
    { DBG_CSREQ, "Requests" },
    { DBG_CSCLNT, "Client requests" },
  { DBG_HWTITLE, "Midas" },
    { DBG_HWINIT, "Init" },
    { DBG_HWIO, "I/O" },
    { DBG_HWAPI, "API" },
    { DBG_HWSTATE, "State" },
    { DBG_HWSEND, "SendData" },
    { DBG_HWFLUSH, "Flush" },
    { DBG_HWCMD, "Commands" },
    { DBG_HWISR, "Interrupt" },
    { DBG_HWFLUSH, "Flush"},
    { DBG_HWERR, "Error" },
    { DBG_HWSTAT, "Status" },
    { DBG_HWINITSRB, "InitSrb" },
    { DBG_HWBUFCFG, "Buffer config" },
    { DBG_HWREG, "Register dumps" },
    { DBG_HWREGWR, "Register writes" },
  { DBG_SYNCTITLE, "A/V Sync" },
    { DBG_SYNCERR, "Errors" },
    { DBG_SYNCADJ, "Adjustments" },
    { DBG_SYNCHW, "Hardware control" },
    { DBG_SYNCDRIFTA, "Audio drift" },
    { DBG_SYNCDRIFTV, "Video drift" },
    { DBG_SYNCWATCH, "Drift watches" },
    { DBG_SYNCSTART, "AutoStart" },
    { DBG_SYNCUNC, "Uncertainty ptrs" },
    { DBG_SYNCVIDPTS, "Vid PTS" },
    { DBG_SYNCAUDPTS, "Aud PTS" },
    { DBG_SYNCDROP, "Drops" },
    { DBG_SYNCINIT, "Init" },
    { DBG_SYNCCHK, "SyncChecks" },
    { DBG_SYNCMSG, "Messages" },
    { DBG_SYNCTBL, "Table entries" },
    { DBG_SYNCEVENT, "Events" },
  { DBG_MSGTITLE, "Messages" },
    { DBG_MSGVID, "Video" },
    { DBG_MSGVIDFORMAT, "Video Format" },
    { DBG_MSGAUD, "Audio" },
    { DBG_MSGSUB, "SubPicture" },
    { DBG_MSGVPE, "VPE" },
    { DBG_MSGCC, "CloseCaption" },
    { DBG_MSGNTSC, "NTSC" },
    { DBG_MSGEVENT, "Events" },
    { DBG_MSGPKT, "Packets" },
    { DBG_MSGERR, "Error" },
    { DBG_MSGTIMER,"Timer" },
    { DBG_FIRST4BYTES,"First 4 bytes"},

  { DBG_AUXTITLE, "AuxData" },
    { DBG_AUXCMD,	"Commands" },
    { DBG_AUXERR, "Errors" },
    { DBG_AUXREAD, "Reads" },
    { DBG_AUXMISS, "Missed frames" },
    { DBG_AUXLAYER, "Layer Completion" },
    { DBG_AUXPIC, "Picture Types" },
  { DBG_TVTITLE, "TV Out Settings" },
    { DBG_TVREG, "Encoder Register R/W" },
    { DBG_TVOUTMODE, "TV Out Mode" },
    { DBG_TVSET, "TV Out Settings" },
    { DBG_TVAPI, "TVOut API" },
    { DBG_TVINFO, "TVOut Info" },
    { DBG_MACROVISION, "MacroVision Cmds"},
  { DBG_CPTITLE, "Control Panel" },
    { DBG_CP_TIMER, "Timer Checks" },
    { DBG_CP_INFO, "General Info" },
    { DBG_CP_SET, "Set" },
  { DBG_AUDTITLE, "Audio" },
    { DBG_AUDERR, "Errors" },
    { DBG_AUDCMD, "Commands" },
    { DBG_AUDHW, "Hardware control" },
    { DBG_AUDSTATE, "State transitions" },
  { DBG_VIDTITLE, "Video" },
    { DBG_VIDCMD, "Commands" },
    { DBG_VIDPANIC, "Panic control" },
    { DBG_VIDSTATE, "State transitions" },
  { DBG_DDRAWTITLE,  "Direct Draw" },
    { DBG_DDINFO, "DD Info" },
    { DBG_DDEVE, "DD Events" },
    { DBG_DDERR, "DD Errors" },
  { DBG_SUBTITLE, "Subpicture" },
    { DBG_SUBMSG, "Messages" },
    { DBG_SUBPOS, "Position" },
    { DBG_SUBHI,  "HiLite enable" },
    { DBG_SUBSTATE, "State Transitions" },
  { DBG_CSSTITLE, "CSS"},
    {DBG_CSSKEYS,	"Report CSS Keys"},
    {DBG_CSSTITLEKEY, "Report Title Keys"},
  { 0,0 }
};

/***************************************************************************/
/** MidasEntry() is the only exported function from the Midas library.  **/
/***************************************************************************/
long MidasEntry(PMIDASCMD pCmd)
{
  long lErr= 0;
  static BYTE SendDataPrinted;
#ifdef _WIN32_WCE
//  MESSAGE((LPVOID)(L"Inside the midas entry\r\n"));
#endif
  if(ISBADPTR(pCmd,sizeof(*pCmd)))
  {
    DbgMsg(DBG_ERR,"LSIHAL_Entry(%08X): Bad ptr.\r\n",pCmd);
    lErr = MARGI_ERR_BADPTR;
  }
  else
  {
#if(0)
    if(pCmd->cmd==MDS_SENDDATA) {
      if(!SendDataPrinted) {
	      DbgMsg(DBG_HWAPI,"MiserCmd: %s.\r\n",Ident(ID_HALCMD,pCmd->cmd));
	      SendDataPrinted= 1;
      }
    } else if(pCmd->cmd!=MDS_TIMER && pCmd->cmd!=MDS_GET_STREAM_TIME) {
      DbgMsg(DBG_HWAPI,"MiserCmd: %s.\r\n",Ident(ID_HALCMD,pCmd->cmd));
      SendDataPrinted= 0;
    }
#endif
    pCmd->dwStatus=MDS_NoStatus;
    switch(pCmd->cmd)
    {           //Commands which do not have a hMidas pointer.
      case MDS_GETREVISION:        lErr = hwGetRevision(pCmd); break;
      case MDS_INITDRIVER:         lErr = hwDriverInit(1,pCmd); break;
      case MDS_FINI:               lErr = hwDriverInit(0,pCmd); break;
      case MDS_LOCATE_HARDWARE:    lErr = hwLocateHardware(pCmd); break;
      case MDS_LOCATE_DMA:         lErr = hwLocateHardDma(pCmd); break;
      default:                     lErr = hwhMidasCmd(pCmd);
    }
    if(pCmd->dwStatus==MDS_NoStatus)
      pCmd->dwStatus=(DWORD)lErr;

    pCmd->lErr = lErr;
  }
  return lErr;
}

static long hwhMidasCmd(PMIDASCMD pCmd) {
  long Err= 0;
  long Size=sizeof(DVHW);
  if(ISBADPTR(pCmd->hMidas,sizeof(DVHW))) {
    DbgMsg(DBG_ERR,"MidasEntry(%s): Bad DVHW ptr. (%d)\r\n",Ident(ID_HALCMD,pCmd->cmd),Size);
    Err= MARGI_ERR_BADPTR;
    DEBUG_BREAKPOINT();
  } else if(pCmd->cmd==MDS_INSTALLDEVICE) {    //DeviceInit() does not yet have a signature.
    Err= hwDeviceInit(1,pCmd->hMidas);
  } else if(((PHW)(pCmd->hMidas))->dwSignature!=DVHW_SIGNATURE) {
    DbgMsg(DBG_ERR,"MidasEntry(%s): Bad DVHW signature.\r\n",Ident(ID_HALCMD,pCmd->cmd));
    Err= MARGI_ERR_BADSIG;
    DEBUG_BREAKPOINT();
  } else {
    switch(pCmd->cmd) {	  //First do high-frequency commands
      case MDS_QUEUEDATA:       Err= hwQueueData(pCmd);       break;
      case MDS_DATATIMER:       Err= dvHwTimerPumpData(pCmd); break;
      case MDS_TIMER:           Err= dvHwTimer(pCmd);         break;
      case MDS_GET_CHANNEL_LEVELS: Err=dvHwGetChnLevels(pCmd);break;
      case MDS_GET_STREAM_TIME: Err= hwGetStreamTime(pCmd);   break;
      case MDS_SET_STREAM_TIME: Err= hwSetStreamTime(pCmd);   break;
      default:			        Err= hwLoFreqCmd(pCmd);
    }
  }
  return(Err);
}

//Infrequent commands.
static long hwLoFreqCmd(PMIDASCMD pCmd) {
  long Err= 0;
  switch (pCmd->cmd) {
    case MDS_UNINSTALLDEVICE:  Err= hwDeviceInit(0,pCmd->hMidas); break;
    case MDS_RESET:            Err= hwReset(pCmd); break;
    case MDS_TESTHW:           Err= hwTestHw(pCmd); break;
    case MDS_TEST_CALLBACK:    Err= hwTestCallback(pCmd); break;
    case MDS_LOCK_MEMORY:      Err= hwLockMemory(pCmd); break;
    case MDS_UNLOCK_MEMORY:    Err= hwUnlockMemory(pCmd); break;

    case MDS_STARTTIMER:       Err= MARGI_ERR_TIMER; break;     // Timer only supported by binding
    case MDS_CANCELDATA:       Err= hwCancelData(pCmd); break;

    case MDS_INITIALIZEVIDEO:  Err= hwInitializeVideo(pCmd); break;
    case MDS_INITIALIZEAUDIO:  Err= hwInitializeAudio(pCmd); break;
    case MDS_INITIALIZESUB:    Err= hwInitializeSub(pCmd); break;
    case MDS_SETVIDEOID:       Err= hwSetVideoID(pCmd); break;
    case MDS_SETAUDIOID:       Err= hwSetAudioID(pCmd); break;
    case MDS_SETSUBID:         Err= hwSetSubID(pCmd); break;

    case MDS_SP_COMPOSITEON:   Err= hwSP_CompositeOn(pCmd); break;
    case MDS_SP_HIGHLIGHT:     Err= hwSP_Highlight(pCmd); break;
    case MDS_SP_PALETTE:       Err= hwSP_Palette(pCmd); break;
    case MDS_MASTERCLOCK:      Err= hwSetMasterClock1(pCmd); break;
    case MDS_SET_TIME_MODE:    Err= hwSetStreamTimeMode(pCmd); break;

    case MDS_SETTVOUT:         Err= hwSetTVOut(pCmd); break;
//    case MDS_VIDOUTMODE:       Err= hwSetVidOutMode(pCmd);  break;
//    case MDS_VIDOUTFORMAT:     Err= hwSetVidOutFormat(pCmd);break;
    case MDS_BLANKVIDEO:       Err= hwSetBlankVideo(pCmd);  break;

//    case MDS_TEST_OSD:         Err=hwTestOsd(pCmd); break;

    case MDS_REGISTEREVENT:    Err= hwRegisterEvent(pCmd); break;
    case MDS_UNREGISTEREVENT:  Err= hwUnregisterEvent(pCmd); break;
    case MDS_ISR:		break;

    case MDS_SETRATE:          Err= hwSetRate(pCmd); break;
    case MDS_GETRATE:          Err= hwGetRate(pCmd); break;
    case MDS_GETMAXRATE:       Err= hwGetMaxRate(pCmd); break;

    case MDS_VPEINFO:          Err= hwSetVPEInfo(pCmd); break;
    case MDS_VIDENABLEZV:      Err= VideoCmd(pCmd->hMidas,VIDCMD_ENABLE,pCmd->u.M.Arg1,0); break;

    case MDS_CCFIFOSTATUS:     Err= hwGetCCFIFOStatus(pCmd); break;
//    case MDS_GETCCDATA:        Err= UserDataCmd(pCmd->hMidas,USERDATACMD_GET,(DWORD)&pCmd->u.CCInfo,0); break;
    case MDS_CCINIT:           Err= UserDataCmd(pCmd->hMidas,USERDATACMD_INIT,0,0); break;
    case MDS_CCFINI:           Err= UserDataCmd(pCmd->hMidas,USERDATACMD_FINI,0,0); break;
    case MDS_CCRESET:          Err= UserDataCmd(pCmd->hMidas,USERDATACMD_RESET,0,0); break;
    case MDS_CCTIMER:          Err= UserDataCmd(pCmd->hMidas,USERDATACMD_TIMER,0,0); break;

    case MDS_CSS_INITHW:
    case MDS_CSS_SYNCTITLE:
    case MDS_CSS_GETREGIONCODE:
    case MDS_CSS_GETCHALLENGE:
    case MDS_CSS_FORCECHALLENGE:
    case MDS_CSS_ENABLE_CHANNEL:
    case MDS_CSS_SETCHALLENGE:
    case MDS_CSS_GETRESPONSE:
    case MDS_CSS_SETRESPONSE:
    case MDS_CSS_SETTITLE:
    case MDS_CSS_SETDISCKEY:   Err= hwCopyProtection(pCmd); break;

    case MDS_OSD_INIT:
    case MDS_OSD_FINI:
    case MDS_OSD_RESET:
    case MDS_OSD_TIMER:
    case MDS_OSD_OPEN_REGION:
    case MDS_OSD_CLOSE_REGION:
    case MDS_OSD_RENDER_STRIP:
    case MDS_OSD_RENDER_RECT:
    case MDS_OSD_FILL_REGION:
    case MDS_OSD_FILL_RECT:
    case MDS_OSD_SHOW_REGION:
    case MDS_OSD_HIDE_REGION:
    case MDS_OSD_SETBUFFSIZE:
    case MDS_OSD_SETPALETTE:   Err=hwOsdCmd(pCmd); break;


    case MDS_PLAY:             Err= hwPlay(pCmd);       break;
    case MDS_STOP:             Err= hwStop(pCmd);       break;
    case MDS_PAUSE:            Err= hwPause(pCmd);      break;
    case MDS_FLUSH:            Err= hwFlushBegin(pCmd); break;
    case MDS_FLUSH_END:        Err= hwFlushEnd(pCmd);   break;
    case MDS_STEP:             Err= hwStep(pCmd);       break;

    case MDS_LOADCPSETTING:    Err= hwLoadCPSettings(pCmd); break;

    case MDS_SETKARAOKEMODE:   Err= AudioCmd(pCmd->hMidas,AUDCMD_SET,AUDITEM_KARAOKE,pCmd->u.M.Arg1); break;
    case MDS_GETKARAOKEMODE:   Err= AudioCmd(pCmd->hMidas,AUDCMD_GET,AUDITEM_KARAOKE,(DWORD)&pCmd->u.M.Arg1); break;
    case MDS_SETMIXMODE:       Err= AudioCmd(pCmd->hMidas,AUDCMD_SET,AUDITEM_MIX,pCmd->u.M.Arg1); break;
    case MDS_GETMIXMODE:       Err= AudioCmd(pCmd->hMidas,AUDCMD_GET,AUDITEM_MIX,(DWORD)&pCmd->u.M.Arg1); break;

    case MDS_SETSPDIFMODE:     Err= AudioCmd(pCmd->hMidas,AUDCMD_SET,AUDITEM_SPDMODE,pCmd->u.M.Arg1); break;
    case MDS_GETSPDIFMODE:     Err= AudioCmd(pCmd->hMidas,AUDCMD_GET,AUDITEM_SPDMODE,(DWORD)&pCmd->u.M.Arg1); break;
    case MDS_SETSPDIFENABLE:   Err= AudioCmd(pCmd->hMidas,AUDCMD_SET,AUDITEM_SPDIF,pCmd->u.M.Arg1); break;
    case MDS_GETSPDIFENABLE:   Err= AudioCmd(pCmd->hMidas,AUDCMD_GET,AUDITEM_SPDIF,(DWORD)&pCmd->u.M.Arg1); break;

    case MDS_SETVOLUME:        Err= AudioCmd(pCmd->hMidas,AUDCMD_SET,AUDITEM_VOLUME,pCmd->u.M.Arg1); break;
    case MDS_GETVOLUME:        Err= AudioCmd(pCmd->hMidas,AUDCMD_GET,AUDITEM_VOLUME,(DWORD)&pCmd->u.M.Arg1); break;
    case MDS_GETMUTE:          Err= AudioCmd(pCmd->hMidas,AUDCMD_GET,AUDITEM_MUTE,(DWORD)&pCmd->u.M.Arg1); break;
    case MDS_SETMUTE:          Err= AudioCmd(pCmd->hMidas,AUDCMD_SET,AUDITEM_MUTE,pCmd->u.M.Arg1); break;

    case MDS_SAVE_STATE:       Err= hwSaveState(pCmd); break;
    case MDS_RESTORE_STATE:    Err= hwRestoreState(pCmd); break;

    case MDS_WRITE_DATA:
    case MDS_READ_DATA:        Err= hwEEPROMData(pCmd); break;
    default:			       Err= hwUnkMsg(pCmd); break;
  }
  return(Err);
}

static long hwUnkMsg(PMIDASCMD pCmd)
{
  long lErr = MARGI_ERR_ARG1;
  DbgMsg(DBG_WRN|DBG_TODO,"Unhandled LSIHAL command: %s.\r\n",Ident(ID_HALCMD,pCmd->cmd));
  return lErr;
}

static long hwLockMemory(PMIDASCMD pCmd) {
  long Err= 0;
  pCmd->u.Lock.pGlobal=pCmd->u.Lock.pLocal;
  return Err;
}


static long hwUnlockMemory(PMIDASCMD pCmd) {
  long Err= 0;
  return Err;
}

static long hwOsdCmd(PMIDASCMD pCmd) {
  PHW pHw= pCmd->hMidas;
  long Err=0;
  PVOID hOsdRegion=pCmd->hRef;
  switch(pCmd->cmd) {
    case MDS_OSD_INIT:        Err=OsdCmd(pHw,OSDCMD_INIT,0,0);         break;
    case MDS_OSD_FINI:        Err=OsdCmd(pHw,OSDCMD_FINI,0,0);     break;
    case MDS_OSD_OPEN_REGION: Err=OsdCmd(pHw,OSDCMD_OPEN_REGION,(DWORD)&pCmd->hRef,(DWORD)&pCmd->u.OsdRegionDesc); break;
    case MDS_OSD_CLOSE_REGION:Err=OsdCmd(pHw,OSDCMD_CLOSE_REGION,(DWORD)hOsdRegion,0); break;
    case MDS_OSD_RENDER_STRIP:Err=OsdCmd(pHw,OSDCMD_RENDER_STRIP,(DWORD)hOsdRegion,(DWORD)&pCmd->u.OsdStrip); break;
    case MDS_OSD_RENDER_RECT: Err=OsdCmd(pHw,OSDCMD_RENDER_RECT,(DWORD)hOsdRegion,(DWORD)&pCmd->u.OsdStrip); break;
    case MDS_OSD_FILL_REGION: Err=OsdCmd(pHw,OSDCMD_FILL_REGION,(DWORD)hOsdRegion,(DWORD)&pCmd->u.OsdStrip); break;
    case MDS_OSD_FILL_RECT:   Err=OsdCmd(pHw,OSDCMD_FILL_RECT,  (DWORD)hOsdRegion,(DWORD)&pCmd->u.OsdStrip); break;
    case MDS_OSD_SHOW_REGION: Err=OsdCmd(pHw,OSDCMD_SHOW_REGION,(DWORD)hOsdRegion,0); break;
    case MDS_OSD_HIDE_REGION: Err=OsdCmd(pHw,OSDCMD_HIDE_REGION,(DWORD)hOsdRegion,0); break;
    case MDS_OSD_SETBUFFSIZE: Err=OsdCmd(pHw,OSDCMD_SETBUFFSIZE,pCmd->u.M.Arg1,0); break;
//    case MDS_OSD_SETPALETTE:  Err=OsdCmd(pHw,OSDCMD_SETPALETTE,0,0); break;
  }
  return Err;
}


static long hwTestCallback(PMIDASCMD pCmd) {
  long Err= 0;
  PHW pHw= pCmd->hMidas;
  PMDS_DATA_BLOCK pMdb=pCmd->u.pMdb;
  pMdb->dwStatus=MDS_Cancel;
  pMdb->pfnCallback(pMdb);
  return Err;
}

long hwQueueData(PMIDASCMD pCmd) {
  long Err= 0;
  PHW pHw= pCmd->hMidas;
  PMDS_DATA_BLOCK pMdb=pCmd->u.pMdb;
  switch(pCmd->wCurrStream) {
    case STRM_VID:  Err=VideoQueueData(pHw,pMdb); break;
    case STRM_AUD:  Err=AudioQueueData(pHw,pMdb); break;
    case STRM_SUB:  Err=SubpicQueueData(pHw,pMdb);break;
    case STRM_CC:   Err=CcQueueData(pHw,pMdb);break;
//    case STRM_SYS:  Err=SysQueueData(pHw,pMdb);   break;
    default:        Err= MARGI_ERR_BADITEM; break;
  }
  return(Err);
}

static long hwCancelData(PMIDASCMD pCmd) {
  long Err= 0;
  PHW pHw= pCmd->hMidas;
  PMDS_DATA_BLOCK pMdb=pCmd->u.pMdb;
  switch(pCmd->wCurrStream) {
    case STRM_VID:  Err=VideoCancelData(pHw,pMdb); break;
    case STRM_AUD:  Err=AudioCancelData(pHw,pMdb); break;
    case STRM_SUB:  Err=SubpicCancelData(pHw,pMdb);break;
    case STRM_CC:   Err=CcCancelData(pHw,pMdb);    break;
    default:        Err= MARGI_ERR_BADITEM; break;
  }
  return(Err);
}



static long hwSetSpdifMode(PMIDASCMD pCmd)
{
  long lErr = MARGI_ERR_ARG1;
  PHW pHw = pCmd->hMidas;
  pHw->dwSpDiffMode = pCmd->u.M.Arg1;
  DbgMsg(DBG_WRN|DBG_TODO,"Unhandled LSIHAL command: %s.\r\n",Ident(ID_HALCMD,pCmd->cmd));
  return lErr;
}

static long hwSetSpdifEnable(PMIDASCMD pCmd)
{
  long lErr = MARGI_ERR_ARG1;
  PHW pHw= pCmd->hMidas;
  pHw->dwSpDiffOut = pCmd->u.M.Arg1;
  DbgMsg(DBG_WRN|DBG_TODO,"Unhandled LSIHAL command: %s.\r\n",Ident(ID_HALCMD,pCmd->cmd));
  return lErr;
}

#if(0)
static long hwSetVidOutMode(PMIDASCMD pCmd) {
  long Err= 0;
  PHW pHw= pCmd->hMidas;
//  pHw->dwVidDispMode= pCmd->u.M.Arg1;
  //Err= dvHwVidSetDisplayMode(pHw,pCmd->u.M.Arg1);
  DbgMsg(DBG_MSGVID,"Midas Set VideoDisp Mode to %s \r\n",Ident(ID_VIDOUT_MODE,pCmd->u.M.Arg1));
  return(Err);
}

static long hwSetVidOutFormat(PMIDASCMD pCmd) {
  long Err= 0;
  PHW pHw= pCmd->hMidas;
  pHw->dwVidDispFormatPreference= pCmd->u.M.Arg1;
  DbgMsg(DBG_MSGVID,"Midas Set VideoDisp Mode to %s \r\n",Ident(ID_VIDOUT_MODE,pCmd->u.M.Arg1));
  return(Err);
}
#endif

static long hwSetBlankVideo(PMIDASCMD pCmd) {
  long Err= 0;
  PHW pHw= pCmd->hMidas;
  VideoCmd(pHw,VIDCMD_BLANK,pCmd->u.M.Arg1,pCmd->u.M.Arg2);
  DbgMsg(DBG_MSGVID,"Midas Blank Video=%d %08x\r\n",pCmd->u.M.Arg1,pCmd->u.M.Arg2);
  return(Err);
}

static long hwSetTVOut(PMIDASCMD pCmd) {
  long Err= 0;
  switch(pCmd->u.M.Arg1) {
    case TVOUT_GETMACROVISIONLEVEL: Err= hwTVOutGetMacroVisionLevel(pCmd); break;
    case TVOUT_SETMACROVISIONLEVEL: Err= hwTVOutSetMacroVisionLevel(pCmd); break;
    case TVOUT_GETCOMP_SVIDEO:      Err= hwTVOutGetTVOutMode(pCmd); break;
    case TVOUT_SETCOMP_SVIDEO:      Err= hwTVOutSetTVOutMode(pCmd); break;
    case TVOUT_GETBRIGHTNESS:       Err= hwTVOutGetBrightness(pCmd); break;
    case TVOUT_SETBRIGHTNESS:       Err= hwTVOutSetBrightness(pCmd); break;
    case TVOUT_GETHUE:              Err= hwTVOutGetHue(pCmd); break;
    case TVOUT_SETHUE:              Err= hwTVOutSetHue(pCmd); break;
    case TVOUT_GETCONTRAST:
    case TVOUT_GETSATURATION:       Err= hwTVOutGetSaturation(pCmd); break;
    case TVOUT_SETCONTRAST:
    case TVOUT_SETSATURATION:       Err= hwTVOutSetSaturation(pCmd); break;
    default:                        Err= MARGI_ERR_UNK_MSG; break;
  }
  return Err;
}

static long hwTVOutGetMacroVisionLevel(PMIDASCMD pCmd) {
  long Err= 0;
  PHW pHw= pCmd->hMidas;
  Err= TVOutProc(pHw->hTvOut,TVOUT_GET_MACROVISION,pCmd->u.M.Arg2,0);
//  DbgMsg(DBG_MACROVISION,"GetMacroVision : Level= %d \r\n",pHw->dwMacroVisionLevel);
  return Err;
}

static long hwTVOutSetMacroVisionLevel(PMIDASCMD pCmd) {
  long Err= 0;
  PHW pHw= pCmd->hMidas;
  DWORD DisplayType= 0;
  BYTE bMode=*(BYTE*)pCmd->u.M.Arg2;
  BYTE bTvOutMacMode=0;
//  pHw->dwMacroVisionLevel= *(DWORD*)pCmd->u.M.Arg2;
  switch (bMode) {
    case 0: bTvOutMacMode=TV_MACROVISION_NONE; break;
    case 1: bTvOutMacMode=TV_MACROVISION_AGC;  break;
    case 2: bTvOutMacMode=TV_MACROVISION_AGC2; break;
    case 3: bTvOutMacMode=TV_MACROVISION_AGC4; break;
  }
  Err=TVOutProc(pHw->hTvOut,TVOUT_SET_MACROVISION,bTvOutMacMode,0);
  DbgMsg(DBG_MACROVISION,"SetMacroVision : Level %d (Err=%s)\r\n",bTvOutMacMode,Ident(ID_MARGIERRORS,Err));
  return Err;
}

static long hwTVOutGetTVOutMode(PMIDASCMD pCmd) {
  long Err= 0;
  PHW pHw= pCmd->hMidas;
  Err= TVOutProc(pHw->hTvOut,TVOUT_GET_OUTPUT,pCmd->u.M.Arg2,0);
  DbgMsg(DBG_CP_SET,"TVOutMode Get %s \r\n",Ident(ID_HW_TVOUTMODE,*(DWORD*)pCmd->u.M.Arg2));
  return Err;
}

static long hwTVOutSetTVOutMode(PMIDASCMD pCmd) {
  long Err= 0;
  PHW pHw= pCmd->hMidas;
  Err= TVOutProc(pHw->hTvOut,TVOUT_SET_OUTPUT,pCmd->u.M.Arg2,0);
  DbgMsg(DBG_CP_SET,"DbgMsg Set TVOut Mode %s \r\n",
          Ident(ID_HW_TVOUTMODE,pHw->dwTVOutMode));
  return Err;
}

static long hwTVOutGetBrightness(PMIDASCMD pCmd) {
  long Err= 0;
  PHW pHw= pCmd->hMidas;
  Err= TVOutProc(pHw->hTvOut,TVOUT_GET_LUMA,pCmd->u.M.Arg2,0);
  DbgMsg(DBG_CP_SET,"Brightness Get %d \r\n",*(DWORD*)pCmd->u.M.Arg2);
  return Err;
}

static long hwTVOutSetBrightness(PMIDASCMD pCmd) {
  long Err= 0;
  PHW pHw= pCmd->hMidas;
  Err= TVOutProc(pHw->hTvOut,TVOUT_SET_LUMA,pCmd->u.M.Arg2,0);
  DbgMsg(DBG_CP_SET,"Brightness set to %d \r\n",pHw->dwVOLuma);
  return Err;
}

static long hwTVOutGetHue(PMIDASCMD pCmd) {
  long Err= 0;
  PHW pHw= pCmd->hMidas;
  Err= TVOutProc(pHw->hTvOut,TVOUT_GET_HUE,pCmd->u.M.Arg2,0);
  return Err;
}

static long hwTVOutSetHue(PMIDASCMD pCmd) {
  long Err= 0;
  PHW pHw= pCmd->hMidas;
  Err= TVOutProc(pHw->hTvOut,TVOUT_SET_HUE,pCmd->u.M.Arg2,0);
  return Err;
}

static long hwTVOutGetSaturation(PMIDASCMD pCmd) {
  long Err= 0;
  PHW pHw= pCmd->hMidas;
  Err= TVOutProc(pHw->hTvOut,TVOUT_GET_CHROMA,pCmd->u.M.Arg2,0);
  DbgMsg(DBG_CP_SET,"Saturation Get %d \r\n",*(DWORD*)pCmd->u.M.Arg2);
  return Err;
}

static long hwTVOutSetSaturation(PMIDASCMD pCmd) {
  long Err= 0;
  PHW pHw= pCmd->hMidas;
  Err= TVOutProc(pHw->hTvOut,TVOUT_SET_CHROMA,pCmd->u.M.Arg2,0);
  DbgMsg(DBG_CP_SET,"Saturation set to %d \r\n",pHw->dwVOChroma);
  return Err;
}


static long hwReset(PMIDASCMD pCmd) {
  long Err= 0;
  DbgMsg(DBG_TODO,"hwReset() needs to be written.\r\n");
  return(Err);
}

static long hwGetRevision(PMIDASCMD pCmd) {
  long Err= 0;
  memset(&pCmd->u.Rev,0,sizeof(pCmd->u.Rev));
  pCmd->u.Rev.code_major= MDS_CODE_MAJOR;
  pCmd->u.Rev.code_minor= MDS_CODE_MINOR;
  DbgMsg(DBG_HWINIT,"hwGetRevision() returns %s.\r\n",Ident(ID_MARGIERRORS,Err));
  return(Err);
}

static long hwInitializeVideo(PMIDASCMD pCmd) {
  long Err= 0;
  VID_DISP_FORMAT Fmt;
  KS_MPEGVIDEOINFO2*   pMpgInfo= pCmd->u.InitVideo.videoinfo;
  KS_VIDEOINFOHEADER2* pVidInfo= &pMpgInfo->hdr;
  KS_BITMAPINFOHEADER* pBm=      &pMpgInfo->hdr.bmiHeader;
  PHW pHw= pCmd->hMidas;

  Fmt.dwAspectRatio;
  Fmt.dwDispMode=pMpgInfo->dwFlags;
  Fmt.nMpegType=    pCmd->u.InitVideo.nMpegType;
  Fmt.wWidth= (WORD)pBm->biWidth;
  Fmt.wHeight=(WORD)pBm->biHeight;

  // width is always scaled to 720 height to 480 or 576
  // this is done for TV Out.
  pBm->biWidth=720;
  if(pBm->biHeight<289)
    pBm->biHeight*=2;

  if(GetLow_MdsLongLong(&pVidInfo->AvgTimePerFrame))
    Fmt.dwPicRate=(DWORD)(1000000000/GetLow_MdsLongLong(&pVidInfo->AvgTimePerFrame))*10;
  else
    Fmt.dwPicRate=29970;

  if((pVidInfo->dwPictAspectRatioX==4) && (pVidInfo->dwPictAspectRatioY==3)) {
    Fmt.dwAspectRatio= ASPECT_4x3;
  } else if((pVidInfo->dwPictAspectRatioX==16) && (pVidInfo->dwPictAspectRatioY==9)) {
    Fmt.dwAspectRatio= ASPECT_16x9;
  }

  VideoCmd(pHw,VIDCMD_DISPFORMAT,(DWORD)&Fmt,0);
#if(0)
  if(!pHw->wStreamsOpened & STRM_VID) {
    } else {
      if(dwPrvDispStd!=dwNewDispStd) {
        VideoCmd(pHw,VIDCMD_RESET,0,0);
        DbgMsg(DBG_HWINITSRB,"Switch from one std. to other (NTSC to PAL or vice versa) Err=%s\r\n",
                Ident(ID_MARGIERRORS,Err));
      }
    }
#endif
  hwDbgOutVideoInfo(pHw);

  pHw->wStreamsOpened|= STRM_VID;
  DbgMsg(DBG_HWINIT,"hwInitializeVideo() returns %s.\r\n",Ident(ID_MARGIERRORS,Err));
  return(Err);
}

static long hwLoadCPSettings(PMIDASCMD pCmd) {
  long Err= 0;
  PHW pHw= pCmd->hMidas;
  hwApplyControlPanelConfig(pHw);
  DbgMsg(DBG_CP_SET|DBG_CP_INFO,"Loaded CP Settings from Permanent Registry. \r\n");
  return Err;
}

static long hwInitializeAudio(PMIDASCMD pCmd) {
  long Err= 0;
  PHW pHw= pCmd->hMidas;
//  LPWAVEFORMATEX pWaveFmt= pCmd->u.InitAudio.lpLPCMFmt;

  //if(pHw->wStreamsOpened & STRM_AUD)
  //  return 0;

  if(!pHw->dwAudRate) {
    pHw->dwAudRate= RATE_NORMAL;
    tmInitStreamTime(pHw);
  }

  if(!pHw->dwAudMaxRate)
    pHw->dwAudMaxRate= AUD_MAX_RATE;

  // Select new audio format.  Datadiscontinuity flag in stream will apply this format
  switch(pCmd->u.InitAudio.AudioSource) {
    case MDS_AS_AC3:	  AudioCmd(pHw,AUDCMD_SET,AUDITEM_SRCTYPE,AUD_AC3); break;
    case MDS_AS_LPCM:  AudioCmd(pHw,AUDCMD_SET,AUDITEM_SRCTYPE,AUD_LPCM); break;
    case MDS_AS_MPEG:  AudioCmd(pHw,AUDCMD_SET,AUDITEM_SRCTYPE,AUD_MPEG); break;
    default:		  Err= hwUnkAudioType(pCmd);
  }
  if(!Err) {
    AudioCmd(pHw,AUDCMD_SET,AUDITEM_SAMPLES,pCmd->u.InitAudio.AudioSampleRate);
    AudioCmd(pHw,AUDCMD_SET,AUDITEM_OUTMODE,pCmd->u.InitAudio.AudioOutputMode);
    AudioCmd(pHw,AUDCMD_SET,AUDITEM_NUMCHANNELS,pCmd->u.InitAudio.AudioNumChannels);
//    pHw->dwAudioBitRate= pWaveFmt->nAvgBytesPerSec*8;
//    pHw->dwAudioBitRate= pHw->dwAudioBitRate ? pHw->dwAudioBitRate : 0xe800;
    hwDbgOutAudioInfo(pHw);
//   Err= AudioCmd(pHw,AUDCMD_RESET,0,0);
    if(!Err)
      pHw->wStreamsOpened|=STRM_AUD;
    DbgMsg(DBG_HWINIT,"hwInitializeAudio() returns %s.\r\n",Ident(ID_MARGIERRORS,Err));
  }
  return Err;
}

static long hwDbgOutAudioInfo(PHW pHw) {
  DbgMsg(DBG_HWINITSRB,"hwInitializeAudio: Audio Info\r\n");
  DbgMsg(DBG_HWINITSRB," Type:       %s\r\n",Ident(ID_HAL_AUDTYPE,AudioCmd(pHw,AUDCMD_GET,AUDITEM_SRCTYPE,0)));
  DbgMsg(DBG_HWINITSRB," SampleRate: %d\r\n",AudioCmd(pHw,AUDCMD_GET,AUDITEM_SAMPLES,0));
  DbgMsg(DBG_HWINITSRB," Output:     %s\r\n",Ident(ID_HAL_AUDOUTPUT,AudioCmd(pHw,AUDCMD_GET,AUDITEM_OUTMODE,0)));
//  DbgMsg(DBG_HWINITSRB," BitRate:    %d (%x)\r\n",pHw->dwAudioBitRate,pHw->dwAudioBitRate);
  return 0;
}

static long hwDbgOutVideoInfo(PHW pHw) {
  DWORD DisplayType;
  VideoCmd(pHw,VIDCMD_GET,VIDITEM_DISPLAY,(DWORD)&DisplayType);
  DbgMsg(DBG_HWINITSRB,"hwInitializeVideo  %s %s:\r\n",(pHw->nMpegType&1)?"MPEG1":"MPEG2",(pHw->nMpegType&2)?" VOB":"");
  DbgMsg(DBG_HWINITSRB," Signal Standard %s\r\n",Ident(ID_HW_SIGNALSTD,DisplayType));
  DbgMsg(DBG_HWINITSRB," Aspect Ratio = %s \r\n",Ident(ID_HAL_ASPECT,pHw->dwAspectRatio));
  DbgMsg(DBG_HWINITSRB," Video Dimension = %d x %d \r\n",pHw->wPicWidth,pHw->wPicHeight);
//  DbgMsg(DBG_HWINITSRB," Video BitRate = %x (%d)\r\n",pHw->dwVideoBitRate,pHw->dwVideoBitRate);
  DbgMsg(DBG_HWINITSRB," Video Display format = %s\r\n",Ident(ID_VIDOUT_MODE,pHw->dwVidDispFormat));
  return 0;
}

static long hwUnkAudioType(PMIDASCMD pCmd) {
  DbgMsg(DBG_ERR,"Unknown Audio Type ???... \r\n");
  return MARGI_ERR_BADTYPE;
}


static long hwInitializeSub(PMIDASCMD pCmd) {
  long Err= 0;
  PHW pHw= pCmd->hMidas;
  pHw->wStreamsOpened|= STRM_SUB;
  if(!pHw->dwSubRate)
    pHw->dwSubRate= RATE_NORMAL;
  if(!pHw->dwSubMaxRate)
    pHw->dwSubMaxRate= SUB_MAX_RATE;
  Err= SubpicCmd(pHw,SUBCMD_RESET,0,0);
  return Err;
}

static long hwPlay(PMIDASCMD pCmd) {
  long Err= 0;
  PHW pHw= pCmd->hMidas;
  DbgMsg(DBG_HWCMD,"hwPlay(%s)\r\n",Ident(ID_HAL_PLAYMODE,pCmd->u.nData));
  if(!Err) {
    switch(pCmd->wCurrStream) {
      case STRM_VID:  Err= VideoCmd(pHw,VIDCMD_RUN,0,0); break;
      case STRM_AUD:  Err= AudioCmd(pHw,AUDCMD_RUN,0,0); break;
      case STRM_SUB:  Err= SubpicCmd(pHw,SUBCMD_RUN,0,0); break;
      default:        Err= MARGI_ERR_BADITEM;
    }
  }
  DbgMsg(DBG_HWCMD,"hwPlay() returns %s.\r\n",Ident(ID_MARGIERRORS,Err));
  return(Err);
}

static long hwStop(PMIDASCMD pCmd) {
  long Err= 0;
  PHW pHw= pCmd->hMidas;
  if(pCmd->wCurrStream==STRM_VID) {
    Err= VideoCmd(pHw,VIDCMD_STOP,0,0);
  } else if(pCmd->wCurrStream==STRM_AUD) {
    Err= AudioCmd(pHw,AUDCMD_STOP,0,0);
    tmInitStreamTime(pHw);
  } else if(pCmd->wCurrStream==STRM_SUB) {
    Err= SubpicCmd(pHw,SUBCMD_STOP,0,0);
  } else {
    Err= MARGI_ERR_BADITEM;
  }
  DbgMsg(DBG_HWCMD,"hwStop() returns %s \r\n",Ident(ID_MARGIERRORS,Err));
  return(Err);
}

static long hwPause(PMIDASCMD pCmd) {
  long Err= 0;
  PHW pHw= pCmd->hMidas;
  if(pCmd->wCurrStream==STRM_VID) {
    Err= VideoCmd(pHw,VIDCMD_PAUSE,0,0);
  } else if(pCmd->wCurrStream==STRM_AUD) {
    Err= AudioCmd(pHw,AUDCMD_PAUSE,0,0);
  } else if(pCmd->wCurrStream==STRM_SUB) {
    Err= SubpicCmd(pHw,SUBCMD_PAUSE,0,0);
  } else {
    Err= MARGI_ERR_BADITEM;
  }
  DbgMsg(DBG_HWCMD,"hwPause() returns %s \r\n",Ident(ID_MARGIERRORS,Err));
  return(Err);
}

static long hwStep(PMIDASCMD pCmd) {
  long Err= 0;
  PHW pHw= pCmd->hMidas;
  DbgMsg(DBG_HWCMD,"hwStep(%d)\r\n",pCmd->u.M.Arg1);
  if(!Err) {
    switch(pCmd->wCurrStream) {
      case STRM_VID:  Err= VideoCmd(pHw, VIDCMD_STEP,pCmd->u.M.Arg1,0); break;
      case STRM_AUD:  Err= AudioCmd(pHw, AUDCMD_STEP,pCmd->u.M.Arg1,0); break;
      case STRM_SUB:  Err= SubpicCmd(pHw,SUBCMD_STEP,pCmd->u.M.Arg1,0); break;
      default:        Err= MARGI_ERR_BADITEM;
    }
  }
  DbgMsg(DBG_HWCMD,"hwPlay() returns %s.\r\n",Ident(ID_MARGIERRORS,Err));
  return(Err);
}



static long hwTestHw(PMIDASCMD pCmd) {
  long Err= 0;
  DbgMsg(DBG_TODO,"hwTestHw() needs to be written.\r\n");
  return(Err);
}

static long hwSetVideoID(PMIDASCMD pCmd) {
//long id
  long Err= 0;
  if(pCmd->u.nData==MDS_VS_ALL) {
    DbgMsg(DBG_HWCMD,"hwSetVideoID(ALL)\r\n");
  } else if(pCmd->u.nData==MDS_VS_OFF) {
    DbgMsg(DBG_HWCMD,"hwSetVideoID(OFF)\r\n");
  } else if(pCmd->u.nData<0 || pCmd->u.nData>15) {
    DbgMsg(DBG_WRN,"hwSetVideoID(%d): Illegal value.\r\n",pCmd->u.nData);
  } else {
    VideoCmd(pCmd->hMidas,VIDCMD_SELECT,pCmd->u.nData,0);
    DbgMsg(DBG_HWCMD,"hwSetVideoID(%d).\r\n",pCmd->u.nData);
  }
  DbgMsg(DBG_HWCMD,"hwSetVideoID() returns %s.\r\n",Ident(ID_MARGIERRORS,Err));
  return(Err);
}

static long hwSetAudioID(PMIDASCMD pCmd) {
//long id
  long Err= 0;
  if(pCmd->u.nData==MDS_ASID_OFF) {
    DbgMsg(DBG_HWCMD,"hwSetAudioID(OFF)\r\n");
  } else if(pCmd->u.nData==MDS_ASID_LPCM) {
    DbgMsg(DBG_HWCMD,"hwSetAudioID(LPCM)\r\n");
  } else if(pCmd->u.nData==MDS_ASID_AC3) {
    DbgMsg(DBG_HWCMD,"hwSetAudioID(AC3)\r\n");
  } else if(pCmd->u.nData==MDS_ASID_ALL_MPEG) {
    DbgMsg(DBG_HWCMD,"hwSetAudioID(ALL_MPEG)\r\n");
  } else if(pCmd->u.nData<0 || pCmd->u.nData>31) {
    DbgMsg(DBG_WRN,"hwSetAudioID(%d): Illegal value.\r\n",pCmd->u.nData);
  } else {
    AudioCmd(pCmd->hMidas,AUDCMD_SELECT,pCmd->u.nData,0);
    DbgMsg(DBG_HWCMD,"hwSetAudioID(%d).\r\n",pCmd->u.nData);
  }
  DbgMsg(DBG_HWCMD,"hwSetAudioID() returns %s.\r\n",Ident(ID_MARGIERRORS,Err));
  return(Err);
}

static long hwSetSubID(PMIDASCMD pCmd) {
//long id
  long Err= 0;
  if(pCmd->u.nData==MDS_NO_SUBSTREAM) {
    DbgMsg(DBG_HWCMD,"hwSetSubID(NO_SUBSTREAM)\r\n");
  } else if(pCmd->u.nData<0 || pCmd->u.nData>31) {
    DbgMsg(DBG_WRN,"hwSetSubID(%d): Illegal value.\r\n",pCmd->u.nData);
  } else {
    DbgMsg(DBG_HWCMD,"hwSetSubID(%d).\r\n",pCmd->u.nData);
    SubpicCmd(pCmd->hMidas,SUBCMD_SELECT,pCmd->u.nData,0);
  }
  DbgMsg(DBG_HWCMD,"hwSetSubID() returns %s.\r\n",Ident(ID_MARGIERRORS,Err));
  return(Err);
}

static long hwStereo(PMIDASCMD pCmd) {
//long StereoMode
  long Err= 0;
  DbgMsg(DBG_HWCMD,"hwStereo(%s)\r\n",Ident(ID_HAL_STEREO,pCmd->u.nData));
  DbgMsg(DBG_TODO,"hwStereo() needs to be written.\r\n");
  DbgMsg(DBG_HWCMD,"hwStereo() returns %s.\r\n",Ident(ID_MARGIERRORS,Err));
  return(Err);
}

static long hwFlushBegin(PMIDASCMD pCmd) {
  long Err= 0;
  PHW pHw= pCmd->hMidas;
  PMDS_DATA_BLOCK pMdb=pCmd->u.pMdb;
  DbgMsg(DBG_SYNCADJ,"ApiEntry: FlushBegin(%s).\r\n",Ident(ID_HW_STRMTYPE,pCmd->wCurrStream));
  if(pCmd->wCurrStream==STRM_VID) {
    SyncCmd(pHw,SYNC_RESET,0,STRM_VID);
    Err= VideoCmd(pHw,VIDCMD_BEGINFLUSH,(DWORD)pMdb,0);
  } else if(pCmd->wCurrStream==STRM_AUD) {
    SyncCmd(pHw,SYNC_RESET,0,STRM_AUD);
    Err= AudioCmd(pHw,AUDCMD_BEGINFLUSH,(DWORD)pMdb,0);
  } else if(pCmd->wCurrStream==STRM_SUB) {
    Err= SubpicCmd(pHw,SUBCMD_BEGINFLUSH,(DWORD)pMdb,0);
  } else {
    Err= MARGI_ERR_BADITEM;
  }
  if(Err)
    DbgMsg(DBG_HWCMD,"hwFlush() returns %s.\r\n",Ident(ID_MARGIERRORS,Err));
  return(Err);
}

static long hwFlushEnd(PMIDASCMD pCmd) {
  long Err= 0;
  PHW pHw= pCmd->hMidas;
  DbgMsg(DBG_HWFLUSH,"ApiEntry: FlushEnd(%s).\r\n",Ident(ID_HW_STRMTYPE,pCmd->wCurrStream));
//  SyncCmd(pHw,SYNC_PREPLAY,1,0);
  if(pCmd->wCurrStream & STRM_VID)
    VideoCmd(pHw,VIDCMD_ENDFLUSH,0,0);
  if(pCmd->wCurrStream & STRM_AUD)
    AudioCmd(pHw,AUDCMD_ENDFLUSH,0,0);
  if(pCmd->wCurrStream & STRM_SUB)
    SubpicCmd(pHw,SUBCMD_ENDFLUSH,0,0);
  return(Err);
}

static long hwIsr(PMIDASCMD pCmd) {
  PHW pHw= pCmd->hMidas;
  //dvHwIsrHandler(pHw);
  return(0);
}

static long hwIsrComplete(PMIDASCMD pCmd) {
  DbgMsg(DBG_HIFREQ|DBG_HWISR,"hwIsrComplete\r\n");
  DbgMsg(DBG_HIFREQ|DBG_HWISR,"hwIsrComplete() needs to be written.\r\n");
  return(0);
}

static long hwRegisterEvent(PMIDASCMD pCmd) {
//struct LSIHD_RegisterEvent_Struct *pRegEvent
  long Err= 0;
  DbgMsg(DBG_HWCMD,"hwRegisterEvent(%s,%08X).\r\n",Ident(ID_HAL_EVENT,pCmd->u.RegEvent.Event),pCmd->u.RegEvent.pFunc);
  DbgMsg(DBG_HWCMD,"hwRegisterEvent() returns %s.\r\n",Ident(ID_MARGIERRORS,Err));
  return(Err);
}

static long hwUnregisterEvent(PMIDASCMD pCmd) {
//long Event
  long Err= 0;
  DbgMsg(DBG_HWCMD,"hwUnregisterEvent(%s,%08X).\r\n",Ident(ID_HAL_EVENT,pCmd->u.nData));
  DbgMsg(DBG_HWCMD,"hwUnregisterEvent() returns %s.\r\n",Ident(ID_MARGIERRORS,Err));
  return(Err);
}

static long hwSP_CompositeOn(PMIDASCMD pCmd) {
  long Err= 0;
  PHW pHw= pCmd->hMidas;
  if(pCmd->u.nData) {
    SubpicCmd(pHw,SUBCMD_ENABLE,SPU_ON,0);
  } else {
    SubpicCmd(pHw,SUBCMD_ENABLE,SPU_OFF,0);
  }
  DbgMsg(DBG_HWCMD,"hwSP_CompositeOn() returns %s.\r\n",Ident(ID_MARGIERRORS,Err));
  return(Err);
}

static long hwSP_Highlight(PMIDASCMD pCmd) {
  PKSPROPERTY_SPHLI ptr= pCmd->u.pSPHLI;
  RECT rt;
  long Err= 0;
  rt.left= ptr->StartX;
  rt.right= ptr->StopX;
  rt.top= ptr->StartY;
  rt.bottom= ptr->StopY;
//  if((!rt.left && !rt.right && !rt.top && !rt.bottom) || !ptr->HLISS) {
  if((!rt.left && !rt.right && !rt.top && !rt.bottom)) { // || !ptr->HLISS) {
    SubpicCmd(pCmd->hMidas,SUBCMD_HIDISABLE,0,0);
  } else {
    PKS_COLCON p=&ptr->ColCon;
    DWORD dwColor;
    dwColor =((p->patcol<<12)|(p->backcol<<8)|(p->emph2col<<4)|p->emph1col);
    dwColor|=((p->patcon<<12)|(p->backcon<<8)|(p->emph2con<<4)|p->emph1con)<<16;

    SubpicCmd(pCmd->hMidas,SUBCMD_SET,SUBITEM_HICOLOR,dwColor);
    SubpicCmd(pCmd->hMidas,SUBCMD_SET,SUBITEM_HIPOS,(DWORD)&rt);
    SubpicCmd(pCmd->hMidas,SUBCMD_HIENABLE,ptr->StartPTM,ptr->EndPTM);
  }
  DbgMsg(DBG_HWCMD,"hwSP_Highlight() returns %s.\r\n",Ident(ID_MARGIERRORS,Err));
  return(Err);
}

static long hwSP_Palette(PMIDASCMD pCmd) {
  PKSPROPERTY_SPPAL ptr= pCmd->u.pSPPAL;
  long Err= 0;
  SubpicCmd(pCmd->hMidas,SUBCMD_PALETTE,(DWORD)ptr,16);
  DbgMsg(DBG_HWCMD,"hwSP_Highlight() returns %s.\r\n",Ident(ID_MARGIERRORS,Err));
  return(Err);
}

static long hwSetMasterClock1(PMIDASCMD pCmd) {
  PHW pHw= pCmd->hMidas;
  DWORD hClock= pCmd->u.M.Arg1;
  DbgMsg(DBG_HWCMD,"hwSetMasterClock: %08X.\r\n",hClock);
  pHw->MasterClock= hClock;
  return(0);
}

			
static long hwGetStreamTime(PMIDASCMD pCmd) {
  long Err;
  REFERENCE_TIME CurTime,OldTime,NewTime;
  PHW pHw=pCmd->hMidas;

  // CurTime is cur SCR
  // OldTime and NewTime are set if pending time discontinuity
  Err=tmGetStreamTime(pHw,&CurTime,&OldTime,&NewTime);
  if(Err) {
    Set_MdsLongLong(&CurTime, 0, 0);
    Set_MdsLongLong(&OldTime, 0, 0);
    Set_MdsLongLong(&NewTime, 0, 0);
  }
  pCmd->u.GetTime.CurTime=CurTime;
  pCmd->u.GetTime.OldTime=OldTime;
  pCmd->u.GetTime.NewTime=NewTime;
  return(Err);
}

static long hwSetStreamTimeMode(PMIDASCMD pCmd) {
  long Err;
  Err=tmSetStreamTimeMode(pCmd->hMidas,pCmd->u.M.Arg1);
  return Err;
}

static long hwSetStreamTime(PMIDASCMD pCmd) {
  long Err;
  PHW pHw=pCmd->hMidas;

  Err=tmSetStreamTime(pHw,pCmd->u.SetTime.NewTime,pCmd->u.SetTime.OldTime);
#ifdef _NEC_DBG_
  printf("SetTime New=%x %08x  Old=%x %08x\r\n",pCmd->u.SetTime.NewTime.Hi,pCmd->u.SetTime.NewTime.Lo,pCmd->u.SetTime.OldTime.Hi,pCmd->u.SetTime.OldTime.Lo);
#endif
  return Err;
}

static long hwSetRate(PMIDASCMD pCmd) {
  long Err= 0;
  PHW pHw= pCmd->hMidas;
  switch(pCmd->wCurrStream) {
    case STRM_VID:    Err= VideoCmd (pHw,VIDCMD_RATE,(DWORD)&pCmd->u.PlayRate,0); break;
    case STRM_AUD:    Err= AudioCmd (pHw,AUDCMD_RATE,(DWORD)&pCmd->u.PlayRate,0); break;
    case STRM_SUB:    Err= SubpicCmd(pHw,SUBCMD_RATE,(DWORD)&pCmd->u.PlayRate,0); break;
  }
  return Err;
}

static long hwGetRate(PMIDASCMD pCmd) {
  long Err= 0;
  PHW pHw= pCmd->hMidas;
  Set_MdsLongLong(&pCmd->u.PlayRate.StartTime, 0, 0);
  switch(pCmd->wCurrStream) {
    case STRM_VID: pCmd->u.PlayRate.Rate= pHw->dwVidRate; break;
    case STRM_AUD: pCmd->u.PlayRate.Rate= pHw->dwAudRate; break;
    case STRM_SUB: pCmd->u.PlayRate.Rate= pHw->dwSubRate; break;
    default:       pCmd->u.PlayRate.Rate=0; break;
  }
  return Err;
}

static long hwGetMaxRate(PMIDASCMD pCmd) {
  long Err= 0;
  PHW pHw= pCmd->hMidas;
  switch(pCmd->wCurrStream) {
    case STRM_VID:    *(DWORD*)pCmd->u.M.Arg1= pHw->dwVidMaxRate; break;
    //case STRM_VID:    Err= VideoCmd(pHw,VIDCMD_GET,VIDITEM_RATEMAX,(DWORD)&pCmd->u.M.Arg1); break;
    case STRM_AUD:    *(DWORD*)pCmd->u.M.Arg1= pHw->dwAudMaxRate; break;
    case STRM_SUB:    *(DWORD*)pCmd->u.M.Arg1= pHw->dwSubMaxRate; break;
  }
  return Err;
}

static long hwSetVPEInfo(PMIDASCMD pCmd) {
  long Err= 0;
  PHW pHw= pCmd->hMidas;
  if(pCmd->u.pVPEInfo_s->dwPortWidth==8)
    pHw->u.s.f8BitZV= 1;
  else 
    pHw->u.s.f8BitZV= 0;
  return Err;
}

static long hwGetCCFIFOStatus(PMIDASCMD pCmd) {
  long DataAvail= 0;
  PHW pHw= pCmd->hMidas;
  BYTE Data;
  Data= dvHwMainReadLsiReg(pHw,USERDATA_FIFO_STATUS_REG);
  switch(Data&USERDATA_STATUS_MASK_BITS) {
    case USERDATA_STATUS_EMPTY:     DataAvail= 0; break;
    case USERDATA_STATUS_READY:     DataAvail= 0; break;
    case USERDATA_STATUS_FULL:      DataAvail= 1; break;
    case USERDATA_STATUS_OVERRUN:   DataAvail= 0; break;
  }
  return DataAvail;
}

BYTE CcDataLocalBuff[200];

static long hwGetCCInfo(PMIDASCMD pCmd) {
  long Err= 0;
#if(0)
  PHW pHw= pCmd->hMidas;
  //DWORD Time90KHz;
  BYTE *pBuff= (BYTE*)pCmd->u.CCInfo.dwBuff;
  DWORD dwBytesRead= 0;
  WORD wCCBytes= 0;


  if(hwGetCCFIFOStatus(pCmd)) {
    for(wCCBytes=0;wCCBytes<200;wCCBytes++)
      CcDataLocalBuff[wCCBytes]= (BYTE)dvHwMainReadLsiReg(pHw,USERDATA_FIFO_DATA_REG);
    DbgMsg(DBG_MSGCC,"CC Data Full ...\r\n");
  }

  /*
  if((dwBytesRead=hwReadUserDataFIFO(pHw,0))) {
    RtlCopyMemory(pBuff,CcDataLocalBuff,dwBytesRead);
    RtlZeroMemory(CcDataLocalBuff,sizeof(CcDataLocalBuff));
    pCmd->u.CCInfo.dwBytesRead= dwBytesRead;
    hwReadUserDataFIFO(0,1);
  } else {
    pCmd->u.CCInfo.dwBytesRead= 0;
  }

  if(pCmd->u.CCInfo.dwBytesRead) {
    Err= SyncCmd(pCmd->hMidas,SYNC_GET,SYNC_ITEM_TIME,(DWORD)&Time90KHz);
    if(!Err)
      pCmd->u.CCInfo.Pts= ((ULONGLONG)Time90KHz*1000)/9;
    else
      pCmd->u.CCInfo.Pts= 0;
    DbgMsg(DBG_MSGCC,"Read %d bytes from CC FIFO \r\n",pCmd->u.CCInfo.dwBytesRead);
  }
  */
#endif
  return Err;
}

static long hwRdOneByteFromUserData(PHW pHw,BYTE* pBuff) {
  long Err= 0xFFFFFFFF;
  if((dvHwMainReadLsiReg(pHw,USERDATA_FIFO_STATUS_REG)&USERDATA_STATUS_MASK_BITS)!=USERDATA_STATUS_EMPTY) {
    *pBuff= (BYTE)dvHwMainReadLsiReg(pHw,USERDATA_FIFO_DATA_REG);
    Err= 0;
  }
  return Err;
}

static long hwReadUserDataFIFO(PHW pHw,BOOL Reset) {
  static BYTE dwOffSet= 0;
  static BYTE dwBytesReqd= 0;
  static BYTE dwBytesRead= 0;
  BYTE dwTemp;
  long Ret= 0;

  if(Reset) {
    dwOffSet= 0;
    dvHwMainWriteLsiRegBits(pHw,USERDATA_FIFO_RESET,USERDATA_FIFO_RESET_VAL);
  } else {
    if(dwOffSet>4)  {
      while(dwBytesReqd) {
        if(hwRdOneByteFromUserData(pHw,&CcDataLocalBuff[dwOffSet++])) {
          dwOffSet--;
          return 0;
        } else {
          dwBytesReqd--;
        }
      }
      dwBytesRead= dwOffSet;
      dwOffSet= 0;
      return dwBytesRead;
    } else {
      if(dwOffSet<4) {
        dwTemp= 4-dwOffSet;
        while(dwTemp--) {
          if(hwRdOneByteFromUserData(pHw,&CcDataLocalBuff[dwOffSet++])) {
            dwOffSet--;
            return 0;
          }
        }
        if(*(DWORD*)CcDataLocalBuff!=0x0001f801) {
          CcDataLocalBuff[0]= CcDataLocalBuff[1];
          CcDataLocalBuff[1]= CcDataLocalBuff[2];
          CcDataLocalBuff[2]= CcDataLocalBuff[3];
          dwOffSet--;
          dwTemp++;
          return 0;
        }
      }
      if(dwOffSet==4) {
        if(hwRdOneByteFromUserData(pHw,(BYTE*)&dwBytesReqd)) {
          return 0;
        } else {
          CcDataLocalBuff[dwOffSet++]= (BYTE)dwBytesReqd;
          dwBytesReqd*= 3;
        }
      }
      return 0;
      //if(dwOffSet==5)
      //  return hwReadUserDataFIFO(pHw,0);
    }
  }
  return 0;
}

static long hwInitCC(PMIDASCMD pCmd) {
  long Err= 0;
  PHW pHw= pCmd->hMidas;
  //Actually have the decoder to push only Line21 data
  dvHwMainWriteLsiRegBits(pHw,RESET_USER_DATA_REG,RESET_USER_DATA);  
  dvHwMainWriteLsiRegBits(pHw,USERDATA_FIFO_RESET,USERDATA_FIFO_RESET_VAL);
  DbgMsg(DBG_MSGCC, "CC Init User Data FIFO \r\n");
  return Err;
}

static long hwResetCC(PMIDASCMD pCmd) {
  long Err= 0;
  PHW pHw= pCmd->hMidas;
  dvHwMainWriteLsiRegBits(pHw,USERDATA_FIFO_RESET,USERDATA_FIFO_RESET_VAL);
  DbgMsg(DBG_MSGCC, "CC Reset User Data FIFO \r\n");
  return Err;
}

static long hwEEPROMData(PMIDASCMD pCmd) {
  long Err= 0;
  PHW pHw= pCmd->hMidas;
  if(pCmd->cmd==MDS_WRITE_DATA)
    Err=dvHwMainEEPROMDataWrite(pHw, (LPBYTE)pCmd->u.M.Arg1, pCmd->u.M.Arg2);
  else
    Err=dvHwMainEEPROMDataRead(pHw, (LPBYTE)pCmd->u.M.Arg1, pCmd->u.M.Arg2);
  return Err;
}

static long hwSaveState(PMIDASCMD pCmd) {
  long Err= 0;
  PHW pHw= pCmd->hMidas;
  DbgMsg(DBG_PNPPOWER,"Saving Hardware State.... \r\n");

  DbgMsg(DBG_PNPPOWER,"   Set Vid,Aud and Sub stream state to STOP... \r\n");
  
  pCmd->wCurrStream= STRM_VID; hwPause(pCmd);
  pCmd->wCurrStream= STRM_AUD; hwPause(pCmd);
  pCmd->wCurrStream= STRM_SUB; hwPause(pCmd);

  pCmd->wCurrStream= STRM_VID; hwStop(pCmd);
  pCmd->wCurrStream= STRM_AUD; hwStop(pCmd);
  pCmd->wCurrStream= STRM_SUB; hwStop(pCmd);

  DbgMsg(DBG_PNPPOWER,"   Shutting down the TV Encoder and local objects... \r\n");
  dvHwMainDeviceShutdown(pHw);
  DbgMsg(DBG_PNPPOWER,"   Writing current config to registry... \r\n");
  hwWriteControlPanelConfig(pHw);

  return Err;
}

static long hwRestoreState(PMIDASCMD pCmd) {
  long Err= 0;
  PHW pHw= pCmd->hMidas;
  DbgMsg(DBG_PNPPOWER,"Restoring Hardware State.... \r\n");

  if(Err= dvHwMainDetect(pHw)) {
    DbgMsg(DBG_PNPPOWER,"Unable to detect the hardware. Can't restore HW state\r\n");
  } else if(Err= dvHwMainDeviceInit(pHw)) {
    DbgMsg(DBG_PNPPOWER,"Unable to initialize the hardware. Can't restore HW state\r\n");
  } else {
    DbgMsg(DBG_PNPPOWER,"   HW detected & initialized\r\n");

    VideoCmd(pHw,VIDCMD_PICSET,0,0);                      //Set video picture parameters.
//    VideoCmd(pHw,VIDCMD_DISPMODE,pHw->dwVidDispMode,0);

    AudioCmd(pHw,AUDCMD_SET,AUDITEM_SRCTYPE,AudioCmd(pHw,AUDCMD_GET,AUDITEM_SRCTYPE,0));
    AudioCmd(pHw,AUDCMD_SET,AUDITEM_SAMPLES,AudioCmd(pHw,AUDCMD_GET,AUDITEM_SAMPLES,0));
    AudioCmd(pHw,AUDCMD_SET,AUDITEM_OUTMODE,AudioCmd(pHw,AUDCMD_GET,AUDITEM_OUTMODE,0));
    pHw->fVidBuffConfigured= pHw->fAudBuffConfigured= pHw->fSubBuffConfigured= 0;

    hwReadControlPanelConfig(pHw);
    hwApplyControlPanelConfig(pHw);
    DbgMsg(DBG_PNPPOWER,"   Config settings loaded from the registry\r\n");

  }
  return Err;
}


/**EOF: APIENTRY.C**/
