#ifndef __AUXDATA_H__
#define __AUXDATA_H__ 0x0100

/*************************************************************************/
/** AuxData handles the LSI auxillary/user data FIFO. This FIFO is how	**/
/** the LSI publishes information about the decoding process, including	**/
/** such things as the picture type last decoded (I,P, or B frame).	**/
/*************************************************************************/
extern long AuxDataCmd(PHW pHw, DWORD Cmd, DWORD Arg1, DWORD Arg2);

#define AUXCMD_INIT		1	//Create a new AuxData object.	Arg1=NA, Arg2=NA
#define AUXCMD_FINI		2	//Destroy AuxData object.	Arg1=NA, Arg2=NA
#define AUXCMD_RESET		3	//Reset state of AuxData.	Arg1=NA, Arg2=NA
#define AUXCMD_TIMER		4	//Check/read FIFO data		Arg1=NA, Arg2=NA
#define AUXCMD_GET		5	//Retrieve data.		Arg1=One of AUXGET_, Arg2= DWORD &Data

#define AUXGET_PICTYPE		1	//Current picture type. Only valid after VIDEVENT_SLICESTART has occurred.
#define AUXGET_EVENTVID		2	//Most recent video event. One or more of EVENTVID_
  #define EVENTVID_PICTSTART	  0x0001
  #define EVENTVID_SLICESTART	  0x0002

#endif
/**EOF: AUXDATA.H**/
