#ifndef __MIDAS_H__
#define __MIDAS_H__ 0x0100

#define ISBADPTR(p,l) (((DWORD)(p)) ? 0:1)
#define HIDWORD(ld) ((DWORD)((ld)>>32))
#define LODWORD(ld) ((DWORD)(ld))

#ifdef _NEC_DBG_
extern int   TimeTableIx;
extern DWORD TimeTable[1024];
#define LOGTIME(tag,time) if(TimeTableIx<1024)TimeTable[TimeTableIx++&0x3ff]=(tag<<28)|time;
#define LOGSUBTRANSFER  1
#define LOGSUBPREFILL   2
#define LOGSUBPLAYSYNC  3
#define LOGSUBPLAY      4
#define LOGVIDCONFIG    5
#define LOGSUBPTS       6
#define LOGSUBCMD       7
#define LOGSUBPAL       8
#define LOGSUBSTAT      9
#else
#define LOGTIME(tag,time)
#endif

//From Init.c
extern void hwWriteControlPanelConfig(PHW pHw);
extern void hwReadControlPanelConfig(PHW pHw);
extern void hwApplyControlPanelConfig(PHW pHw);
extern long hwDriverInit(BOOL fInit, PMIDASCMD pCmd);
//extern DWORD hwGetDataSize(void);
extern long hwLocateHardware(PMIDASCMD pCmd);
extern long hwLocateHardDma(PMIDASCMD pCmd);  
extern long hwDeviceInit(BOOL fInit, PHW pHw);
extern struct Option_s {
  union {
    struct {
      BOOL fDbgMsg:1;
      BOOL fProfiler:1;
      BOOL fSystemMonitor:1;
      BOOL fUsePktPTS:1;
      BOOL fParsePTS:1;
    }s;
    DWORD dwFlags;
  }u;
  BYTE ColorBarsOnly;             //Encoder Always Outputs colorBars Only,
  BYTE gfForcePCMCIA;             //Force that the HW is a PCMCIA Card.
  BYTE fUseSCRforMasterClock;
  DWORD AutostartDelay;
  DWORD dwInvertClock;             //To Invert the pixel clock
} Opt;
extern DWORD fSWOnly;

//From SendData.c
struct Send_s;
extern long hwSendData(PHW pHw, struct Send_s *pSend);
extern long hwSetMasterClock(PHW pHw, DWORD hClock);
extern BYTE gOkToReadReg;
extern WORD gMonitorReg;
extern DWORD gIntrTime;

//From Time.c
typedef struct SYNC_TIME90_s {
  DWORD dwTimeLo;
  DWORD dwTimeHi;
} SYNC_TIME90;

//extern DWORD Margi_timeGetTime(void);
void  tmInitStreamTime(PHW pHw);
DWORD tmAdjustStreamTime(PHW pHw,MDSLONGLONG* pddTime);
long  tmGetStreamTime(PHW pHw,MDSLONGLONG* pddTime,MDSLONGLONG* pddOldTime,MDSLONGLONG* pddNewTime);
long  tmSetStreamTime(PHW pHw,MDSLONGLONG ddNewTime,MDSLONGLONG ddOldTime);
long  tmSetStreamTimeMode(PHW pHw, DWORD dwMode);
int   tmCompareTimes(DWORD dwTime1, DWORD dwTime2);
void  tmCueNewClkRate(PHW pHw,DWORD dwNewRate, MDSLONGLONG dlNewStartTime);
void  tmConvertTime10Mto90K(MDSLONGLONG* pTime10M,SYNC_TIME90* pTime90K);
void  tmConvertTime90Kto10M(SYNC_TIME90* pTime90K,MDSLONGLONG* pTime10M);


//From CopyProt.c
extern long hwCopyProtection(PMIDASCMD pCmd);

//From dwHwSync.c
extern DWORD hwSyncConvert(PHW pHw, MDSLONGLONG lPts);
extern long hwSyncAdd(PHW pHw, DWORD StrmType, MDSLONGLONG lPts, BOOL fBegin);
extern long hwSyncQuery(PHW pHw);
extern DWORD dwAudBuffCount; //Counter that has # of buffers for the new PTS entered into the table.
extern DWORD dwVidBuffCount;

//From dvHwIsr.c
typedef struct QUEUE_s{
  PMDS_DATA_BLOCK pHead;   // Head of Data Block Queue (next block to send to decoder)
  PMDS_DATA_BLOCK pTail;   // Most recent Data Block received
  DWORD dwEntries;
  BYTE  fInEnQue;
} QUEUE, *PQUEUE;

extern long dvHwTimer(PMIDASCMD pCmd);
extern long dvHwGetChnLevels(PMIDASCMD pCmd);
extern long dvHwTimerPumpData(PMIDASCMD pCmd);
//extern long dvHwTimerSendData(PMIDASCMD pCmd);

extern void qInitQueue(PQUEUE pQ);
extern void qEnqueue(PQUEUE pQ,PMDS_DATA_BLOCK pMdb);
extern PMDS_DATA_BLOCK qDequeue(PQUEUE pQ);
extern PMDS_DATA_BLOCK qPeekqueue(PQUEUE pQ);
extern PMDS_DATA_BLOCK qFindAndDequeue(PQUEUE pQ,PMDS_DATA_BLOCK pMdb);
extern void qPurgeQueue(PQUEUE pQ,DWORD dwStatus);


//From Transfer.c
#define FLUSH_NORMAL  1	    //Video packet header with 00 data.
#define FLUSH_NULL    2	    //2048 bytes of 00
#define FLUSH_EOS     3	    //Video packet header with EOS marker.
#define FLUSH_PIPE    4	    //Don't send data just flush DMA or Bus Master buffers - send all data
#define FLUSH_DISCARD 5     //Discard all data in Bus Master buffers

extern void TransferInit(PHW pHw);
extern long TransferFlushPkt(PHW pHw, DWORD Type);
extern long TransferData(PHW pHw, BYTE *pData, DWORD Bytes, DWORD *pBytesSent, DWORD StrmType);

#endif
/**EOF: MIDAS.H**/
