//#include <StrmIni.h>
//#include <mmsystem.h>
//#include <KsMedia.h>
#include "system.h"
#include "Idents.h"
#include "MidasApi.h"
#include "dvhwMain.h"
#include "identcls.h"
#include "lsi64020.h"

#define ID(name) { name,#name }

struct IdentEntry_s IdentsHal[]= {
  { ID_HAL_ERR, 0 },
    { MDS_Success, "OK" },
  { ID_HAL_AUDTYPE, 0 },
    { AUD_MPEG, "MPEG" },
    { AUD_LPCM, "LPCM" },
    { AUD_AC3, "AC3" },
  { ID_HW_SIGNALSTD, 0},
    { PAL, "PAL" },
    { NTSC, "NTSC" },
  { ID_HAL_AUDRATE, 0 },
    { MDS_SR44_1, "44KHz" },
    { MDS_SR48_0, "48KHz" },
    { MDS_SR32_0, "32KHz" },
  { ID_HAL_ASPECT, 0 },
    { ASPECT_4x3, "4x3" },
    { ASPECT_16x9, "16x9" },
  { ID_HAL_AUDOUTPUT, 0 },
    { MDS_DAC, "DAC" },
    { MDS_IEC958, "IEC958" },
    { MDS_CD_BYPASS, "CD Bypass" },
  { ID_VIDOUT_MODE, 0 },
    { MDS_NORMAL_RECT, "NormalRect" },
    { MDS_PAN_SCAN, "PanScan" },
    { MDS_LETTER_BOX, "LetterBox" },
  { ID_KARAOKE_MODE, 0 },
    { KARAOKE_NO_VOCAL, "No Vocal" },
    { KARAOKE_VOCAL1, "Vocal1 Only" },
    { KARAOKE_VOCAL2, "Vocal2 Only" },
    { KARAOKE_VOCAL12, "Vocal1 + Vocal2" },
  { ID_AC3_DOWNMIX, 0 },
    { CONVENTIONAL_MIX, "Conventional Stereo Mix" },
    { DOLBY_SORROUND_MIX, "Dolby Sorround Mix" },
#if 0
  { ID_HAL_VIDTYPE, 0 },
    { MDS_ELEMENTARY, "Elementary" },
    { MDS_PES, "PES" },
    { MDS_MPEG, "MPEG" },
    { MDS_DVD, "DVD" },
#endif
  { ID_HAL_VIDFORMAT, 0 },
    { MDS_DISPLAY_NTSC_720, "NTSC 720" },
    { MDS_DISPLAY_NTSC_704, "NTSC 704" },
    { MDS_DISPLAY_PAL_720, "PAL 720" },
    { MDS_DISPLAY_PAL_704, "PAL 704" },
  { ID_HAL_PLAYMODE, 0 },
    { MDS_PLAY_NORMAL, "Normal" },
    { MDS_PLAY_FASTFORWARD, "FastForward" },
    { MDS_PLAY_FFASTFORWARD, "FFastForward" },
  { ID_HAL_STEREO, 0 },
    { MDS_SM_STEREO, "Full stereo" },
    { MDS_SM_RIGHT, "Mono right" },
    { MDS_SM_LEFT, "Mono left" },
  { ID_HAL_KARAOKE, 0 },
    { MDS_KM_OFF, "Off" },
    { MDS_KM_NO_VOCAL, "No vocals" },
    { MDS_KM_VOCAL1, "Vocal1" },
    { MDS_KM_VOCAL2, "Vocal2" },
    { MDS_KM_VOCAL1_2, "Vocal 1 & 2" },
  { ID_HAL_EVENT, 0 },
    { MDS_EVENT_VIDEO_ERROR, "Video Error" },
    { MDS_EVENT_AUDIO_ERROR, "Audio Error" },
    { MDS_EVENT_PACK_DATA, "Pack Data" },
    { MDS_EVENT_VIDEO_PES, "Video PES" },
    { MDS_EVENT_AUDIO_PES, "Audio PES" },
    { MDS_EVENT_SPU_PES, "SPU PES" },
    { MDS_EVENT_VBI_PES, "VBI PES" },
    { MDS_EVENT_DSI_PES, "DSI PES" },
    { MDS_EVENT_VIDEO_PTS, "Video PTS" },
    { MDS_EVENT_AUDIO_PTS, "Audio PTS" },
    { MDS_EVENT_SEQUENCE_LAYER, "Sequence Layer" },
    { MDS_EVENT_GOP_LAYER, "GOP Layer" },
    { MDS_EVENT_PICTURE_LAYER, "Picture Layer" },
    { MDS_EVENT_EXT_SEQUENCE, "Ext Sequence" },
    { MDS_EVENT_EXT_DISPLAY, "Ext Display" },
    { MDS_EVENT_EXT_QUANT_MATRIX, "Ext Quantizer matrix" },
    { MDS_EVENT_EXT_PAN_SCAN, "Ext Pan & Scan" },
    { MDS_EVENT_EXT_PICTURE_CODING, "Ext Picture Coding" },
    { MDS_EVENT_EXT_COPYRIGHT, "Ext Copyright" },
    { MDS_EVENT_CLOSE_CAPTION, "CloseCaption" },
    { MDS_EVENT_USER_DATA, "UserData" },
#if(0)
  { ID_STRM_REQ, 0},
    { SRB_READ_DATA,             "SRB_READ_DATA"},
    { SRB_WRITE_DATA,            "SRB_WRITE_DATA"},
    { SRB_GET_STREAM_STATE,      "SRB_GET_STREAM_STATE"},
    { SRB_SET_STREAM_STATE,      "SRB_SET_STREAM_STATE"},
    { SRB_SET_STREAM_PROPERTY,   "SRB_SET_STREAM_PROPERTY"},
    { SRB_GET_STREAM_PROPERTY,   "SRB_GET_STREAM_PROPERTY"},
    { SRB_OPEN_MASTER_CLOCK,     "SRB_OPEN_MASTER_CLOCK"},
    { SRB_INDICATE_MASTER_CLOCK, "SRB_INDICATE_MASTER_CLOCK"},
    { SRB_UNKNOWN_STREAM_COMMAND,"SRB_UNKNOWN_STREAM_COMMAND"},
    { SRB_SET_STREAM_RATE,       "SRB_SET_STREAM_RATE"},
    { SRB_PROPOSE_DATA_FORMAT,   "SRB_PROPOSE_DATA_FORMAT"},
    { SRB_CLOSE_MASTER_CLOCK,    "SRB_CLOSE_MASTER_CLOCK"},
    { SRB_PROPOSE_STREAM_RATE,   "SRB_PROPOSE_STREAM_RATE"},
    { SRB_SET_DATA_FORMAT,       "SRB_SET_DATA_FORMAT"},
    { SRB_GET_DATA_FORMAT,       "SRB_GET_DATA_FORMAT"},
    { SRB_GET_STREAM_INFO,       "SRB_GET_STREAM_INFO"},
    { SRB_OPEN_STREAM,           "SRB_OPEN_STREAM"},
    { SRB_CLOSE_STREAM,          "SRB_CLOSE_STREAM"},
    { SRB_OPEN_DEVICE_INSTANCE,  "SRB_OPEN_DEVICE_INSTANCE"},
    { SRB_CLOSE_DEVICE_INSTANCE, "SRB_CLOSE_DEVICE_INSTANCE"},
    { SRB_GET_DEVICE_PROPERTY,   "SRB_GET_DEVICE_PROPERTY"},
    { SRB_SET_DEVICE_PROPERTY,   "SRB_SET_DEVICE_PROPERTY"},
    { SRB_INITIALIZE_DEVICE,     "SRB_INITIALIZE_DEVICE"},
    { SRB_CHANGE_POWER_STATE,    "SRB_CHANGE_POWER_STATE"},
    { SRB_UNINITIALIZE_DEVICE,   "SRB_UNINITIALIZE_DEVICE"},
    { SRB_UNKNOWN_DEVICE_COMMAND,"SRB_UNKNOWN_DEVICE_COMMAND"},
    { SRB_PAGING_OUT_DRIVER,     "SRB_PAGING_OUT_DRIVER"},
    { SRB_GET_DATA_INTERSECTION, "SRB_GET_DATA_INTERSECTION"},
    { SRB_INITIALIZATION_COMPLETE,"SRB_INITIALIZATION_COMPLETE" },
    { SRB_BEGIN_FLUSH, "SRB_BEGIN_FLUSH" },
    { SRB_END_FLUSH, "SRB_END_FLUSH" },
#endif
  { ID_HALCMD, 0 },
    ID(MDS_INITDRIVER),
//    ID(MDS_GETDATASIZE),
    ID(MDS_LOCATE_HARDWARE),
    ID(MDS_LOCATE_DMA),
    ID(MDS_INSTALLDEVICE),
    ID(MDS_UNINSTALLDEVICE),
    ID(MDS_RESET),
    ID(MDS_GETREVISION),
    ID(MDS_INITIALIZEVIDEO),
    ID(MDS_INITIALIZEAUDIO),
    ID(MDS_INITIALIZESUB),
    ID(MDS_PLAY),
    ID(MDS_STOP),
    ID(MDS_PAUSE),
    ID(MDS_TESTHW),
    ID(MDS_SETVIDEOID),
    ID(MDS_SETAUDIOID),
    ID(MDS_SETSUBID),
    ID(MDS_KARAOKEMODE),
    ID(MDS_FLUSH),
    ID(MDS_FLUSH_END),
    ID(MDS_ISR),
    ID(MDS_ISRCOMPLETE),
    ID(MDS_REGISTEREVENT),
    ID(MDS_UNREGISTEREVENT),
    ID(MDS_SP_COMPOSITEON),
    ID(MDS_SP_HIGHLIGHT),
    ID(MDS_SP_PALETTE),
//    ID(MDS_SENDDATA),
    ID(MDS_TIMER),
    ID(MDS_MASTERCLOCK),
    ID(MDS_SETTVOUT),
//    ID(MDS_VIDOUTMODE),
    ID(MDS_SETRATE),
    ID(MDS_GETRATE),
    ID(MDS_GETMAXRATE),
    ID(MDS_VPEINFO),
    ID(MDS_CSS_INITHW),
    ID(MDS_CSS_SYNCTITLE),
    ID(MDS_CSS_GETCHALLENGE),
    ID(MDS_CSS_GETRESPONSE),
    ID(MDS_CSS_SETCHALLENGE),
    ID(MDS_CSS_SETRESPONSE),
    ID(MDS_CSS_SETTITLE),
    ID(MDS_CSS_SETDISCKEY),
    ID(MDS_CSS_GETREGIONCODE),
    ID(MDS_GET_STREAM_TIME),
#if(0)
  { ID_CLOCKCMD, 0 },
    ID(TIME_GET_STREAM_TIME),
    ID(TIME_READ_ONBOARD_CLOCK),
    ID(TIME_SET_ONBOARD_CLOCK),
#endif
  { ID_STRM, 0 },
    { STRM_VID, "video" },
    { STRM_AUD, "audio" },
    { STRM_SUB, "subpicture" },
#if(0)
  { ID_SRBOPT, 0 },
    { KSSTREAM_HEADER_OPTIONSF_SPLICEPOINT, "SplicePoint" },
    { KSSTREAM_HEADER_OPTIONSF_PREROLL, "Preroll" },
    { KSSTREAM_HEADER_OPTIONSF_DATADISCONTINUITY, "DataDiscontinuity" },
    { KSSTREAM_HEADER_OPTIONSF_TYPECHANGED, "TypeChanged" },
    { KSSTREAM_HEADER_OPTIONSF_TIMEVALID, "TimeValid" },
    { KSSTREAM_HEADER_OPTIONSF_TIMEDISCONTINUITY, "TimeDiscontinuity" },
    { KSSTREAM_HEADER_OPTIONSF_FLUSHONPAUSE, "FlushOnPause" },
    { KSSTREAM_HEADER_OPTIONSF_DURATIONVALID, "DurationValid" },
    { KSSTREAM_HEADER_OPTIONSF_ENDOFSTREAM, "EndOfSteam" },
    { KSSTREAM_HEADER_OPTIONSF_LOOPEDDATA, "LoopedData" },
#endif
  { 0,0 }
};

/** EOF: IDENTLST.C**/
