/**************************************************************************
 * Copyright (c) 1995, 2006 MARGI Systems, Inc.
 *                                                                        
 *$History: Idents.c $
 * 
 * *****************  Version 23  *****************
 * User: Viraf        Date: 3/01/04    Time: 4:40p
 * Updated in $/Dvd/AutoDVD/mdvdhdrv
 * No change
 * 
 * *****************  Version 22  *****************
 * User: Viraf           Date: 11/16/01  Time: 11:59a
 * Checked in $/Dvd/AutoDVD/Navigator
 * 
 * *****************  Version 21  *****************
 * User: Viraf           Date: 10/18/99  Time:  3:28p
 * Checked in $/Dvd/DvdToGo/NewModel/MDvdHDrv
 * 
 * *****************  Version 20  *****************
 * User: Viraf           Date:  3/22/99  Time: 10:35a
 * Checked in $/Dvd/DvdToGo/Win95/Navigator
 * 
 * *****************  Version 19  *****************
 * User: John            Date:  1/22/99  Time:  9:29p
 * Checked in $/Dvd/WDM/Driver/Midas
 * * Fix problem re-entering Idents
 * 
 * *****************  Version 18  *****************
 * User: Ravi            Date: 12/03/98  Time:  3:38p
 * Checked in $/Dvd/WDM/Driver/Midas
 * * Rolling back
 * 
 * *****************  Version 17  *****************
 * User: Ravi            Date: 12/03/98  Time:  1:30p
 * Checked in $/Dvd/WDM/Driver/Midas
 * * nt5 changes. Doesnot affect the Win98 build.
 * 
 * *****************  Version 16  *****************
 * User: Chip2           Date: 10/19/98  Time:  4:13p
 * Checked in $/Dvd/WDM/Driver/Midas
 * * '0' values were not being printed.
 * 
 * *****************  Version 15  *****************
 * User: Chip-loki       Date: 10/12/98  Time: 11:15a
 * Checked in $/Dvd/WDM/Driver/Midas
 * * Fixing bug which prevented string output.
 * 
 * *****************  Version 14  *****************
 * User: Chip-loki       Date: 10/09/98  Time:  3:33p
 * Checked in $/Dvd/WDM/Driver/Midas
 * * Removing dependency on printf.c
 * 
 * *****************  Version 13  *****************
 * User: Shude           Date:  8/13/98  Time:  4:32p
 * Checked in $/VidCap/WDM/Common
 * * Compiling for WDM environment.
 * 
 * *****************  Version 12  *****************
 * User: Chip-loki       Date:  6/15/98  Time:  9:11p
 * Checked in $/Util/DbgMsg/DbgMsg51/Common
 * * Adding tag
 * 
 * *****************  Version 11  *****************
 * User: Chip2           Date:  6/15/98  Time: 10:54a
 * Checked in $/Util/DbgMsg/DbgMsg51/Common
 * * Fixed a benign bug in the way the OutStrings[] was being used.
 * (Compiler error?)
 * * Prevented a bad reference if someone passes in 0 as the dwID value.
 * 
 * *****************  Version 10  *****************
 * User: Chip-loki       Date:  5/12/98  Time:  2:59p
 * Checked in $/Util/DbgMsg/DbgMsg51/Common
 * * Removing LEAN_AND_MEAN, use project settings instead.
 * 
 * *****************  Version 9  *****************
 * User: Ravi            Date:  4/15/98  Time:  2:28p
 * Checked in $/Dvd/WDM/LSI/Midas
 * * Bug in Checking BADDDY pointers..
 * 
 * *****************  Version 8  *****************
 * User: Chip-loki       Date:  4/14/98  Time:  4:22p
 * Checked in $/Dvd/VSD/Common
 * * Adding GUID identifiers
 * 
 * *****************  Version 7  *****************
 * User: Chip-loki       Date:  2/09/98  Time:  4:37p
 * Checked in $/Dvd/VSD/Common
 * * Adding YESNO
 * * Fixed bug which skipped the first entry of each section.
 * 
 * *****************  Version 6  *****************
 * User: Chip-loki       Date:  2/04/98  Time: 12:33p
 * Checked in $/Dvd/VSD/Common
 * * Optimized identifier type lookups.
 * 
 * *****************  Version 5  *****************
 * User: Chip-loki       Date: 12/30/97  Time: 11:22a
 * Checked in $/Dvd/VSD/Vxd
 * * Adding ENABL
 * 
 * *****************  Version 4  *****************
 * User: Chip-modi       Date: 12/22/97  Time:  9:43a
 * Checked in $/Dvd/DmaVxd/App
 * * Fixed bug with boolean identifier types.
 * 
 * *****************  Version 3  *****************
 * User: Chip-modi       Date: 12/21/97  Time: 12:41a
 * Checked in $/Dvd/DmaVxd/Vxd
 * * Adding signed numbers
 * 
 * *****************  Version 2  *****************
 * User: Chip-loki       Date: 12/09/97  Time: 12:00p
 * Checked in $/Dvd/DmaVxd/App
 * * Removing extra includes
 * * Added comments for IdentAddClass().
 * 
 * *****************  Version 1  *****************
 * User: Chip-modi       Date: 12/08/97  Time: 12:10a
 * Created Idents.c
 * New version of Identifiers.c, includes ability to add new external
 * identifier lists.
 * 
 **************************************************************************/

//Remember to define __VXD__ in the CL command line for the VxD!!
#if defined (__VXD__) || defined (__WDM__)
  #include <BaseDef.h>
  #define ISBADPTR(p,l) (((DWORD)(p)) ? 0:1)
  //#define ISBADPTR(p,n) (((DWORD)(p)!=0) ? 1:0)
#elif defined (_WINDOWS)
  #include <Windows.h>
  #define ISBADPTR(p,n) IsBadReadPtr((void*)(p),n)
#else
  #include "system.h"
  #define ISBADPTR(p,l) (((DWORD)(p)) ? 0:1)
#endif

#include "Idents.h"

//08Dec97 Chip Doran
// NOTE: MAX_OUTSTRING must be 2^n
#define MAX_TABLE 64
#define OUTSTRING_LEN 256
#define MAX_OUTSTRING 4
#define MAX_INDEX 256
#define GUID_LEN 16

typedef struct IdentEntry_s *ENTRY;
typedef struct IdentIndex_s {
  DWORD IdentClass;
  ENTRY pEntry;
} *INDEX;

static BOOL IdentGuidCmp(BYTE *pG1, BYTE *pG2);

static struct IdentEntry_s IdentStandards[]= {
  { ID_WAS, 0},
    { 0, "was not" },
    { 1, "was" },
  { ID_IS, 0 },
    { 0, "is not" },
    { 1, "is" },
  { ID_WERE, 0 },
    { 0, "were not" },
    { 1, "were" },
  { ID_TRUE, 0 },
    { 0, "false" },
    { 1, "true" },
  { ID_ON, 0 },
    { 0, "off" },
    { 1, "on" },
  { ID_ENABL, 0 },
    { 0, "disabl" },
    { 1, "enabl" },
  { ID_YESNO, 0 },
    { 0, "no" },
    { 1, "yes" },
  { ID_MONTH, 0 },
    { 0, "Jan" },
    { 1, "Feb" },
    { 2, "Mar" },
    { 3, "Apr" },
    { 4, "May" },
    { 5, "Jun" },
    { 6, "Jul" },
    { 7, "Aug" },
    { 8, "Sep" },
    { 9, "Oct" },
    { 10, "Nov" },
    { 11, "Dec" },
  { ID_DAYOFWEEK, 0 },
    { 0, "Sun" },
    { 1, "Mon" },
    { 2, "Tue" },
    { 3, "Wed" },
    { 4, "Thu" },
    { 5, "Fri" },
    { 6, "Sat" },
  { 0,0 }
};

static char *IdentStr(char *pDst, char *pSrc);
static char *IdentHex(char *pDst, WORD Zeroes, DWORD Val);
static char *IdentDec(char *pDst, long Val);

static char OutBuffers[MAX_OUTSTRING*OUTSTRING_LEN];
static char *OutStrings[MAX_OUTSTRING];
static struct IdentEntry_s *IdentList[MAX_TABLE];
static BYTE InitDone;
static BYTE CurOutString;
static DWORD LastIndex;
static struct IdentIndex_s IdentIndex[MAX_INDEX+1];   //Leave last one zeroed

/*************************************************************************/
/** EntryList points to an array of IdentEntry_s entries, using the     **/
/** following format:                                                   **/
/** struct IdentEntry_s IdentifiersMyIds[]= {                           **/
/**   { ID_MYTYPE, 0 },       //0 indicates beginning of type block     **/
/**     { MYCONSTANT, "MyConstantName" },                               **/
/**     { MYOTHERCONSTANT, "MyOtherConstantName" },                     **/
/**   { ID_MYOTHERTYPE, 0 },  //Beginning of next type block            **/
/**     { MYOTHERTYPE, "MyOtherTypeConstantName" },                     **/
/**   { 0,0 }                 //0,0 terminates list                     **/
/*************************************************************************/
static long IdentInit(void) {
  long Err= 0;
  DWORD n1;
  if(!InitDone) {
    InitDone= 1;
    for(n1=0;n1<MAX_OUTSTRING;n1++)
      OutStrings[n1]= &OutBuffers[n1*OUTSTRING_LEN];
    IdentAddClass(IdentStandards);
  }
  return(Err);
}

long __stdcall IdentAddClass(struct IdentEntry_s *EntryList) {
  DWORD nTable,nList;
  long Err= -1;
  if(!InitDone)
    IdentInit();
  for(nTable=0;nTable<MAX_TABLE && IdentList[nTable];nTable++);
  if(nTable<MAX_TABLE) {
    IdentList[nTable]= EntryList;
    for(nList=0;LastIndex<MAX_INDEX && EntryList[nList].dID;) {
      IdentIndex[LastIndex].IdentClass= EntryList[nList].dID;
      IdentIndex[LastIndex].pEntry= &EntryList[nList+1];
      LastIndex++;
      while(EntryList[++nList].sTxt);
    }
    Err= 0;
  }
  return(Err);
}

char* __stdcall Ident(DWORD dType, DWORD dID) {
  char *pDst;
  INDEX pIndex;
  ENTRY pID= 0;
  DWORD dListType=0;
  BYTE  bOutString;
  dType&= 0xFFFF;
  if(!InitDone)
    IdentInit();
  bOutString=CurOutString++;
  bOutString&=(MAX_OUTSTRING-1);

  pDst= OutStrings[bOutString];
  for(pIndex=IdentIndex;pIndex->pEntry && LOWORD(pIndex->IdentClass)!=LOWORD(dType);pIndex++);
  if(!pIndex->pEntry) {
    pDst= IdentHex(pDst,1,dID);
    pDst= IdentStr(pDst,":UNK Type");
  } else {
    dListType= pIndex->IdentClass;
    pID= pIndex->pEntry;
    if(dListType & ID_BOOL) {
      if(dID)
        dID= 1;
      dListType= ID_DECIMAL;
    }
    if(dListType & ID_BITFIELD) {
      if(!(pID->dID & ID_NONUM)) {
	pDst= IdentHex(pDst,1,dID);
	*pDst++= ':';
      }
      for(pID++;pID->sTxt;pID++) {
        if(pID->dID & dID) {
	  *pDst++= ' ';
	  pDst= IdentStr(pDst,pID->sTxt);
	}
      }
    } else if(dListType & ID_GUID) {
      if(ISBADPTR(dID,GUID_LEN)) {
	pDst= IdentHex(pDst,0,dID);
	pDst= IdentStr(pDst,":BADPTR");
      } else {
        for(;pID->sTxt && !IdentGuidCmp((BYTE*)pID->dID,(BYTE*)dID);pID++);
        if(pID->sTxt) {
	  pDst= IdentStr(pDst,pID->sTxt);
	} else {
	  pDst= IdentHex(pDst,0,*(DWORD*)dID);
	  pDst= IdentStr(pDst,":UNK");
	}
      }
    } else {
      for(;pID->sTxt && pID->dID!=dID;pID++);
      if(pID->sTxt) {
        if(dListType & ID_NONUM) {
	  pDst= IdentStr(pDst,pID->sTxt);
        } else if(dListType & ID_DECIMAL) {
	  pDst= IdentDec(pDst,dID);
	  *pDst++= ':';
	  pDst= IdentStr(pDst,pID->sTxt);
        } else {
	  pDst= IdentHex(pDst,0,dID);
	  *pDst++= ':';
	  pDst= IdentStr(pDst,pID->sTxt);
        }
      } else {
	pDst= IdentHex(pDst,1,dID);
	pDst= IdentStr(pDst,":UNK");
      }
    }
  }
  *pDst= 0;
  return(OutStrings[bOutString++]);
}

static BOOL IdentGuidCmp(BYTE *pG1, BYTE *pG2) {
  DWORD n1;
  for(n1=0;n1<GUID_LEN && pG1[n1]==pG2[n1];n1++);
  return((BOOL)(n1>=GUID_LEN));
}

static char *IdentStr(char *pDst, char *pSrc) {
  if(pSrc && pDst) {
    while(*pSrc)
      *pDst++= *pSrc++;
  }
  return(pDst);
}

static char *IdentHex(char *pDst, WORD Zeroes, DWORD Val) {
  static char HexDigits[]= {"0123456789ABCDEF"};
  BYTE Digit,Shifts= 32;
  while(Shifts) {
    Shifts-= 4;
    Digit= (BYTE)((Val>>Shifts) & 0x0F);
    if(Digit || Zeroes) {
      *pDst++= HexDigits[Digit];
      Zeroes= 1;
    }
  }
  if(!Zeroes)
    *pDst++= '0';
  return(pDst);
}

static char *IdentDec(char *pDst, long Val) {
  BYTE Digits,Digit,Zeroes=0;
  static long Powers[]= { 
    1000000000,
    100000000,
    10000000,
    1000000,
    100000,
    10000,
    1000,
    100,
    10,
    1,
    0
  };
  if(Val<0) {
    *pDst++= '-';
    Val= -Val;
  }
  for(Digits=0;Powers[Digits];Digits++) {
    Digit= (BYTE)(Val/Powers[Digits]);
    Val= Val%Powers[Digits];
    if(Digit || Zeroes) {
      *pDst++= (char)(Digit+'0');
      Zeroes= 1;
    }
  }
  if(!Zeroes)
    *pDst++= '0';
  return(pDst);
}

/**EOF: IDENTS.C**/
