#ifndef __ININAMES_H__
#define __ININAMES_H__ 0x0200

#ifdef ININAMES_CODE
#define INIENTRY(Name,Text) char Name[]= { Text }
#else
#define INIENTRY(Name,Text) extern char Name[]
#endif

#include "mdsnames.h"

INIENTRY(IniMdsFName,"DVD-to-Go\\Midas");

//INIENTRY(IniFileNameDvd,"DVD-to-Go");

INIENTRY(IniMdsSection,"HwDec");
INIENTRY(IniTvSection,"Settings");
//INIENTRY(IniInstalling,"Installing");
//INIENTRY(IniPciVgaID,"PciVgaID");
//INIENTRY(IniPanicMode,"PanicMode");
//INIENTRY(IniIsaIoAddr,"MidasIo");
INIENTRY(IniPcmciaIoAddr,"PCMCIAIo");
//INIENTRY(IniPciVgaPhysAddr,"PciVgaPhysAddr");		//Bypass PCI device scan, use this physical address.
INIENTRY(IniSWOnly,"SWOnly");				//To enable software only support
INIENTRY(IniColorBarsOnly,"ColorBarsOnly");		//Set Encoder so that it outputs ColorBars Always
//INIENTRY(IniMarginOR,"MarginOR");
INIENTRY(IniMargin,"Margin");
//INIENTRY(IniTimerThreshold,"TimerThreshold");
//INIENTRY(IniTimerPeriod,"TimerPeriod");
//INIENTRY(IniDataSendMaxTime,"DataSendMaxTime");		//Maximum time spent in data send loop.
INIENTRY(IniAutostartDelay,"AutostartDelay");		//Difference between minimum PTS and programmed SCR in 90KHz ticks.
//INIENTRY(IniCropTop,"CropTop");
INIENTRY(IniInvertClock,"InvertClock");                //=1 inverts the pixel clock.
INIENTRY(IniUseSCRforMasterClock,"UseSCRforMasterClock");  //=1; return SCR value as the Stream Time to the Stream Class Drivers
INIENTRY(IniAudChnlSpacePad,"AudChnlSpacePad");		//Extra padding required before transferring audio data. (4096)
INIENTRY(IniVidChnlSpacePad,"VidChnlSpacePad");		//Extra padding required before transferring video data. (16384)
INIENTRY(IniSubChnlSpacePad,"SubChnlSpacePad");		//Extra padding reuqired before transferring subpicture data. (2048)

INIENTRY(IniSectionSync,"Sync");
INIENTRY(IniSyncCaptureVid,"VidCapture");		//Enable capturing video SCR (1)
INIENTRY(IniSyncCaptureAud,"AudCapture");		//Enable capturing audio SCR (1)
INIENTRY(IniSyncVideo,"VideoSync");			//Enable video sync (1)
INIENTRY(IniSyncAudio,"AudioSync");			//Enable audio sync (1)
INIENTRY(IniSyncDumps,"Dumps");				//Enable period sync info dumps (0)
INIENTRY(IniSyncDumpStats,"DumpStats");			//Dump sync statistics. (0)
INIENTRY(IniSyncDumpTable,"DumpTable");			//Dump contents of sync tables. (0)
INIENTRY(IniSyncDumpEntries,"DumpEntries");		//Dump each entry in the sync table. (0)
INIENTRY(IniSyncDumpPeriod,"DumpPeriod");		//mSec between periodic table dumps. If 0, dump tables on timer event.
INIENTRY(IniSyncVideoChk,"VidChk");			//Enable video sync drift calculations (1)
INIENTRY(IniSyncAudioChk,"AudChk");			//Enable audio sync drift calculations (1)
INIENTRY(IniSyncVidAdjustEnable,"VidAdjustEnable");	//Enable video sync adjustments (1)
INIENTRY(IniSyncAudAdjustEnable,"AudAdjustEnable");	//Enable audio sync adjustments (0)
INIENTRY(IniSyncAudToleranceGross,"AudToleranceGross");	//Audio drift tolerance beyond which drift corrections commence. (10ms)
INIENTRY(IniSyncAudToleranceFine,"AudToleranceFine");	//Once drift correction has commenced, this tolerance is used to finish it. (1ms)
INIENTRY(IniSyncVidToleranceGross,"VidToleranceGross");	//Video drift tolerance beyond which drift corrections commence. (100ms)
INIENTRY(IniSyncVidToleranceFreeze,"VidToleranceFreeze");//Video drift tolerance beyond which drift corrections are made by freezing multiple frames. (400ms)
INIENTRY(IniSyncVidMaxFreeze,"VidMaxFreeze");		//Maximum freeze time (1000ms)
INIENTRY(IniSyncVidToleranceFine,"VidToleranceFine");	//Once drift correction has commenced, this tolerance is used to finish it. (30ms)
INIENTRY(IniSyncMaxTolerance,"MaxTolerance");		//If drift is greater than this (ms), don't try to correct. (0=no limit) (0)
INIENTRY(IniSyncMinAdjustPeriod,"MinAdjustPeriod");	//Minimum elapsed time between adjustments (500ms)
INIENTRY(IniSyncAdjHoldoff,"AdjHoldoff");		//Min elapsed time since autostart completion before sync adjustments allowed. (5000ms)
INIENTRY(IniSyncVidInSyncErrorPersistence, "VidInSyncErrorPersistence"); //Min elapsed time with out of tolerance drift before adjustments allowed.
INIENTRY(IniSyncVidOutSyncErrorPersistence,"VidOutSyncErrorPersistence");//Min elapsed time with out of tolerance drift before adjustments allowed.
INIENTRY(IniSyncAudInSyncErrorPersistence, "AudInSyncErrorPersistence"); //Min elapsed time with out of tolerance drift before adjustments allowed.
INIENTRY(IniSyncAudOutSyncErrorPersistence,"AudOutSyncErrorPersistence");//Min elapsed time with out of tolerance drift before adjustments allowed.
INIENTRY(IniSyncPlotChannels,"PlotChannels");		//1= plot current read and write channel pointers to DbgMsg profiler.
INIENTRY(IniSyncAudDelay,"AudDelay");			//Fudge factor to bump audio PTS value. (0ms)
INIENTRY(IniSyncVidDelay,"VidDelay");			//Fudge factor to bump video PTS value. (0ms)
INIENTRY(IniSyncDtsReorder,"DtsReorder");		//Enable PTS->DTS frame reordering. (0)
INIENTRY(IniSyncVidReadFifo,"VidReadFifo");		//Size of video read FIFO (64*8 bytes)
INIENTRY(IniSyncVidPktUncertainty,"VidPktUncertainty");	//When PTS found in FIFO uncertainty, drift must be greater than this to trigger correction. (41ms)
INIENTRY(IniSyncAudReadFifo,"AudReadFifo");		//Size of audio read FIFO (6*8 bytes)
INIENTRY(IniSyncAudPktUncertainty,"AudPktUncertainty");	//When PTS found in FIFO uncertainty, drift must be greater than this to trigger correction. (2ms)
INIENTRY(IniSyncSubAdjustEnable,"SubAdjustEnable");	//Enable subpicture sync adjustments (0)

//INIENTRY(IniSectionDbgMsg,"DbgMsg");
//INIENTRY(IniDbgMsg,"DbgMsg");
//INIENTRY(IniDbgFilter,"DbgMsgFilter");

//INIENTRY(IniTempKey,    "TempSettings");
//INIENTRY(IniMdsSettingsKey,"Settings");
//INIENTRY(IniModified,   "modified");
//INIENTRY(IniMixmode,    "mixmode");
//INIENTRY(IniSpdiffmode, "spdiffmode");
//INIENTRY(IniSpdiffout,  "spdiffout");
//INIENTRY(IniTvTest,     "TvTest");
//INIENTRY(IniTvOutput,   "vomode");
//INIENTRY(IniTvLumaOffset,"voluma");
//INIENTRY(IniTvLumaGain, "TvLumaGain");
//INIENTRY(IniTvChroma,   "vochroma");
//INIENTRY(IniTvHue,      "vohue");
//INIENTRY(IniTvNtscScSynth,"TvNtscScSynth");
//INIENTRY(IniTvPalScSynth, "TvPALScSynth");
//INIENTRY(IniTvNtscScAmp,  "TvNTSCScAmp");
//INIENTRY(IniTvPalScAmp,   "TvPALScAmp");


//INIENTRY(IniVomode,"vomode");
//INIENTRY(IniVoluma,"voluma");
//INIENTRY(IniVochroma,"vochroma");
//INIENTRY(IniVohue,"vohue");
//INIENTRY(IniCorrectenable,"correctenable");
//INIENTRY(IniScrncontrast,"screencontrast");
//INIENTRY(IniScrnbrightness,"scrnbrightnes");
//INIENTRY(IniScrngamma,"scrngamma");
//INIENTRY(IniVideomode,"videomode");
//INIENTRY(IniSectionTempsettings,"TempSettings");			
//INIENTRY(IniVOVolume,"Volume");			
//INIENTRY(IniVOMute,"Mute");			

//INIENTRY(IniDisplayMode,"DisplayMode");			
//INIENTRY(IniKaraokeMode,"KaraokeMode");

#endif
/**EOF: ININAMES.C**/
