//#include <Conio.h>
//#include <StrmIni.h>
//#include <mmsystem.h>
//#include <KsMedia.h>
#include "system.h"

#include "DbgMsg.h"
#include "DbgFltr.h"
#include "Idents.h"
#include "margierr.h"
#include "Settings.h"
#include "DeviceID.h"

#include "MidasApi.h"
#include "dvHwMain.h"
#include "Global.h"
#include "IniNames.h"
//#include "Pci.h"
#include "dvHwAud.h"
#include "tvout.h"

#define DBGINIT_INIT  0x0001
#define DBGINIT_FINI  0x0002
#define DBGINIT_DRV   0x0004
#define DBGINIT_DEV   0x0008

struct Option_s Opt;
DWORD fSWOnly= 0;
//DWORD gdwIoAddrInit;
//DWORD gdwMemAddrInit;

#ifdef _NEC_		// this needs to be removed anyhow.
/* IANM 980429 DEBUGGING ONLY */
extern void* gpMidasUI;
#endif
extern int   gfResetTime;

static DVHW DfltDevice;

//This gets called during the driver load, very early during system boot.
//BEWARE: The IFS file system is not yet stable! Defer file logging until
//device initialization, which will occur much later when a stream is actually
//opened.
long hwDriverInit(BOOL fInit, PMIDASCMD pCmd)
{
  static BYTE fInitDone;
  static BYTE bNumOfTries = 0;
  long lErr= 0;
  PHW pHw= pCmd->hMidas;
  if(pHw == NULL && !fInit)
    return MARGI_ERR_ARG2;
  SettingFName(IniMdsFName,IniMdsSection);
  if(fInit)
  {
    Opt.AutostartDelay= SettingLoad(SET_DWORD,IniAutostartDelay,0,2);
    Opt.ColorBarsOnly= (BYTE)SettingLoad(SET_DWORD,IniColorBarsOnly,0,0);
    if(Opt.ColorBarsOnly)
      DbgMsg(DBG_SET,"Encoder Outputs Only ColorBars \r\n");
    Opt.fUseSCRforMasterClock= (BYTE)SettingLoad(SET_DWORD,IniUseSCRforMasterClock,0,1);
    Opt.dwInvertClock= (DWORD)SettingLoad(SET_DWORD,IniInvertClock,0,0);
    if(fSWOnly= SettingLoad(SET_DWORD,IniSWOnly,0,fSWOnly))
      DbgMsg(DBG_CRIT,"Using Software Only support\r\n");
    if(!fInitDone)
    {
      DbgMsg(DBG_CRIT,"Midas: Driver Init.\r\n");
      fInitDone= 1;
    }
    else
      DbgMsg(DBG_WRN,"Extraneous call to MDS_InitDriver(INIT).\r\n");
  }
  else
  {
    DWORD dwTimeReg;
    if(fInitDone)
    {
      while(pHw->fWrEEPROMInProgress)  // Midas is having data to be written to the EEPROM.
      {
        dwTimeReg = MargiGetTime();
        for(;(MargiGetTime()-dwTimeReg)>20;);           // wait for 20ms
        if(pHw->dwTmrRunIndicator != pHw->dwIsrCntr)  // indicates the timer is happening and the dwIsrCntr is rolling
        {
          pHw->dwTmrRunIndicator = pHw->dwIsrCntr;    // log the new to do the test next time
          bNumOfTries = 0;
        }
        else if(bNumOfTries >= 150)   // indicates that the timer is not running so no point in waiting for the flag
          pHw->fWrEEPROMInProgress = 0;   // waits for 250*20ms = 5sec
        else 
          bNumOfTries++;
      }
      bNumOfTries = 0;
      DbgMsg(DBG_HWINIT,"Shutting down Midas driver.\r\n");
      fInitDone= 0;
    }
    else
      DbgMsg(DBG_WRN,"Extraneous call to MDS_InitDriver(FINI).\r\n");
  }
  return lErr;
}


//This gets called very early on, before anything is initialized.
//DWORD hwGetDataSize(void) {
//  DWORD nDataSize= sizeof(DVHW);
//  return(nDataSize);
//}

//This gets called to check whether the hardware is present.
//If the hardware is present, be sure to power it back down
//before returning. This does not initialize the hardware!
//Because no one knows how to enumerate daughter cards, we're going to 
//go find a board we can run on for now.
long hwLocateHardware(PMIDASCMD pCmd) {
  long Err= MARGI_ERR_HW_NOTFOUND;
  DbgMsg(DBG_HWINIT,"MDS_ChkDevice()\r\n");
//  gdwIoAddrInit=0;
//  gdwMemAddrInit=0;
  pCmd->hMidas=0;
  if(Err= dvHwMainConstruct(&DfltDevice,pCmd->u.HwResource)) {
    DbgMsg(DBG_HWERR,"Unable to initialize default device hMidas.\r\n");
  } else {
    if(Err= dvHwMainDetect(&DfltDevice)) {
      DbgMsg(DBG_HWERR,"No Midas hardware found.\r\n");
    } else {
      DbgMsg(DBG_HWINIT,"Midas hardware found.\r\n");
      dvHwMainDeviceShutdown(&DfltDevice);
//      dvHwMainDestruct(&DfltDevice);
      pCmd->hMidas=&DfltDevice;   // Use static instance - we probably will never support multiple decoders
      Err= 0;
    }
  }
#ifdef _NEC_
  /* IANM 980429 -- GIVE THE UI A POINTER TO MIDAS */
  gpMidasUI = pCmd->hMidas;
  gfResetTime=1;
#endif  
  return(Err);
}

long hwLocateHardDma(PMIDASCMD pCmd) {
  long Err= 0;
  PMDS_HW_RESOURCE pRsrc;    
  pRsrc = pCmd->u.HwResource;

  if(pRsrc->dwFlags&1) {
      // Setup I/O base address - this must be present and is used for reg i/o
    DfltDevice.dwChnAddr = DfltDevice.dwIoAddr+4; // channel xfr uses i/o this may be changed to mem in dvHwMainDetectPcmcia
    DfltDevice.fUseDMA=0;
  }     
  if(pRsrc->dwFlags&4) {
      // Setup DMA resource for channel data - dlMemBaseAddr is used as reference for DMA Handler
    DfltDevice.dwChnAddr = DfltDevice.dwDMAAddr;
    DfltDevice.fUseDMA=1;
  }
  else if(pRsrc->dwFlags&2) {
      // Setup Mem Address for channel data
    DfltDevice.dwChnAddr = DfltDevice.dwMemAddr+8; // channel xfr uses i/o this may be changed to mem in dvHwMainDetectPcmcia
    DfltDevice.fUseDMA=0;
  }

  if(pRsrc->pfnChnWrWords)
      DfltDevice.pfnChnWrWords = pRsrc->pfnChnWrWords;
  else
      DfltDevice.pfnChnWrWords = 0;

  return (Err);
}

//This gets called when the device needs to be powered up,
//shortly before it actually gets used.
//It should now be safe to use the IFS for file logging.
long hwDeviceInit(BOOL fInit, PHW pHw) {
  long Err= 0;
  if(fInit) {
    DbgMsg(DBG_HWINIT,"MDS_DeviceInit(INIT)\r\n");
//    if(Err= dvHwMainConstruct(pHw,gdwIoAddrInit,gdwMemAddrInit)) {
//      DbgMsg(DBG_HWERR,"hwDeviceInit: Unable to initialize device hMidas.\r\n");
//    } else 
    if(Err= dvHwMainDetect(pHw)) {
      DbgMsg(DBG_HWERR,"hwDeviceInit: Unable to detect Midas hardware.\r\n");
    } else if(Err= dvHwMainDeviceInit(pHw)) {
      DbgMsg(DBG_HWERR,"hwDeviceInit: Unable to initialize Midas hardware.\r\n");
    } else {
      DbgMsg(DBG_CRIT,"Scenario: Midas hardware detected.\r\n");
      hwReadControlPanelConfig(pHw);
    }
  } else {
    DbgMsg(DBG_HWINIT,"MDS_DeviceInit(FINI)\r\n");
    Err= dvHwMainDeviceShutdown(pHw);
    hwWriteControlPanelConfig(pHw);
//    dvHwMainDestruct(pHw);
  }
  DbgMsg(DBG_HWINIT,"MDS_Initialize(%d) returns %s.\r\n",fInit,Ident(ID_MARGIERRORS,Err));
  return(Err);
}

void hwReadControlPanelConfig(PHW pHw) {
  SettingFName(IniFName,IniSettingsKey);
  DbgMsg(DBG_CP_SET,"CP: Reading config from %s/%s reg key\r\n",IniFName,IniSettingsKey);

  pHw->AC3MixMode= SettingLoad(SET_DWORD,IniMixmode,0,0);
  pHw->dwSpDiffMode= SettingLoad(SET_DWORD,IniSpdiffmode,0,0);
  pHw->dwSpDiffOut= SettingLoad(SET_DWORD,IniSpdiffout,0,1);
  pHw->dwVolume= SettingLoad(SET_DWORD,IniVOVolume,0,100);
  pHw->dwMute= SettingLoad(SET_DWORD,IniVOMute,0,0);
//  pHw->dwVidDispFormatPreference=SettingLoad(SET_DWORD,IniDisplayFormat,0,0);
  pHw->dwKaraokeMode= SettingLoad(SET_DWORD,IniKaraokeMode,0,0);
//  pHw->dwTVOutMode= SettingLoad(SET_DWORD,IniVomode,0,0);      
//  pHw->dwVOLuma= SettingLoad(SET_DWORD,IniVoluma,0,50);
//  pHw->dwVOChroma= SettingLoad(SET_DWORD,IniVochroma,0,50);
//  pHw->dwVOHue= SettingLoad(SET_DWORD,IniVohue,0,0);

  SettingFName(IniFName,IniSection);
}

void hwWriteControlPanelConfig(PHW pHw) {
  SettingFName(IniFName,IniSettingsKey);
  DbgMsg(DBG_CP_SET,"CP: Writing config to %s/%s reg key\r\n",IniFName,IniSettingsKey);

  SettingSave(SET_DWORD,IniMixmode,pHw->AC3MixMode);
  SettingSave(SET_DWORD,IniSpdiffmode,pHw->dwSpDiffMode);
  SettingSave(SET_DWORD,IniSpdiffout,pHw->dwSpDiffOut);
//  SettingSave(SET_DWORD,IniVomode,pHw->dwTVOutMode);      
//  SettingSave(SET_DWORD,IniVoluma,pHw->dwVOLuma);
//  SettingSave(SET_DWORD,IniVochroma,pHw->dwVOChroma);
//  SettingSave(SET_DWORD,IniVohue,pHw->dwVOHue);
  SettingSave(SET_DWORD,IniVOVolume,pHw->dwVolume);
  SettingSave(SET_DWORD,IniVOMute,pHw->dwMute);
//  SettingSave(SET_DWORD,IniDisplayMode,pHw->dwVidDispMode);
//  SettingSave(SET_DWORD,IniDisplayFormat,pHw->dwVidDispFormat);
  SettingSave(SET_DWORD,IniKaraokeMode,pHw->dwKaraokeMode);

  SettingFName(IniFName,IniSection);
}

void hwApplyControlPanelConfig(PHW pHw) {
  MIDASCMD cmd;
  memset(&cmd,0,sizeof(cmd));

  /* set hardware to config */
  DbgMsg(DBG_CP_SET,"CP: Applying config to hardware.\r\n");
  cmd.cmd= MDS_SETMIXMODE;
  cmd.hMidas = pHw;
  cmd.u.M.Arg1= pHw->AC3MixMode;
  cmd.u.M.Arg2= 0;
  MidasEntry(&cmd);

  cmd.cmd= MDS_SETSPDIFMODE;
  cmd.hMidas = pHw;
  cmd.u.M.Arg1= pHw->dwSpDiffMode;
  cmd.u.M.Arg2= 0;
  MidasEntry(&cmd);

  cmd.cmd= MDS_SETSPDIFENABLE;
  cmd.hMidas = pHw;
  cmd.u.M.Arg1= pHw->dwSpDiffOut;
  cmd.u.M.Arg2= 0;
  MidasEntry(&cmd);

#if(0)

  cmd.cmd= MDS_SETTVOUT;
  cmd.hMidas = pHw;
  cmd.u.M.Arg1= TVOUT_SETCOMP_SVIDEO;
  cmd.u.M.Arg2= pHw->dwTVOutMode;
  MidasEntry(&cmd);

  cmd.cmd= MDS_SETTVOUT;
  cmd.hMidas = pHw;
  cmd.u.M.Arg1= TVOUT_SETBRIGHTNESS;
  cmd.u.M.Arg2= pHw->dwVOLuma;
  MidasEntry(&cmd);

  cmd.cmd= MDS_SETTVOUT;
  cmd.hMidas = pHw;
  cmd.u.M.Arg1= TVOUT_SETCONTRAST;
  cmd.u.M.Arg2= pHw->dwVOChroma;
  MidasEntry(&cmd);

  cmd.cmd= MDS_SETTVOUT;
  cmd.hMidas = pHw;
  cmd.u.M.Arg1= TVOUT_SETHUE;
  cmd.u.M.Arg2= pHw->dwVOHue;
  MidasEntry(&cmd);
#endif

  cmd.cmd= MDS_SETMUTE;
  cmd.hMidas = pHw;
  cmd.u.M.Arg1= pHw->dwMute;
  cmd.u.M.Arg2= 0;
  MidasEntry(&cmd);

    cmd.cmd= MDS_SETVOLUME;
  cmd.hMidas = pHw;
  cmd.u.M.Arg1= pHw->dwVolume;
  cmd.u.M.Arg2= 0;
  MidasEntry(&cmd);

//  cmd.cmd= MDS_VIDOUTFORMAT;
//  cmd.hMidas = pHw;
//  cmd.u.M.Arg1= pHw->dwVidDispFormat;
//  cmd.u.M.Arg2= 0;
//  MidasEntry(&cmd);

  cmd.cmd= MDS_SETKARAOKEMODE;
  cmd.hMidas = pHw;
  cmd.u.M.Arg1= pHw->dwKaraokeMode;
  cmd.u.M.Arg2= 0;
  MidasEntry(&cmd);

}

/**EOF: INIT.C**/
