enum CL5446_ADDRESS_MAP_REGS
{
  REG_5446_INDEX           = 0x00,
  REG_5446_DATA            = 0x20,
  REG_5446_AUDIO_CHANNEL   = 0x04,
  REG_5446_VIDEO_CHANNEL   = 0x24,
  REG_5446_LSI_INDEXL      = 0x08,
  REG_5446_LSI_INDEXH      = 0x0C,
  REG_5446_LSI_DATA        = 0x28
};

enum ISA_ADDRESS_MAP_REGS
{
  REG_ISA_INDEX           = (WORD)0x00,
  REG_ISA_DATA            = (WORD)0x02,
  REG_ISA_AUDIO_CHANNEL   = (WORD)0x04,
  REG_ISA_VIDEO_CHANNEL   = (WORD)0x06,
  REG_ISA_LSI_INDEXL      = (WORD)0x08,
  REG_ISA_LSI_INDEXH      = (WORD)0x0C,
  REG_ISA_LSI_DATA        = (WORD)0x0A
};

#define REG_INDEX(pHw) (pHw->pRegTbl[0])
#define REG_DATA(pHw) (pHw->pRegTbl[1])
#define REG_AUDIO_CHANNEL(pHw) (pHw->pRegTbl[2])
#define REG_VIDEO_CHANNEL(pHw) (pHw->pRegTbl[3])
#define REG_LSI_INDEXL(pHw) (pHw->pRegTbl[4])
#define REG_LSI_INDEXH(pHw) (pHw->pRegTbl[5])
#define REG_LSI_DATA(pHw) (pHw->pRegTbl[6])

#define REG_LSI_INDEX  REG_LSI_INDEXL


enum CONTROL_INDEX_REGS
{
  RIX_BOARD_ID        = 0x00,
  RIX_MODE            = 0x01,
  RIX_IRQ_CNTRL       = 0x02,
  RIX_IRQ_STATUS      = 0x03,
  RIX_DMA_CNTRL       = 0x04,
  RIX_DMA_STATUS      = 0x05,
  RIX_LSI_CNTRL       = 0x06,
  RIX_LSI_STATUS      = 0x07,
  RIX_OSC_CNTRL       = 0x08,
  RIX_VID_CNTRL       = 0x09,
  RIX_ZV_CNTRL        = 0x0a,
  RIX_VID_TABLE       = 0x0b,
  RIX_EEP_CNTRL       = 0x0c,
  RIX_VID_HDELAY      = 0x0d,
  RIX_VID_HACTIVE     = 0x0e,
  RIX_VID_MSBS        = 0x0f,
  RIX_GPIO_CTRL       = 0x10,
  RIX_GPIO_PINS       = 0x11,
  RIX_CSS_CMD         = 0x12,
  RIX_CSS_STAT        = 0x13,
  RIX_CSS_KEY         = 0x14
};

#define VID_DECODE_STAT_REG     0,0x01
#define AUD_DECODE_STAT_REG     0,0x01
#define SLICE_START_CODE_DETECT 0,0x04
#define POST_SEQ_END_CODE_REG   0,0x08
#define NEW_FIELD_DETECT        0,0x80

#define AUDIO_SYNC_CODE_DETECT  1,0x01
#define PICT_START_CODE_DETECT  1,0x02
#define BEGIN_ACTIVE_VIDEO_REG  1,0x10

#define PRE_SEQ_END_CODE_REG    2,0x10
#define SPU_PES_DATA_RDY        2,0x08

#define AUD_CH_OVFL 3,0x01
#define VID_CH_OVFL 3,0x02
#define SPU_CH_OVFL 3,0x04
#define VBI_CH_OVFL 3,0x08

#define AUD_CH_UNFL 3,0x10
#define VID_CH_UNFL 3,0x20
#define SPU_CH_UNFL 3,0x40
#define VBI_CH_UNFL 3,0x80

#define CH_CONFIG_REG 5,0x03
#define CH_PAUSE_REG  5,0x04
enum REG5
{
  CH_UNPAUSE  =0x00,
  CH_CONFIG   =0x01,
  CH_PAUSE    =0x04
};

#define CHANNEL_CTRL_REG   7,0x01
#define STREAM_SELECT_REG  7,0x06
#define SOFT_RESET_REG     7,0x20
enum REG7
{
  CHANNEL_RESET       = 0x00,
  CHANNEL_START       = 0x01,

  PARALLEL_CHAN       = 0x02,

  STREAM_SELECT_PES   = 0x00,
  STREAM_SELECT_PRG   = 0x04,
  STREAM_SELECT_ELM   = 0x0C,

  SOFT_RESET          = 0x20
};

#define RESET_FIFO_REG      68,0x7F
enum REG68
{
  RESET_FIFO_ALL = 0x7F,
  RESET_FIFO_VID = 0x20,
  RESET_FIFO_AUD = 0x40,
  RESET_FIFO_SUB = 0x04,
  RESET_FIFO_SYS = 0x02
};

#define CAPCOMP_MODE_REG    17
#define SCR_COMPARE         0x02
#define CAPTURE_AUD         0x09
#define CAPTURE_VID         0x05

#define VID_PANIC_MODE_REG  69,0x18
enum REG69
{
  VID_NUMITEMS_PANIC = 0x08,
  PICS_IN_CHAN_PANIC = 0x10
};

#define VID_CHAN_START_REG  72
#define AUD_CHAN_START_REG  76
#define SPU_CHAN_START_REG  80
#define VID_PES_START_REG   80
#define DATA_DUMP_REG       84
#define AUD_PES_START_REG   88
#define DSI_CHAN_START_REG  92

#define VID_CHAN_WRITE_ADDR_REG  96
#define AUD_CHAN_WRITE_ADDR_REG  99
#define SUB_CHAN_WRITE_ADDR_REG  102

#define VID_CHAN_READ_ADDR_REG   108
#define AUD_CHAN_READ_ADDR_REG   111

#define PICT_START_CODE_READ_ADDR_REG  128
#define AUD_SYNC_CODE_READ_ADDR_REG    131

#define VID_CHAN_NUMITEM_REG     134
#define VID_CHAN_PANIC_REG       134
#define AUD_CHAN_NUMITEM_REG     137
#define AUD_CHAN_PANIC_REG       137


#define AUDIO_STREAM_REG         143
#define PRIVATE_STREAM_REG       144
#define VIDEO_PES_ENABLE_REG     145,0xC0
#define VIDEO_STREAM_REG         145,0x3F
enum REG145
{
  WRITE_NO_HEADERS    = 0x00,
  WRITE_ONE_VID_PTS   = 0x40,
  WRITE_ALL_HEADERS   = 0x80,
  WRITE_ALL_VID_PTS   = 0xc0,
  ALL_STREAMS_SELECT  = 0x20
};

#define SPU_SUB_STREAM_ID_REG    146,0x1F
#define SPU_STREAM_ENABLE_REG    146,0x20
#define PES_HEADER_ENABLE_REG    147
enum REG147
{
  WRITE_ONE_AUD_PTS  = 0x01,
  WRITE_ALL_AUD_PTS  = 0x03
};

#define TOP_OF_SECTOR_REG        148,0x01
#define PICT_IN_VID_CHAN_REG     150


#define CSS_INTR						176
#define		CSS_INT_DVR_CHALLENGE		0x01
#define		CSS_INT_DECODE_RESPONSE		0x02
#define		CSS_INT_DISK_KEY_EXTRACT	0x04
#define		CSS_INT_DISK_KEY_ERROR		0x08
#define		CSS_INT_TITLE_KEY			0x10
#define		CSS_INT_TITLE_KEY_DIFF		0x20
#define		CSS_INT_KEY_DATA_ERROR		0x40
#define		CSS_INT_TOS					0x80

#define CSS_CMD					177
#define		CSS_PCDVD					0x01
#define		CSS_FORCE_NONDESCRAMBLE		0x02
#define		CSS_ENABLE					0x04
#define		CSS_USER_BANK1				0x08

#define	CSS_MODE				178
#define		CSS_MODE_MASK				0x07
#define		CSS_MODE_BYPASS				0x00
#define		CSS_MODE_DK					0x01
#define		CSS_MODE_AV_DESC			0x02
#define		CSS_MODE_AUTH_DK			0x03
#define		CSS_MODE_AUTH_TK			0x04
#define		CSS_SOFT_RESET				0x08

#define CSS_CHALLENGE_DATA		180
#define	CSS_RESPONSE_DATA		180
#define	CSS_TITLE_KEY			185

#define DRAM_STATUS                 192
#define     HOST_RD_FIFO_EMPTY      0x01
#define     HOST_RD_FIFO_FULL       0x02
#define     HOST_WR_FIFO_EMPTY      0x04
#define     HOST_WR_FIFO_FULL       0x08
#define     DMA_RD_FIFO_EMPTY       0x10
#define     DMA_RD_FIFO_FULL        0x20
#define     DMA_WR_FIFO_EMPTY       0x40
#define     DMA_WR_FIFO_FULL        0x80

#define DRAM_MODE                   193
#define     DM_MASK                 0x06
#define     DM_IDLE                 0x00
#define     DM_DMA_READ             0x02
#define     DM_DMA_WRITE            0x04
#define     DM_BLOCK_MOVE           0x06
#define     DM_HOST_BIG_ENDIAN      0x08
#define     DM_REFRESH_EXT_MASK     0x30
#define     CM_DMA_BIG_ENDIAN       0x40

#define DRAM_READ                   194
#define DRAM_WRITE                  195
#define TARGET_ADDR0_7              196
#define TARGET_ADDR8_15             197
#define TARGET_ADDR16_18            198

#define SRC_ADDR0_7                 199
#define SRC_ADDR8_15                200
#define SRC_ADDR16_18               201

#define FORWARD_ANCHOR_LUMA_REG     224
#define FORWARD_ANCHOR_CHROMA_REG   226
#define BACKWARD_ANCHOR_LUMA_REG    228
#define BACKWARD_ANCHOR_CHROMA_REG  230
#define DISPLAY_LUMA_REG            232
#define DISPLAY_CHROMA_REG          234

#define VIDEO_SKIP_MODE_REG         236,0x03
enum REG236
{
  SKIP_NONE      = 0x00,
  SKIP_B_FRAME   = 0x01,
  SKIP_P_FRAME   = 0x02,
  SKIP_ANY_FRAME = 0x03
};
#define VIDEO_CONT_SKIP_MODE_REG    236,0x04

#define VIDEO_REPEAT_MODE_REG       237,0x03
enum REG237
{
  REPEAT_NONE      = 0x00,
  REPEAT_NEXT      = 0x01,
  REPEAT_CONTT     = 0x03
};

#define SINGLE_STEP_REG             238,0x03
#define CURRENT_DISPLAY_FRAME_REG   238,0x0C
#define CURRENT_DECODE_FRAME_REG    238,0x30
enum REG238
{
  FORWARD_FRAME  = 0x00,
  BACKWARD_FRAME = 0x01,
  DISPLAY_FRAME  = 0x02
};

#define HOST_FORCE_BROKEN_LINK_REG  239,0x02
#define RESET_USER_DATA_REG         239,0x08
enum REG239
{
  FORCE_BROKEN_LINK = 0x02,
  RESET_USER_DATA   = 0x08
};

#define SEARCH_FOR_NEXT_GOP_REG     240,0x01
enum REG240
{
   SEARCH_FOR_NEXT_GOP = 0x01
};

#define DECODER_COMMAND_REG         246,0x01
enum REG246
{              
  DECODER_STOP,
  DECODER_START
};

#define REDUCED_MEMORY_MODE_REG     248,0x01
#define DISPLAY_OVERRIDE_REG        265,0x30
#define VID_BACKGROUND_REG          265,0xC0
enum REG265
{
  DISP_NORMAL_MODE = 0x00,
  DISP_FRAME_MODE  = 0x10,
  DISP_FILED_MODE  = 0x20,

  VIDEO_NORMAL     = 0x00,
  VIDEO_BLACK      = 0x40,
  VIDEO_BLUE       = 0x80,
  VIDEO_ON_BLUE    = 0xC0
};

#define FREEZE_MODE_REG             275,0x03
#define PULL_DOWN_REG               275,0x1C
enum REG275
{
  UNFREEZE           = 0x00,
  FREEZE_FRAME       = 0x01,
  FREEZE_LAST_FIELD  = 0x02,
  FREEZE_FIRST_FIELD = 0x03,

  AUTO_32            = 0x14,  
  REPEAT_1ST_FIRST   = 0x08,
  TOP_FIELD_1ST      = 0x10
};

#define LAST_FIELD_REG              276,0x01
#define HORIZONTAL_FILTER_ENABLE    276,0x02
#define HORIZONTAL_FILTER_SELECT    276,0x04
#define DISPLAY_MODE_REG            276,0x78
enum REG276
{
  PROGRESSIVE_LINE_REPEAT           = 0x00,
  PROGRESSIVE_FILTER_LUMA           = 0x08,
  PROGRESSIVE_FILTER_CHROMA         = 0x10,
  PROGRESSIVE_LETTERBOX             = 0x18,
  INTER_CHROMA_FIELD_REPEAT         = 0x20,
  INTER_CHROMA_FIELD_REPEAT_FILTER  = 0x28,
  INTER_CHROMA_LINE_REPEAT          = 0x30,
  INTER_CHROMA_LINE_REPEAT_FILTER   = 0x38,
  INTERLACED_LETTERBOX              = 0x40
};

#define HORIZONTAL_FILTER_SCALE     277
#define MAIN_READ_LINE_REG          278
#define AUTO_FIELD_INVERSION_REG    279,0x80
#define PANSCAN_FROM_BITSTREAM_REG  279,0x40
#define NUM_OF_SEGMENTS_RMM_REG     289,0x7E
#define TV_STANDARD_REG             290,0x03
enum REG290
{
  NTSC = 1,
  PAL
};

#define MAIN_START_ROW_LOREG        297,0xFF
#define MAIN_START_ROW_HIREG        299,0x07
#define MAIN_END_ROW_LOREG          298,0xFF
#define MAIN_END_ROW_HIREG          299,0x70
#define DISPLAY_START_REG           309,0x01
#define SPU_MIX_ENABLE_REG          309,0x02

#define MUC_SAMPLE_FREQ_REG         337,0xC0
#define AC3_FSCOD_REG               343,0xC0
#define AUD_DECODER_COMMAND_REG     355,0x80
#define AUD_PLAY_MODE_REG           355,0x60
enum REG355
{
  AUD_DECODER_STOP  = 0x00,
  AUD_DECODER_START = 0x80,
  
  AUD_PAUSE_MODE    = 0x00,
  AUD_PLAY_MODE     = 0x20,
  AUD_FAST_MODE     = 0x40,
  AUD_SLOW_MODE     = 0x60
};

#define LPCM_FSCOD_REG              352,0xC0
#define AUD_FMT_REG                 356  
#define AUD_FMT_COMMAND_REG         356,0x80
#define AUD_FMT_PLAY_MODE_REG       356,0x60
#define BS_SELECT_REG               357,0xE0
#define USER_MUTE_REG               358,0x40
#define PCM_SCALE_REG               362
#define DIVIDER_SEL_REG             364,0x0F
#define KARAOKE_SEL_REG             364,0xE0
#define OVERWRITE_QUANT             366,0x0E
#define AC3_DOWNMIX_MODE_SELECT     358,0x10
#define AUDIO_DUAL_MONO_MODE_REG    358,0x0C

enum REG358
{
  AUD_STEREO      = 0x00,
  AUD_RIGHT_ONLY  = 0x04,
  AUD_LEFT_ONLY   = 0x08,
  AUD_MIX_MONO    = 0x0C
};

enum AC3_DOWNMIX_MODE {
  CONVENTIONAL_MIX      = 0x00,
  DOLBY_SORROUND_MIX    = 0x01
};

enum KARAOKE_MODES {
  KARAOKE_NO_VOCAL  = 0x00,
  KARAOKE_VOCAL1    = 0x01,
  KARAOKE_VOCAL2    = 0x02,
  KARAOKE_VOCAL12   = 0x03
};

#define SPU_DECODER_COMMAND_REG     416,0x01
#define SPU_PAUSE_REG               416,0x02
#define SPU_DISPLAY_OFF_REG         416,0x0C
#define SPU_RESET_PALETTE_REG       416,0x10
#define SPU_JUMP_TO_NEXT_REG        416,0x20
enum REG416
{
  SPU_DISPLAY_ON        = 0x00,
  SPU_DISPLAY_OFF       = 0x04,
  SPU_DISPLAY_FORCE_OFF = 0x08
};

#define SPU_PALETTE_DATA_REG        446
                                       
#define HIGHLIGHT_ENABLE_REG        447,0x01
#define HIGHLIGHT_COLOR_REG         448
#define HIGHLIGHT_CONTRAST_REG      450
#define HIGHLIGHT_POSITION_REG      452

#define VID_CHAN_UNDERFLOW 0x20
#define AUD_CHAN_UNDERFLOW 0x10

#define AUXFIFO_SEQ_ITEMS     12
#define AUXFIFO_GOP_ITEMS      6
#define AUXFIFO_PIC_ITEMS_SHRT 3
#define AUXFIFO_PIC_ITEMS_LONG 8
#define AUXFIFO_SEQEXT1_ITEMS  7
#define AUXFIFO_SEQEXT2_ITEMS  8
#define AUXFIFO_PICEXT3_ITEMS  0
#define AUXFIFO_PICEXT4_ITEMS 13
#define AUXFIFO_PICEXT7_ITEMS  6
#define AUXFIFO_PICEXT8_ITEMS 19


#define CHANNEL_STATUS_REG          7
#define SCR_VALUE_7_DOWNTO_0        9
#define SCR_VALUE_15_DOWNTO_8       10
#define SCR_VALUE_23_DOWNTO_16      11
#define SCR_VALUE_31_DOWNTO_24      12


#define USERDATA_FIFO_STATUS_REG        65
#define USERDATA_FIFO_DATA_REG          66
#define USERDATA_FIFO_RESET             65,0x01
#define USERDATA_FIFO_RESET_VAL         0x01

#define USERDATA_STATUS_MASK_BITS       0x03
#define USERDATA_STATUS_EMPTY           0x00
#define USERDATA_STATUS_READY           0x01
#define USERDATA_STATUS_FULL            0x02
#define USERDATA_STATUS_OVERRUN         0x03


/* EOF : LSI64020.H */
