/**************************************************************************
 * Copyright (c) 1999, 2006 MARGI Systems, Inc.
 *                                                                        
 *$History: MdsLong.c $
 * 
 * *****************  Version 21  *****************
 * User: Arshad       Date: 7/30/04    Time: 11:34a
 * Updated in $/Dvd/AutoDVD/mdvdhdrv
 * Reverted back the earlier change.
 * 
 * *****************  Version 20  *****************
 * User: Arshad       Date: 7/30/04    Time: 11:30a
 * Updated in $/Dvd/AutoDVD/mdvdhdrv
 * Just some code relocated in the file.  No code change.
 * 
 * *****************  Version 19  *****************
 * User: Arshad       Date: 6/07/04    Time: 11:38a
 * Updated in $/Dvd/AutoDVD/mdvdhdrv
 * Integrated ST 64 bit arithmetic library code for 64 bit Div operation.
 * 
 * *****************  Version 18  *****************
 * User: Vidya        Date: 3/26/04    Time: 1:21p
 * Updated in $/Dvd/AutoDVD/mdvdhdrv
 * Added comments for Division explaining which parameter is
 * dividend/divisor
 * 
 * *****************  Version 17  *****************
 * User: Vidya        Date: 3/25/04    Time: 3:07p
 * Updated in $/Dvd/AutoDVD/mdvdhdrv
 * Made changes in the current subtraction calculation to incorporate
 * carry over.
 * 
 * *****************  Version 16  *****************
 * User: Viraf        Date: 3/01/04    Time: 4:51p
 * Updated in $/Dvd/AutoDVD/mdvdhdrv
 * No change
 * 
 * *****************  Version 15  *****************
 * User: Viraf           Date: 11/27/02  Time: 11:40p
 * Checked in $/Dvd/Branched/AutoDVD/Driver
 * 
 * *****************  Version 14  *****************
 * User: Viraf           Date: 11/27/02  Time:  9:39p
 * Checked in $/Dvd/Branched/AutoDVD/Driver
 * 
 * *****************  Version 13  *****************
 * User: Viraf           Date: 11/27/02  Time:  3:28p
 * Checked in $/Dvd/Branched/AutoDVD/mdvdhdrv
 * 
 * *****************  Version 12  *****************
 * User: Arshad          Date:  6/05/02  Time: 12:22p
 * Checked in $/Dvd/AutoDVD/mdvdhdrv
 * Added divide by zero checks.  Removed old code.
 * 
 * *****************  Version 11  *****************
 * User: Arshad          Date:  6/04/02  Time:  8:12p
 * Checked in $/Dvd/AutoDVD/mdvdhdrv
 * Added code to check for overflow in Eq 5.
 * 
 * *****************  Version 10  *****************
 * User: Arshad          Date:  6/04/02  Time: 12:29p
 * Checked in $/Dvd/AutoDVD/mdvdhdrv
 * Faster implementation of Div_MdsLongLong().
 * 
 * *****************  Version 9  *****************
 * User: Viraf           Date: 12/04/01  Time:  7:42p
 * Checked in $/Dvd/AutoDVD/mdvdhdrv
 * 
 * *****************  Version 8  *****************
 * User: Viraf           Date:  6/08/01  Time:  5:21p
 * Checked in $/Dvd/SIEMENS/mdvdhdrv
 * 
 * *****************  Version 7  *****************
 * User: Anoop           Date:  6/14/00  Time: 10:18a
 * Checked in $/Dvd/DvdToGo/WinCE/mdvdhdrv
 * Modified code for WINCE driver.
 * 
 * *****************  Version 6  *****************
 * User: Viraf           Date: 11/22/99  Time:  6:22p
 * Checked in $/Dvd/DvdToGo/NewModel/MHal/Midas
 * 
 * *****************  Version 5  *****************
 * User: Viraf           Date:  6/20/99  Time:  2:34p
 * Checked in $/Dvd/Dvdtogo/WDM/mhal/Midas
 * 
 * *****************  Version 4  *****************
 * User: Viraf           Date:  6/18/99  Time:  4:29p
 * Checked in $/Dvd/DvdToGo/NewModel/MDvdHDrv
 * 
 * *****************  Version 3  *****************
 * User: Viraf           Date:  6/18/99  Time:  4:19p
 * Checked in $/Dvd/DvdToGo/NewModel/MDvdHDrv
 * 
 * *****************  Version 2  *****************
 * User: Viraf           Date:  6/18/99  Time:  4:15p
 * Checked in $/Dvd/Dvdtogo/WDM/mhal/Midas
 * 
 * *****************  Version 1  *****************
 * User: Viraf           Date:  6/18/99  Time:  3:46p
 * Created MdsLong.c
 * 
 **************************************************************************/

#include "System.h"
#include "MdsLong.h"

#ifdef USE_64_BITS
#pragma message("MdsLongLong using System 64 bits support")

BYTE __stdcall IsEqual_MdsLongLong(MDSLONGLONG* pLglg1, MDSLONGLONG* pLglg2)
{
  return (BYTE)(*pLglg1==*pLglg2);
}

BYTE __stdcall IsGreater_MdsLongLong(MDSLONGLONG* pLglg1, MDSLONGLONG* pLglg2)
{
  return (BYTE)(*pLglg1>*pLglg2);
}

void __stdcall Set_MdsLongLong(MDSLONGLONG* pLglg, DWORD dwMdsLow, DWORD dwMdsHigh)
{
  long* pLg = (long*)pLglg;
  pLg[0] = (long)dwMdsLow; pLg[1]=(long)dwMdsHigh;
}

void __stdcall Copy_MdsLongLong(MDSLONGLONG* pLglgTar, MDSLONGLONG* pLglgSrc)
{
  *pLglgTar = *pLglgSrc;
}

long __stdcall GetLow_MdsLongLong(MDSLONGLONG* pLglg)
{
  long* pLg = (long*)pLglg;
  return pLg[0];
}

long __stdcall GetHigh_MdsLongLong(MDSLONGLONG* pLglg)
{
  long* pLg = (long*)pLglg;
  return pLg[1];
}

void __stdcall Add_MdsLongLong(MDSLONGLONG* pLglg3, MDSLONGLONG* pLglg1, MDSLONGLONG* pLglg2)
{
  *pLglg3 = *pLglg1 + *pLglg2;
}

void __stdcall Sub_MdsLongLong(MDSLONGLONG* pLglg3, MDSLONGLONG* pLglg1, MDSLONGLONG* pLglg2)
{
  *pLglg3 = *pLglg1 - *pLglg2;
}

void __stdcall Mul_MdsLongLong(MDSLONGLONG* pLglg2, MDSLONGLONG* pLglg1, DWORD dwMul)
{
  *pLglg2 = *pLglg1 * dwMul;
}

void __stdcall Div_MdsLongLong(MDSLONGLONG* pLglg2, MDSLONGLONG* pLglg1, DWORD dwDiv)
{
  *pLglg2 = *pLglg1 / dwDiv;
}

#else

#ifndef _ST_
  #pragma message("MdsLongLong using Software 64 bits support")
#endif



/* LOCAL PROTOTYPES */
/* Taken from ST code */
static void LONGSUM (DWORD *CarryOut, DWORD *Sum, DWORD Left, DWORD Right, DWORD CarryIn);
static void LONGDIFF (DWORD *BorrowOut, DWORD *Diff, DWORD Left, DWORD Right, DWORD BorrowIn);
static void LONGPROD (DWORD *ProdHi, DWORD *ProdLo, DWORD Left, DWORD Right, DWORD CarryIn);
static void SHIFTRIGHT (DWORD *OutHi, DWORD *OutLo, DWORD InHi, DWORD InLo, DWORD Places);
static void SHIFTLEFT (DWORD *OutHi, DWORD *OutLo, DWORD InHi, DWORD InLo, DWORD Places);
static void NORMALISE (DWORD *Places, DWORD *OutHi, DWORD *OutLo, DWORD InHi, DWORD InLo);
static void LONGDIV (DWORD *Quot, DWORD *Rem, DWORD DividHi, DWORD DividLo, DWORD Divis);
static void Int64UnsDiv (BOOL *Error, DWORD *QuotHi, DWORD *QuotLo, DWORD *RemHi, DWORD *RemLo, DWORD DvdHi, DWORD DvdLo, DWORD DvsrHi, DWORD DvsrLo);






BYTE __stdcall IsEqual_MdsLongLong(MDSLONGLONG* pLglg1, MDSLONGLONG* pLglg2)
{
  DWORD* pLg1 = (DWORD*)pLglg1;
  DWORD* pLg2 = (DWORD*)pLglg2;

  if(pLg1[1]==pLg2[1] && pLg1[0]==pLg2[0])
    return 1;
  else
    return 0;
}

BYTE __stdcall IsGreater_MdsLongLong(MDSLONGLONG* pLglg1, MDSLONGLONG* pLglg2)
{
  DWORD* pLg1 = (DWORD*)pLglg1;
  DWORD* pLg2 = (DWORD*)pLglg2;

  if(pLg1[1]>pLg2[1])
    return 1;
  else if(pLg2[1]>pLg1[1])
    return 0;
  else if(pLg1[0]>pLg2[0])
    return 1;
  else
    return 0;
}

void __stdcall Set_MdsLongLong(MDSLONGLONG* pLglg, DWORD dwMdsLow, DWORD dwMdsHigh)
{
  DWORD* pLg = (DWORD*)pLglg;
  pLg[0]=dwMdsLow; pLg[1]=dwMdsHigh;
}

void __stdcall Copy_MdsLongLong(MDSLONGLONG* pLglgTar, MDSLONGLONG* pLglgSrc)
{
  DWORD* pLgT = (DWORD*)pLglgTar;
  DWORD* pLgS = (DWORD*)pLglgSrc;
  pLgT[0] = pLgS[0];
  pLgT[1] = pLgS[1];
}

long __stdcall GetLow_MdsLongLong(MDSLONGLONG* pLglg)
{
  DWORD* pLg = (DWORD*)pLglg;
  return (long)pLg[0];
}

long __stdcall GetHigh_MdsLongLong(MDSLONGLONG* pLglg)
{
  DWORD* pLg = (DWORD*)pLglg;
  return (long)pLg[1];
}

void __stdcall Add_MdsLongLong(MDSLONGLONG* pLglg3, MDSLONGLONG* pLglg1, MDSLONGLONG* pLglg2)
{
  DWORD* pLg1 = (DWORD*)pLglg1;
  DWORD* pLg2 = (DWORD*)pLglg2;
  DWORD* pLg3 = (DWORD*)pLglg3;

  pLg3[1] = pLg1[1] + pLg2[1] + ((~pLg1[0])<pLg2[0]?1:0);
  pLg3[0] = pLg1[0] + pLg2[0];
}

void __stdcall Sub_MdsLongLong(MDSLONGLONG* pLglg3, MDSLONGLONG* pLglg1, MDSLONGLONG* pLglg2)
{
  DWORD* pLg1   = (DWORD*)pLglg1;
  DWORD* pLg2   = (DWORD*)pLglg2;
  DWORD* pLg3   = (DWORD*)pLglg3;
  BYTE   bCarry = 0;

  // Two's compliment addition c= a + ~b +1 where ~b is 1's compliment of b
  // splitting this addition into two steps, add a+~b first and then add 1
  // Since the first DWORD block is taken, if there is any carry from this
  // need to transfer the carry to the next DWORD block.
  bCarry = DetermineCarry(&pLg3[0], pLg1[0], ~pLg2[0]);
  bCarry |=  DetermineCarry(&pLg3[0],pLg3[0],1);

  pLg3[1] = pLg1[1] + (~pLg2[1]) + bCarry; // If carry present, add carry to next DWORD block
}

BYTE DetermineCarry(DWORD* pLgl4, DWORD pLgl1, DWORD pLgl2)
{
  *pLgl4 = pLgl1 + pLgl2;
  if((*pLgl4<pLgl1) && (*pLgl4<pLgl2))
    return 1; // carry is present 
  else
    return 0;
}

void __stdcall Mul_MdsLongLong(MDSLONGLONG* pLglg2, MDSLONGLONG* pLglg1, DWORD dwMul)
{
  DWORD* pLg1       = (DWORD*)pLglg1;
  DWORD* pLg2       = (DWORD*)pLglg2;
  DWORD dwTempCurr  = (DWORD)pLg1[0];
  DWORD dwTempLo    = (DWORD)pLg1[0];
  DWORD dwTemp      = 0;
  BYTE  bTotalBits  = sizeof(DWORD)*8;
  BYTE  bCurrPos    = 1;

  pLg2[0] = pLg1[0]*dwMul;
  pLg2[1] = pLg1[1]*dwMul;

  while(bTotalBits--)
  {
    if(dwMul&0x80000000)
    {
      if(~dwTemp < (dwTempLo<<bTotalBits))
        pLg2[1]++;  // to accomodate the overflow.   

      dwTemp += (dwTempLo << bTotalBits);
      if(!bTotalBits)
        break;

      dwTempCurr >>= bCurrPos;
      pLg2[1] = (long)((DWORD)pLg2[1] + dwTempCurr);
      bCurrPos = 1;
    }
    else
    {
      bCurrPos++;
    }
    dwMul<<=1;
  }
}

// DO NOT MODIFY UNLESS ALL STEPS ARE UNDERSTOOD //
void __stdcall ArshadDiv_MdsLongLong(MDSLONGLONG* pLglg2, MDSLONGLONG* pLglg1, DWORD dwDiv)
{                              // pLglg2 holds the result, pLglg1=dividend(qty to be divided), dwDiv=divisor
#define BitSize 32
#define TWO_POW_16 0x10000
  MDSLONGLONG Result;
  unsigned long *pResult = (unsigned long*)&Result;
  unsigned long lValueHi, lValueLo;
  unsigned long lRLo1=0, lRLo2=0;

  lValueHi = GetHigh_MdsLongLong(pLglg1);
  lValueLo = GetLow_MdsLongLong(pLglg1);

  if (!dwDiv)
    dwDiv = 1;
  //Eq 0: Rh:Rl = (Vh:Vl)/D
  //Eq 1: R = Rh x 2^32 + Rl = Rh:Rl

  //Eq 2: Rh = Vh/D
  pResult[1] = lValueHi/dwDiv;    

  //Eq 4: Rl1 = (Vh%D) x ((2^32)/D)
  lRLo1 = (-1ul)/dwDiv;
  if ((((-1ul)%dwDiv)+1)>=dwDiv)
    lRLo1++;
  lRLo1 *= (lValueHi%dwDiv);

  //Eq 5: Rl2 = (((Vh%D) x ((2^32)%D)) + Vl)/D
  //          = (((Vh%D) x ((2^32)%D)) / D) + (Vl/D)
  // This calculation has potential of overflow in multiplication.
  {
    unsigned long lTerm1,     // lTerm1 = Vh%D
                  lTerm2;     // lTerm2 = (2^32)%D
    unsigned char bBitReduced=0;
    unsigned long lReducedDivisor;

    lTerm1 = lValueHi%dwDiv;
    lTerm2 = (-1ul)%dwDiv;
    if ((lTerm2+1)==dwDiv)      //Adjust value because we used 2^32-1.
      lTerm2 = 0;

    while (lTerm1 > TWO_POW_16) {
      lTerm1 >>= 1;
      bBitReduced++;
    }
    while (lTerm2 > TWO_POW_16) {
      lTerm2 >>= 1;
      bBitReduced++;
    }

    lReducedDivisor = dwDiv >> bBitReduced;
    if (!lReducedDivisor)
      lReducedDivisor = 1;      //Avoid Error Condition.
    lRLo2 = ((lTerm1 * lTerm2) / lReducedDivisor) +
              (lValueLo/dwDiv);
    if ((((lTerm1 * lTerm2) % lReducedDivisor) +(lValueLo%dwDiv)) >= dwDiv)
      lRLo2++;  //Adjust the term
  }

  //Eq 3: Rl = Rl1 + Rl2
  pResult[0] = lRLo1 + lRLo2;

  Copy_MdsLongLong(pLglg2, &Result);
}




void __stdcall Div_MdsLongLong(MDSLONGLONG* pLglg2, MDSLONGLONG* pLglg1, DWORD dwDiv)
{                              // pLglg2 holds the result, pLglg1=dividend(qty to be divided), dwDiv=divisor
  BOOL rc;
  DWORD DvdHi, DvdLo; // Divide Hi/Lo Value
  DWORD DvsrHi, DvsrLo; // Divisor Hi/Lo Value
  DWORD RemHi, RemLo; // Remainder
  DWORD QuotHi, QuotLo; // Quotient Result.

  DvdHi = pLglg1->Hi;
  DvdLo = pLglg1->Lo;
  DvsrHi = 0;
  DvsrLo = dwDiv;

  Int64UnsDiv(&rc, &QuotHi, &QuotLo, &RemHi, &RemLo, DvdHi, DvdLo, DvsrHi, DvsrLo);
  if (rc) // we have error; return zero.
    pLglg2->Hi = pLglg2->Lo = 0;
  else
  {
    pLglg2->Hi = QuotHi;
    pLglg2->Lo = QuotLo;
  }

  return;
}










/************************* ST Arithmetic Code *****************************/

/* 8 bit word values */
#define SignBit8  0X00000080
#define LowBits8  0X000000FF
#define HighBits8 0XFFFFFF00
#define NegBits8  0XFFFFFF80

/* 16 bit word values */
#define SignBit16  0X00008000
#define LowBits16  0X0000FFFF
#define HighBits16 0XFFFF0000
#define NegBits16  0XFFFF8000

/* 32 bit word values */
#define SignBit32  0X80000000
#define LowBits32  0XFFFFFFFF
#define HighBits32 0X00000000
#define NegBits32  0X80000000


#ifndef MOSTPOS_INT32_UNSIGNED
#define MOSTPOS_INT32_UNSIGNED 0XFFFFFFFFU
#define MOSTNEG_INT32_UNSIGNED 0U

#define MaxUnsignedInt32 MOSTPOS_INT32_UNSIGNED
#define MinUnsignedInt32 MOSTNEG_INT32_UNSIGNED
#endif


static void LONGSUM (DWORD *CarryOut, DWORD *Sum, DWORD Left, DWORD Right, DWORD CarryIn)
{
    CarryIn &= 1;

    if ((MaxUnsignedInt32 - Left) >= Right)
    {
        *Sum = Left + Right;
        
        if ((CarryIn != 0) && (*Sum == MaxUnsignedInt32))
        {
            *Sum = 0;
            *CarryOut = 1;
        }
        else
        {
            *Sum = *Sum + CarryIn;
            *CarryOut = 0;
        }
    }
    else
    {
        *CarryOut = 1;
        *Sum = (Right - ((MaxUnsignedInt32 - Left) + 1)) + CarryIn;
    }
}


static void LONGDIFF (DWORD *BorrowOut, DWORD *Diff, DWORD Left, DWORD Right, DWORD BorrowIn)
{
    BorrowIn &= 1;
    *BorrowOut = 0;

    if (Left >= Right)
        *Diff = Left - Right;
    else
    {
        *Diff = MaxUnsignedInt32 - Right;
        *Diff = (*Diff + Left) + 1;
        *BorrowOut = 1;
    }

    if (BorrowIn != 0)
    {
        if (*Diff > 0)
            (*Diff)--;
        else
        {
            *Diff = MaxUnsignedInt32;
            *BorrowOut = 1;
        }
    }
}



static void LONGPROD (DWORD *ProdHi, DWORD *ProdLo, DWORD Left, DWORD Right, DWORD CarryIn)
{
    DWORD Temp1, Temp2, Temp3, Temp4, TempLo, TempHi, Carry;

    Temp1 = Left & LowBits16;          /* Left MOD 2^16 */
    Temp2 = (Left >> 16) & LowBits16;  /* Left DIV 2^16 */
    Temp3 = Right & LowBits16;         /* Right MOD 2^16 */
    Temp4 = (Right >> 16) & LowBits16; /* Right DIV 2^16 */

    *ProdLo = Temp1 * Temp3;
    TempLo = Temp2 * Temp3;
    TempHi = (TempLo >> 16) & LowBits16;
    TempLo = TempLo << 16;

    LONGSUM(ProdHi, ProdLo, *ProdLo, TempLo, 0);

    *ProdHi = *ProdHi + TempHi;
    TempLo = Temp1 * Temp4;
    TempHi = (TempLo >> 16) & LowBits16;
    TempLo = TempLo << 16;

    LONGSUM(&Carry, ProdLo, *ProdLo, TempLo, 0);

    *ProdHi = (*ProdHi + Carry) + TempHi;

    LONGSUM(&Carry, ProdLo, *ProdLo, CarryIn, 0);

    *ProdHi = (*ProdHi + Carry) + (Temp2 * Temp4);
}


static void SHIFTRIGHT (DWORD *OutHi, DWORD *OutLo, DWORD InHi, DWORD InLo, DWORD Places)
{
    if (Places >= 64)
    {
        *OutHi = 0;
        *OutLo = 0;
    }
    else if (Places >= 32)
    {
        *OutHi = 0;
        *OutLo = InHi >> (Places - 32);
    }
    else if (Places == 0)
    {
        *OutLo = InLo;
        *OutHi = InHi;
    }
    else
    {
        *OutLo = (InLo >> Places) | (InHi << (32 - Places));
        *OutHi = InHi >> Places;
    }
}



static void SHIFTLEFT (DWORD *OutHi, DWORD *OutLo, DWORD InHi, DWORD InLo, DWORD Places)
{
    if (Places >= 64)
    {
        *OutHi = 0;
        *OutLo = 0;
    }
    else if (Places >= 32)
    {
        *OutLo = 0;
        *OutHi = InLo << (Places - 32);
    }
    else if (Places == 0)
    {
        *OutLo = InLo;
        *OutHi = InHi;
    }
    else
    {
        *OutHi = (InHi << Places) | (InLo >> (32 - Places));
        *OutLo = InLo << Places;
    }
}


static void NORMALISE (DWORD *Places, DWORD *OutHi, DWORD *OutLo, DWORD InHi, DWORD InLo)
{
    if ((InHi == 0) && (InLo == 0))
    {
        *Places = 64;
        *OutHi = 0;
        *OutLo = 0;
    }
    else
    {
        *Places = 0;
        *OutHi = InHi;
        *OutLo = InLo;
        
        while ((*OutHi & SignBit32) == 0)
        {
            SHIFTLEFT(OutHi, OutLo, *OutHi, *OutLo, 1);
            (*Places)++;
        }
    }
}






static void LONGDIV (DWORD *Quot, DWORD *Rem, DWORD DividHi, DWORD DividLo, DWORD Divis)
{
    if (Divis == 0)
    {
        *Quot = 0;
        *Rem = 0;
    }
    else if ((DividHi == 0) && (DividLo == 0))
    {
        *Quot = 0;
        *Rem = 0;
    }
    else
    {
        INT BitCount;
        DWORD Places, RemHi, RemLo, QuotHi, QuotLo;
        
        RemHi = 0;
        RemLo = 0;
        QuotHi = DividHi;
        QuotLo = DividLo;
        
        NORMALISE(&Places, &QuotHi, &QuotLo, QuotHi, QuotLo);
        
        BitCount = 64 - ((INT) Places);
        do
        {
            SHIFTLEFT(&RemHi, &RemLo, RemHi, RemLo, 1);
            
            if ((QuotHi & SignBit32) != 0)
                RemLo++;
            
            SHIFTLEFT(&QuotHi, &QuotLo, QuotHi, QuotLo, 1);
            
            if ((RemHi > 0) || ((RemHi == 0) && (RemLo >= Divis)))
            {
                DWORD Borrow;
                
                LONGDIFF(&Borrow, &RemLo, RemLo, Divis, 0);
                LONGDIFF(&Borrow, &RemHi, RemHi, 0, Borrow);
                QuotLo++;
            }
            
            BitCount--;
        }
        while (BitCount > 0);
        
        *Quot = QuotLo;
        *Rem = RemLo;
    }
}


static void Int64UnsDiv (BOOL *Error, DWORD *QuotHi, DWORD *QuotLo, DWORD *RemHi, DWORD *RemLo, DWORD DvdHi, DWORD DvdLo, DWORD DvsrHi, DWORD DvsrLo)
{
    *Error = FALSE;

    if ((DvsrLo == 0) && (DvsrHi == 0))
        *Error = TRUE;
    else
    {
        DWORD Count, X, U[3], W[3], V[2];
        
        if (DvsrHi == 0)
        {
            /* double by single */
            *RemHi = 0;
            
            LONGDIV(QuotHi, &U[1], 0, DvdHi, DvsrLo);
            LONGDIV(QuotLo, RemLo, U[1], DvdLo, DvsrLo);
        }
        else
        {
            /*double by double */
            /*normalise the operands */
            NORMALISE(&Count, &V[1], &V[0], DvsrHi, DvsrLo);
            if (Count == 0)
            {
                /* already normalised */
                U[2] = 0;
                U[1] = DvdHi;
                U[0] = DvdLo;
            }
            else
            {
                /* shift the dividend */
                SHIFTLEFT(&U[2], &X, 0, DvdHi, Count);
                SHIFTLEFT(&U[1], &U[0], DvdHi, DvdLo, Count);
            }
            
            /* evaluate the quotient */
            *QuotHi = 0;
            
            if (U[2] == V[1])
                *QuotLo = MaxUnsignedInt32;
            else
                LONGDIV(QuotLo, &X, U[2], U[1], V[1]);
            
            if (*QuotLo != 0)
            {
                /* evaluate and check for overflow */
                LONGPROD(&W[1], &W[0], *QuotLo, V[0], 0);
                LONGPROD(&W[2], &W[1], *QuotLo, V[1], W[1]);
                
                LONGDIFF(&X, &U[0], U[0], W[0], 0);
                LONGDIFF(&X, &U[1], U[1], W[1], X);
                LONGDIFF(&X, &U[2], U[2], W[2], X);
                
                while ((U[2] & SignBit32) != 0)
                {
                    /* add back as required */
                    *QuotLo = *QuotLo - 1;
                    
                    LONGSUM(&X, &U[0], U[0], V[0], 0);
                    LONGSUM(&X, &U[1], U[1], V[1], X);
                    LONGSUM(&X, &U[2], U[2], 0, X);
                }
            }
            
            /* evaluate the remainder */
            if (Count == 0)
            {
                *RemLo = U[0];
                *RemHi = U[1];
            }
            else
                SHIFTRIGHT(RemHi, RemLo, U[1], U[0], Count);
        }
    }
}



#endif











/* eof */
