#ifndef __DVHW__SYNC__
#define  __DVHW__SYNC__ 0x1234

#define SYNC_ENABLE_DISABLE      0  //disable logging and adjust
#define SYNC_ENABLE_ENABLE       1  //enable with adjust audio is master
#define SYNC_ENABLE_NO_ADJUST    2  //disable adjust
#define SYNC_ENABLE_VID_MASTER   4  //video is master (video adjusts SCR)

#define SYNC_INIT		             1  //Allocate tables.  Arg1=NA.                Arg2=NA.
#define SYNC_FINI		             2  //Free tables.		  Arg1=NA.                Arg2=NA.
#define SYNC_RESET		           3  //Reset sync info.  Arg1=DWORD FullReset.   Arg2=0=All streams,1=Video,2=Audio
#define SYNC_SHOW_ERROR		       8  //Display drifts.	  Arg1=NA	                Arg2=NA
#define SYNC_TIMER		          10	//Periodic checks	  Arg1=DWORD Events       Arg2=NA
#define SYNC_GET                14	//Get parameter.	  Arg1= one of SYNC_ITEM_,Arg2= DWORD &Value
#define SYNC_SET                15	//Set parameter.	  Arg1= one of SYNC_ITEM_,Arg2= DWORD Value
#define SYNC_ENABLE		          16  //Enable/disable sync temporarily. Arg1= DWORD StrmType,  Arg2= DWORD Enable flags.
#define SYNC_GET_SCR          	17  //Get System Stream Time Arg1=Overflow count              Arg2=90KHz time
#define SYNC_SET_SCR 	          18  //Get System Stream Time Arg1=Overflow count              Arg2=90KHz time
#define SYNC_GET_VIDPTS         19  //Get Video Stream Time Arg1=Overflow count               Arg2=90KHz time
#define SYNC_GET_AUDPTS         20  //Get Audio Stream Time Arg1=Overflow count               Arg2=90KHz time
#define SYNC_PKTHDR_GET_PTS     21  //Extract PTS from Video or Audio Packet Header
#define SYNC_SET_PTS_MODE       22  // Set or clear fParseForPTS flag
#define SYNC_STRM_START         23  // Indicate Stream Started Arg1=Stream  Arg2=90KHz time difference

#define SYNC_ITEM_AUDFRAMES	1	  //Number of audio sync codes detected. ReadOnly.
#define SYNC_ITEM_VIDFRAMES	2	  //Number of video sync codes detected. ReadOnly.
#define SYNC_ITEM_AUDPTSMIN	3	  //Minimum audio PTS detected since preplay began.
#define SYNC_ITEM_AUDPTSCUR	4	  //Most recent audio PTS detected.
#define SYNC_ITEM_VIDPTSMIN	5	  //Minimum video PTS detected since preplay began.
#define SYNC_ITEM_VIDPTSCUR	6	  //Most recent video PTS detected.

extern long  SyncCmd(PHW pHw, DWORD Msg, DWORD Arg1, DWORD Arg2);
extern void* SyncVidPktBegin(PHW,BYTE* pData,DWORD dwBytes,SYNC_TIME90*);
extern long  SyncVidPktEnd(void*);
extern void* SyncAudPktBegin(PHW,BYTE* pData,DWORD dwBytes,SYNC_TIME90*);
extern long  SyncAudPktEnd(void*);

extern void  DbgDispPTS(DWORD dwDbgFilt, DWORD llTime,char* szPre,char* szPost);

#endif
/**EOF: DVHWSYNC.H**/
