/**************************************************************************
 * Copyright (c) 1995, 1996 MARGI Systems, Inc.
 */                                                                        
#ifndef SYSTEM_H
#define SYSTEM_H

#ifdef __QNXNTO__
#ifdef __cplusplus
#include <cstring>
#endif
#endif

#ifdef __cplusplus
extern "C" {
#endif

#define MEMORY_DONT_CARE      0
#define MEMORY_NON_CACHEABLE  1
#define MEMORY_CACHEABLE      2
#define MEMORY_CACHEABLE_2    3

#if(0)          // Set to 1 to test compile for non X86
  #undef _X86_
  #define _asm BLAH
  #define __asm BLAH
  #define _outp BLAH
  #define _outpw BLAH
  #define _outpd BLAH
  #define _inp BLAH
  #define _inpw BLAH
#endif

#define DO_MULT_DIV(Value, Multiplier, Divisor) \
  ((Value/Divisor) * Multiplier) + (((Value % Divisor) * Multiplier)/Divisor)

#ifdef _DBG_BITS_
  void SetDbgBit(int nReg, int nSet);
#endif

#ifndef DEBUG_BREAK
  #define DEBUG_BREAK
#endif

#ifdef _WIN32_WINNT
//None
#elif defined(_WIN32_WCE)
  #include <windows.h>
  #ifndef FAR
    #define FAR
  #endif
  #define RtlCopyMemory(Destination,Source,Length) memcpy((Destination),(Source),(Length))
  #define RtlZeroMemory(Destination,Length) memset((Destination),0,(Length))
  #define FHANDLE HANDLE
  #define FHANDLE_ERROR INVALID_HANDLE_VALUE
  #define _FARPTR_ 
  #define RECT_DEFINED
  #ifndef DLLEXPORT
    #define DLLEXPORT 
//    #define DLLEXPORT _declspec(dllexport)
  #endif
  #define MALLOC malloc
  #define FREE   free
  #define MEMSET memset
  #define MEMCPY memcpy
  #define MEMCMP memcmp
  #define TOUPPER towupper
  #define CLOSE_FILE(x)
  #define LOADDS
  
//  #define SetFilePointer(x, y, z, a)

// end of _WIN32_WCE section
#else
  #if (defined(_WINDOWS) || defined(_CONSOLE) || defined(WIN32))
    #include <windows.h>
    #define _MARGITYPESDEFINED
  
    #define LOCAL static
  
    #if (defined(_WIN32) || defined(WIN32))
      #define LOADDS
      #ifndef DLLEXPORT
        #define DLLEXPORT _declspec(dllexport)
      #endif
  
      #define DLLEXPORT16
      #define EXPORT_CALL CALLBACK
      #define HUGE
  
      #define MALLOC malloc
      #define FREE   free
      #define MEMSET memset
      #define MEMCPY memcpy
      #define MEMCMP memcmp
  
      #define FSTRNCPY strncpy
      #define FSTRCPY  strcpy
  
  
      #ifdef UNICODE
        #define CONVERT_UNICODE_TO_CHAR(lpUnicode, cString)   WideCharToMultiByte(CP_ACP, 0, lpUnicode, wcslen(lpUnicode), cString, sizeof(cString), NULL, NULL);
        #define LSTRRCHR wcsrchr 
        #define TOUPPER towupper
      #else
        #define CONVERT_UNICODE_TO_CHAR(lpUnicode, cString)   lstrcpy(cString, lpUnicode);
        #define LSTRRCHR strrchr
        #define TOUPPER toupper
      #endif
  
      #define FHANDLE HANDLE
      #define OPEN_FILE(PathName) CreateFile(PathName, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL)
      #define CLOSE_FILE(Handle) CloseHandle(Handle)
  
      #define IsInstanceValid(hIn) (hIn) //LoadLibrary
  
      #define GET_WMCMD_NOTIFYCMD(wParam, lParam) HIWORD(wParam)
      #define GET_WM_DATA(wParam, lParam) HIWORD(wParam)
      #define GET_WM_HANDLE(lParam) lParam
  
    #else  // not _WIN32
      #define LOADDS _loadds
      #define DLLEXPORT
      #define DLLEXPORT16 _export LOADDS FAR
      #define EXPORT_CALL CALLBACK _export LOADDS
      #define HUGE __huge
  
      #define MALLOC _fmalloc
      #define FREE   _ffree
      #define MEMSET _fmemset
      #define MEMCPY _fmemcpy
      #define MEMCMP _fmemcmp
  
      #define FSTRNCPY _fstrncpy
      #define FSTRCPY  _fstrcpy

  
      #define MAKEWORD(a, b)      ((WORD)(((BYTE)(a)) | ((WORD)((BYTE)(b))) << 8))
      #define LOBYTE(w)           ((BYTE)(w))
  
      #define MoveMemory(Destination,Source,Length) memmove((Destination),(Source),(Length))
      #define CopyMemory(Destination,Source,Length) MEMCPY((Destination),(Source),(Length))
      #define FillMemory(Destination,Length,Fill)   MEMSET((Destination),(Fill),(Length))
      #define ZeroMemory(Destination,Length)        MEMSET((Destination),0,(Length))
  
  //file
      #define FILE_BEGIN    SEEK_SET
      #define FILE_CURRENT  SEEK_CUR
      #define FILE_END      SEEK_END
  
      #define FHANDLE HFILE
      #define OPEN_FILE(PathName) open(PathName, OF_READ)
      #define CLOSE_FILE(Handle) _close(Handle)
      #define ReadFile(Handle,Buffer,Size,nRead,Overlapped) *nRead = _read(Handle,Buffer, Size)
      #define WriteFile(Handle,Buffer,Size,nWrote,Overlapped) _lwrite(Handle,Buffer, Size)
      #define GetFileSize(Handle,Unknown)   _lseek(Handle,0L,SEEK_END);_lseek(Handle,0L,SEEK_SET)
      #define CloseHandle(Handle)           _close(Handle)
      #define SetFilePointer(Handle,Position,Unknown,Reference) _lseek(Handle,Position,Reference)
      #define INVALID_HANDLE_VALUE HFILE_ERROR
  
  // String
      #define CHAR  char
      #define TCHAR char
      #define LPTSTR  LPSTR
      #define LPCTSTR LPCSTR
      #define LPCWSTR LPCSTR
  
      #define TEXT(xx) xx
      #define wcsrchr strrchr
      #define wcscat strcat
      #define wcscpy strcpy
      #define wcslen strlen
      #define vswprintf vsprintf
      #define wvsprintf wsprintf
      #define _itow _itoa
      #define CONVERT_UNICODE_TO_CHAR(lpUnicode, cString)   lstrcpy(cString, lpUnicode);
      #define LSTRRCHR strrchr
      #define TOUPPER toupper
  
      #define IsInstanceValid(hIn) (hIn > HINSTANCE_ERROR) //LoadLibrary
  
      #define GET_WMCMD_NOTIFYCMD(wParam, lParam) HIWORD(lParam)
      #define GET_WM_DATA(wParam, lParam) LOWORD(lParam)
      #define GET_WM_HANDLE(lParam) HIWORD(lParam)
  
    #endif  //_WIN32
  
    #define READ_FILE ReadFile
    #define GET_FILE_SIZE GetFileSize
    #define SET_FILE_POINTER SetFilePointer
    #define FHANDLE_ERROR INVALID_HANDLE_VALUE
  
  #else //_WINDOWS
  //===============================================================
  //     _NEC_
  //===============================================================
    #ifdef _NEC_
      #include <math.h>
      #include <stdio.h>
      #include <stdlib.h>
      #include <string.h>
      #define _DONT_INC_MEMORY_H 
      #define  __int64 long
      #ifndef LOCAL
        #define LOCAL static
      #endif
      #define ULONGLONG unsigned __int64
      #define __stdcall
      #define WINAPI
      #define _stdcall
      #define TEXT(xx) xx
      #define _loadds
      #ifndef FAR
        #define FAR
      #endif
      #ifndef NEAR
        #define NEAR
      #endif
      #define LONG long
      #define push
      #define pop 1
      #define HINSTANCE LPVOID
      #define HANDLE LPVOID
      #ifndef RECT_DEFINED
        #define RECT_DEFINED
        typedef struct tagRECT
        {
          LONG    left;
          LONG    top;
          LONG    right;
          LONG    bottom;
        } RECT, FAR *LPRECT, NEAR *NPRECT, *PRECT;
        typedef const RECT FAR* LPCRECT;
      #endif  // RECT_DEFINED
      
      #ifndef POINT_DEFINED
        #define POINT_DEFINED
        typedef struct tagPOINT
        {
          LONG  x;
          LONG  y;
        } POINT, *PPOINT, NEAR *NPPOINT, FAR *LPPOINT;
      #endif
  
      #ifndef _TCHAR_DEFINED
        typedef char TCHAR, *PTCHAR;
        typedef unsigned char TBYTE , *PTBYTE ;
        #define _TCHAR_DEFINED
      #endif /* !_TCHAR_DEFINED */
    
      #define DLLEXPORT
      #define DLLEXPORT16
      #define EXPORT_CALL
      #define LOADDS
      #define CALLBACK
  
      #ifdef HUGE
        #undef HUGE
        #define HUGE
      #endif
      #define _huge
      #define SW_SHOW 0
      #define _loadds
      #define PASCAL
      #ifndef UINT
        #define UINT unsigned int
      #endif  //UINT
      #ifndef INT
        #define INT int
      #endif  //INT
  
  
  //  #define CD_RAW_SECTOR_SIZE  2352   ///from CDROM.h
    
  //file
      #define FILE_BEGIN    SEEK_SET
      #define FILE_CURRENT  SEEK_CUR
      #define FILE_END      SEEK_END
      #define HFILE FILE*
      #define FHANDLE HFILE
      #define INVALID_HANDLE_VALUE NULL
      #define FHANDLE_ERROR INVALID_HANDLE_VALUE
      #define OPEN_FILE(PathName) fopen(PathName, "r")
      #define ReadFile(Handle,Buffer,Size,nRead,Overlapped) ReadSectors(NULL,0xa0000,8,(LPBYTE)Buffer)
      #define WriteFile(Handle,Buffer,Size,nWrote,Overlapped)
      #define CloseHandle(Handle)
      #define GetFileSize(x,y) 0x7fffffff  // to fool the NEC environment.
      #define SetFilePointer(x, y, z, a)
      #define CLOSE_FILE(x)
      #define _lwrite(x,y,z)
      #define START_OF_FILE 305105 
                                //  #define START_OF_FILE 305105  //pioneer test video disc4_1
                                //  #define START_OF_FILE 0x64A   //lord of dances.
                                //  #define START_OF_FILE 0x3c40  //sony disc.
                                //  #define START_OF_FILE 638    //J Brahms 1.vob
                                //  #define START_OF_FILE 524723    //J Brahms 2.vob
                                //  #define START_OF_FILE 548158  //pioneer test video disc.6_1
                                //  #define START_OF_FILE 434147  //pioneer test video disc.5_1
  
                                /*
                                Navigator disc
                                  Max     = 160740 to 196141(Absolute)
                                  Min     = 196891 to 205977(   "    )
                                  Var GOP = 205978 to 222280(   "    )
                                  Typical =  41909 to 160739(   "    )
                                  vts_01_1.vob start addr = 750.
                                */
  
  //string
      #define wsprintf sprintf
      #define lstrcpy strcpy
      #define lstrcat strcat
      #define lstrlen strlen
      #define LPCSTR const char*
      #define LPSTR  char*
      #define LPCTSTR const char *
      #define LPTSTR char *
      #define TOUPPER toupper
    
  //
      #define WPARAM UINT
      #define LPARAM LONG
      #define LRESULT LONG
  
      #define min(a,b)            (((a) < (b)) ? (a) : (b))
      #define max(a,b)            (((a) > (b)) ? (a) : (b))
      #define MAKEWORD(a, b)      ((WORD)(((BYTE)(a)) | ((WORD)((BYTE)(b))) << 8))
      #define MAKELONG(a, b)      ((LONG)(((WORD)(a)) | ((DWORD)((WORD)(b))) << 16))
      #define LOWORD(l)           ((WORD)(l))
      #define HIWORD(l)           ((WORD)(((DWORD)(l) >> 16) & 0xFFFF))
      #define LOBYTE(w)           ((BYTE)(w))
      #define HIBYTE(w)           ((BYTE)(((WORD)(w) >> 8) & 0xFF))
      #define MAKEWPARAM(l, h)      (WPARAM)MAKELONG(l, h)
      #define MAKELPARAM(l, h)      (LPARAM)MAKELONG(l, h)
      #define MAKELRESULT(l, h)     (LRESULT)MAKELONG(l, h)
      #define MAKELONG(a, b)      ((LONG)(((WORD)(a)) | ((DWORD)((WORD)(b))) << 16))
  
  //memory
      #define RtlZeroMemory(Destination,Length) memset((Destination),0,(Length))
      #define RtlCopyMemory(Destination,Source,Length) memcpy((Destination),(Source),(Length))
  
      #define MALLOC malloc
      #define MEMSET memset
      #define MEMCPY memcpy
      #define MEMCMP memcmp
      #define FREE   free
  
      #define ZeroMemory(Destination,Length ) memset((Destination),0,(Length))
      #define MoveMemory(Destination,Source,Length) memmove((Destination),(Source),(Length))
      #define CopyMemory(Destination,Source,Length) MEMCPY((Destination),(Source),(Length))
      #define FillMemory(Destination,Length,Fill)   MEMSET((Destination),(Fill),(Length))
  
      #ifdef __cplusplus
        extern "C"{
      #endif  //__cplusplus
        FHANDLE NECFileOpen(char*);
      #ifdef __cplusplus
        }
      #endif
      #ifdef _MIDAS
        #define _outpw(x,y) *((BYTE*)x)=(BYTE)y
        #define _inpw(x)   ((BYTE)*(BYTE *)x)
        #define _outpd _outpw
      #endif  //_MIDAS
  //===============================================================
  //     _ST_
  //===============================================================
    #elif defined(_ST_)
      //ST define NEED to add a define
      #include <math.h>
      #include <stdio.h>
      #include <stdlib.h>
      #include <string.h>
      #include <ctype.h>
      #include "debug.h"

      #define _DONT_INC_MEMORY_H 
      #define __stdcall
      #define WINAPI
      #define _stdcall
      #define __cdecl
      #define TEXT(xx) xx
      #define _loadds
      #ifndef FAR
        #define FAR
      #endif
      #ifndef NEAR
        #define NEAR
      #endif
      #define LONG long
      #define HINSTANCE LPVOID
      #define HANDLE LPVOID

      #ifndef UINT
        #define UINT unsigned int
      #endif  //UINT
      #ifndef INT
        #define INT int
      #endif  //INT

      #ifndef _TCHAR_DEFINED
        typedef char TCHAR, *PTCHAR;
        typedef unsigned char TBYTE , *PTBYTE ;
        #define _TCHAR_DEFINED
      #endif /* !_TCHAR_DEFINED */

      #define DLLEXPORT
      #define DLLEXPORT16
      #define EXPORT_CALL
      #define LOADDS
      #define CALLBACK

      #ifndef RECT_DEFINED
        #define RECT_DEFINED
        typedef struct tagRECT
        {
          LONG    left;
          LONG    top;
          LONG    right;
          LONG    bottom;
        } RECT, FAR *LPRECT, NEAR *NPRECT, *PRECT;
        typedef const RECT FAR* LPCRECT;
      #endif   // RECT_DEFINED

        #ifndef POINT_DEFINED
        #define POINT_DEFINED
        typedef struct tagPOINT
        {
          LONG  x;
          LONG  y;
        } POINT, *PPOINT, NEAR *NPPOINT, FAR *LPPOINT;
      #endif

  //file
      #define FILE_BEGIN    SEEK_SET
      #define FILE_CURRENT  SEEK_CUR
      #define FILE_END      SEEK_END
      #define HFILE FILE*
      #define FHANDLE HFILE
      #define INVALID_HANDLE_VALUE NULL
      #define FHANDLE_ERROR INVALID_HANDLE_VALUE
      #define OPEN_FILE(PathName) fopen(PathName, "r")
      #define ReadFile(Handle,Buffer,Size,nRead,Overlapped)
      #define WriteFile(Handle,Buffer,Size,nWrote,Overlapped)
      #define CloseHandle(Handle)
      #define GetFileSize(x,y) 0x7fffffff  // to fool the environment.
      #define SetFilePointer(x, y, z, a)
      #define CLOSE_FILE(x)
      //#define _lwrite(x,y,z)

  //string
      #define wsprintf sprintf
      #define lstrcpy strcpy
      #define lstrcat strcat
      #define lstrlen strlen
      #define LPCSTR const char*
      #define LPSTR  char*
      #define LPCTSTR const char *
      #define LPTSTR char *
      #define TOUPPER toupper
      #define LSTRRCHR strrchr
  //
      #define WPARAM UINT
      #define LPARAM LONG
      #define LRESULT LONG
      #define MARGIBIT INT
  
      #define min(a,b)            (((a) < (b)) ? (a) : (b))
      #define max(a,b)            (((a) > (b)) ? (a) : (b))
      #define MAKEWORD(a, b)      ((WORD)(((BYTE)(a)) | ((WORD)((BYTE)(b))) << 8))
      #define MAKELONG(a, b)      ((LONG)(((WORD)(a)) | ((DWORD)((WORD)(b))) << 16))
      #define LOWORD(l)           ((WORD)(l))
      #define HIWORD(l)           ((WORD)(((DWORD)(l) >> 16) & 0xFFFF))
      #define LOBYTE(w)           ((BYTE)(w))
      #define HIBYTE(w)           ((BYTE)(((WORD)(w) >> 8) & 0xFF))
      #define MAKEWPARAM(l, h)      (WPARAM)MAKELONG(l, h)
      #define MAKELPARAM(l, h)      (LPARAM)MAKELONG(l, h)
      #define MAKELRESULT(l, h)     (LRESULT)MAKELONG(l, h)
      #define MAKELONG(a, b)      ((LONG)(((WORD)(a)) | ((DWORD)((WORD)(b))) << 16))
  
  //memory
      #define RtlZeroMemory(Destination,Length) memset((Destination),0,(Length))
      #define RtlCopyMemory(Destination,Source,Length) memcpy((Destination),(Source),(Length))

      void* malloc_ex(size_t Size, unsigned char bCacheableType);
      void free_ex(void* pMemory, unsigned char bCacheableType);

      #define MALLOCEX(Size, bCacheableType) malloc_ex(Size, bCacheableType)
      #define FREEEX(pMemory, Size, bCacheableType) free_ex(pMemory, bCacheableType)

      #define MALLOC(Size)    malloc_ex(Size, MEMORY_CACHEABLE)
      #define MEMSET memset
      #define MEMCPY memcpy
      #define MEMCMP memcmp
      #define FREE(pMemory)   free_ex(pMemory, MEMORY_CACHEABLE)


      #define ZeroMemory(Destination,Length ) memset((Destination),0,(Length))
      #define MoveMemory(Destination,Source,Length) memmove((Destination),(Source),(Length))
      #define CopyMemory(Destination,Source,Length) MEMCPY((Destination),(Source),(Length))
      #define FillMemory(Destination,Length,Fill)   MEMSET((Destination),(Fill),(Length))

      #define __stdcall
      
      #ifdef __cplusplus
        extern "C"{
      #endif  //__cplusplus
       
      #ifdef __cplusplus
        }
      #endif

  //===============================================================
  //   __QNXNTO__
  //===============================================================
    #elif defined(__QNXNTO__)
      //
      #include <stdio.h>
      #include <stdlib.h>
      #include <unistd.h>
      #include <string.h>
      #include <ctype.h>
      #include <errno.h>
//    #include <math.h>
//    #include "debug.h"

      //
      #pragma pack(8)
      //

      #define _DONT_INC_MEMORY_H 
      #define WINAPI
//      #define __stdcall
//      #define _stdcall
      #define _loadds
      #define __cdecl
      #define TEXT(xx)  xx
      #define FAR
      #define NEAR
      #define HINSTANCE LPVOID
      #define HANDLE    LPVOID

      #ifndef LONG
       #define LONG     long
      #endif
      #ifndef UINT
        #define UINT    unsigned int
      #endif  //UINT
      #ifndef INT
        #define INT     int
      #endif  //INT

      #ifndef _TCHAR_DEFINED
        typedef char    TCHAR, *PTCHAR;
        typedef unsigned char TBYTE , *PTBYTE ;
        #define _TCHAR_DEFINED
      #endif /* !_TCHAR_DEFINED */

      #define DLLEXPORT
      #define DLLEXPORT16
      #define EXPORT_CALL
      #define LOADDS
      #define CALLBACK

      #ifndef RECT_DEFINED
        #define RECT_DEFINED
        typedef struct tagRECT
        {
          LONG    left;
          LONG    top;
          LONG    right;
          LONG    bottom;
        } RECT, FAR *LPRECT, NEAR *NPRECT, *PRECT;
        typedef const RECT FAR* LPCRECT;
      #endif   // RECT_DEFINED

        #ifndef POINT_DEFINED
        #define POINT_DEFINED
        typedef struct tagPOINT
        {
          LONG  x;
          LONG  y;
        } POINT, *PPOINT, NEAR *NPPOINT, FAR *LPPOINT;
      #endif

  //file
      #define FILE_BEGIN                  SEEK_SET
      #define FILE_CURRENT                SEEK_CUR
      #define FILE_END                    SEEK_END
      #define HFILE FILE*
      #define FHANDLE HFILE
      #define INVALID_HANDLE_VALUE        NULL
      #define FHANDLE_ERROR               INVALID_HANDLE_VALUE
      #define OPEN_FILE(PathName)         fopen(PathName, "r")
      #define CLOSE_FILE(x)
      //#define _lwrite(x,y,z)

  //string
      #define wsprintf sprintf
      #define lstrcpy  strcpy
      #define lstrcat  strcat
      #define lstrlen  strlen
      #define LPCSTR   const char*
      #define LPSTR    char*
      #define LPCTSTR  const char *
      #define LPTSTR   char *
      #define TOUPPER  toupper
      #define LSTRRCHR strrchr
  //
      #define WPARAM   UINT
      #define LPARAM   LONG
      #define LRESULT  LONG
      #define MARGIBIT UINT
  
      #define min(a,b)            (((a) < (b)) ? (a) : (b))
      #define max(a,b)            (((a) > (b)) ? (a) : (b))
      #define MAKEWORD(a, b)      ((WORD)(((BYTE)(a)) | ((WORD)((BYTE)(b))) << 8))
      #define MAKELONG(a, b)      ((LONG)(((WORD)(a)) | ((DWORD)((WORD)(b))) << 16))
      #define LOWORD(l)           ((WORD)(l))
      #define HIWORD(l)           ((WORD)(((DWORD)(l) >> 16) & 0xFFFF))
      #define LOBYTE(w)           ((BYTE)(w))
      #define HIBYTE(w)           ((BYTE)(((WORD)(w) >> 8) & 0xFF))
      #define MAKEWPARAM(l, h)    (WPARAM)MAKELONG(l, h)
      #define MAKELPARAM(l, h)    (LPARAM)MAKELONG(l, h)
      #define MAKELRESULT(l, h)   (LRESULT)MAKELONG(l, h)
      #define MAKELONG(a, b)      ((LONG)(((WORD)(a)) | ((DWORD)((WORD)(b))) << 16))
  
  //memory
      #define RtlZeroMemory(Destination,Length)        memset((Destination),0,(Length))
      #define RtlCopyMemory(Destination,Source,Length) memcpy((Destination),(Source),(Length))

      void*   OsQnx_MallocEx(size_t Size, unsigned char bCacheableType);
      void    OsQnx_FreeEx(void* pMemory,  size_t Size, unsigned char bCacheableType);

      #define MALLOCEX(Size, bCacheableType)        OsQnx_MallocEx(Size, bCacheableType)
      #define FREEEX(pMemory, Size, bCacheableType) OsQnx_FreeEx(pMemory, Size, bCacheableType)

      #define MALLOC malloc
      #define MEMSET memset
      #define MEMCPY memcpy
      #define MEMCMP memcmp
      #define FREE   free

      #define ZeroMemory(Destination,Length )          memset((Destination),0,(Length))
      #define MoveMemory(Destination,Source,Length)    memmove((Destination),(Source),(Length))
      #define CopyMemory(Destination,Source,Length)    MEMCPY((Destination),(Source),(Length))
      #define FillMemory(Destination,Length,Fill)      MEMSET((Destination),(Fill),(Length))

      #define __stdcall
      
      #ifdef __cplusplus
        extern "C"{
      #endif  //__cplusplus
       
      #ifdef __cplusplus
        }
      #endif
 
    #endif  //__QNXNTO__

  #endif //_WINDOWS
/***************************************************************
       _NEC_ end
***************************************************************/
#endif //_WIN32_WINNT

#ifdef WINNT

  #define FAR

//__declspec(dllimport) void _fastcall KfLowerIrql(unsigned char NewIrql);
//__declspec(dllimport) unsigned char _fastcall KfRaiseIrql(unsigned char NewIrql);

//#define IRQLEVEL unsigned char
//#define IRQ_RAISE_LEVEL(a,b) *(b)=KfRaiseIrql(a)
//#define IRQ_LOWER_LEVEL(a)   KfLowerIrql(a)

//__declspec(dllimport) void KeQuerySystemTime(__int64* CurrentTime);
//#define GET_SYSTEM_TIME  KeQuerySystemTime
  #define RtlCopyMemory(Destination,Source,Length) memcpy((Destination),(Source),(Length))
  #define RtlZeroMemory(Destination,Length) memset((Destination),0,(Length))
  #define RtlCopyMemory(Destination,Source,Length) memcpy((Destination),(Source),(Length))
#else 
//#define IRQLEVEL unsigned char
//#define IRQ_RAISE_LEVEL(a,b)
//#define IRQ_LOWER_LEVEL(a)
#endif

#ifndef _MARGITYPESDEFINED
  #define _MARGITYPESDEFINED
  #ifndef TRUE
    #define TRUE      1
    #define FALSE     0
  #endif
  #ifndef NULL
    #define NULL      0
  #endif  //NULL
  #ifndef LOCAL
    #define LOCAL static
  #endif
  #define BOOL      int
  #define BYTE      unsigned char
  #define PBYTE     unsigned char*
  #define LPBYTE    unsigned char*
  #define WORD      unsigned short
  #define PWORD     unsigned short*
  #define LPWORD    unsigned short*
  //#define LPLONG    unsigned short*  
  #define DWORD     unsigned long
  #define PDWORD    unsigned long*
  #define LPDWORD   unsigned long*
  #define ULONG     unsigned long
  #define UBYTE     unsigned char
  #define LONGLONG  __int64
  #define ULONGLONG unsigned __int64

  #define PVOID     void*
  #define LPVOID    void*

  #define DEBUG_BREAKPOINT()
  #define LOWORD(l)           ((WORD)(l))
#endif

#ifndef MARGIBIT
  #define MARGIBIT BYTE
#endif

#ifdef MALLOC
  #ifndef MALLOCEX
    #define MALLOCEX(Size, Cacheable) MALLOC(Size)
  #endif
#endif

#ifdef FREE
  #ifndef FREEEX
    #define FREEEX(pMemory, Size, Cacheable) FREE(pMemory)
  #endif
#endif

#define DEFINE_HANDLE(handle) typedef struct dummy##handle {int dummy;} FAR* handle

#ifdef __cplusplus
}
#endif

#endif

/* eof */
