//#include <StrmIni.h>
//#include <KS.h>
//#include <KsMedia.h>
//#include <mmsystem.h>
#include "system.h"
#include "MidasApi.h"
#include "dvHwMain.h"
#include "global.h"
#include "sync.h"

#if(0)
//Returns current system time in milliseconds
DWORD Margi_timeGetTime(void) {
  LONGLONG CurTime;
  DWORD dwMS;
  GET_SYSTEM_TIME(&CurTime);    //100ns ticks
  dwMS= (DWORD)(CurTime/10000);
  return(dwMS);
}
#endif

void tmInitStreamTime(PHW pHw) {
  pHw->dwClkRate=RATE_NORMAL;
  Set_MdsLongLong(&pHw->dlClkStartTime, 0, 0);

  pHw->dwNewClkRate=RATE_NORMAL;
  Set_MdsLongLong(&pHw->dlNewStartTime, 0, 0);

  pHw->dwScrTrigValue=0;
  pHw->dwScrTrigTime=0;
}

DWORD tmAdjustStreamTime(PHW pHw,MDSLONGLONG* pddTime)
{
  MDSLONGLONG ddTemp = {0};
  if(pHw->dwClkRate && pHw->dwClkRate!=RATE_NORMAL)
  {
    if(IsGreater_MdsLongLong(pddTime, &pHw->dlClkStartTime))
    {
      MDSLONGLONG ddTempTime = {0};

      //*pddTime=(*pddTime-pHw->dlClkStartTime)*10000/pHw->dwClkRate + pHw->dlClkStartTime;
      Sub_MdsLongLong(&ddTempTime, pddTime, &pHw->dlClkStartTime);  // ddTempTime = *pddTime - pHw->dlClkStartTime;
      Mul_MdsLongLong(&ddTempTime, &ddTempTime, 10000);             // ddTempTime = ddTempTime * 10000;
      Div_MdsLongLong(&ddTempTime, &ddTempTime, pHw->dwClkRate);    // ddTempTime = ddTempTime / pHw->dwClkRate;
      Add_MdsLongLong(pddTime, &ddTempTime, &pHw->dlClkStartTime);  // *pddTime   = ddTempTime + pHw->dlClkStartTime;
    }
  }
  else if(pHw->dwNewClkRate==RATE_NORMAL)
  {
    Copy_MdsLongLong(&pHw->dlClkStartTime, pddTime);  //pHw->dlClkStartTime = *pddTime;
  }
  //return (DWORD)(*pddTime*9/1000);
  Mul_MdsLongLong(&ddTemp, pddTime, 9);     // ddTemp = pddTime * 9;
  Div_MdsLongLong(&ddTemp, &ddTemp, 1000);  // ddTemp = ddTemp / 1000;
  return (DWORD)GetLow_MdsLongLong(&ddTemp);
}

long tmGetStreamTime(PHW pHw,MDSLONGLONG* pddCurTime,MDSLONGLONG* pddOldTime,MDSLONGLONG* pddNewTime) {
  long Err;
  SYNC_TIME90 CurTime90,OldTime90,NewTime90;

  dvHwMainGetTimeDiscontinuity(pHw,&OldTime90.dwTimeHi,&OldTime90.dwTimeLo,
                                   &NewTime90.dwTimeHi,&NewTime90.dwTimeLo);
  Err=SyncCmd(pHw,SYNC_GET_SCR,(DWORD)&CurTime90.dwTimeHi,(DWORD)&CurTime90.dwTimeLo);


  if(Err) {
    Set_MdsLongLong(pddCurTime,0,0);
    if(pddOldTime)
      Set_MdsLongLong(pddOldTime,0,0);
    if(pddNewTime)
      Set_MdsLongLong(pddNewTime,0,0);
  } else if(pHw->fTimeFormat10M) {
    tmConvertTime90Kto10M(&CurTime90,pddCurTime);
    if(pddOldTime)
      tmConvertTime90Kto10M(&OldTime90,pddOldTime);
    if(pddNewTime)
      tmConvertTime90Kto10M(&NewTime90,pddNewTime);
  } else {
    Set_MdsLongLong(pddCurTime,CurTime90.dwTimeLo,CurTime90.dwTimeHi);
    if(pddOldTime)
      Set_MdsLongLong(pddOldTime,OldTime90.dwTimeLo,OldTime90.dwTimeHi);
    if(pddNewTime)
      Set_MdsLongLong(pddNewTime,NewTime90.dwTimeLo,NewTime90.dwTimeHi);
  }
  return(Err);
}

long tmSetStreamTime(PHW pHw,MDSLONGLONG ddNewTime,MDSLONGLONG ddOldTime) {
  long Err;
  SYNC_TIME90 NewTime90;
  SYNC_TIME90 OldTime90;
  if(pHw->fTimeFormat10M) {
    tmConvertTime10Mto90K(&ddNewTime,&NewTime90);
    tmConvertTime10Mto90K(&ddOldTime,&OldTime90);
  } else {
    NewTime90.dwTimeLo=(DWORD)GetLow_MdsLongLong(&ddNewTime);
    NewTime90.dwTimeHi=(DWORD)GetHigh_MdsLongLong(&ddNewTime);
    OldTime90.dwTimeLo=(DWORD)GetLow_MdsLongLong(&ddOldTime);
    OldTime90.dwTimeHi=(DWORD)GetHigh_MdsLongLong(&ddOldTime);
  }
  Err= SyncCmd(pHw,SYNC_SET_SCR,(DWORD)&NewTime90,(DWORD)&OldTime90);
  return(Err);
}

long tmSetStreamTimeMode(PHW pHw, DWORD dwMode) {
  long Err=0;
  if(dwMode&MDS_STF_10M)
    pHw->fTimeFormat10M=1;
  else
    pHw->fTimeFormat10M=0;
  Err= SyncCmd(pHw,SYNC_SET_PTS_MODE,dwMode&MDS_STF_USE_MDP,0);
  return Err;
}

void tmConvertTime10Mto90K(MDSLONGLONG* pTime10M,SYNC_TIME90* pTime90K) {
  MDSLONGLONG ddTime90={0};
  Mul_MdsLongLong(&ddTime90,pTime10M,9);      //ddTime90 = pTime10M * 9;
  Div_MdsLongLong(&ddTime90,&ddTime90,1000);   //ddTime90 = ddTime90 / 1000;
  pTime90K->dwTimeLo= (DWORD)GetLow_MdsLongLong(&ddTime90);
  pTime90K->dwTimeHi= (DWORD)GetHigh_MdsLongLong(&ddTime90);
}

void tmConvertTime90Kto10M(SYNC_TIME90* pTime90K,MDSLONGLONG* pTime10M) {
  MDSLONGLONG ddTime90={0};
  Set_MdsLongLong(&ddTime90,pTime90K->dwTimeLo,pTime90K->dwTimeHi);
  Mul_MdsLongLong(&ddTime90,&ddTime90,1000);// ddTime90= ddTime90 * 1000;
  Div_MdsLongLong(pTime10M,&ddTime90,9);    // Time10M= ddTime / 9;
}

// Compare to 32 bit SCR's return TRUE is Time1 >= Time2
// Handle wrap by testing MSB
// If MSBs(Time1)==00 (+ve) and MSBs(Time2)==11 (-ve) then Time1 > Time2
// If MSBs(Time1)==11 (-ve) and MSBs(Time2)==00 (+ve) then Time1 < Time2
int tmCompareTimes(DWORD dwTime1, DWORD dwTime2) {
  if(((dwTime1&0xC0000000)==0) && ((dwTime2&0xC0000000)==0xC0000000))
    return 1;
  if(((dwTime1&0xC0000000)==0xC0000000) && ((dwTime2&0xC0000000)==0))
    return 0;
  else if(dwTime1>=dwTime2)
    return 1;
  else
    return 0;
}

void tmCueNewClkRate(PHW pHw,DWORD dwNewRate,MDSLONGLONG dlNewStartTime) {
  MDSLONGLONG ddTemp = {0};

  pHw->dwNewClkRate=dwNewRate;
  Copy_MdsLongLong(&pHw->dlNewStartTime, &dlNewStartTime);

  //pHw->dwScrTrigValue=(DWORD)(dlNewStartTime*90)/1000;
  Mul_MdsLongLong(&ddTemp, &dlNewStartTime, 90);      // ddTemp = dlNewStartTime * 90;
  Div_MdsLongLong(&ddTemp, &ddTemp, 1000);            // ddTemp = ddTemp / 1000;
  pHw->dwScrTrigValue = GetLow_MdsLongLong(&ddTemp);  // pHw->dwScrTrigValue = (DWORD)ddTemp;

  if(pHw->dwScrTrigValue==0)
    pHw->dwScrTrigValue++;    // make sure not zero so we know it is active
  if(pHw->dwClkRate==RATE_NORMAL)
    pHw->dwScrTrigTime=pHw->dwScrTrigValue;
  else
  {
    Set_MdsLongLong(&ddTemp, 0, 0);
    //pHw->dwScrTrigTime=(DWORD)((dlNewStartTime-pHw->dlClkStartTime)*(RATE_NORMAL/pHw->dwClkRate)*90/1000);
    Sub_MdsLongLong(&ddTemp, &dlNewStartTime, &pHw->dlClkStartTime);    // ddTemp = dlNewStartTime - pHw->dlClkStartTime;
    Mul_MdsLongLong(&ddTemp, &ddTemp, (RATE_NORMAL/pHw->dwClkRate));    // ddTemp = ddTemp * (RATE_NORMAL/pHw->dwClkRate)*90;
    Mul_MdsLongLong(&ddTemp, &ddTemp, 90);                              // ddTemp *= 90;
    Div_MdsLongLong(&ddTemp, &ddTemp, 1000);                            // ddTemp = ddTemp / 1000;
    pHw->dwScrTrigTime = (DWORD)GetLow_MdsLongLong(&ddTemp);
    if(pHw->dwScrTrigTime==0)
      pHw->dwScrTrigTime++;    // make sure not zero so we know it is active
  }
}

/**EOF: TIME.C**/
