//#include <StrmIni.h>
//#include <mmsystem.h>
//#include <KsMedia.h>
#include "system.h"
#include "DbgMsg.h"
#include "DbgFltr.h"
#include "Idents.h"
#include "margierr.h"

#include "MidasApi.h"
#include "lsi64020.h"
#include "dvHwMain.h"
#include "dvHwVid.h"
#include "dvHwAud.h"
#include "dvHwSub.h"
#include "Global.h"
#include "Settings.h"
#include "MdsNames.h"

// Set OUTSIZE to 2 for IOSW and 4 for IOSD
#define OUTSIZE 4
#define MEMSIZE 2

//static void TransferDataLog(PHW pHw, BYTE *pData, DWORD Bytes, DWORD StrmType);
//static long TransferDataMemMap(PHW pHw, BYTE *pData, DWORD Bytes, DWORD *pBytesSent, DWORD StrmType);
//static DWORD TransferDataIo (PHW pHw, BYTE *pData, DWORD Bytes);
//static DWORD TransferDataMem(PHW pHw, BYTE *pData, DWORD Bytes);
static DWORD TransferChnData(PHW pHw, BYTE *pData,DWORD Bytes,DWORD dwFlags);

static DWORD StopLogCnt= 0;
static BYTE FlushPkt[2048];
static BYTE FlushPktHdr[]= { 
  0x00,0x00,0x01,0xE0,0x07,0xFA,0x81,0x00,  //0-7
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,  //8-15
  0x00,0x00,0x00,0x00,0x00,0x00		    //16-21
//  0x00,0x00,0x01,0xE0,0x07,0xFA,0x81,0xC1,  //0-7
//  0x0D,0x31,0x00,0x03,0x5F,0xEB,0x11,0x00,  //8-15
//  0x03,0x48,0x75,0x1E,0x60,0xE8		    //16-21
};
static BYTE FlushPktEOS[]= { 0x00,0x00,0x01,0xB7 };
static DWORD FlushPending=0;  //Should be in some structure somewhere.
static WORD ghDbgDataLog;     //Handle to DbgMsg data logfile.
static WORD DbgDataStream;    //Mask of STRM_ streams to log.

void TransferInit(PHW pHw) {
  pHw->fOddByte=0;
}

long TransferFlushPkt(PHW pHw, DWORD Type) {
  long Err= 0;
  int   fDoFlush=1;
  DWORD Timeout,BytesToSend,Chunk,BytesSent=0,BytesAvail=0;
  BYTE *pData;
  FlushPending= 0;
  BytesToSend= sizeof(FlushPkt);
  memset(FlushPkt,0,sizeof(FlushPkt));
  switch(Type) {
    case FLUSH_NULL:
      DbgMsg(DBG_HWFLUSH,"Send: Flushing NULL packet.\r\n");
      break;
    case FLUSH_NORMAL:
      memcpy(FlushPkt,FlushPktHdr,sizeof(FlushPktHdr));
      DbgMsg(DBG_HWFLUSH,"Send: Flushing normal packet.\r\n");
      break;
    case FLUSH_EOS:
      memcpy(FlushPkt,FlushPktHdr,sizeof(FlushPktHdr));
      memcpy(FlushPkt+sizeof(FlushPktHdr),FlushPktEOS,sizeof(FlushPktEOS));
      DbgMsg(DBG_HWFLUSH,"Send: Flushing EOS packet.\r\n");
      break;  
    case FLUSH_PIPE:
      TransferData(pHw,0,0,0,MDS_XFR_FLAG_FLUSH|STRM_VID);
      fDoFlush=0;
      DbgMsg(DBG_HWFLUSH,"Send: Flush Pipe.\r\n");
      break;  
    case FLUSH_DISCARD:
      TransferData(pHw,0,0,0,MDS_XFR_FLAG_RESET|STRM_VID);
      fDoFlush=0;
      DbgMsg(DBG_HWFLUSH,"Send: Flush Discard.\r\n");
      break;  
    default:
      DbgMsg(DBG_HWFLUSH,"Send: Error Bad Flush Type.\r\n");
      break;
  }
  Timeout= MargiGetTime()+100;
  pData= FlushPkt;
  if(fDoFlush) {
    Err= TransferData(pHw,pData,BytesToSend,&Chunk,STRM_VID);
    // Indicate Flush incase DMA being used
    TransferData(pHw,0,0,0,MDS_XFR_FLAG_FLUSH|STRM_VID);
    if(Err==MARGI_ERR_WRT_FAILED) {   //RdyErr
      DbgMsg(DBG_CRIT,"Flush");
      dvHwMainClrRdyError(pHw);
      dvHwMainReportRdyError(pHw,3);
    }
  }
  return(Err);
}

void SearchData(BYTE* pData,DWORD dwBytes) {
  DWORD dw;
  volatile int i;
  if(dwBytes&0x0000ffff)
    for(dw=0;dw<dwBytes-8;dw++,pData++)
      if(*(pData+0)==0x99)
        if(*(pData+1)==0x5c)
          if(*(pData+2)==0x3f)
            if(*(pData+3)==0xdf)
              if(*(pData+4)==0x41)
                if(*(pData+5)==0x2b)
                  if(*(pData+6)==0xb5)
                    if(*(pData+7)==0x8b)
                      i=0;
}


long TransferData(PHW pHw, BYTE *pData, DWORD Bytes, DWORD *pBytesSent,DWORD StrmType) {
  long Err= 0;
  DWORD PktType,BytesSent= 0;
  if(PktType= FlushPending) {
    FlushPending= 0;
    TransferFlushPkt(pHw,FlushPending);
  } else {
//    TransferDataLog(pHw,pData,Bytes,StrmType);
//    DbgMsgCmd(DBGCMD_PROFILE|DBGCMD_PROF_ENTER,DBGPRF_WRITEVID,0);
//      SearchData(pData,Bytes);
      BytesSent=TransferChnData(pHw,pData,Bytes,StrmType);
//    DbgMsgCmd(DBGCMD_PROFILE|DBGCMD_PROF_EXIT,DBGPRF_WRITEVID,0);
    if(dvHwMainGetChannelStatus(pHw) & 8) {
      Err= MARGI_ERR_WRT_FAILED;
      BytesSent= 0;
    } else if(Bytes && !BytesSent) {
      Err= MARGI_ERR_WRT_STALLED;
    }
  }
  if(!ISBADPTR(pBytesSent,sizeof(*pBytesSent)))
    *pBytesSent= BytesSent;
  return Err;
}

#if(0)
static void TransferDataLog(PHW pHw, BYTE *pData, DWORD Bytes, DWORD StrmType) {
  if(ghDbgDataLog && StopLogCnt) {
    StopLogCnt--;
    if(DbgDataStream & StrmType) {
      DbgMsgCmd(((DWORD)ghDbgDataLog<<16)|DBGCMD_DATAWRITE,Bytes,(DWORD)pData);
      if(!StopLogCnt) {
        DbgMsgCmd(MAKELONG(DBGCMD_DATACLOSE,ghDbgDataLog),0,0);
        ghDbgDataLog= 0;
      }
    }
  }
}
#endif


static DumptoReg(BYTE  PactNum, BYTE* pData, DWORD Length)
{
  BYTE Pack[10];
  BYTE* pPack = Pack;
  if (PactNum < 200)
  {
    memcpy(pPack, "Pack", 4);
    pPack = Pack + 4;
    *pPack++ = 48 + (PactNum / 100) ;
    PactNum %= 100; 
    *pPack++ = 48 + (PactNum / 10) ;
    *pPack++ = 48 + (PactNum % 10) ;
    *pPack = 0;
    SettingFName(IniFName,IniDumKey);
    SettingSaveB(SET_DATA,Pack,(DWORD) pData, Length);
  }
}

BYTE   PackNum = 0;

static DWORD TransferChnData(PHW pHw, BYTE *pData,DWORD Bytes,DWORD dwFlags) {
  long Err= 0;
  DWORD dwWords;
  DWORD dwByteCount=0;
  BYTE*  pDumpData = pData;
  DWORD  dDumpByte = Bytes;

#ifdef _WIN32_WCE
  if(!pData)
    return 0L;
#endif

  if(dwFlags&MDS_XFR_FLAGS)
    pHw->fOddByte=0;
  
  if(pHw->fOddByte) {
    WORD wDat=pHw->bOddByte|(WORD)(*pData<<8);
    pHw->pfnChnWrWords(pHw->dwChnAddr,(BYTE*)&wDat,1,dwFlags);
    pHw->fOddByte=0;
    pData++;
    dwByteCount++;
    Bytes--;
  }

  dwWords=pHw->pfnChnWrWords(pHw->dwChnAddr,pData,Bytes/2,dwFlags);
  dwByteCount+=dwWords*2;
  pData+=dwWords*2;

  if(Bytes&1) {
    pHw->bOddByte=*pData;
    pHw->fOddByte=1;
    pData++;
    Bytes--;
    dwByteCount++; 
  }
#ifdef  DumpReg
  if ((PackNum < 200) && pDumpData && dwByteCount)
    DumptoReg(PackNum ++, pDumpData, dDumpByte);
#endif  
  return dwByteCount;
}

/**EOF: TRANSFER.C**/
