//#include <StrMini.h>
//#include <MMSystem.h>
//#include <KsMedia.h>
#include "system.h"
#include "DbgMsg.h"
#include "DbgFltr.h"
#include "margierr.h"
#include "Idents.h"

#include "MidasApi.h"
#include "Lsi64020.h"
#include "dvHwMain.h"
#include "Global.h"
#include "IdentCls.h"
#include "UserData.h"
#include "Sync.h"
#include "dvhwvid.h"

#pragma message("UserData.c: Optimizer disabled.")
#pragma optimize("",off)

struct Line21Data_s {
  union {
    struct {
      BYTE marker_bits:7;
      BYTE line21_switch:1;
    }s;
    BYTE marker_line21switch;
  }u;
  BYTE line21_data[2];
};

struct CCData_s {
  BYTE DataValid;
  BYTE Reserved[4];
  union {
    struct {
      BYTE top_field_flag_of_gop:1;
      BYTE reservd:1;
      BYTE num_of_displayed_field_gop:6;
    }s;
    BYTE Gops;
  }u;
  struct Line21Data_s *Lin21Data;
  MDSLONGLONG Pts;
};

typedef struct Cc_s {
  DWORD Signature;
  PHW   pHw;
  DWORD State;
  QUEUE DataQ;
  int   fFlush;
} CC;

#define CC_SIGNATURE 0xABBAABBA

CC Cc;

//struct CCData_s CCData[2];
BYTE LocalBuff[200];
BYTE LocalBuffOffSet= 0;
BYTE PrevCCData[200];
BYTE PrevCCDataValid;
BYTE PrevCCDataSize;
BYTE gfInitDone= FALSE;
MDSLONGLONG PrevCCDataPts = {0};
BYTE gfCCDataDiscontinuity=0;

static long UserDataInit(PHW pHw);
static long UserDataFini(PHW pHw);
static long UserDataTimer(PHW pHw);
static long UserDataGet(PHW pHw,DWORD Arg1);
static long UserDataReset(PHW pHw);
static long UserDataFlush(PHW pHw);
static long UserDataDiscontinuity(PHW,DWORD dwFlag);
static long UserDataReSync(PHW pHw);
static long UserDataRdOneByte(PHW pHw,BYTE* pBuff);
static DWORD CcPumpData(PHW pHw);
static CC *CcPtr(DWORD hCc);

long UserDataCmd(PHW pHw, DWORD Cmd, DWORD Arg1, DWORD Arg2);

long UserDataCmd(PHW pHw, DWORD Cmd, DWORD Arg1, DWORD Arg2) {
  long Err= 0;
  switch(Cmd) {
    case USERDATACMD_INIT:      Err= UserDataInit(pHw); break;
    case USERDATACMD_FINI:      Err= UserDataFini(pHw); break;
    case USERDATACMD_TIMER:     Err= UserDataTimer(pHw); break;
    case USERDATACMD_GET:       Err= UserDataGet(pHw,Arg1); break;
    case USERDATACMD_RESET:     Err= UserDataReset(pHw); break;
    case USERDATACMD_FLUSH:     Err= UserDataFlush(pHw); break;
    case USERDATACMD_DISCONTINUITY: Err=UserDataDiscontinuity(pHw,Arg1); break;
    default:                    Err= MARGI_ERR_BADCMD; break;
  }
  return Err;
}


static long UserDataInit(PHW pHw) {
  long Err= 0;
  Cc.Signature= CC_SIGNATURE;
  Cc.pHw= pHw;
  qInitQueue(&Cc.DataQ);
  pHw->hCc= (DWORD)&Cc;
  dvHwMainWriteLsiRegBits(pHw,RESET_USER_DATA_REG,RESET_USER_DATA);  
  dvHwMainWriteLsiRegBits(pHw,USERDATA_FIFO_RESET,USERDATA_FIFO_RESET_VAL);
  gfInitDone= TRUE;
  return Err;
}

static long UserDataReset(PHW pHw) {
  long Err= 0;
  RtlZeroMemory(&LocalBuff[0],sizeof(LocalBuff));
  RtlZeroMemory(&PrevCCData[0],sizeof(LocalBuff));
  LocalBuffOffSet= 0;
  PrevCCDataValid= FALSE;
  dvHwMainWriteLsiRegBits(pHw,USERDATA_FIFO_RESET,USERDATA_FIFO_RESET_VAL);
  return Err;
}

static long UserDataDiscontinuity(PHW pHw,DWORD dwFlag) {
  gfCCDataDiscontinuity=1;
  return 0;
}

static long UserDataFlush(PHW pHw) {
  long Err=0;
  CC *pCc;
  if(pCc=CcPtr(pHw->hCc))
    pCc->fFlush=1;
  return Err;
}


static long UserDataFini(PHW pHw) {
  long Err= 0;
  gfInitDone= FALSE;
  return Err;
}

static long UserDataTimer(PHW pHw) {
  long Err= 0;
  CC *pCc;
  if(!gfInitDone)
    return 0;
  if(pCc=CcPtr(pHw->hCc)) {
    while(!UserDataRdOneByte(pHw,&LocalBuff[LocalBuffOffSet])) {
      LocalBuffOffSet++;
      if(LocalBuffOffSet>=200) {
        LocalBuffOffSet= 0;
        DbgMsg(DBG_MSGCC,"UserData: BUG! BuffOffset exceeding 200 bytes. \r\n");
        break;
      }
      if(LocalBuffOffSet>2) {
        if(*(WORD*)&LocalBuff[LocalBuffOffSet-2]==0xf801) {
          if(PrevCCDataValid) {
            DbgMsg(DBG_MSGCC,"Previous CC Data Has not been fetched. Overwritng the Data\r\n");
          }
          PrevCCDataSize= LocalBuffOffSet-2;
          RtlCopyMemory(&PrevCCData[0],&LocalBuff[0],PrevCCDataSize);
          PrevCCDataValid= TRUE;
          Err=tmGetStreamTime(pHw,&PrevCCDataPts,0,0);
          if(Err)
            Set_MdsLongLong(&PrevCCDataPts, 0, 0);

          RtlZeroMemory(&LocalBuff[0],200);
          LocalBuffOffSet= 2;
          *(WORD*)&LocalBuff[0]=0xf801;

          if(VideoCmd(pHw,VIDCMD_GET,VIDITEM_STATE,0)==Z_STATE_PLAY && 
             VideoCmd(pHw,VIDCMD_GET,VIDITEM_RATECUR,0)==RATE_NORMAL) {
            CcPumpData(pHw);
          }
        }
      }
    }
    if(gfCCDataDiscontinuity || pCc->fFlush) {
      CcPumpData(pHw);
    }
  }
  return Err;
}

static long UserDataGet(PHW pHw,DWORD Arg1) {
  long Err= 0;
  struct CCInfo_s* pCCInfo= (struct CCInfo_s*)Arg1;
//  DWORD Time90KHz;
//  BYTE *pBuff;

  if(PrevCCDataValid && pCCInfo) {
    if(VideoCmd(pHw,VIDCMD_GET,VIDITEM_STATE,0)!=Z_STATE_PLAY) {
        DbgMsg(DBG_MSGCC," Video Stream is NOT playing. \r\n");
    } else if(VideoCmd(pHw,VIDCMD_GET,VIDITEM_RATECUR,0)!=RATE_NORMAL) {
        DbgMsg(DBG_MSGCC," Video Play Rate is NOT normal. \r\n");
    } else {
      if(*(WORD*)&PrevCCData[0]==0xf801) {
//        RtlCopyMemory((void*)pCCInfo->dwBuff,&PrevCCData[0],8);
//        pBuff= (BYTE*)pCCInfo->dwBuff;
//        *(pBuff+2)= (*(pBuff+2)<<7) | (*(pBuff+3)<<6) | (*(pBuff+4));
//        RtlCopyMemory(pBuff+3,&PrevCCData[5],PrevCCDataSize-5);
//        pCCInfo->dwBytesRead= PrevCCDataSize-2;

        RtlZeroMemory(&PrevCCData[0],sizeof(PrevCCData));
        PrevCCDataValid= FALSE;
  
      } else {
        DbgMsg(DBG_MSGCC,"Bogus Closed Caption Data \r\n");
      }
/*
      if(pCCInfo->dwBytesRead) {
        Err= SyncCmd(pHw,SYNC_GET,SYNC_ITEM_TIME,(DWORD)&Time90KHz);
        if(!Err)
          pCCInfo->Pts= ((ULONGLONG)Time90KHz*1000)/9+10000000;
        else
          pCCInfo->Pts= 0;
        DbgMsg(DBG_MSGCC,"Read %d byted from UserData Fifo (0x%08x) \r\n",pCCInfo->dwBytesRead,*(DWORD*)pCCInfo->dwBuff);
      }
*/
//      pCCInfo->Pts= PrevCCDataPts;
    }
  }
  return Err;
}

static long UserDataRdOneByte(PHW pHw,BYTE* pBuff) {
  long Err= 0xFFFFFFFF;
  BYTE Data= dvHwMainReadLsiReg(pHw,USERDATA_FIFO_STATUS_REG);
  if((Data&USERDATA_STATUS_MASK_BITS)!=USERDATA_STATUS_EMPTY) {
    *pBuff= (BYTE)dvHwMainReadLsiReg(pHw,USERDATA_FIFO_DATA_REG);
    Err= 0;
  }
  return Err;
}

static CC *CcPtr(DWORD hCc) {
  if(hCc && *(DWORD*)hCc==CC_SIGNATURE)
    return((CC*)hCc);
  return(0);
}


long CcQueueData(PHW pHw,PMDS_DATA_BLOCK pMdb) {
  long lErr=0;
  CC *pCc;
  if(pCc=CcPtr(pHw->hCc)) {
    pMdb->dwCurPacket=0;
    qEnqueue(&pCc->DataQ,pMdb);
  } else
    lErr= MARGI_ERR_BADHANDLE;
  return lErr;
}

long CcCancelData(PHW pHw,PMDS_DATA_BLOCK pMdb) {
  long Err=0;
  CC *pCc;
  if(pCc=CcPtr(pHw->hCc)) {
    if(pMdb) {
      pMdb->dwCurPacket=0;
      pMdb->dwStatus=MDS_Cancel;
      if(qFindAndDequeue(&pCc->DataQ,pMdb)) {
        PMDB_CALLBACK pfnCallback = (PMDB_CALLBACK)pMdb->pfnCallback;
        pfnCallback(pMdb);
      }
    } else {
      qPurgeQueue(&pCc->DataQ,MDS_Cancel);
    }
  } else
    Err= MARGI_ERR_BADHANDLE;
  return 0;
}

DWORD CcPumpData(PHW pHw) {
  DWORD dwBytesTransfered=0;
  CC* pCc;
  if(pCc=CcPtr(pHw->hCc)) {
    PQUEUE pQ;
    PMDS_DATA_BLOCK  pMdb;
    PMDS_DATA_PACKET pMdp;
    BYTE *pBuff;
    pQ=&pCc->DataQ;
    if(pCc->fFlush) {
      pCc->fFlush=0;
      qPurgeQueue(pQ,MDS_Cancel);
    }
    pMdb=pQ->pHead;
    if(pMdb) {
      pMdp=&pMdb->pPackets[pMdb->dwCurPacket];
      if(*(WORD*)&PrevCCData[0]==0xf801) {
        pBuff= (BYTE*)(((DWORD)pMdp->Data));
        RtlZeroMemory(pBuff,pMdp->DataUsed);
        *(DWORD*)pBuff= 0xB2010000;
        *(WORD*)((DWORD)pBuff+4)= (WORD)0x4343;
        pBuff= (BYTE*)(((DWORD)pMdp->Data)+6);
        RtlCopyMemory((void*)pBuff,&PrevCCData[0],8);
        //pBuff= (BYTE*)pMdp->Data;
        *(pBuff+2)= (*(pBuff+2)<<7) | (*(pBuff+3)<<6) | (*(pBuff+4));
        RtlCopyMemory(pBuff+3,&PrevCCData[5],PrevCCDataSize-5);
        pMdp->DataUsed= PrevCCDataSize-2;
        pMdp->DataUsed= PrevCCDataSize+4;
        Copy_MdsLongLong(&pMdp->PresentationTime.Time, &PrevCCDataPts);
        Set_MdsLongLong(&pMdp->Duration, 1000, 0);
        PrevCCDataValid= FALSE;
        pMdb->dwStatus=MDS_Success;
      } else if(gfCCDataDiscontinuity) {
//        pMdp->DataUsed=0;
//        pMdb->dwStatus=MDS_Success;
      }
      if(pMdb->dwStatus==MDS_Success) {
        if(gfCCDataDiscontinuity) {
          pMdp->OptionsFlags|=MDB_FLAG_DATADISCONTINUITY;
          gfCCDataDiscontinuity=0;
        }
        qDequeue(pQ);
        ((PMDB_CALLBACK)pMdb->pfnCallback)(pMdb);
      }
    }
  }
  return dwBytesTransfered;
}


/* EOF : USERDATA.C */
