//
// Avi's CSS attempt...
// Created from IDA Pro dump
//
#include "system.h"
#include "DbgMsg.h"
#include "DbgFltr.h"
#include "Settings.h"

#include "Lsi64020.h"
#include "MidasApi.h"
#include "dvHwMain.h"
#include "Global.h"
#include "Sync.h"
#include "margierr.h"
#include "Idents.h"
#include "dvHwVid.h"
#include "dvHwAud.h"
#include "dvCss.h"
#include "identcls.h"
#include "IniNames.h"
#include "eeprom.h"

//hwCopyProtection wrappers
LOCAL long CSS_InitHardware(PMIDASCMD pCmd);
LOCAL long CSS_SyncTitle(PMIDASCMD pCmd);
LOCAL long CSS_GetChallenge(PMIDASCMD pCmd);
LOCAL long CSS_GetResponse(PMIDASCMD pCmd);
LOCAL long CSS_SetChallenge(PMIDASCMD pCmd);
LOCAL long CSS_SetResponse(PMIDASCMD pCmd);
LOCAL long CSS_SetTitle(PMIDASCMD pCmd);
LOCAL long CSS_SetDiskKey(PMIDASCMD pCmd);
LOCAL long CSS_GetRegionCode(PMIDASCMD pCmd);
LOCAL long CSS_VidCmdCssOk(PMIDASCMD pCmd);

//internal functions
LOCAL long hwCssInitLSI(PHW pHw, DWORD DwIoAddr, int mode);
LOCAL long hwCssRdCssKey40(PHW pHw, BYTE* key40);
LOCAL BYTE hwCssReadCssKeyReg(PHW pHw);
LOCAL long hwCssReadCssStatus(PHW pHw);
LOCAL long hwCssSetCssCmd(PHW pHw,WORD wCmd);
LOCAL long hwCssSendCssCmd(PHW pHw,WORD wCmd);
LOCAL long hwCssGenHostChallenge(PHW pHw, BYTE *pKey80, int opt);
LOCAL long hwCssCmpKey(BYTE *key1, BYTE *key2, int size);
LOCAL long hwCssRdKey80(PHW pHw, BYTE* pKey80);
LOCAL void hwCssWrKey40(PHW pHw, BYTE* pKey40);
LOCAL long hwCssWrKey80(PHW pHw, BYTE* pKey80);
LOCAL long hwCssSetChallenge(PHW pHw, PKS_DVDCOPY_BUSKEY pBUSKEY, BYTE* pKey80);
LOCAL long hwCssSetResponse(PHW pHw,  PKS_DVDCOPY_BUSKEY pBUSKEY);
LOCAL long hwCssDriveRefKey(PHW pHw, BYTE *pKey40);
LOCAL long hwCssWriteTitleKey(PHW pHw, BYTE *pKey40);
LOCAL long hwCssDescramble(PMIDASCMD pCmd, long arg1, long arg2);
LOCAL void hwWriteChanData(PHW pHw, WORD val);
LOCAL long hwCssWriteDiskKey(PHW pHw, BYTE *pDiskKey, long size);
LOCAL void hwCssWrBusKey(PHW pHw, PKS_DVDCOPY_BUSKEY pBUSKEY);

BYTE css_buskey[10];

long hwCopyProtection(PMIDASCMD pCmd)
{
	long Err= 0;
	switch(pCmd->cmd) {
	case	MDS_CSS_INITHW:	//CSS Init the Hardware
		Err = CSS_InitHardware(pCmd);
		break;

	case	MDS_CSS_SYNCTITLE:
		Err = CSS_SyncTitle(pCmd);
		break;

	case	MDS_CSS_GETCHALLENGE:   //Get CSS Challange Key - TODO
		Err = CSS_GetChallenge(pCmd);
		break;

	case	MDS_CSS_GETRESPONSE:    //Get DVD Key2 (provides the dvd drive with bus key 2 from the decoder) - TODO
		Err = CSS_GetResponse(pCmd);	
		break;

	case	MDS_CSS_SETCHALLENGE:   //Set CSS Challange Key - TODO
		Err = CSS_SetChallenge(pCmd);
		break;

	case	MDS_CSS_SETRESPONSE:    //Set DVD Key1 (provides the dvd drive bus key 1 for the decoder) - TODO
		Err= CSS_SetResponse(pCmd);
		break;

	case	MDS_CSS_SETTITLE:       //Set DVD title key (provides the dvd drive title key to the decoder) - TODO
		Err = CSS_SetTitle(pCmd);
		break;

	case	MDS_CSS_SETDISCKEY:     //Set the DVD disc key.(provides the dvd disc key to the decoder) - TODO
		Err = CSS_SetDiskKey(pCmd);
		break;

	case	MDS_CSS_GETREGIONCODE:  //Get Region Code
		Err = CSS_GetRegionCode(pCmd);
		break;

	case	MDS_CSS_ENABLE_CHANNEL: //Enable data transfer select descramble or not Arg1=Enable Channel, Arg2=Enable CSS
		Err = hwCssDescramble(pCmd, pCmd->u.M.Arg1, pCmd->u.M.Arg2);
		break;

	case	MDS_CSS_FORCECHALLENGE:
		Err = CSS_VidCmdCssOk(pCmd);
		break;

	default:
		Err = MARGI_ERR_ARG1;
		break;
	}
	return(Err);
}



long CSS_InitHardware(PMIDASCMD pCmd)
{
	PHW pHw = (PHW)pCmd->hMidas;
	(void)hwCssInitLSI(pHw, pHw->dwIoAddr, 0);
	pHw->fCssTitleKeySet = 0;
	pHw->fCssApplyingTitleKey = 0;
	return(0);
}

long CSS_SyncTitle(PMIDASCMD pCmd)
{
	long Err = 0;
	PHW pHw = pCmd->hMidas;
	DWORD Arg1 = (DWORD) pCmd->u.pMdb;

	switch(pCmd->wCurrStream) {
	case STRM_VID:
		Err = VideoCmd(pHw, VIDCMD_SYNCTITLE, Arg1, 0);
		break;
	case STRM_AUD:
		Err = AudioCmd(pHw, AUDCMD_SYNCTITLE, Arg1, 0);
		break;
	default:
		Err = MARGI_ERR_BADITEM;
		break;
	}
	
	return Err;
}

long hwCssGenHostChallenge(PHW pHw, BYTE *pKey80, int opt)
{
	BYTE	*p_key80 = pKey80;
	long	Err = 0;
	int	loop = 0;
	BYTE	new_key[10];

	hwCssSetCssCmd(pHw, CssCmdNone);
	do {
		hwCssSendCssCmd(pHw, CssCmdGenCh);
		hwCssSendCssCmd(pHw, CssCmdRdCh);
		hwCssReadCssStatus(pHw);
		hwCssRdKey80(pHw, pKey80);
		hwCssRdKey80(pHw, new_key);
		if (hwCssCmpKey(pKey80, new_key, 10)) {
			return(Err);
		} 
	}while(loop++ < 2);
	return(MARGI_ERR_CSS_GENCHALLENGE);
}


long CSS_GetChallenge(PMIDASCMD pCmd)
{
	long Err = 0;
	long loop = 5;
	PHW pHw = (PHW)pCmd->hMidas;
	PKS_DVDCOPY_CHLGKEY pCHLGKEY = pCmd->u.pCHLGKEY;
	do {
		Err = hwCssGenHostChallenge(pHw, pCHLGKEY->bChlgKey, 0);
		if (!Err) break;
	} while (loop--);
	return Err;
}

long CSS_GetResponse(PMIDASCMD pCmd)
{
	memcpy(pCmd->u.pBUSKEY, css_buskey, 5);
	return(0);
}

long CSS_SetChallenge(PMIDASCMD pCmd)
{
	return(hwCssSetChallenge(pCmd->hMidas, pCmd->u.pBUSKEY, css_buskey));
}

long CSS_SetResponse(PMIDASCMD pCmd)
{
	return(hwCssSetResponse(pCmd->hMidas, pCmd->u.pBUSKEY));
}

long CSS_SetTitle(PMIDASCMD pCmd)
{
	PHW  pHw = pCmd->hMidas;
	PKS_DVDCOPY_TITLEKEY pTitleKey = pCmd->u.pTITLEKEY;

	long Err = 0;
	long loop = 5;
	long title_flag = 0;
	long flag1 = 0;
	long var4;

	while (loop) {
		if ((Err = hwCssWriteTitleKey(pHw, pTitleKey->bTitleKey) ) == 0) break;
		var4 = 0;
		loop--;
	}
	title_flag = 1;
	flag1 = title_flag;
	pHw->fCssTitleKeySet = title_flag;
	hwCssDescramble(pCmd, title_flag, flag1);
	pHw->fCssNewTitleKey = title_flag;
	pHw->fCssWaitForTitleKey = 0;
	pHw->fCssApplyingTitleKey= 0;

	return (Err);
}

LOCAL long  CSS_SetDiskKey(PMIDASCMD pCmd)
{
	return(hwCssWriteDiskKey(pCmd->hMidas, pCmd->u.pDISCKEY->bDiscKey, 2048));
}

LOCAL long CSS_GetRegionCode(PMIDASCMD pCmd)
{
//	unsigned long reg_info;
	PMIDASCMD _pCmd = pCmd;
	PKS_DVDCOPY_REGION pReg = pCmd->u.pRegionInfo;
	EEPROM_Proc(_pCmd->hMidas, EEPROM_READ_REGION, (unsigned long)&pCmd , 0);
	_pCmd->u.pRegionInfo->RegionData   = (BYTE)pCmd;
	_pCmd->u.pRegionInfo->Reserved2[0] = (BYTE) (((unsigned long)pCmd)>>8);
	_pCmd->u.pRegionInfo->Reserved2[1] = (BYTE) (((unsigned long)pCmd)>>16);
	return 0;
}

LOCAL long CSS_VidCmdCssOk(PMIDASCMD pCmd)
{
	long Err = 0;
	PHW pHw = pCmd->hMidas;
	if (VideoCmd(pHw, VIDCMD_CSS_OK, 0, 0)==0) {
		hwCssWrBusKey(pHw, pCmd->u.pBUSKEY);	
	} else {
		Err = MARGI_ERR_CSS_TIMEOUT;
	}
	return Err;
}

/******************
*
*
******************/


LOCAL long hwCssInitLSI(PHW pHw, DWORD dwIoAddr, int mode)
{
	long Err = 0;

	if (mode!=0) {
		Err = MARGI_ERR_CSS_HW_NOTFOUND;
	} else {
		WrByte(pHw, REG_INDEX(pHw), RIX_BOARD_ID);
		if (RdByte(pHw, REG_DATA(pHw)) != 0xDD) {
			Err = MARGI_ERR_CSS_HW_NOTFOUND;
		} else {
			WrByte(pHw, REG_INDEX(pHw), RIX_OSC_CNTRL);
			WrByte(pHw, REG_DATA(pHw), (RdByte(pHw, REG_DATA(pHw)) & 0xF7) );

			WrByte(pHw, REG_INDEX(pHw), RIX_LSI_CNTRL);
			WrByte(pHw, REG_DATA(pHw), (RdByte(pHw, REG_DATA(pHw)) | 0x1) );
		}
	}
	return(Err);
}

LOCAL long hwCssRdCssKey40(PHW pHw, BYTE* key40)
{
	long	Err = 0;
	long	status;

	int nr_bytes = 0;
	while (Err==0) {
		if (nr_bytes>=5) break;
		key40[nr_bytes] = hwCssReadCssKeyReg(pHw);
		hwCssSendCssCmd(pHw, CssCmdRdCh);
		status = hwCssReadCssStatus(pHw);
		if (status&1) {
			Err = MARGI_ERR_CSS_RDKEY40;
		}
		nr_bytes++;
	} 
	return (Err);
}


LOCAL BYTE hwCssReadCssKeyReg(PHW pHw) 
{
	WrByte(pHw,REG_INDEX(pHw),(BYTE)RIX_CSS_KEY);
	return(RdByte(pHw,REG_DATA(pHw)));
}

LOCAL long hwCssReadCssStatus(PHW pHw) 
{
	int loop = 10000;
	BYTE status = 0;
	WrByte(pHw, REG_INDEX(pHw), RIX_CSS_STAT);
	do {
		status = RdByte(pHw, REG_DATA(pHw));
		if (!(status&1)) {
			return status;
		}
	} while(loop--!=0);
	return(status&0xff);
}
	
LOCAL long hwCssSendCssCmd(PHW pHw,WORD wCmd) 
{
	long Err= 0;
	WrByte(pHw,REG_INDEX(pHw),(BYTE)(RIX_CSS_CMD));
	if(wCmd&0x80) {
		WrByte(pHw,REG_DATA(pHw),(BYTE)(wCmd&0x7f));
		WrByte(pHw,REG_DATA(pHw),(BYTE)((wCmd&0x7f)|0x10));
	}
	WrByte(pHw,REG_DATA(pHw),(BYTE)(wCmd&0x7f));
	return Err;
}


LOCAL long hwCssSetCssCmd(PHW pHw,WORD wCmd) 
{
	DbgMsg(DBG_HWCMD,"Set Css Cmd=%d\r\n",wCmd);
	WrByte(pHw,REG_INDEX(pHw),(BYTE)RIX_CSS_CMD);
	WrByte(pHw,REG_DATA(pHw), (BYTE)(wCmd&0x7f));
	return 0;
}

LOCAL long hwCssCmpKey(BYTE *key1, BYTE *key2, int size)
{
	BYTE *p1 = key1;
	BYTE *p2 = key2;
	int loop = 0;
	if (size > 0) {
		while(loop<size) {
			if (*p1!=*p2) break;
			p1++;
			p2++;
			loop++;
		}
	} 
	return (size==loop);
}

LOCAL long  hwCssRdKey80(PHW pHw, BYTE* pKey80)
{
	long Err;
	Err = hwCssRdCssKey40(pHw, pKey80);
	if (Err) return Err;
	Err = hwCssRdCssKey40(pHw, pKey80+5);
	return Err;
}

LOCAL void hwCssWrKey40(PHW pHw, BYTE* pKey40)
{
	unsigned short val = ((unsigned short*)pKey40)[0];
	WrWord(pHw, REG_AUDIO_CHANNEL(pHw), val);
	val = ((unsigned short*)pKey40)[1];
	WrWord(pHw, REG_AUDIO_CHANNEL(pHw), val);
	val = pKey40[4];
	WrWord(pHw, REG_AUDIO_CHANNEL(pHw), val);

}

LOCAL long hwCssWrKey80(PHW pHw, BYTE* pKey80)
{
	long Err = 0;
	long status;
	hwCssSendCssCmd(pHw, CssCmdWrCh);
	hwCssWrKey40(pHw, pKey80);
	status = hwCssReadCssStatus(pHw);
	if (status&1) {
		return(MARGI_ERR_CSS_WRKEY40);
	}
	hwCssSendCssCmd(pHw, CssCmdWrCh);
	hwCssWrKey40(pHw, pKey80+5);
	status = hwCssReadCssStatus(pHw);
	if (status&1) {
		return(MARGI_ERR_CSS_WRKEY40);
	}
	return(Err);
}

LOCAL long hwCssSetChallenge(PHW pHw, PKS_DVDCOPY_BUSKEY pBUSKEY, BYTE* pKey40)
{
	long Err = 0;
	long status;
	if (Err = hwCssWrKey80(pHw, pBUSKEY->bBusKey )) return Err;
	hwCssSendCssCmd(pHw, CssCmdDecAuth);
	status = hwCssReadCssStatus(pHw);
	if ((status&3)!=2) {
		return(MARGI_ERR_CSS_DECAUTH);
	}
	hwCssRdCssKey40(pHw, pKey40);
	return(Err);
}

LOCAL long hwCssSetResponse(PHW pHw, PKS_DVDCOPY_BUSKEY pBUSKEY)
{
	long Err = 0;
	long status;
	if ( !(Err = hwCssDriveRefKey(pHw, pBUSKEY->bBusKey) ) ) {
		hwCssSendCssCmd(pHw, CssCmdDrvAuth);
		status = hwCssReadCssStatus(pHw);
		if ((status&3)!=2) {
			Err = MARGI_ERR_CSS_DRVAUTH;
		}
	}
	return Err;
}

LOCAL long hwCssDriveRefKey(PHW pHw, BYTE *pKey40)
{
	long Err = 0;
	hwCssSendCssCmd(pHw, CssCmdWrDrvRef);
	hwCssWrKey40(pHw, pKey40);
	if (hwCssReadCssStatus(pHw) &1) { 
		Err = MARGI_ERR_CSS_WRDRVREFKEY;
	}
	return(Err);
}

LOCAL long hwCssWriteTitleKey(PHW pHw, BYTE *pKey40)
{
	long Err = 0;
	long status = 0;
	hwCssSendCssCmd(pHw, CssCmdTitleKey);
	hwCssWrKey40(pHw, pKey40);
	status = hwCssReadCssStatus(pHw);
	if ((status&3)!=2) {
		Err = MARGI_ERR_CSS_TITLEKEY;
	} 
	hwCssSetCssCmd(pHw, CssCmdNone&0x7f); 
	return Err;
}


LOCAL long hwCssDescramble(PMIDASCMD pCmd, long arg1, long arg2)
{
	PHW pHw = pCmd->hMidas;
	hwCssSetCssCmd(pHw, CssCmdNone);
	pHw->fCssEnabled = arg2 & 0xff;
	if (arg1) {
		if (arg2) {
			hwCssSendCssCmd(pHw, CssCmdDescram);
		} else {
			hwCssSendCssCmd(pHw, CssCmdNoDescram);
			pHw->fCssWaitForTitleKey = 0;
			pHw->fCssApplyingTitleKey = 0;
			pHw->fCssNewTitleKey = 0;		
		}
	}
	return(0);
}

LOCAL void hwWriteChanData(PHW pHw, WORD val)
{
	WrWord(pHw, REG_AUDIO_CHANNEL(pHw), val);
}

LOCAL long hwCssWriteDiskKey(PHW pHw, BYTE *pDiskKey, long size)
{
	int i;
	long Err = 0;
	long status = 0;
	hwCssSetCssCmd(pHw, CssCmdNone);
	hwCssSendCssCmd(pHw, CssCmdDiscKey);
	for(i=0;i<2048;i+=2) {
		hwWriteChanData(pHw, *(unsigned short *)(pDiskKey+i) );
	}
	status = hwCssReadCssStatus(pHw);
	if ((status&3)!=2) {
		Err = MARGI_ERR_CSS_DISCKEY;
	}
	return Err;
}

LOCAL void hwCssWrBusKey(PHW pHw, PKS_DVDCOPY_BUSKEY pBUSKEY)
{
	hwCssSetCssCmd(pHw, CssCmdNone);
	hwCssWrKey80(pHw, pBUSKEY->bBusKey);
}