#ifndef __DVHWAUD_H__
#define __DVHWAUD_H__ 0x0300

//Audio object commands.
extern long AudioCmd(PHW pHw, DWORD Cmd, DWORD Arg1, DWORD Arg2);
extern long AudioQueueData(PHW pHw, PMDS_DATA_BLOCK pMdb);
extern long AudioCancelData(PHW pHw, PMDS_DATA_BLOCK pMdb);
extern DWORD AudioPumpData(PHW pHw);

//Audio decoder commands.
#define AUDCMD_INIT	1	//Create an audio object.
#define AUDCMD_FINI	2	//Destroy an audio object.
#define AUDCMD_RESET	3	//Reset object completely.
#define AUDCMD_STOP     4
#define AUDCMD_PAUSE    5
#define AUDCMD_RUN      6
#define AUDCMD_TIMER	7	//Timer tick
#define AUDCMD_SELECT	8	//Select an audio stream. Arg1= DWORD Stream
#define AUDCMD_SAMPLE	9	//Set audio sample rate from current parameters.
#define AUDCMD_SETCLK	12	//Set clock from current parms.
#define AUDCMD_RATE	14	//Set play rate. Arg1= DLONG &StartTime, Arg2= DWORD FrameRate
#define AUDCMD_BEGINFLUSH 15	//Notify audio decoder of end of flush.
#define AUDCMD_ENDFLUSH 16	//Notify audio decoder of end of flush.
#define AUDCMD_GET	18	//Get audio parameter. Arg1= Item, one of AUDITEM_. Arg2= DWORD &Value
#define AUDCMD_SET	19	//Set audio parameter. Arg1= Item, one of AUDITEM_. Arg2= DWORD Value
#define AUDCMD_DATA	20	//Send data to decoder. Arg1= struct Send_s *pSend
#define AUDCMD_SYNCTITLE 21
#define AUDCMD_CORRECT  22
#define AUDCMD_STEP 23

#define AUDITEM_STATE	1	//Current state. READONLY. If FLUSHING, high-word is flushing substate.
#define AUDITEM_VOLUME	2	//Audio volume
#define AUDITEM_MUTE	3	//Mute, 0=audible, 1=silent
#define AUDITEM_MIX	4	//AC3 MixMode
#define AUDITEM_SRCTYPE	5	//AUD_AC3, AUD_LPCM, AUD_MPEG.
#define AUDITEM_SAMPLES	6	//Sample rate.
#define AUDITEM_OUTMODE	7	//Output mode.
#define AUDITEM_KARAOKE 8       //Karaoke Modes.
#define AUDITEM_SPDIF   9       //Enable/Disable SPDIF mode
#define AUDITEM_SPDMODE 10      //SPDIF Mode
#define AUDITEM_NUMCHANNELS 11  //Set # of channels mono,stereo, ...

#endif
/**EOF: DVHWAUD.H**/
