#ifndef __DVHWOSD_H__
#define __DVHWOSD_H__ 0x0300

typedef void* HOSDREGION;

typedef struct OsdRegion_s {
  WORD x;             //left,top,width,height on screen 0,0,720,480(ntsc),576(pal)
  WORD y;
  WORD dx;
  WORD dy;
  WORD wClrMode;      //# bits/pel  0:2bps, 1:8bps, 2:4bps
  WORD wMixWeight;
  WORD Palette[16];
} OSDREGION,*POSDREGION;

typedef struct OsdStrip_s {
  WORD x;
  WORD y;
  WORD dx;
  WORD dy;
  BYTE* pStrip;     // upto 8 bytes
  WORD  wSize;      // number of bytes (not pixels)
} OSDSTRIP, *POSDSTRIP;

#ifndef _DVDHWOSD_NO_API_
//Osd object commands.
extern long  OsdCmd(PHW pHw, DWORD Cmd, DWORD Arg1, DWORD Arg2);

//Osd queued command flags
#define OSD_FLAG_COPY   0
#define OSD_FLAG_SET    1
#define OSD_FLAG_WR_REG 2

//Osd decoder commands.
#define OSDCMD_INIT	 1          //Create an osd object.
#define OSDCMD_FINI	 2          //Destroy an osd object.
#define OSDCMD_RESET 3          //Reset object completely.
#define OSDCMD_TIMER 4          //Called periodically to perform updates (every 10mS)
#define OSDCMD_OPEN_REGION  5   //Define rectangular region Arg2 points to OSDRECT  return handle in *Arg1
#define OSDCMD_CLOSE_REGION 6   //Close region
#define OSDCMD_RENDER_STRIP 7   //Render strip of bytes. Arg1=region handle, Arg2=&OSDSTRIP
#define OSDCMD_RENDER_RECT  8   //Render rectangle.      Arg1=region handle, Arg2=&OSDSTRIP
#define OSDCMD_FILL_REGION  9   //Fill region with specified 8 byte pattern
#define OSDCMD_FILL_RECT    10  //Fill rectangle with specified 8 byte pattern
#define OSDCMD_SHOW_REGION  11  //Display Region Arg1=region handle, if 0 then show all
#define OSDCMD_HIDE_REGION  12  //Hide Region  Arg1=region handle, if 0 then hide all
#define OSDCMD_SETBUFFSIZE  13  //Use before Video,Audio initialize and Open Region to reserve memory for OSD
#define OSDCMD_SETPALETTE   14  //Set Palette ??
#endif _DVDHWOSD_NO_API_

#endif
/**EOF: DVHWOSD.H**/
