#ifndef __DVHWSUB_H__
#define __DVHWSUB_H__ 0x0300

extern long  SubpicCmd(PHW pHw, DWORD Cmd, DWORD Arg1, DWORD Arg2);
extern long  SubpicQueueData(PHW pHw, PMDS_DATA_BLOCK pMdb);
extern long  SubpicCancelData(PHW pHw, PMDS_DATA_BLOCK pMdb);
extern DWORD SubpicPumpData(PHW pHw);

#define SUBCMD_INIT	      1	//Create a new subpicture object.
#define SUBCMD_FINI	      2	//Destroy a subpicture object.
#define SUBCMD_RESET	    3	//Reset
#define SUBCMD_GET	      4	//Get a parameter. Arg1= Item, one of SUBITEM_. Arg2= DWORD &Value
#define SUBCMD_SET	      5	//Set a parameter. Arg1= Item, one of SUBITEM_. Arg2= DWORD Value
#define SUBCMD_TIMER	    6	//Timer tick
#define SUBCMD_ENABLE	    7	//Enable subpicture. Arg1= DWORD Enable, 0=disable, 1=enable.
#define SUBCMD_SELECT	    8	//Select stream. Arg1= DWORD Stream
#define SUBCMD_HIDISABLE	9	//Disable highlight. Arg1= DWORD StartTime, Arg2= DWORD EndTime
#define SUBCMD_HIENABLE	 10	//Enable highlight.  Arg1= DWORD StartTime, Arg2= DWORD EndTime
#define SUBCMD_PALETTE	 11	//Set color palette. Arg1= DWORD Palette[], Arg2= DWORD NumColors.

#define SUBCMD_STOP	     12	//Start decoder. Arg1= DWORD Start, 0=Stop, 1=Run
#define SUBCMD_PAUSE	   13	//Begin playing.
#define SUBCMD_RUN	     14	//Begin playing.
#define SUBCMD_RATE	     15	//Set frame rate. Arg1= DLONG &StartTime, Arg2= DWORD Rate.
#define SUBCMD_BEGINFLUSH 16	//Notify decoder that flush has concluded.
#define SUBCMD_ENDFLUSH  17	//Notify decoder that flush has concluded.
#define SUBCMD_DATA	     18	//Send data to decoder. Arg1= struct Send_s *pSend.

#define SUBCMD_STEP      19

#define SUBITEM_STATE	    1	//Current hardware state. One of Z_STATE_. READONLY.
#define SUBITEM_HICOLOR	  2	//Highlight color
#define SUBITEM_HIPOS	    3	//Highlight position. Value is a pointer to a RECT.

#endif
/**EOF: DVHWSUB.H**/
