#ifndef __VIDEO_H__
#define __VIDEO_H__ 0x0300

typedef struct VIDDISPFORMAT_s {
  DWORD dwAspectRatio;
  DWORD dwDispMode;
  DWORD dwPicRate;
  int   nMpegType;
  WORD  wWidth;
  WORD  wHeight;
} VID_DISP_FORMAT, *PVID_DISP_FORMAT;

//Video object commands.
extern long VideoCmd(PHW pHw, DWORD Cmd, DWORD Arg1, DWORD Arg2);
extern long VideoQueueData(PHW pHw, PMDS_DATA_BLOCK pMdb);
extern long VideoCancelData(PHW pHw, PMDS_DATA_BLOCK pMdb);
extern DWORD VideoPumpData(PHW pHw);

//Video decoder commands.
#define VIDCMD_INIT	       1	//Create a video object.
#define VIDCMD_FINI	       2	//Destroy a video object.
#define VIDCMD_RESET	     3	//Reset object completely.
#define VIDCMD_ENABLE	     5	//Enable video output, Arg1= 0:disable, 1:enable.
#define VIDCMD_BLANK	     6	//Blank video output,  Arg1= 0:normal,  1:blank (black screen)

#define VIDCMD_START	     8	//Start/stop decoder: Arg1= 0:stop, 1:run
#define VIDCMD_PICSET	     9	//Program decoder using current state
#define VIDCMD_SELECT	    10	//Select a video stream, Arg1= stream

#define VIDCMD_RATE	      14	//Set picture rate: Arg1= DLONG &StartTime, Arg2= DWORD PictureRate
#define VIDCMD_DISPFORMAT 15	//Set display mode: Arg1= PVIDCMD_DISPFORMAT

#define VIDCMD_TIMER	    17	//Called on every timer tick.
#define VIDCMD_DATA	      18	//Send data to decoder. Arg1= struct Send_s *pSend
#define VIDCMD_GET	      19	//Get video parameter. Arg1= Item (one of VIDITEM_), Arg2= DWORD &Value.
#define VIDCMD_SET	      20	//Set video parameter. Arg1= Item (one of VIDITEM_), Arg2= DWORD Value.

#define VIDCMD_STOP       22
#define VIDCMD_PAUSE      23
#define VIDCMD_RUN        24
#define VIDCMD_BEGINFLUSH 25
#define VIDCMD_ENDFLUSH   26
#define VIDCMD_CORRECT    27
#define VIDCMD_SYNCTITLE  28
#define VIDCMD_CSS_OK     29
#define VIDCMD_STEP       30

//Panic modes
#define VIDPANIC_OFF	0	//No panic control. Video channel may underrun.
#define VIDPANIC_LO	1	//Low panic: video channel will almost empty.
#define VIDPANIC_HI	2	//High panic: video channel paused using panic control.
#define VIDPANIC_ITEMS	3	//Intermediate panic: panic level set to number of items.

//Get/Set items
#define VIDITEM_STATE	1	//Current state. One of Z_STATE_. READONLY.
#define VIDITEM_DISPLAY	2	//DisplayType (PAL or NTSC). READONLY.
#define VIDITEM_RATECUR	3	//Current playback speed. (10000= normal)
#define VIDITEM_RATEMAX	4	//Maximum playback speed.

#endif
/**EOF: VIDEO.H**/
