/********************************************************************************
        Copyright Margi Systems, Inc. (c) 1994

File:       i2c.h
Purpose:    Provide I2C interface functions
Developed:  jec
Date:       29 Nov 1994

********************************************************************************/
#ifndef _I2C_INCLUDED
#define _I2C_INCLUDED
#ifndef FAR
  #define FAR
#endif

#ifndef _PSETGPIO
#define _PSETGPIO
  typedef void (FAR *PSETGPIO)(LPVOID lpParent, BYTE bPinNumber, BYTE bEnable, BYTE bValue);
  typedef BYTE (FAR *PGETGPIO)(LPVOID lpParent, BYTE bPinNumber, LPBYTE lpEnable, LPBYTE lpValue);
#endif

#ifdef  _DECLARE_I2C
typedef struct
{
#if(0)
  WORD  wCsIx;
  WORD  wCsReg;
  WORD  wCsAddr;
  WORD  wCsMask;
  WORD  wClkIx;
  WORD  wClkReg;
  WORD  wClkInIx;
  WORD  wClkInReg;
  WORD  wDatIx;
  WORD  wDatReg;
  WORD  wDatInIx;
  WORD  wDatInReg;
  WORD  wImage;
#endif
  PSETGPIO pSet;
  PGETGPIO pGet;
  LPVOID   hRef;
} I2C;              
typedef I2C*   PI2C;
#else
typedef void*  PI2C;
#endif


PI2C i2cNew(PSETGPIO,PGETGPIO,LPVOID);
void  i2cDelete     (PI2C);
int   i2cReset      (PI2C);
int   i2cStart      (PI2C);
int   i2cStop       (PI2C);
int   i2cWriteByte   (PI2C, BYTE b);
int   i2cWriteWord   (PI2C, WORD w);
int   i2cWriteDWord  (PI2C, DWORD dw);
int   i2cWriteStream (PI2C, BYTE* bData, int nLength);
int   i2cWriteCommand(PI2C, BYTE bAddr, BYTE bCommand, WORD wValue);

BYTE  i2cReadByte   (PI2C);

int i2cReadBt819Reg (PI2C p, BYTE bAddr, int nReg);
int i2cWriteBt819Reg(PI2C p, BYTE bAddr, int nReg, int nData);
int i2cSend(PI2C p, int nAddr, int nReg, int nValue);

#define I2CSend i2cSend


#endif

/* eof */
