
/*Include Files*/
/*-------------*/
//#include <windows.h>
//#include <StrmIni.h>
//#include <mmsystem.h>
//#include <KsMedia.h>
#include "system.h"
#ifndef WIN32
//#include <wownt16.h> //Ex32W calls
#endif
#include <string.h>

#include "DbgMsg.h"
#include "DbgFltr.h"
#include "TVOut.h"
#include "Settings.h"
#include "IniNames.h"
#include "i2c.h"

#define   DBG_I2C   DBG_INFO
#define   DBG_MACR  DBG_INFO

#define DELAY(n)  {volatile int i; for(i=0; i<n*10;i++);}
#define CONTROL_REG1 0
#define CONTROL_REG2 0

#define ID_CL4952   0x02
#define ID_CL4953   0x13
#define ID_CL4954   0x04   
#define ID_CL4955   0x05

#define ENCODER_4952    1
#define ENCODER_4953    2
#define ENCODER_4954    3
#define ENCODER_4955    4
#define ENCODER_UNKNOWN 5

#define LCH_ADJUST_NOT_SET  32767

#define INCLUDE_ATI 0
#if INCLUDE_ATI
#pragma message("ATI Macrovision included in this build")
#ifndef WIN32
extern DWORD FAR CDECL CallProcEx32W( DWORD, DWORD, DWORD, ... );
#endif
typedef long (CALLBACK* LPFNDLLFUNC2)(DWORD,DWORD);
extern LPFNDLLFUNC2 lpfnDllFuncSetATIMacroMode;
extern BOOL gbTVOutPlusIsLoaded;
#endif

#if(1)
typedef struct {
    PSETGPIO pSetGPIO;
    PGETGPIO pGetGPIO;
    LPVOID   hGPIORef;

    int   nLumaGain;      // Contrast   0 - 100
    int   nLumaOffset;    // Brightness 0 - 100
    int   nChroma;        // Saturation 0 - 100
    int   nHue;           // Colour   -50 - 50

    int   nLumaGainReset;     // Default setpoints
    int   nLumaOffsetReset;
    int   nChromaReset;
    int   nHueReset;

    int   fEnable;
    int   fTestMode;
    BYTE  bOutput;
    BYTE  bMacrovisionMode;
    BYTE  bLumaGainNorm;    // Sets midpoint of Y Amp reg (value to set when nLumaGain==50)

    DWORD dwNTSCScSynth;   
    WORD  wNTSCScAmp;
    DWORD dwPALScSynth;
    WORD  wEEPROMStartAddr;
    WORD  wPALScAmp;
    DWORD dwResetTime;           // Hold reset for 5mS

    BYTE  bI2CDevAddr;
    PI2C  pI2C;
    WORD  fEncodeI2C;
    BYTE  bDispStd;                           
    BYTE  bCurrAPSValue;
    BYTE  bEncoderFound;
} TVOUTSTRUCT;

typedef TVOUTSTRUCT* PTVOUTSTRUCT;

TVOUTSTRUCT  gsTvOut;

#else
static PSETGPIO pSetGPIO;
static PGETGPIO pGetGPIO;
LPVOID lpParent = NULL;

WORD  gwLuma=0xffff;
WORD  gwChroma=0xffff;
WORD  gwHue=0xffff;
WORD  gwLumaReset=0;
WORD  gwChromaReset=0;
WORD  gwHueReset=0;

int   gfTV_Enable=0;
int   gfTV_TestMode=0;
int   gfTV_SVideo=0;        
int   gfTV_Comp  =0;        
int   gfTV_Comp75=0;                         
DWORD gdwNTSCScSynth=0x43e0f83e;   
WOD    gwNTSCScAmp=0x1c;
DWORD gdwPALScSynth= 0x54131596;
WORD  wEEPROMStartAddr= 0x1F0;
WORD  gwPALScAmp=0x15;
DWORD gdwResetTime=5;           // Hold reset for 5mS

BYTE Encoder_I2C_Address= 0;
PI2C pTvOut->pI2C;
WORD gfEncodeI2C=1;
BYTE gbDispStd=0xff;                           
BYTE gfCurrAPSValue= 0;
BYTE TempStr[40];
BYTE g4953HwID= 0x13;
BYTE g4952HwID= 0x02;
BYTE g4954HwID= 0x04;
BYTE g4955HwID= 0x05;
BYTE gfEncoderFound= ENCODER_UNKNOWN;
#endif

char *gszCurrAPSString[]= {
  "No APS",
  "AGC Only"
  "AGC + 2Lines",
  "AGC + 4Lines"
};

enum TV_GPIO
{
  GPIO_PIN_RESET = 0,
  GPIO_PIN_CLOCK = 1,
  GPIO_PIN_DATA  = 2
};

static long EncoderWrite(PTVOUTSTRUCT p,BYTE bReg,BYTE bVal);
static long EncoderRead (PTVOUTSTRUCT p,BYTE bReg);

static long TVOutMsgNotSupported(PTVOUTSTRUCT pTvOut,WORD wMsg);
static long TVOutReadConfig(PTVOUTSTRUCT pTvOut);
static long TVOutWriteConfig(PTVOUTSTRUCT pTvOut);
static long TVOutReset(PTVOUTSTRUCT pTvOut);
static long TVOutPowerDown(PTVOUTSTRUCT pTvOut);
static long TVOutSetMacrovisionMode(PTVOUTSTRUCT pTvOut,BYTE bMode);
static long TVOutGetMacrovisionMode(PTVOUTSTRUCT pTvOut,BYTE* pbMode);
static long TVOutInit(PTVOUTINIT_S);
static long TvOutTestI2C(PTVOUTSTRUCT pTvOut);
static long TVOutEnable(PTVOUTSTRUCT pTvOut,BOOL fEnable);
static long TVOutSetStandard(PTVOUTSTRUCT pTvOut,BYTE bStandard);
static long TVOutSetOutput(PTVOUTSTRUCT pTvOut,BYTE bOutput);
static long TVOutGetStandard(PTVOUTSTRUCT pTvOut);
static long TVOutGetOutput(PTVOUTSTRUCT pTvOut);
static long TVOutClose(PTVOUTSTRUCT pTvOut);
static long TVOutTestMode(PTVOUTSTRUCT pTvOut,BOOL fOnOff);
static long TVOutEncoderWrite(PTVOUTSTRUCT pTvOut,BYTE bReg,BYTE bVal);
static long TVOutEncoderRead(PTVOUTSTRUCT pTvOut,BYTE bReg);
static long TVOutSetLumaGain(PTVOUTSTRUCT pTvOut,int nGain);
static long TVOutGetLumaGain(PTVOUTSTRUCT pTvOut);
static long TVOutSetLumaOffset(PTVOUTSTRUCT pTvOut,int nOffset);
static long TVOutGetLumaOffset(PTVOUTSTRUCT pTvOut);
static long TVOutSetChroma(PTVOUTSTRUCT pTvOut,int nChroma);
static long TVOutGetChroma(PTVOUTSTRUCT pTvOut);
static long TVOutSetHue(PTVOUTSTRUCT pTvOut,int nHue);
static long TVOutGetHue(PTVOUTSTRUCT pTvOut);
static long TVOutResetPicture(PTVOUTSTRUCT pTvOut);


#if _WIN32_WCE
long TVOutProc(LPVOID hTvOut,WORD wMsg, DWORD dwParm1, DWORD dwParm2) {
#elif WINNT
long TVOutProc(LPVOID hTvOut,WORD wMsg, DWORD dwParm1, DWORD dwParm2) {
#else 
#ifndef WIN32
long FAR _loadds TVOutProc(LPVOID hTvOut,WORD wMsg, DWORD dwParm1, DWORD dwParm2) {
#else
__declspec(dllexport) long _TVOutProc(LPVOID hTvOut,WORD wMsg, DWORD dwParm1, DWORD dwParm2) {
#endif
#endif
  long Err= 0;
  PTVOUTSTRUCT pTvOut=(PTVOUTSTRUCT)hTvOut;
  if(wMsg==TVOUT_INIT)
    Err= TVOutInit((PTVOUTINIT_S)dwParm1);
  else if(pTvOut) {
    switch(wMsg) {
      case TVOUT_FINI           : Err= TVOutClose(pTvOut); break;
      case TVOUT_ENABLE         : Err= TVOutEnable(pTvOut,(BOOL)dwParm1); break;
      case TVOUT_READ_CONFIG    : Err= TVOutReadConfig(pTvOut); break;
      case TVOUT_WRITE_CONFIG   : Err= TVOutWriteConfig(pTvOut); break;
      case TVOUT_TEST_MODE      : Err= TVOutTestMode(pTvOut,(BOOL)dwParm1); break;
      case TVOUT_SET_MACROVISION: Err= TVOutSetMacrovisionMode(pTvOut,(BYTE)dwParm1); break;
      case TVOUT_GET_MACROVISION: Err= TVOutGetMacrovisionMode(pTvOut,(BYTE*)dwParm1); break;
      case TVOUT_SET_STANDARD   : Err= TVOutSetStandard(pTvOut,(BYTE)dwParm1); break;
      case TVOUT_GET_STANDARD   : Err= TVOutGetStandard(pTvOut); break;
      case TVOUT_SET_OUTPUT     : Err= TVOutSetOutput(pTvOut,(BYTE)dwParm1); break;
      case TVOUT_GET_OUTPUT     : Err= TVOutGetOutput(pTvOut); break;
      case TVOUT_SET_LUMA       : Err= TVOutSetLumaOffset(pTvOut,(int)dwParm1); break;
      case TVOUT_GET_LUMA       : Err= TVOutGetLumaOffset(pTvOut); break;
      case TVOUT_SET_LUMA_GAIN  : Err= TVOutSetLumaGain(pTvOut,(int)dwParm1); break;
      case TVOUT_GET_LUMA_GAIN  : Err= TVOutGetLumaGain(pTvOut); break;
      case TVOUT_SET_CHROMA     : Err= TVOutSetChroma(pTvOut,(int)dwParm1); break;
      case TVOUT_GET_CHROMA     : Err= TVOutGetChroma(pTvOut); break;
      case TVOUT_SET_HUE        : Err= TVOutSetHue(pTvOut,(int)dwParm1); break;
      case TVOUT_GET_HUE        : Err= TVOutGetHue(pTvOut); break;
      case TVOUT_RESET_PICTURE  : Err= TVOutResetPicture(pTvOut); break;
      case TVOUT_ENCODER_WRITE  : Err= TVOutEncoderWrite(pTvOut,(BYTE)dwParm1,(BYTE)dwParm2); break;
      case TVOUT_ENCODER_READ   : Err= TVOutEncoderRead(pTvOut,(BYTE)dwParm1); break;
      default                   : Err= TVOutMsgNotSupported(pTvOut,wMsg); break;
    }
  }
  return(Err);
}

static long TVOutEncoderWrite(PTVOUTSTRUCT pTvOut,BYTE bReg,BYTE bVal) {
  return (EncoderWrite(pTvOut,bReg,bVal));
}

static long TVOutEncoderRead(PTVOUTSTRUCT pTvOut,BYTE bReg) {
  return (EncoderRead(pTvOut,bReg));
}

static long TVOutMsgNotSupported(PTVOUTSTRUCT pTvOut,WORD wMsg) {
  DbgMsg(DBG_ERR,DBGID" UnSupproted Message Passed to TVOut DLL (%d) \r\n",wMsg);
  return 0xFFFFFFFF;
}

static long TVOutReadConfig(PTVOUTSTRUCT pTvOut) {

  SettingFName(IniMdsFName,IniTvSection);

  pTvOut->fTestMode= (WORD)SettingLoad(SET_DWORD,IniTvTest,0,pTvOut->fTestMode);
  DbgMsg(DBG_SET,DBGID"TV Out Setting: TestMode=%d\r\n",pTvOut->fTestMode);

  pTvOut->bOutput= (BYTE)SettingLoad(SET_DWORD,IniTvOutput,0,pTvOut->bOutput);
  DbgMsg(DBG_SET,DBGID"TV Out Setting: Output=%02x\r\n",pTvOut->bOutput);

  pTvOut->nLumaGain= (WORD)SettingLoad(SET_DWORD,IniTvLumaGain,0,pTvOut->nLumaGain);
  DbgMsg(DBG_SET,DBGID"TV Out Setting: LumaGain=%02x\r\n",pTvOut->nLumaGain);

  pTvOut->nLumaOffset= (WORD)SettingLoad(SET_DWORD,IniTvLumaOffset,0,pTvOut->nLumaOffset);
  DbgMsg(DBG_SET,DBGID"TV Out Setting: LumaOffset=%02x\r\n",pTvOut->nLumaOffset);

  pTvOut->nChroma= (WORD)SettingLoad(SET_DWORD,IniTvChroma,0,pTvOut->nChroma);
  DbgMsg(DBG_SET,DBGID"TV Out Setting: Chroma=%02x\r\n",pTvOut->nChroma);

  pTvOut->nHue= (WORD)SettingLoad(SET_DWORD,IniTvHue,0,pTvOut->nHue);
  DbgMsg(DBG_SET,DBGID"TV Out Setting: Hue=%02x\r\n",pTvOut->nHue);

  pTvOut->dwNTSCScSynth= SettingLoad(SET_DWORD,IniTvNtscScSynth,0,pTvOut->dwNTSCScSynth);
  DbgMsg(DBG_SET,DBGID"TV Out Setting: NTSCScSynth=%08lx\r\n",pTvOut->dwNTSCScSynth);

  pTvOut->dwPALScSynth= SettingLoad(SET_DWORD,IniTvPalScSynth,0,pTvOut->dwPALScSynth);
  DbgMsg(DBG_SET,DBGID"TV Out Setting: PALScSynth=%08lx\r\n",pTvOut->dwPALScSynth);

  pTvOut->wNTSCScAmp= (WORD)SettingLoad(SET_DWORD,IniTvNtscScAmp,0,pTvOut->wNTSCScAmp);
  DbgMsg(DBG_SET,DBGID"TV Out Setting: NTSCScAmp=%02x\r\n",pTvOut->wNTSCScAmp);

  pTvOut->wPALScAmp= (WORD)SettingLoad(SET_DWORD,IniTvPalScAmp,0,pTvOut->wPALScAmp);
  DbgMsg(DBG_SET,DBGID"TV Out Setting: PALScAmp=%02x\r\n",pTvOut->wPALScAmp);

  return 0;
}

static long TVOutWriteConfig(PTVOUTSTRUCT pTvOut)
{
  /* write out the current tv-out settings */
  SettingFName(IniMdsFName,IniTvSection);
  SettingSave(SET_DWORD, IniTvTest,        pTvOut->fTestMode);
  SettingSave(SET_DWORD, IniTvOutput,      pTvOut->bOutput);
  SettingSave(SET_DWORD, IniTvLumaGain,    pTvOut->nLumaGain);
  SettingSave(SET_DWORD, IniTvLumaOffset,  pTvOut->nLumaOffset);
  SettingSave(SET_DWORD, IniTvChroma,      pTvOut->nChroma);
  SettingSave(SET_DWORD, IniTvHue,         pTvOut->nHue);
  SettingSave(SET_DWORD, IniTvNtscScSynth, pTvOut->dwNTSCScSynth);
  SettingSave(SET_DWORD, IniTvPalScSynth,  pTvOut->dwPALScSynth);
  SettingSave(SET_DWORD, IniTvNtscScAmp,   pTvOut->wNTSCScAmp);
  SettingSave(SET_DWORD, IniTvPalScAmp,    pTvOut->wPALScAmp);

  DbgMsg(DBG_SET,DBGID"TV Out Setting Save: TestMode=%d\r\n",      pTvOut->fTestMode);
  DbgMsg(DBG_SET,DBGID"TV Out Setting Save: Output=%02x\r\n",      pTvOut->bOutput);
  DbgMsg(DBG_SET,DBGID"TV Out Setting Save: LumaGain=%02x\r\n",    pTvOut->nLumaGain);
  DbgMsg(DBG_SET,DBGID"TV Out Setting Save: LumaOffset=%02x\r\n",  pTvOut->nLumaOffset);
  DbgMsg(DBG_SET,DBGID"TV Out Setting Save: Chroma=%02x\r\n",      pTvOut->nChroma);
  DbgMsg(DBG_SET,DBGID"TV Out Setting Save: Hue=%02x\r\n",         pTvOut->nHue);
  DbgMsg(DBG_SET,DBGID"TV Out Setting Save: NTSCScSynth=%08lx\r\n",pTvOut->dwNTSCScSynth);
  DbgMsg(DBG_SET,DBGID"TV Out Setting Save: PALScSynth=%08lx\r\n", pTvOut->dwPALScSynth);
  DbgMsg(DBG_SET,DBGID"TV Out Setting Save: NTSCScAmp=%02x\r\n",   pTvOut->wNTSCScAmp);
  DbgMsg(DBG_SET,DBGID"TV Out Setting Save: PALScAmp=%02x\r\n",    pTvOut->wPALScAmp);
  return 1;
}


static long EncoderWrite(PTVOUTSTRUCT pTvOut,BYTE bReg,BYTE bVal) {
  BOOL Ret= 1;
  PI2C p=pTvOut->pI2C;
  if(p) {
    i2cStart(p);
    Ret&= i2cWriteByte(p,pTvOut->bI2CDevAddr);
    Ret&= i2cWriteByte(p,bReg);
    Ret&= i2cWriteByte(p,bVal);
    if(Ret) 
      DbgMsg(DBG_I2C,DBGID" Encoder I2C: 0x%02X is written to reg. 0x%02X \r\n",bVal,bReg);
    else 
      DbgMsg(DBG_I2C,DBGID" Encoder I2C: I2C Error while writing 0x%02X to reg. 0x%02X \r\n",bVal,bReg);
    i2cStop(p);
  } else {
    DbgMsg(DBG_I2C,DBGID" Encoder I2C Control/Data Info Not Available \r\n");
    Ret= 0xFFFF;
  }
  return Ret;
}

static long EncoderRead(PTVOUTSTRUCT pTvOut,BYTE bReg) {
  BOOL Ret= 1;
  BYTE bDat=0;
  PI2C p=pTvOut->pI2C;
  if(p) {
    i2cStart(p);
    Ret = i2cWriteByte(p,pTvOut->bI2CDevAddr);
    Ret&= i2cWriteByte(p,bReg);
    i2cStart(p);
    Ret&= i2cWriteByte(p,(BYTE)(pTvOut->bI2CDevAddr|1));
    bDat= i2cReadByte(p);
    if(Ret) {
      DbgMsg(DBG_I2C,DBGID" Encoder I2C: 0x%02X is being read from reg. 0x%02X \r\n",bDat,bReg);
    } else { 
      DbgMsg(DBG_I2C,DBGID" Encoder I2C: I2C Error while reading reg. 0x%02X \r\n",bReg);
    }
    i2cStop(p);
  } else {
    DbgMsg(DBG_I2C,DBGID" Encoder I2C Control/Data Info Not Available \r\n");
    Ret= 0xFFFF;
  }
  return bDat;
}    

static long TVOutReset(PTVOUTSTRUCT pTvOut) {
  DbgMsg(DBG_SET,DBGID" TVOutReset()\r\n");
  if(pTvOut->pSetGPIO) {
    (*pTvOut->pSetGPIO)(pTvOut->hGPIORef, GPIO_PIN_RESET, 1, 0); //Enable   Pin # 0 ie. Reset and set low
    (*pTvOut->pSetGPIO)(pTvOut->hGPIORef, GPIO_PIN_CLOCK, 0, 0); //TriState Pin # 1 ie. Clock
    (*pTvOut->pSetGPIO)(pTvOut->hGPIORef, GPIO_PIN_DATA, 0, 0);  //TriState Pin # 2 ie. Data
    DELAY(5);
    (*pTvOut->pSetGPIO)(pTvOut->hGPIORef, GPIO_PIN_RESET, 1, 1); //Enable   Pin # 0 ie. Reset and set high
  }
  pTvOut->bDispStd=0xff;
  return 0;
}

static long TVOutPowerDown(PTVOUTSTRUCT pTvOut) {
  DbgMsg(DBG_SET,DBGID" TVOutPowerDown()\r\n");
  if(pTvOut->pSetGPIO) {
    (*pTvOut->pSetGPIO)(pTvOut->hGPIORef, GPIO_PIN_RESET, 1, 0); //Enable   Pin # 0 ie. Reset and set low
    (*pTvOut->pSetGPIO)(pTvOut->hGPIORef, GPIO_PIN_CLOCK, 0, 0); //TriState Pin # 1 ie. Clock
    (*pTvOut->pSetGPIO)(pTvOut->hGPIORef, GPIO_PIN_DATA, 0, 0);  //TriState Pin # 2 ie. Data
  }
  return 0;
}

#define NUM_MAC_REGS 20
BYTE APS_RegUpDate_4953[NUM_MAC_REGS]={
               0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,0x28,0x29,0x2A,0x2B,0x2C,0x2D,0x2E,0x2F,0x30,0x31,0x32,0x33};
BYTE APS_Table_NTSC_4953[4][NUM_MAC_REGS]= {
  { /* OFF  */ 0x00,0x17,0x15,0x21,0x15,0xB7,0x1B,0x1B,0x24,0x0F,0x78,0x00,0x00,0x0F,0x0F,0x60,0x07,0xA0,0x2C,0xFF},
  { /* AGC  */ 0x36,0x17,0x15,0x21,0x15,0xB7,0x1B,0x1B,0x24,0x0F,0x78,0x00,0x00,0x0F,0x0F,0x60,0x07,0xBF,0x1A,0xF0},
  { /* AGC2 */ 0x3E,0x1D,0x11,0x25,0x11,0x3C,0x1B,0x1B,0x24,0x0F,0x78,0x00,0x00,0x0F,0x0F,0x60,0x07,0xA0,0x2C,0xFF},
  { /* AGC4 */ 0x3E,0x17,0x15,0x21,0x15,0xB6,0x1B,0x1B,0x24,0x0F,0x78,0x00,0x00,0x0F,0x0F,0x60,0x07,0xA0,0x2C,0xFF}
};
BYTE APS_Table_PAL_4953[4][NUM_MAC_REGS]= {
  { /* OFF  */ 0x00,0x1A,0x22,0x34,0x22,0xA8,0x1C,0x3D,0x14,0x07,0x7E,0x02,0x54,0xFE,0x7E,0x60,0x02,0x40,0x27,0x55},
  { /* AGC  */ 0x36,0x1A,0x22,0x34,0x22,0xA8,0x1C,0x3D,0x14,0x07,0x7E,0x02,0x54,0xFE,0x7E,0x60,0x02,0x40,0x27,0x55},
  { /* AGC2 */ 0x36,0x1A,0x22,0x34,0x22,0xA8,0x1C,0x3D,0x14,0x07,0x7E,0x02,0x54,0xFE,0x7E,0x60,0x02,0x40,0x27,0x55},
  { /* AGC4 */ 0x36,0x1A,0x22,0x34,0x22,0xA8,0x1C,0x3D,0x14,0x07,0x7E,0x02,0x54,0xFE,0x7E,0x60,0x02,0x40,0x27,0x55}
};

BYTE APS_RegUpDate_4955[NUM_MAC_REGS]={
               0x43,0x44,0x45,0x46,0x47,0x48,0x49,0x4A,0x4B,0x4C,0x4D,0x4E,0x4F,0x50,0x51,0x52,0x53,0x54,0x55,0x56};
BYTE APS_Table_NTSC_4955[4][NUM_MAC_REGS]= {
  { /* OFF  */ 0x00,0x17,0x15,0x21,0x15,0xB7,0x1B,0x1B,0x24,0x0F,0x78,0x00,0x00,0x0F,0x0F,0x60,0x07,0xA0,0x2C,0xFF},
  { /* AGC  */ 0x36,0x17,0x15,0x21,0x15,0xB7,0x1B,0x1B,0x24,0x0F,0x78,0x00,0x00,0x0F,0x0F,0x60,0x07,0xBF,0x1A,0xF0},
  { /* AGC2 */ 0x3E,0x1D,0x11,0x25,0x11,0x3C,0x1B,0x1B,0x24,0x0F,0x78,0x00,0x00,0x0F,0x0F,0x60,0x07,0xA0,0x2C,0xFF},
  { /* AGC4 */ 0x36,0x17,0x15,0x21,0x15,0xB6,0x1B,0x1B,0x24,0x0F,0x78,0x00,0x00,0x0F,0x0F,0x60,0x07,0xA0,0x2C,0xFF}
};
BYTE APS_Table_PAL_4955[4][NUM_MAC_REGS]= {
  { /* OFF  */ 0x00,0x1A,0x22,0x2A,0x22,0xA8,0x1C,0x3D,0x14,0x07,0x7E,0x02,0x54,0xFE,0x7E,0x60,0x02,0x80,0x27,0x55},
  { /* AGC  */ 0x36,0x1A,0x22,0x2A,0x22,0xA8,0x1C,0x3D,0x14,0x07,0x7E,0x02,0x54,0xFE,0x7E,0x60,0x02,0x80,0x27,0x55},
  { /* AGC2 */ 0x36,0x1A,0x22,0x2A,0x22,0xA8,0x1C,0x3D,0x14,0x07,0x7E,0x02,0x54,0xFE,0x7E,0x60,0x02,0x80,0x27,0x55},
  { /* AGC4 */ 0x36,0x1A,0x22,0x2A,0x22,0xA8,0x1C,0x3D,0x14,0x07,0x7E,0x02,0x54,0xFE,0x7E,0x60,0x02,0x80,0x27,0x55},
};

// Get Macrovision setup tables for Encoder type, TV Standard and Macrovision Mode
// return 0 if table found or Macrovision mode is NONE
// else return 1 so the TV output can be disabled
long GetMacTables(PTVOUTSTRUCT pTvOut,BYTE** ppMacTable, BYTE** ppRegTable) {
  long Ret=0;
  BYTE *pMacTable=0;
  BYTE *pRegTable=0;
  BYTE bStd= pTvOut->bDispStd;
  BYTE bMode=pTvOut->bMacrovisionMode;

  switch(pTvOut->bEncoderFound) {
    case ENCODER_4955:
      pRegTable=APS_RegUpDate_4955;
      if(bStd==TV_TYPE_NTSC)
        pMacTable=&APS_Table_NTSC_4955[bMode&3][0];
      else if(bStd==TV_TYPE_PAL)
        pMacTable=&APS_Table_PAL_4955[bMode&3][0];
      break;
    case ENCODER_4953:
      pRegTable=APS_RegUpDate_4953;
      if(bStd==TV_TYPE_NTSC)
        pMacTable=&APS_Table_NTSC_4953[bMode&3][0];
      else if(bStd==TV_TYPE_PAL)
        pMacTable=&APS_Table_PAL_4953[bMode&3][0];
      break;
  }
  if(ppMacTable)
    *ppMacTable=pMacTable;
  if(ppRegTable)
    *ppRegTable=pRegTable;

  if((bMode!=TV_MACROVISION_NONE) && (!pMacTable || !pRegTable))
    Ret=1; // return error - must disable TV Out

  return Ret;
}

static long UpdateMacRegs(PTVOUTSTRUCT pTvOut,BYTE* pRegTable,BYTE* pMacTable) {
  BOOL Ret= 0;
  int n;
  for(n=0;n<NUM_MAC_REGS;n++)
    EncoderWrite(pTvOut,pRegTable[n],pMacTable[n]);
  return Ret;
}


#if(0)
static long TVOutNTSCMacroVision_4953(PTVOUTSTRUCT pTvOut,BYTE bType) {
  BOOL Ret= 0;
  int OffSet=0,i= 0;
  for(OffSet=0;APS_Table_NTSC_4953[OffSet][0];OffSet++) {
    if(APS_Table_NTSC_4953[OffSet][0]==bType)
      break;
  }
  if(APS_Table_NTSC_4953[OffSet][0]==bType) {
    pTvOut->bCurrAPSValue= (bType&0x03);
    for(i=1;i<NUM_OF_REGISTERS_FOR_UPDATE;i++)
      EncoderWrite(pTvOut,APS_RegUpDate_4953[i],APS_Table_NTSC_4953[OffSet][i]);
  } else {
    DbgMsg(DBG_SET,DBGID" Requested Analog Protection Scheme NOT available (0x%02X) \r\n",bType);
  }
  return Ret;
}

static long TVOutNTSCMacroVision_4955(PTVOUTSTRUCT pTvOut,BYTE bType) {
  BOOL Ret= 0;
  int OffSet=0,i= 0;
  for(OffSet=0;APS_Table_NTSC_4955[OffSet][0];OffSet++) {
    if(APS_Table_NTSC_4955[OffSet][0]==bType)
      break;
  }
  if(APS_Table_NTSC_4955[OffSet][0]==bType) {
    pTvOut->bCurrAPSValue= (bType&0x03);
    for(i=1;i<NUM_OF_REGISTERS_FOR_UPDATE;i++)
      EncoderWrite(pTvOut,APS_RegUpDate_4955[i],APS_Table_NTSC_4955[OffSet][i]);
  } else {
    DbgMsg(DBG_SET,DBGID" Requested Analog Protection Scheme NOT available (0x%02X) \r\n",bType);
  }
  return Ret;
}

static long TVOutNTSCMacroVision(PTVOUTSTRUCT pTvOut,BYTE bType) {
  switch(pTvOut->bEncoderFound) {
    case ENCODER_4953:
      DbgMsg(DBG_SET,DBGID" Setting NTSC Macrovision for the 4953 encoder\r\n");
      return(TVOutNTSCMacroVision_4953(pTvOut,bType));

    case ENCODER_4955:
      DbgMsg(DBG_SET,DBGID" Setting NTSC Macrovision for the 4955 encoder\r\n");
      return(TVOutNTSCMacroVision_4955(pTvOut,bType));
  }
  return 0;
}

static long TVOutPALMacroVision_4953(PTVOUTSTRUCT pTvOut,BYTE bType) {
  BOOL Ret= 0;
  int OffSet=0,i= 0;
  for(OffSet=0;APS_Table_PAL_4953[OffSet][0];OffSet++) {
    if(APS_Table_PAL_4953[OffSet][0]==bType)
      break;
  }
  if(APS_Table_PAL_4953[OffSet][0]==bType) {
    pTvOut->bCurrAPSValue= (bType&0x03);
    for(i=1;i<NUM_OF_REGISTERS_FOR_UPDATE;i++)
      EncoderWrite(pTvOut,APS_RegUpDate_4953[i],APS_Table_PAL_4953[OffSet][i]);
  } else {
    DbgMsg(DBG_SET,DBGID" Requested Analog Protection Scheme NOT available (0x%02X) \r\n",bType);
  }
  return Ret;
}

static long TVOutPALMacroVision_4955(PTVOUTSTRUCT pTvOut,BYTE bType) {
  BOOL Ret= 0;
  int OffSet=0,i= 0;
  for(OffSet=0;APS_Table_PAL_4955[OffSet][0];OffSet++) {
    if(APS_Table_PAL_4955[OffSet][0]==bType)
      break;
  }
  if(APS_Table_PAL_4955[OffSet][0]==bType) {
    pTvOut->bCurrAPSValue= (bType&0x03);
    for(i=1;i<NUM_OF_REGISTERS_FOR_UPDATE;i++)
      EncoderWrite(pTvOut,APS_RegUpDate_4955[i],APS_Table_PAL_4955[OffSet][i]);
  } else {
    DbgMsg(DBG_SET,DBGID" Requested Analog Protection Scheme NOT available (0x%02X) \r\n",bType);
  }
  return Ret;
}

static long TVOutPALMacroVision(PTVOUTSTRUCT pTvOut,BYTE bType) {
  switch(pTvOut->bEncoderFound) {
    case ENCODER_4953:
      DbgMsg(DBG_SET,DBGID" Setting PAL Macrovision for the 4953 encoder\r\n");
      return(TVOutPALMacroVision_4953(pTvOut,bType));

    case ENCODER_4955:
      DbgMsg(DBG_SET,DBGID" Setting PAL Macrovision for the 4955 encoder\r\n");
      return(TVOutPALMacroVision_4955(pTvOut,bType));
  }
  return 0;
}
#endif


#if(0)
#define xINCLUDE_ATI

static long TVOutMacroVisionDisable(PTVOUTSTRUCT pTvOut,BYTE bNTSC_PAL) {
  DbgMsg(DBG_MACR,DBGID"TVOutMacroVisionDisable()\r\n");
#ifdef INCLUDE_ATI
  if (gbTVOutPlusIsLoaded)
#ifndef WIN32
    CallProcEx32W(2|CPEX_DEST_CDECL, 0, 
		  (DWORD)lpfnDllFuncSetATIMacroMode,
		  (DWORD)FALSE, (DWORD)0);
#else
    lpfnDllFuncSetATIMacroMode((DWORD)FALSE, (DWORD)0);
#endif
#endif
    return TVOutMacroVisionEnable(pTvOut,bNTSC_PAL,MACROVISION_NONE);
}
#endif

static long TVOutInit(PTVOUTINIT_S pInit) {
  BOOL Err= 0;
  PTVOUTSTRUCT pTvOut;

  DbgMsg(DBG_SET,DBGID"TVOutInit()\r\n");

  pTvOut=&gsTvOut;

  pTvOut->nLumaGain  = LCH_ADJUST_NOT_SET;
  pTvOut->nLumaOffset= LCH_ADJUST_NOT_SET;
  pTvOut->nChroma    = LCH_ADJUST_NOT_SET;
  pTvOut->nHue       = LCH_ADJUST_NOT_SET;
  pTvOut->nLumaGainReset=50;
  pTvOut->nLumaOffsetReset=50;
  pTvOut->nChromaReset=50;
  pTvOut->nHueReset=50;

  pTvOut->bDispStd=0xff;                           
  pTvOut->bOutput=0;
  pTvOut->fTestMode=0;
  pTvOut->fEnable=0;

  pTvOut->dwNTSCScSynth=0x43e0f83e;   
  pTvOut->dwPALScSynth= 0x54131596;
  pTvOut->wNTSCScAmp=0x1c;
  pTvOut->wPALScAmp=0x15;
  pTvOut->dwResetTime=5;           // Hold reset for 5mS
  pTvOut->bLumaGainNorm=0x7c;

  pTvOut->wEEPROMStartAddr= 0x1F0;
  pTvOut->bI2CDevAddr= 0;
  pTvOut->fEncodeI2C=1;
//  pTvOut->bCurrAPSValue= 0;
//  pTvOut->szTempStr[40];
//  pTvOut->b4953HwID= 0x13;
//  pTvOut->b4952HwID= 0x02;
//  pTvOut->b4954HwID= 0x04;
//  pTvOut->b4955HwID= 0x05;
  pTvOut->bEncoderFound= ENCODER_UNKNOWN;

  pTvOut->pSetGPIO = (PSETGPIO)pInit->pSetGPIO;
  pTvOut->pGetGPIO = (PGETGPIO)pInit->pGetGPIO;
  pTvOut->hGPIORef = (LPVOID)  pInit->hGPIORef;

  pTvOut->pI2C=i2cNew(pInit->pSetGPIO,pInit->pGetGPIO,pInit->hGPIORef);
  pTvOut->bDispStd=0xff;

  if(pTvOut->pI2C) {
    BYTE bHWIDRead;
    TVOutReset(pTvOut);
    bHWIDRead= (BYTE)EncoderRead(pTvOut,0x3D);
    if(bHWIDRead==ID_CL4953) {
      pTvOut->bEncoderFound= ENCODER_4953;
      DbgMsg(DBG_SET,DBGID" Encoder 4953 Found ...\r\n");
    } else if(bHWIDRead==ID_CL4952) {
      pTvOut->bEncoderFound= ENCODER_4952;
      DbgMsg(DBG_SET,DBGID" Encoder 4952 Found ...\r\n");
    } else {
      //The 4954/5's ID is in a different register
      bHWIDRead= (BYTE)EncoderRead(pTvOut,0x5A);
      if(bHWIDRead==ID_CL4955) {
      	pTvOut->bEncoderFound= ENCODER_4955;
        DbgMsg(DBG_SET,DBGID" Encoder 4955 Found ...\r\n");
      }else if(bHWIDRead==ID_CL4954) {
        pTvOut->bEncoderFound= ENCODER_4954;
        DbgMsg(DBG_SET,DBGID" Encoder 4954 Found ...\r\n");
      }else{
        pTvOut->bEncoderFound= ENCODER_UNKNOWN;  
        DbgMsg(DBG_SET,DBGID" Encoder Unknown...\r\n");
      }
    } 
    pInit->hTvOut=(LPVOID)pTvOut;
  } else {
    pInit->hTvOut=0;
    Err=1;
  }
  return Err;
}

static long TvOutTestI2C(PTVOUTSTRUCT pTvOut) {
  BOOL fOk=1;
  BYTE bWr,bRd;
  for(bWr=1;bWr;bWr<<=1) {
    EncoderWrite(pTvOut,9,bWr);
    bRd=(BYTE)EncoderRead(pTvOut,9);
    if(bRd!=bWr) {
      DbgMsg(DBG_SET|DBG_ERR,"Tv Out I2C error expected %02x, read %02x\r\n",bWr,bRd);
      fOk=0;
    }
  }  
  if(fOk)
    DbgMsg(DBG_INFO,"Tv Out I2C ok\r\n",bWr,bRd);
  return fOk;
}

static long UpdateStandard(PTVOUTSTRUCT pTvOut) {
  BOOL Err= 0;                        
  BYTE bCntrl0,bCntrl1,bScAmp;
  DWORD dwScSynth;
  BYTE  bDispStd=pTvOut->bDispStd;
  BYTE  bMacMode=pTvOut->bMacrovisionMode;
  BYTE* pMacTable;
  BYTE* pRegTable;
  int   fSetSync30IRE=0;
  
  if(pTvOut->pI2C && pTvOut->bEncoderFound) {
    switch(bDispStd) {
      case TV_TYPE_NTSC:  bCntrl0=0x01;
                          bScAmp =(BYTE)pTvOut->wNTSCScAmp;
                          dwScSynth=pTvOut->dwNTSCScSynth;
                          if(bMacMode==TV_MACROVISION_NONE) {
                            fSetSync30IRE=0;            // Sync tips normally 40IRE
                            pTvOut->bLumaGainNorm=0x7c;
                          } else {
                            fSetSync30IRE=1;            // Sync tips 40IRE when Macrovision process enabled
                            pTvOut->bLumaGainNorm=0x70;
                          }


                          break;
      case TV_TYPE_PAL:   bCntrl0=0x41;
                          bCntrl1=0x04;
                          bScAmp =(BYTE)pTvOut->wPALScAmp;
                          dwScSynth=pTvOut->dwPALScSynth;
                          pTvOut->bLumaGainNorm=0x7f;
                          break;
      default:            bCntrl0=0;
                          break;
    }
    if(bCntrl0) {                         
      int fColorBars=pTvOut->fTestMode;

      if(GetMacTables(pTvOut,&pMacTable,&pRegTable)==0) {
        if(pMacTable && pRegTable) {
          UpdateMacRegs(pTvOut,pRegTable,pMacTable);
        }
      } else
        fColorBars=1; // if macrovision required but chip won't do it then colorbars only

      EncoderWrite(pTvOut,0x00,(BYTE)(bCntrl0|0x0a)); // Put it into Slave Mode, Enable Input From Decoder, Inform that the input is in CCIR656
      switch(pTvOut->bEncoderFound) {
        case ENCODER_4954:
        case ENCODER_4955:
          EncoderWrite(pTvOut,0x01,(BYTE)(fSetSync30IRE?0x00:0x02));
          if(fColorBars)
            EncoderWrite(pTvOut,0x03,0x01);
          else
            EncoderWrite(pTvOut,0x03,0x00);
          break;
        case ENCODER_4952:
        case ENCODER_4953:
          if(fColorBars)
            EncoderWrite(pTvOut,0x01,(BYTE)(fSetSync30IRE?0x02:0x06));
          else
            EncoderWrite(pTvOut,0x01,(BYTE)(fSetSync30IRE?0x00:0x04));
          EncoderWrite(pTvOut,0x02,0x00);
          break;
      }
      EncoderWrite(pTvOut,0x08,0x03);                 // background colour = Blue
      EncoderWrite(pTvOut,0x10,bScAmp);    
      EncoderWrite(pTvOut,0x11,(BYTE) (dwScSynth&0x000000ff));    
      EncoderWrite(pTvOut,0x12,(BYTE)((dwScSynth&0x0000ff00)>>8));    
      EncoderWrite(pTvOut,0x13,(BYTE)((dwScSynth&0x00ff0000)>>16));    
      EncoderWrite(pTvOut,0x14,(BYTE)((dwScSynth&0xff000000)>>24));

      if(pTvOut->nLumaGain==LCH_ADJUST_NOT_SET)
        pTvOut->nLumaGain=pTvOut->nLumaGainReset;
      else
        TVOutSetLumaGain(pTvOut,pTvOut->nLumaGain);

      if(pTvOut->nLumaOffset==LCH_ADJUST_NOT_SET)
        pTvOut->nLumaOffset=pTvOut->nLumaOffsetReset;
      else
        TVOutSetLumaOffset(pTvOut,pTvOut->nLumaOffset);

      if(pTvOut->nChroma==LCH_ADJUST_NOT_SET)
        pTvOut->nChroma=pTvOut->nChromaReset;
      else
        TVOutSetChroma(pTvOut,pTvOut->nChroma);

      if(pTvOut->nHue==LCH_ADJUST_NOT_SET)
        pTvOut->nHue=pTvOut->nHueReset;
      else
        TVOutSetHue(pTvOut,pTvOut->nHue);
    }                             
  }
  return Err;
}

static long TVOutSetStandard(PTVOUTSTRUCT pTvOut,BYTE bDispStd) {
  BOOL Err= 0;                        
  pTvOut->bDispStd=bDispStd;
  UpdateStandard(pTvOut);
  return Err;
}

static long TVOutGetStandard(PTVOUTSTRUCT pTvOut) {
  return (long)pTvOut->bDispStd;
}


// UpdateOutput
// will setup encode DAC's according to ->bOutput
// if ->fEnable is set, otherwise disable DAC's
static long UpdateOutput(PTVOUTSTRUCT pTvOut) {
  long lErr=0;
  BYTE b2,b4,b5;
  BYTE bOutput;
  if(pTvOut->pI2C) {
    bOutput=pTvOut->fEnable?pTvOut->bOutput:0;
    DbgMsg(DBG_SET,DBGID"UpdateOutput bOutput=%d\r\n",bOutput);
    switch(pTvOut->bEncoderFound) {
      case ENCODER_4954:
      case ENCODER_4955:
        b2=0x00;  // default to RGB instead of YCrCb 
        b4=0xff;  // default all DACs powered down
        b5=0x40;  // default Low Impedance, All DACs disabled
  	    if(bOutput&TV_OUT_SVID)  {b4&=0xE7;b5|=0x18;} 
        if(bOutput&TV_OUT_COMP)  {b4&=0xdf;b5|=0x20;}
        if(bOutput&TV_OUT_YCRCB) {b4&=0xf8;b5|=0x07;b2=0x20;}
        if(bOutput&TV_OUT_RGB)   {b4&=0xf8;b5|=0x07;}
        EncoderWrite(pTvOut,0x02,b2);
        EncoderWrite(pTvOut,0x04,b4);
        EncoderWrite(pTvOut,0x05,b5);
        break;

      case ENCODER_4952:
      case ENCODER_4953:
        b4=0xf0;
	      if(bOutput&TV_OUT_SVID) {b4|=0x03; b4&=0xcf;} 
        if(bOutput&TV_OUT_COMP) {b4|=0x04; b4&=0xbf;}
	      EncoderWrite(pTvOut,0x04,b4);
        break;
    }
  } else
    lErr=1;
  return lErr;
}

static long TVOutSetOutput(PTVOUTSTRUCT pTvOut,BYTE bOutput) {
  pTvOut->bOutput=bOutput;
  UpdateOutput(pTvOut);
return 0;
}

/************************************************************************************
 ** long TVOutGetSelection(void);
 ************************************************************************************/
static long TVOutGetOutput(PTVOUTSTRUCT pTvOut)
{
  return (long)pTvOut->bOutput;
}

static long TVOutEnable(PTVOUTSTRUCT pTvOut,BOOL fEnable) {
  pTvOut->fEnable=fEnable;
  if(fEnable)
    UpdateStandard(pTvOut);
  UpdateOutput(pTvOut);
  return 0;
}

static long TVOutTestMode(PTVOUTSTRUCT pTvOut,BOOL fOnOff) {
  long Err= 0;
  pTvOut->fTestMode=fOnOff;
  UpdateStandard(pTvOut);
  return Err;
}

static long TVOutClose(PTVOUTSTRUCT pTvOut) {
  BOOL Err= 0;
  if(pTvOut->pI2C) {
    DbgMsg(DBG_SET,"DVD Encoder CLOSE ************************************** \r\n");
    TVOutWriteConfig(pTvOut);
    TVOutPowerDown(pTvOut);
    i2cDelete(pTvOut->pI2C);
    pTvOut->pI2C= 0;
  }
  return Err;
}

static long TVOutSetMacrovisionMode(PTVOUTSTRUCT pTvOut,BYTE bMode) {
  BOOL Ret= 0;
  DbgMsg(DBG_MACR,DBGID" SetATIMacroMode(%d)\r\n", bMode&0x03);

#if INCLUDE_ATI
  if (gbTVOutPlusIsLoaded)
#ifndef WIN32
    CallProcEx32W(2|CPEX_DEST_CDECL,0,(DWORD)lpfnDllFuncSetATIMacroMode,(DWORD)TRUE,(DWORD)bMode&0x03);
#else
    lpfnDllFuncSetATIMacroMode((DWORD)TRUE, (DWORD)bMode&0x03);
#endif
#endif
  pTvOut->bMacrovisionMode=bMode;
  UpdateStandard(pTvOut);
  return Ret;
}

static long TVOutGetMacrovisionMode(PTVOUTSTRUCT pTvOut, BYTE* pbMode) {
  long lErr = 0;
  DbgMsg(DBG_SET,DBGID"TVOutGetCurrMacrovisionAPS\r\n");

  *pbMode = pTvOut->bCurrAPSValue;

  return lErr;
}

static long TVOutSetLumaGain(PTVOUTSTRUCT pTvOut,int nGain) {
  // nGain is 0 to 100
  WORD wScaled;
  BYTE bMidpoint=pTvOut->bLumaGainNorm;
  BYTE bMin=32;

  if(nGain<=50) 
    wScaled=(WORD)((((long)nGain*(bMidpoint-bMin))+25)/50)+bMin;
  else
    wScaled=(WORD)(((((long)nGain-50)*(255-bMidpoint))+25)/50)+bMidpoint;

  switch(pTvOut->bEncoderFound) {
    case ENCODER_4954:
    case ENCODER_4955:
      EncoderWrite(pTvOut,0x24,(BYTE)wScaled);
      break;

    case ENCODER_4952:
    case ENCODER_4953:
      EncoderWrite(pTvOut,0x0E,(BYTE)wScaled);
      break;
  }
  pTvOut->nLumaGain=nGain;
  return 1;
}

static long TVOutGetLumaGain(PTVOUTSTRUCT pTvOut)  {
   return (long)pTvOut->nLumaGain;
}

static long TVOutSetLumaOffset(PTVOUTSTRUCT pTvOut,int nOffset) {
  // nOffset is 0 to 100 (50 is nominal)
  BYTE bMin=32;
  WORD wScaled=(WORD)((((long)nOffset*(255-bMin))+50)/100)-128;
  wScaled+=bMin;

  switch(pTvOut->bEncoderFound) {
    case ENCODER_4954:
    case ENCODER_4955:
      EncoderWrite(pTvOut,0x28,(BYTE)wScaled);
      break;

    case ENCODER_4952:
    case ENCODER_4953:
      TVOutSetLumaGain(pTvOut,nOffset);   // cheating: use Gain since offset not available in 52/53
      break;
  }
  pTvOut->nLumaOffset=nOffset;
  return 1;
}

static long TVOutGetLumaOffset(PTVOUTSTRUCT pTvOut)  {
   return (long)pTvOut->nLumaOffset;
}

static long TVOutSetChroma(PTVOUTSTRUCT pTvOut,int nChroma)  {
  // bChroma is 0 to 100 (50 is nominal)
  WORD wScaled=(WORD)((((long)nChroma*255)+50)/100);
  switch(pTvOut->bEncoderFound) {
    case ENCODER_4954:
    case ENCODER_4955:
      EncoderWrite(pTvOut,0x22,(BYTE)wScaled);
      EncoderWrite(pTvOut,0x23,(BYTE)wScaled);
      break;

    case ENCODER_4952:
    case ENCODER_4953:

      EncoderWrite(pTvOut,0x0D,(BYTE)wScaled);
      break;
  }
  pTvOut->nChroma=nChroma;
  return 1;
}

static long TVOutGetChroma(PTVOUTSTRUCT pTvOut)  {
  return (long)pTvOut->nChroma;
}

static long TVOutSetHue(PTVOUTSTRUCT pTvOut,int nHue) {
  // nHue is 0 to 100 (50 is nominal)
  WORD wScaled;
  wScaled=(WORD)((((long)(nHue)*511)+50)/100);
  wScaled-=256;
//  wScaled=(WORD)((((long)(nHue)*1023)+50)/100);
//  wScaled-=512;
  EncoderWrite(pTvOut,0x15,(BYTE)wScaled);
  EncoderWrite(pTvOut,0x16,(BYTE)((wScaled>>8)&3));
  pTvOut->nHue=nHue;
  return 1;
}

static long TVOutGetHue(PTVOUTSTRUCT pTvOut) {
  return (long)pTvOut->nHue;
}

static long TVOutResetPicture(PTVOUTSTRUCT pTvOut) {
  TVOutSetLumaOffset(pTvOut,pTvOut->nLumaOffsetReset);
  TVOutSetLumaGain(pTvOut,pTvOut->nLumaGainReset);
  TVOutSetChroma(pTvOut,pTvOut->nChromaReset);
  TVOutSetHue   (pTvOut,pTvOut->nHueReset);
  return 1;
}

/* eof */
