
#ifndef _TVOUT_DEF
#define _TVOUT_DEF      0x1234



#define TVOUT_API                     0x0300    //0x03 Major; 0x00 Minor;


// List of Messages to TVOutProc

#define TVOUT_INIT                    0x0001
#define TVOUT_FINI                    0x0002
#define TVOUT_READ_CONFIG             0x0003
#define TVOUT_WRITE_CONFIG            0x0004

#define TVOUT_TEST_MODE               0x0005
#define TVOUT_SET_MACROVISION         0x0006
#define TVOUT_GET_MACROVISION         0x0007
#define TVOUT_SET_STANDARD            0x0008
#define TVOUT_GET_STANDARD            0x0009
#define TVOUT_SET_OUTPUT              0x000A
#define TVOUT_GET_OUTPUT              0x000B
#define TVOUT_ENABLE                  0x000C

#define TVOUT_SET_LUMA                0x000D
#define TVOUT_GET_LUMA                0x000E
#define TVOUT_SET_LUMA_GAIN           0x000F
#define TVOUT_GET_LUMA_GAIN           0x0010
#define TVOUT_SET_CHROMA              0x0011
#define TVOUT_GET_CHROMA              0x0012
#define TVOUT_SET_HUE                 0x0013
#define TVOUT_GET_HUE                 0x0014
#define TVOUT_RESET_PICTURE           0x0015
#define TVOUT_ENCODER_WRITE           0x0016
#define TVOUT_ENCODER_READ            0x0017
#ifndef _PSETGPIO
 #define _PSETGPIO
 typedef void (FAR *PSETGPIO)(LPVOID lpParent, BYTE bPinNumber, BYTE bEnable, BYTE bValue);
 typedef BYTE (FAR *PGETGPIO)(LPVOID lpParent, BYTE bPinNumber, LPBYTE lpEnable, LPBYTE lpValue);
#endif

typedef struct TvOut_s 
{
  DWORD     wAPI;          // check TVOUT API version
  PSETGPIO pSetGPIO;      // SetGPIO function pointer
  PGETGPIO pGetGPIO;      // GetGPIO function pointer
  LPVOID   hGPIORef;      // Reference for Set/GetGPIO functions
  LPVOID   hTvOut;        // TVOUT Hanlde  TVOUT_INIT returns, all other commands require
} TVOUTINIT_S;

typedef TVOUTINIT_S FAR* PTVOUTINIT_S;

#define TV_TYPE_NTSC  1
#define TV_TYPE_PAL   2

#define TV_OUT_NONE   0
#define TV_OUT_SVID   1
#define TV_OUT_COMP   2
#define TV_OUT_YCRCB  4
#define TV_OUT_RGB    8

#define TV_MACROVISION_NONE 0x10
#define TV_MACROVISION_AGC  0x11
#define TV_MACROVISION_AGC2 0x12
#define TV_MACROVISION_AGC4 0x13

#if _WIN32_WCE
long TVOutProc(LPVOID hTvOut,WORD wMsg, DWORD dwParm1, DWORD dwParm2);
#elif WINNT
long TVOutProc(LPVOID hTvOut,WORD wMsg, DWORD dwParm1, DWORD dwParm2);
#else 
#ifndef WIN32
long FAR _loadds TVOutProc(LPVOID hTvOut,WORD wMsg, DWORD dwParm1, DWORD dwParm2);
#else
__declspec(dllexport) long _TVOutProc(LPVOID hTvOut,WORD wMsg, DWORD dwParm1, DWORD dwParm2);
#endif
#endif


#endif
