#define WANTVXDWRAPS 1

#include <StrMini.h>
#include <KsMedia.h>
//#include <WinDef.h>
#include <Vmm.h>
#include <VxdWraps.h>
#include <ConfigMg.h>

#include "DbgMsg.h"
#include "DbgFltr.h"
#include "Settings.h"
#include "Idents.h"
#include "margierr.h"

//#include "Globals.h"

#include "cardserv.h"
#include "margipnp.h"
#include "cardsrvc.h"
#include "util.h"
#include "regkeys.h"
#include "zvcntrl.h"
#include "cardid.h"

static DWORD ConfigApmDflt(DWORD FuncID);
#define CONFIG_APM_FLAGS_MASK 0xFFFFF000

void SetDefaults(void);

static DWORD ConfigFilter(DEVNODE DevNode);
static DWORD ConfigRemove(DEVNODE DevNode,CONFIGFUNC FuncID);
static DWORD ConfigStop(DEVNODE DevNode,SUBCONFIGFUNC FuncID);
static DWORD ConfigAPM(DEVNODE DevNode,SUBCONFIGFUNC FuncID);
static DWORD ConfigTest(DEVNODE DevNode,SUBCONFIGFUNC FuncID);

DEVNODE gpnpHandle=0;   // most recently allocated DEVNODE

struct IO_Resource_1_s {
  IO_DES  IO_Header;
  IO_RANGE IO_Data;
};
typedef struct IO_Resource_1_s IO_RES1;

WORD ConfigGetDmaBase(PDEVICE p);


/*************************************************************************/
/** This is a total hack which sniffs up the registry enumeration tree	**/
/** to find the DevNode for the card, then uses existing configuration	**/
/** manager code to initialize it.					**/
/*************************************************************************/
DEVNODE ConfigFindDevNode(void) {
  DEVNODE MargiDevNode=0;
  DEVNODE DevNode,NextDevNode;

  DEVNODEID DevNodeID_Margi="PCMCIA\\MARGI_SYSTEMS-DVD_DECODER-D492\\0";
  DEVNODEID DevNodeID_Dell= "PCMCIA\\DELL-DVD_PLAYER-364F\\0";
  DEVNODEID DevNodeID_Billi="PCMCIA\\MARGI-BILLIONTON-DVD_PLAYER-BE24\\0";
  CONFIGRET Err;
  char Buff[512];

  if(!MargiDevNode)
    CM_Locate_DevNode(&MargiDevNode,DevNodeID_Margi,0);
  if(!MargiDevNode)
    CM_Locate_DevNode(&MargiDevNode,DevNodeID_Dell,0);
  if(!MargiDevNode)
    CM_Locate_DevNode(&MargiDevNode,DevNodeID_Billi,0);

  if(!MargiDevNode) {
    if(!(Err=CM_Locate_DevNode(&DevNode,0,0))) {
      while(!MargiDevNode && DevNode) {
        RtlZeroMemory(Buff,sizeof(Buff));
        CM_Get_Device_ID(DevNode,Buff,sizeof(Buff),0);
        if( (strstr(Buff,"DVD")) && (strstr(Buff,"MARGI") || strstr(Buff,"BILLIONTON") || strstr(Buff,"DELL")) ) {
          MargiDevNode= DevNode; break;
        }
        if(!(Err=CM_Get_Child(&NextDevNode,DevNode,0))) {
          DevNode= NextDevNode;
        } else {
          while(1) {
            if((Err=CM_Get_Sibling(&NextDevNode,DevNode,0))==CR_SUCCESS) {
              DevNode= NextDevNode;
              break;
            } else {
              if((Err=CM_Get_Parent(&NextDevNode,DevNode,0))==CR_SUCCESS) {
                DevNode= NextDevNode;
              } else {
                DevNode= 0;
                break;
              }
            }
          }
        }
      }
    }
  }
  return MargiDevNode;
}

void ConfigReleaseDevNode(DEVNODE DevNode) {
  if(DevNode)
    ConfigRemove(DevNode,CONFIG_REMOVE);
}

/*************************************************************************/
/** Configuration manager main message handler.				**/
/*************************************************************************/
static DWORD ConfigDflt(DWORD Func, DWORD SubFunc);

WORD CMFAR _cdecl OnConfigure(CONFIGFUNC cf, SUBCONFIGFUNC scf, DEVNODE DevNode, DWORD RefData, ULONG Flags) {
  DWORD Ret;
  switch(cf) {
    case CONFIG_FILTER:	    Ret= ConfigFilter(DevNode); break;
    case CONFIG_START:	    Ret= ConfigStart(DevNode); break;
    case CONFIG_PREREMOVE:
    case CONFIG_REMOVE:	    Ret= ConfigRemove(DevNode,cf);break;
    case CONFIG_STOP:	    Ret= ConfigStop(DevNode,cf); break;
    case CONFIG_APM:	    Ret= ConfigAPM(DevNode,scf); break;
    case CONFIG_TEST:	    Ret= ConfigTest(DevNode,scf); break;
    default:		    Ret= ConfigDflt(cf,scf); break;
  }
  return(WORD)Ret;
}

static DWORD ConfigDflt(DWORD Func, DWORD SubFunc) {
  DbgMsg(DBG_PNPUNK,"OnConfig unhandled message %s.\r\n",Ident(ID_CFGMGR,Func));
  return(CR_DEFAULT);
}

/*************************************************************************/
/** Automatic Power Management (APM) messages.				**/
/*************************************************************************/
static DWORD ConfigAPM(DEVNODE DevNode, SUBCONFIGFUNC FuncID) {
  DWORD Ret= CR_SUCCESS;
  switch(FuncID & ~CONFIG_APM_FLAGS_MASK) {
    default:					Ret= ConfigApmDflt(FuncID); break;
  }
  return(Ret);
}

static DWORD ConfigApmDflt(DWORD FuncID) {
  DbgMsg(DBG_PNPUNK,"ConfigApmDflt: Unhandled message %u.\r\n",FuncID);
  return(CR_SUCCESS);
}

/*************************************************************************/
/*************************************************************************/
static DWORD ConfigTestStop(void);
static DWORD ConfigTestRemove(void);
static DWORD ConfigTestDflt(DWORD FuncID);

static DWORD ConfigTest(DEVNODE DevNode,SUBCONFIGFUNC FuncID) {
  DWORD Ret= CR_SUCCESS;
  switch(LOWORD(FuncID)) {
    case CONFIG_TEST_CAN_STOP:	  Ret= ConfigTestStop(); break;
    case CONFIG_TEST_CAN_REMOVE:  Ret= ConfigTestRemove(); break;
    default:			  Ret= ConfigTestDflt(FuncID);
  }
  return(Ret);
}

static DWORD ConfigTestStop(void) {
  DbgMsg(DBG_PNPMSG,"ConfigTestStop\r\n");
  return(CR_SUCCESS);
}

static DWORD ConfigTestRemove(void) {
  DbgMsg(DBG_PNPMSG,"ConfigTestRemove\r\n");
  return(CR_SUCCESS);
}

static DWORD ConfigTestDflt(DWORD FuncID) {
  DbgMsg(DBG_PNPMSG,"ConfigTestDflt: Unhandled CONFIG_TEST message %u.\r\n",FuncID);
  return(CR_SUCCESS);
}

#if(1)
WORD ConfigRequestDmaBase(PDEVICE p) {
  CONFIGRET ret;
  WORD wDmaIoBase=0;
  if(p) {
    DEVNODE dn;
    DEVNODE dnParent;
    DEVNODE dnDMA;
    LOG_CONF lc;
    RES_DES  rd;
    IO_RES1 ior;
    dn=p->DevNode;
    p->dnDMA=0;
    if(CM_Get_Parent(&dnParent,dn,0)==CR_SUCCESS) {     // get socket controller devnode
      ret=CM_Create_DevNode(&dnDMA,0,dnParent,0);       // create DMA reg device
      if(ret==CR_SUCCESS) {
        ret=CM_Add_Empty_Log_Conf(&lc,dnDMA,LCPRI_NORMAL,BASIC_LOG_CONF|PRIORITY_EQUAL_FIRST);
        if(ret==CR_SUCCESS) {
          memset(&ior,0,sizeof(ior));
          ior.IO_Header.IOD_Count=1;
          ior.IO_Header.IOD_Type=sizeof(ior.IO_Data);
          ior.IO_Data.IOR_Align=0xfff0;
          ior.IO_Data.IOR_nPorts=16;
          ior.IO_Data.IOR_Min=0;
          ior.IO_Data.IOR_Max=0xffff;        
          if(CM_Add_Res_Des(&rd,lc,ResType_IO,&ior,sizeof(ior),0)==CR_SUCCESS) {  // DMA reg i/o address
            p->dnDMA=dnDMA;
            CM_Register_Device_Driver(dnDMA,OnConfigure,(DWORD)p,CM_REGISTER_DEVICE_DRIVER_DISABLEABLE|CM_REGISTER_DEVICE_DRIVER_REMOVABLE);
          }
        }
      }
    }
  }
  return wDmaIoBase;
}

WORD ConfigGetDmaBase(PDEVICE p) {
  WORD wDmaIoBase=0;
  if(p->dnDMA) {
    CMCONFIG config;
    CM_Get_Alloc_Log_Conf(&config,p->dnDMA,CM_GET_ALLOC_LOG_CONF_ALLOC);
    wDmaIoBase=config.wIOPortBase[0];
  }
  return wDmaIoBase;
}
#endif

/*************************************************************************/
/*************************************************************************/
static DWORD ConfigFilter(DEVNODE DevNode) {
  RES_DES  rd;
  LOG_CONF lc;
  DWORD ResId;
  RES_DES irq_res=0;
  DWORD Status=CM_Get_First_Log_Conf(&lc,DevNode,FILTERED_LOG_CONF);
  gpnpHandle= DevNode;
  SettingSave(SET_STR,KEYVAL_CURSTATE,(DWORD)KEYVAL_STATE_INSERTIONSTART);
  while(Status==CR_SUCCESS) {
    rd=(RES_DES)lc;
    while(CM_Get_Next_Res_Des(&rd,rd,ResType_All,(PRESOURCEID)&ResId,0)==CR_SUCCESS) {
      switch(ResId) {
        case ResType_IRQ: break;
        case ResType_IO:  break;
        case 0x897c:	  break;
      }
    }
    Status=CM_Get_Next_Log_Conf(&lc,lc,0);
  }
  return(CR_SUCCESS);
}

static DWORD ConfigFilterIRQ(RES_DES *pRes) {
  DbgMsg(DBG_PNPCFG,"ConfigFilterIRQ\r\n");
  return(CR_SUCCESS);
}

static DWORD ConfigFilterIO(RES_DES *pRes) {
  DbgMsg(DBG_PNPCFG,"ConfigFilterIO\r\n");
  return(CR_SUCCESS);
}

/*************************************************************************/
/** New PNP devnode creation.						**/
/*************************************************************************/
static DWORD NewNodeDevLoader(DEVNODE DevNode);
static DWORD NewNodeEnumerate(DEVNODE DevNode);

static DWORD OnPnpNewDevnode(DEVNODE DevNode, DWORD loadtype) {
  DWORD Ret= CR_DEFAULT;
  SetRegistryFirstEntry(FIRSTENTRY_DEVNODE,KEYVAL_DEVNODE);
  switch(loadtype) {
    case DLVXD_LOAD_DEVLOADER:  Ret= NewNodeDevLoader(DevNode); break;
    case CONFIG_ENUMERATE:      Ret= NewNodeEnumerate(DevNode); break;
  }
  return(Ret);
}

static DWORD NewNodeDevLoader(DEVNODE DevNode) {
  DWORD Err= CR_SUCCESS;
  DbgMsg(DBG_PNPLOAD,"MargiDVD.wdm: New Devnode via DevLoader.\r\n");
  return(Err);
}

static DWORD NewNodeEnumerate(DEVNODE DevNode) {
  DWORD Ret= CR_DEFAULT;
  DbgMsg(DBG_PNPLOAD,"MargiDVD.wdm: New devnode via Enumerator.\r\n");
  return(Ret);
}

/*************************************************************************/
/*************************************************************************/
PDEVICE GetLocalDevice(DEVNODE DevNode, int fNew) {
  PDEVICE pDev,pFirstEmpty=0;
  int n;
  for(n=0;n<NUM_SOCKETS;n++) {
    pDev= &gCardDevice[n];
    if(!pDev->DevNode && !pFirstEmpty)
      pFirstEmpty= pDev;
    if(pDev->DevNode==DevNode)
      return(pDev);
  }
  if(fNew)
    pDev= pFirstEmpty;
  return(pDev);
}

/*************************************************************************/
/** DWORD ConfigStart(DevNode)						**/
/** --  Here we would initialize the device, doing things like          **/
/**     virtualizing the IRQ, etc.                                      **/
/*************************************************************************/
DWORD ConfigStart(DEVNODE DevNode) {
  PDEVICE pDev;
  CMCONFIG config;
  WORD nCardId=0;
  BYTE CardIDStr[16];

  DbgMsg(DBG_PNPCFG,"ConfigStart\r\n");
  SettingSave(SET_STR,KEYVAL_CURSTATE,(DWORD)KEYVAL_STATE_INSERTIONSTART);
  pDev =GetLocalDevice(DevNode,1);     // Get empty entry in device table
  if(pDev) {
    pDev->DevNode=DevNode;
    CM_Get_Alloc_Log_Conf(&config,DevNode,CM_GET_ALLOC_LOG_CONF_ALLOC);
    pDev->nIrqChannel= config.bIRQRegisters[0];
    pDev->nIoAddress = config.wIOPortBase[0];
    pDev->fDmaSupported=1;
    
    // Perform Custom Configuration to Enable ZV Port
    if(!ZVConfig(pDev)) {
      strcpy(TmpStr,"Zoomed Video Card inserted in Non-ZV socket");
      SettingSave(SET_STR,KEYVAL_ERROR,(DWORD)TmpStr);
      ErrBox(MARGI_ERR_DEVICE,"MargiPNP WARNING",TmpStr);
    }
#if(0)
    {
      int nRetry;
      for(nRetry=0; nRetry<5; nRetry++) {
        //Wait 10mSec before IDing card - fix problem on Extensa
        CM_Yield(10000,CM_YIELD_NO_RESUME_EXEC);
        nCardId=GetCardIoId(pDev->nIoAddress);
        pDev->CardType=GetCardTypeFromIo(nCardId);
        if(pDev->CardType)
          break;
      }
      if(!pDev->CardType) {
        strcpy(TmpStr,"Unable to detect card ");
        AppendHexStr(TmpStr,nCardId);
        SettingSave(SET_STR,KEYVAL_ERROR,(DWORD)TmpStr);
        ErrBox(MARGI_ERR_DEVICE,"MargiPNP ERROR",TmpStr);
      }
    }
#else
    pDev->CardType=DVD_TYPE;
#endif
//    ZVSetupDma(pDev);
    pDev->State = S_INSERTED;
    //Broadcast message to all registered callbacks
    NotifyCallback(0,pDev->State,pDev->l_socket,nCardId);
    strcpy(CardIDStr,"Card ");
    AppendHexStr(CardIDStr,nCardId);
    SettingSave(SET_STR,KEYVAL_CARDID,(DWORD)CardIDStr);
    SettingSave(SET_STR,KEYVAL_CURSTATE,(DWORD)KEYVAL_STATE_INSERTIONDONE);
    ZVEnable(pDev);
  }
  return(CR_SUCCESS);
}

int ConfigCheckDma(DEVNODE DevNode) {
  PDEVICE pDev;
  pDev =GetLocalDevice(DevNode,0);  // Get entry in device table

  return ZVCheckDma(pDev);  
}

int ConfigSetupDma(DEVNODE DevNode,DWORD dwIoBase) {
  PDEVICE pDev;
  pDev =GetLocalDevice(DevNode,0);  // Get entry in device table

  return ZVSetupDma(pDev,dwIoBase);
}

/*************************************************************************/
/** DWORD ConfigStop(DevNode,FuncID)					**/
/** --  Here we would disable the device and do things like             **/
/**     unvirtualizing our IRQ.                                         **/
/*************************************************************************/
static DWORD ConfigStop(DEVNODE DevNode, CONFIGFUNC FuncID) {
  DbgMsg(DBG_PNPCFG,"ConfigStop\r\n");
  ResetRegistryFlags(0);
  return(ConfigRemove(DevNode,CONFIG_REMOVE));
}

/*************************************************************************/
/*************************************************************************/
static DWORD ConfigRemove(DEVNODE DevNode,CONFIGFUNC FuncId) {
  PDEVICE pDev;

  pDev= GetLocalDevice(DevNode,0);
  if(pDev) {
    pDev->nIrqChannel= 0;
    pDev->nIoAddress = 0;
    pDev->State = S_EXTRACTED;
    if(pDev->CardType) {
      //Broadcast message to all registered callbacks
      NotifyCallback(0,pDev->State,pDev->l_socket,pDev->CardType);
      ZVRelease(pDev);
    }
    pDev->CardType= 0;
    if(FuncId==CONFIG_REMOVE) 
      pDev->DevNode=0;
    if(pDev->DevNode) {
      // notify all callbacks that they going to be disconnected
      NotifyCallback(0,S_VXD_UNLOAD,0,0);
    }
  }
  return(CR_SUCCESS);
}

BYTE GetPnpIrqChannel(DEVNODE dn) {
  CMCONFIG config;
  CM_Get_Alloc_Log_Conf(&config,dn,CM_GET_ALLOC_LOG_CONF_ALLOC);
  return((BYTE)config.bIRQRegisters[0]);
}

WORD GetPnpIoBase(DEVNODE dn) {
  CMCONFIG config;
  CM_Get_Alloc_Log_Conf(&config,dn,CM_GET_ALLOC_LOG_CONF_ALLOC);
  return((WORD)config.wIOPortBase[0]);
}

/**EOF: CONFIG.C**/
