/*************************************************************************
*
*  File:
*     CSCLIENT.C - Sample VxD to CS Interface
*
*  Copyright (c) 1995 SystemSoft Corporation.  All Rights Reserved.
*
\************************************************************************/

#define WANTVXDWRAPS 1

#include <WinDef.h>
#include <Vmm.h>
#include <VWin32.h>
#include <VxdWraps.h>
#include <ConfigMg.h>

#include "DbgMsg.h"
#include "DbgFltr.h"
#include "Settings.h"
#include "margierr.h"

#include "IniNames.h"
#include "csgatew.h"
#include "cardserv.h"
#include "margipnp.h"
#include "cardsrvc.h"
#include "util.h"
#include "regkeys.h"
#include "deviceid.h"
#include "zvcntrl.h"
#include "cardid.h"
#include "retcodes.h"

#include "IoCtrl.h"

#define _PCI_DECLARE
#include "PCIDEFS.H"

/*** Global Data ***/
WORD gPnPDeviceInit=0;
WORD gVxDFirstEntry= 0;

TYPE_STRUCT      gTypeTable[]={ {MAKEU32(MARGI_OLD_ID,MPEGTOGO_ID),MPEGTOGO_IOID,MPEG_TYPE},
                                {MAKEU32(MARGI_ID,MPEGTOGO_ID),MPEGTOGO_IOID,MPEG_TYPE},
                                {MAKEU32(FUJIF_ID,MPEGTOGO_ID),MPEGTOGO_IOID,MPEG_TYPE},
                                {MAKEU32(CEI_ID,  MPEGTOGO_ID),MPEGTOGO_IOID,MPEG_TYPE},
                                {MAKEU32(MARGI_OLD_ID,CAPTTOGO_ID),CAPTTOGO_IOID,CAPT_TYPE},
                                {MAKEU32(MARGI_ID,CAPTTOGO_ID),CAPTTOGO_IOID,CAPT_TYPE},
                                {MAKEU32(FUJIF_ID,CAPTTOGO_ID),CAPTTOGO_IOID,CAPT_TYPE},
                                {MAKEU32(CEI_ID,  CAPTTOGO_ID),CAPTTOGO_IOID,CAPT_TYPE},
                                {MAKEU32(MARGI_ID,DVDTOGO_ID), DVDTOGO_IOID, DVD_TYPE},
                                {0,0}
                              };

char TmpStr[80]= {"Empty"};

unsigned char GetPnpIrqChannel(DEVNODE dn);
WORD GetPnpIoBase(DEVNODE dn);

/*** Local Function Prototypes ***/
int ConfigureCard(PDEVICE p, int fPwr, int fIO, int fIRQ);
DWORD HardwareAcquire(DWORD *pHndl);
DWORD HardwareRelease(DWORD *pHndl);
DWORD HardwareIsInserted(DWORD *pInserted);

ULONG gulSocketControllerId=0;
int gfCompaq=0;
int gnZVSource=0;
int gnPrevZVState=0;

/*************************************************************************/
void ResetRegistryFlags(WORD fComplete) {
  SettingSave(SET_DWORD,KEYVAL_CURSTATE,(DWORD)KEYVAL_STATE_PREINIT);
  if(fComplete) {
    SettingSave(SET_DWORD,KEYVAL_DEVINIT,0);
    SettingSave(SET_DWORD,KEYVAL_LOADED,0);
    SettingSave(SET_DWORD,KEYVAL_ENTRY,0);
    SettingSave(SET_DWORD,KEYVAL_PNPINIT,1);
    SettingSave(SET_DWORD,KEYVAL_IOCTRL,1);
    SettingSave(SET_DWORD,KEYVAL_DEVNODE,1);
  }
}

WORD SetRegistryFirstEntry(WORD EntryID, BYTE *ValueName) {
  WORD fFirst= 0;
  SettingSave(SET_DWORD,ValueName,1);
  SettingSave(SET_DWORD,KEYVAL_LOADED,1);
  if(!gVxDFirstEntry) {
    fFirst= 1;
    gVxDFirstEntry= EntryID;
    SettingSave(SET_STR,KEYVAL_ENTRY,(DWORD)ValueName);
    SettingSave(SET_STR,KEYVAL_CURSTATE,(DWORD)KEYVAL_STATE_PREINIT);
  }
  return(fFirst);
}

/*************************************************************************/
void InitDeviceList(void) {
  PDEVICE p;
  int n;
  static BYTE fInitDone= 0;
  if(!fInitDone) {
    for (n=0;n<NUM_SOCKETS;n++) {
      p= &gCardDevice[n];
      memset(p,0,sizeof(*p));
      p->l_socket= n;
    }
    fInitDone= 1;
  }
}

WORD GetCardIoId(int iobase)
{
  int id;
  _asm
  {
    mov eax,iobase
    mov dx,ax
    mov al,0
    out dx,al
    add dx,2
    in  ax,dx
    mov id,eax
  }
  return id & 0x00ff;
}

WORD GetCardTypeFromIo(WORD id)
{
  int n;
  for(n=0;gTypeTable[n].CardId;n++)
  {
    if(gTypeTable[n].IoId==id)
      return gTypeTable[n].Type;
  }
  return 0;
}

WORD GetCardTypeFromCis(DWORD id)
{
  int n;
  for(n=0;gTypeTable[n].CardId;n++)
  {
    if(gTypeTable[n].CardId==id)
      return gTypeTable[n].Type;
  }
  return 0;
}

//UINT16 GetDevCardType(PDEVICE p)
//{
//   return GetCardType(p->CardId);
//}

int IsTypeSupported(WORD type)
{
   int n;
   for(n=0;gTypeTable[n].CardId;n++)
   {
      if(gTypeTable[n].Type == type)
         return 1;
   }
   return 0;
}


int NotifyCallback(int hCb, int msg, DWORD uParam1, DWORD uParam2)
{
   DWORD uFnc, uVM;
   int n,last;
   int nMsgSent=0;
   DWORD data_addr,func_addr,event;


   if (hCb)    // if hCB is specifed then PostMessage once
   {
      n= hCb-1;
      last=n;
   }
   else        // if hCB not specified then broadcast to all callbacks
   {
      n= 0;
      last= NUM_CALLBACKS-1;
   }

   for(;n<=last;n++)
   {
     int m;
     NOTIFY_MSG_S* pMsg;
     uVM  = gNotify[n].dwVM;
     uFnc = gNotify[n].CBInfo.dwProc;

     // if msg is S_VXD_UNLOAD then disconnect after sending message
     if(msg==S_VXD_UNLOAD)
        gNotify[n].CBInfo.dwProc=0;

     //messages are queued in the Msg array
     //and scheduled for later execution.
     //The EventNotify function in MARGIPNP.ASM will perform
     //the callback and then remove the message from the queue.
     //look for free element in message array
     for(m=0;m<NUM_MSG;m++)
        if(!gNotify[n].Msg[m].uFunc)
           break;
     if(m>=NUM_MSG)  //If no room in message array then can't send
       break;
     pMsg = &gNotify[n].Msg[m];

     // post message only if cardtype matches or callback wants all cardtypes
     if(uFnc&&(!gNotify[n].CBInfo.dwCardType||!uParam2||gNotify[n].CBInfo.dwCardType==uParam2))
     {
         {
           pMsg->uFunc   = uFnc;
           pMsg->uMsg    = msg;
           pMsg->uParam1 = uParam1;
           pMsg->uParam2 = uParam2;
           data_addr = (DWORD)pMsg;
           //RAVI func_addr = (UINT32)EventNotify; // Scheduled EventNotify() proc in MARGIPNP.ASM
                                          // Note: EventNotify() will release the message

          // Schedule a VM event that will callback into the DLL
          _asm mov     ebx, uVM                    // VM handle
          _asm mov     esi, func_addr
          _asm mov     edx, data_addr

          VMMCall(Call_VM_Event);
          _asm mov     event,esi
          pMsg->uEvent = event;
        }
        nMsgSent++;
     }
   }
  return nMsgSent;
}


int DeleteNotify()
{
   int n,last;
   int nMsgSent=0;
   DWORD uVM,uEvent;

   n= 0;
   last= NUM_CALLBACKS-1;

   // loop thru all scheduled events and cancel them
   for(;n<=last;n++)
   {
     int m;
     uVM = gNotify[n].dwVM;

     for(m=0;m<NUM_MSG;m++)
     {
       if(gNotify[n].Msg[m].uEvent)
       {
         uEvent=gNotify[n].Msg[m].uEvent;

         _asm mov ebx, uVM
         _asm mov esi, uEvent
         VMMCall(Cancel_VM_Event);

         gNotify[n].Msg[m].uEvent=0;
         gNotify[n].Msg[m].uFunc=0;
         nMsgSent++;
       }
     }
   }
   return nMsgSent;
}



WORD V86GetVersionID(void) {
  WORD VersionID;
  GetVersionID(&VersionID);
  return(VersionID);
}

WORD V86GetResources(RESOURCES_STRUCT* pRsrc)
{
  PDEVICE p;
  int n,status;
  int fSetFlags;

  // recover set flags flag and remove from card type
  // if SetFlags is true then we should set the dwFlags field in Rsrc
  fSetFlags=pRsrc->CardType&1;
  pRsrc->CardType&=~1;

  if(fSetFlags) {
    pRsrc->wFlagsLo=0;
    pRsrc->wFlagsHi=0;
  }

  pRsrc->wSocket=0;
  for (n=0;n<NUM_SOCKETS;n++) {
     p = &gCardDevice[n];
     if(pRsrc->CardType == p->CardType)
        break;
  }
  if(n>=NUM_SOCKETS)  // Requested Card Not Found
  {
     if(p->DevNode)             // If Plug and Play Driver Configured card
       pRsrc->State = 0x30d;    // and card not found then most likely that not in ZV Socket
                                // return config error, invalid i/f type
     else
       pRsrc->State = S_EXTRACTED;
     pRsrc->IOBase= 0;
     pRsrc->IRQ   = 0;
     DbgMsg(DBG_CSCLNT,"MARGIPNP V86GetResources: Requested Card Not Found\r\n");
     SettingSave(SET_STR,KEYVAL_STATUS,(DWORD)"Error.");
     SettingSave(SET_STR,KEYVAL_ERROR,(DWORD)"Requested card not found.");
     return 0;
  }

  p->Error=0;
  pRsrc->wSocket= n+1;

  if(p->DevNode)     // If Plug and Play Driver Configured card
  {
    pRsrc->IRQ=    p->nIrqChannel;
    pRsrc->IOBase= p->nIoAddress;
    if(fSetFlags) {
      pRsrc->wFlagsLo=(WORD)(p->dwFlags&0xffff);
      pRsrc->wFlagsHi=(WORD)(p->dwFlags>>16);
    }
    // Enable ZV for Socket
    if(!ZVEnable(p))
    {
      p->State = 0x030d;   // will give "Not ZV Socket" Message
      SettingSave(SET_STR,KEYVAL_STATUS,(DWORD)"Error.");
      SettingSave(SET_STR,KEYVAL_ERROR,(DWORD)"ZVEnable() failed.");
    }
    else {
      SettingSave(SET_STR,KEYVAL_STATUS,(DWORD)"PnP OK - ZV Enabled.");
    }
    ZVCardPowerUp(p);
  }
  else if(p->State == S_INSERTED)
  {
     status = ConfigureCard(p,1,1,pRsrc->IRQ);
     if(status == R_SUCCESS)
     {
       pRsrc->IOBase= p->io.io_parms[0].base_port;
       pRsrc->IRQ=    p->irq.assigned_irq;
       ZVEnable(p);
       //Notify all registered callbacks with simulated insertion message
       NotifyCallback(0,S_INSERTED,pRsrc->wSocket,pRsrc->CardType);
       DbgMsg(DBG_CSCLNT,"MARGIPNP V86GetResources: Card Resources Configured\r\n");
       SettingSave(SET_STR,KEYVAL_STATUS,(DWORD)"CS OK - ZV Enabled.");
     }
     p->Error = status;
  }
  else
  {
    pRsrc->IOBase= 0;
    pRsrc->IRQ   = 0;
    SettingSave(SET_STR,KEYVAL_STATUS,(DWORD)"Error.");
    SettingSave(SET_STR,KEYVAL_ERROR,(DWORD)"CS Card not inserted.");
  }

  if(p->Error)
    pRsrc->State = p->Error;
  else
    pRsrc->State = p->State;

  return 0;
}

WORD V86FreeResources(RESOURCES_STRUCT* pRsrc)
{
  PDEVICE p;
  int n;

  n=pRsrc->wSocket-1;
  if(n<0 || n>=NUM_SOCKETS)
  {
     DbgMsg(DBG_CSCLNT,"MARGIPNP V86FreeResources: Invalid socket\r\n");
     return 0;
  }
  p = &gCardDevice[n];

  if(!p->DevNode)     // If Not Plug and Play Driver Configured card
  {
   // Release resources, remove power
#if !PERM_RESOURCE_ALLOC
    ConfigureCard(p,0,0,0);
#endif
  }
  pRsrc->IOBase= 0;
  pRsrc->IRQ   = 0;
  ZVDisable(p);
  SettingSave(SET_STR,KEYVAL_STATUS,(DWORD)"Null");
  ZVCardPowerDown(p);

  return 0;
}

WORD V86SetCallback(VXD_CALLBACK_INFO_S* pCBackInfo)
{
  int n=0;

  if(!pCBackInfo)
     return 0;

  if(!pCBackInfo->dwHandle)
  {  //If hCallback is not specified then
     //search for an unused element in the array.
     for(n=0;n<NUM_CALLBACKS;n++)
        if(!gNotify[n].CBInfo.dwProc)
        {
          pCBackInfo->dwHandle = n+1;
          break; //break if unused array found
        }
  }
  else
    n=pCBackInfo->dwHandle-1;


  if(n < NUM_CALLBACKS)
  {
    // if CardType is 0 then callback wants messages for all types
    // otherwise CardType must be recognized by this VxD
    if(!pCBackInfo->dwCardType || IsTypeSupported((WORD)pCBackInfo->dwCardType))
    {
      int s;
      DWORD vm;

      Get_Cur_VM_Handle();
      _asm mov [vm],ebx

      memcpy(&gNotify[n].CBInfo,pCBackInfo,sizeof(VXD_CALLBACK_INFO_S));
      memset(&gNotify[n].Msg,0,sizeof(NOTIFY_MSG_S));
      gNotify[n].dwVM = vm;

      // Acknowledge Callback has been registered
      NotifyCallback(pCBackInfo->dwHandle,S_COMPLETE,0,pCBackInfo->dwCardType);
      // Check all sockets for Inserted cards
      // Simulate insertion messages for each inserted card
      for(s=0;s<NUM_SOCKETS;s++)
      {
         PDEVICE p=&gCardDevice[s];
         if(p->State==S_INSERTED)
            NotifyCallback(pCBackInfo->dwHandle,S_INSERTED,s,pCBackInfo->dwCardType);
      }
    }
    else
    {
      gNotify[n].CBInfo.dwProc=0;
      return SC_ERR_BADTYPE;
    }
  }
  else
      return SC_ERR_MAX;    // Max callbacks already installed

  return SC_ERR_NONE;
}

int V86Activate(int nSocket)
{
  PDEVICE p;
  
  nSocket&=0x0000ffff;
  nSocket--;
  if(nSocket<0 || nSocket>=NUM_SOCKETS)
    return 0;

  p= &gCardDevice[nSocket];

  return ZVActivate(p);
}

int V86GetDmaResource(VXD_DMA_INFO* pDmaInfo)
{
  PDEVICE p;
  int nErr=1;
  WORD wSocket;
  WORD w;

  if(pDmaInfo) {
    wSocket=pDmaInfo->wSocket-1;
    pDmaInfo->wBuffs    = 0;
    pDmaInfo->wBuffPages= 0;
    pDmaInfo->wCtrlIoBase=0;
    if(wSocket<NUM_SOCKETS) {
      p=&gCardDevice[wSocket];
      if(p && p->wDmaNumBuffs) {
        for(w=0;w<p->wDmaNumBuffs;w++)
          pDmaInfo->dwPhysMem[w]=p->dwDmaPhysAddr[w];
        pDmaInfo->wBuffs    = p->wDmaNumBuffs;
        pDmaInfo->wBuffPages= p->wDmaNumPages;
        pDmaInfo->wCtrlIoBase=p->wDmaCtrlIoBase;
      }
    }
  }
  return nErr;
}

/****************************************************************************
*
*  Procedure:
*      Device_Init
*
*  Description:
*      Handles "Init_Complete" control message.
*
*  Return:
*      R_SUCCESS or Card Services error code.  Ignored by caller for now.
*
\***************************************************************************/
int Device_Init(void) {
  int fOK= 0;
  GetVMMVersion();
  DbgMsg(DBG_PNPLOAD,"Device_Init()\r\n");
  SetRegistryFirstEntry(FIRSTENTRY_DEVINIT,KEYVAL_DEVINIT);
  ReportVersion(KEY_VXD);
  SettingSave(SET_STR,KEYVAL_CARDID,(DWORD)"Null");
  if(gPnPDeviceInit) {
    fOK= 1;
  } else {
    fOK= CardServiceConnect();
  }
  return(fOK);
}

void ReleaseAllCards(void) {
  int n1;
  PDEVICE pDev;
  for(n1=0;n1<NUM_SOCKETS;n1++) {
    pDev= &gCardDevice[n1];
    if(pDev->State==S_INSERTED) {
      pDev->State= S_EXTRACTED;
      ReleaseCard(pDev);
      pDev->CardType= 0;
    }
  }
}

int Device_Exit(void) {
  DbgMsg(DBG_PNPLOAD,"Device_Exit()\r\n");
  ResetRegistryFlags(1);
  ReleaseAllCards();
  CardServiceDisconnect();
  return(1);
  //UnloadMe();
}

/****************************************************************************
*
*  Procedure:
*      PnPDevice_Init
*
\***************************************************************************/
int PnPDevice_Init()
{
  GetVMMVersion();
  DbgMsg(DBG_PNPLOAD,"PnPDevice_Init()\r\n");
  SetRegistryFirstEntry(FIRSTENTRY_PNPINIT,KEYVAL_PNPINIT);
  ReportVersion(KEY_VXD);
  InitDeviceList();
  gPnPDeviceInit=1;
  gCSDevice = PCCARD_DEVICE_ID;  // use PCCARD i/f for card services
  return 1;
}

int PnPDevice_Exit(void) {
  // notify all callbacks that they going to be disconnected
  // NotifyCallback(0,S_VXD_UNLOAD,0,0);
  // Cancel all scheduled events since we won't be here
  DbgMsg(DBG_PNPLOAD,"PnPDevice_Exit\r\n");
  ResetRegistryFlags(1);
  //RAVI  DeleteNotify();
  ReleaseAllCards();
  gPnPDeviceInit=0;
  return(1);
}

DWORD DeviceIOcontrol(DIOCPARAMETERS *pIO) {
  DWORD Ret= 0;
  GetVMMVersion();
  DbgMsg(DBG_PNPIOCTRL,"DeviceIoControl %u.\r\n",pIO->dwIoControlCode);
  SetRegistryFirstEntry(FIRSTENTRY_IOCTRL,KEYVAL_IOCTRL);
  switch(pIO->dwIoControlCode) {
    case IOCTRL_VER:    GetVersionID((WORD *)(pIO->lpvOutBuffer)); break;
    case IOCTRL_RES:    V86GetResources((RESOURCES_STRUCT*)(pIO->lpvOutBuffer)); break;
    case IOCTRL_ACQ:    Ret= HardwareAcquire((DWORD*)pIO->lpvOutBuffer); break;
    case IOCTRL_REL:    Ret= HardwareRelease((DWORD*)pIO->lpvInBuffer); break;
    case IOCTRL_QUERY:  Ret= HardwareIsInserted((DWORD*)pIO->lpvOutBuffer); break;
  }
  return(Ret);
}


DWORD FindPCIController(int nUnit, WORD* pwBus, WORD* pwDevice)
{
  int n,nErr;
  WORD wBus,wDevice,wFunction,wIndex;
  DWORD dwPCIDevId=0;
  for(n=0;gPCITypeList[n];n++)
  {             
     for(wIndex=0;wIndex<8;wIndex++)
     {
       nErr=pciFindDevice(gPCIDeviceIdList[n],gPCIVendorIdList[n],wIndex,&wBus,&wDevice);
       wFunction=wDevice&0x07;
       wDevice&=0xf8;
       if(wFunction) nErr=1;
       if(!nErr)
       {
         if(nUnit==0) break;
         nUnit--;
       }       
       else
         break;
     }
     if(!nErr && (nUnit==0)) break;
  }
  if(gPCITypeList[n])
    dwPCIDevId=((DWORD)gPCIVendorIdList[n]<<16)+gPCIDeviceIdList[n];
  else
  {
    wDevice=0;
    wBus=0;
  }
  *pwBus=wBus;
  *pwDevice=wDevice;
  return dwPCIDevId;
}

int GetSocketNumber()
{
  return 0;
}

int IsToshiba()
{
  char id[]="TOSHIBA";
  char *p=(char*)_MapPhysToLinear(0x000fe010,0x10,0);

  return strncompare(p,id,sizeof(id)-1);
}

int IsCompaq()
{
  char id[]="COMPAQ";
  char *p=(char*)_MapPhysToLinear(0x000fffea,0x10,0);

  return strncompare(p,id,sizeof(id)-1);
}

#define MAXCOUNT	0x40
int IsPanasonic_CF63()
{
	WORD result, i;
	//Location "0xF1087"	DB 	"CF-63"
	//Location "0xF10AB"	DB	"CF-63"

  // Search for the id string in the BIOS region
  char id[]="CF-63";	// Actual string length is length -1 to account for end string char

  char *p=(char*)_MapPhysToLinear(0x000f107a,0x40,0);

  // perform a search for the ID String in the BIOS region
  for (i=0; i < MAXCOUNT; i++) {
	if ((result=strncompare(p++,id,sizeof(id)-1)) == TRUE)	// if string matches exit;
		break; 
	result = FALSE;
  }
  return result;
}

WORD hextoword(char* s)
{
  int n;
  WORD w=0;
  for (n=0;n<4;n++)
  {
    w*=16;
    w+=(s[n]>='a')?s[n]-'a'+10:(s[n]>='A')?s[n]-'A'+10:s[n]-'0';
  }
  return w;
}

DWORD GetPCIControllerId(DEVNODE dn)
{
  int fPCIBus;
  WORD wVendor;
  WORD wDevice;
  // Get Device ID and Check if 1131 or 1130
  char      szInfo[32];
  ULONG     ulSize=sizeof(szInfo);
  CM_Get_Device_ID(dn,szInfo,ulSize,0);
  fPCIBus=szInfo[0]=='P' && szInfo[1]=='C' && szInfo[2]=='I';
  wVendor=hextoword(&szInfo[8]);
  wDevice=hextoword(&szInfo[17]);

  return fPCIBus?((DWORD)wVendor<<16)+wDevice:0;
}

WORD GetSocketIOWindow(WORD wIoBase,int socket)
{
  BYTE b;
  WORD wIoWin=0;
  BYTE bReg=socket?0x40:0x00;
  outp(wIoBase,(BYTE)(bReg+6));
  b=inp((WORD)(wIoBase+1));
  if(b&0x40)                                  // if socket i/o window 0 enabled
  {
    outp(wIoBase,(BYTE)(bReg+8));
    wIoWin=(WORD)inp((WORD)(wIoBase+1));      // get lsb of socket i/o window
    outp(wIoBase,(BYTE)(bReg+9));
    wIoWin|=(WORD)inp((WORD)(wIoBase+1))*256; // get msb of socket i/o window
  }
  return wIoWin;
}

// If socket controller in R2 then return Chip Revision
WORD GetR2ControllerRev(DEVNODE dn)
{
  CMCONFIG cm;
  DEVNODE   dnParent;
  WORD wRev=0;
  int nSocket=-1;
  if(CM_Get_Parent(&dnParent,dn,0)==CR_SUCCESS)
  {
    // get io address for access socket controller in R2 mode
    if(CM_Get_Alloc_Log_Conf(&cm,dnParent,CM_GET_ALLOC_LOG_CONF_ALLOC)==CR_SUCCESS)
	  if(cm.wNumIOPorts)
	  {
      outp(cm.wIOPortBase[0],(BYTE)0);
      wRev=(WORD)inp((WORD)(cm.wIOPortBase[0]+1));
	  }
  }
  return wRev;
}

// Determine socket for card by matching Config manager I/O window
// against I/O window programmed into R2 registers
int DetermineR2Socket(DEVNODE dn)
{
  CMCONFIG cm;
  DEVNODE   dnParent;
  WORD wA,wB;
  int nSocket=-1;
  if(CM_Get_Parent(&dnParent,dn,0)==CR_SUCCESS)
  {
    // get io address for access socket controller in R2 mode
    if(CM_Get_Alloc_Log_Conf(&cm,dnParent,CM_GET_ALLOC_LOG_CONF_ALLOC)==CR_SUCCESS)
	  if(cm.wNumIOPorts)
	  {
        wA=GetSocketIOWindow(cm.wIOPortBase[0],0);  // i/o window for socket A (0=no window)
        wB=GetSocketIOWindow(cm.wIOPortBase[0],1);  // i/o window for sockey B
	  }
      // get i/o address for the PC Card from config manager
      if(CM_Get_Alloc_Log_Conf(&cm,dn,CM_GET_ALLOC_LOG_CONF_ALLOC)==CR_SUCCESS)
	    if(cm.wNumIOPorts)
        {
          if(cm.wIOPortBase[0]==wA)
            nSocket=0;
          else if(cm.wIOPortBase[0]==wB)
            nSocket=1;
        }
  }
  return nSocket;
}

int GetSocketControllerInfo(PDEVICE p)
{
  DEVNODE   dnParent;
  CMBUSTYPE BusType;
  BYTE      Info[32];
  ULONG     ulSize=sizeof(Info);
  BYTE*     pExCABase=0;
  DWORD     dwCtrlId=0;
  DEVNODE   dn=p->DevNode;
  WORD      wBus=0,wDevice=0;
  int       nSocket=-1;

  // Get DevNode of Socket Controller Socket
  if(dn)
  {
    if(CM_Get_Parent(&dnParent,dn,0)==CR_SUCCESS)
    {
      // Get PCI Bus and Device #
      CM_Get_Bus_Info(dnParent,&BusType,&ulSize,Info,0);
      switch(BusType)
      {
        case BusType_PCI:
          wBus=Info[0];
          wDevice=Info[1];
          dwCtrlId=GetPCIControllerId(dnParent);
		  if((wDevice&7)==0) { // if Dev is zero then possibly R2 i/o reg i/f
            nSocket=DetermineR2Socket(dn);  // if not R2 then will ret -1
		  }
		  if(nSocket<0)			// if not R2 socket then socket # given by wDevice
			nSocket=(int)(wDevice&0x0007);
          break;
        case BusType_BIOS:
        default:
          dwCtrlId=FindPCIController(0,&wBus,&wDevice);
          nSocket=DetermineR2Socket(dn);
          break;
      }
    }
  }
  else
  {
    dwCtrlId=FindPCIController(0,&wBus,&wDevice);
    nSocket=(WORD)p->l_socket;
  }

  p->SocketState.dwPCIAddr=wBus*256+wDevice;
  p->SocketState.dwDeviceId=dwCtrlId;
  p->SocketState.nSocket=nSocket;
  return (nSocket>=0);
}

void IdentifyHostMachine(PDEVICE p)
{
  char szPlatform[64];
  char Ultra2000_string[64];
  long lSize=sizeof(szPlatform);

  // Reset machine settings
  p->dwMachineType=MT_UNKNOWN;
  p->SocketState.dwPCIAddr=0;

  // Get PCI Id, Bus and Device for Socket Controller
  GetSocketControllerInfo(p);

  // Test for the exisitence of the Digital HighNote Ultra 2000
  SettingFName(KEY_ENUM,KEY_DIGITALULTRA);
  lSize= 0; //SettingLoad(SET_STR,KEY_DIGITALULTRA_BIOSVERSION,Ultra2000_string,0); 
  SettingFName(KEY_MARGI,KEY_VXD);
  if (lSize)
  {
//   char Ultra2000_string[] = {"SystemSoft Version 1.28 for Digital HiNote Ultra 2000"};
//   lSize = 53;
    if(strncompare(Ultra2000_string+(lSize-26),KEY_DIGITALULTRA_ID,min((int)lSize,25)))
      p->dwMachineType=MM_DIGITALULTRA;
  }

  lSize= 0; //SettingLoad(SET_STR,KEYVAL_PLATFORM,szPlatform,0);
  if(lSize)
  {
    if(strncompare(szPlatform,"SANYO",min((int)lSize,5)))
      p->dwMachineType=MM_SANYO;
    if(strncompare(szPlatform,"DIGITAL",min((int)lSize,7)))
      p->dwMachineType=MM_DIGITAL;
  }
  
  // Get ZV enabled socket bit mask
  p->dwZVEnableMask= 0x03; //SettingLoad(SET_DWORD,KEYVAL_ZVENABLED,0,0x03);
  // Get Power management mode
  p->dwPowerManMode= 0x00; //SettingLoad(SET_DWORD,KEYVAL_POWERMAN,0,0x00);

  if(p->dwMachineType==MT_UNKNOWN) {
    // Check for COMPAQ
    if(IsCompaq())
    {
      p->dwMachineType=MM_COMPAQ;
      if(p->SocketState.dwDeviceId==DEVICE_TI1130 || p->SocketState.dwDeviceId==DEVICE_TI1131)
        p->dwMachineType=MT_COMPAQ_ALTAIR;
    }
    else if(IsToshiba())
    {
      p->dwMachineType=MM_TOSHIBA;
      if(!p->SocketState.dwDeviceId)
          p->SocketState.dwDeviceId=DEVICE_TOPIC;
    }
	else if(IsPanasonic_CF63())
    {
      p->dwMachineType=MM_PANASONIC_CF63;
      if(!p->SocketState.dwDeviceId)
          p->SocketState.dwDeviceId=DEVICE_RL5C476;

	  //add other qualifiers if necessary; Panasonic CF-63 has RICOH 476
    }
  }

  {
    char sz[9];
    SettingFName(IniFName,KEY_SYSINFO);
    sz[0]=0;
    AppendHexStr(sz,p->dwMachineType);
    SettingSave(SET_STR,KEYVAL_PLATFORM,(DWORD)sz);
    sz[0]=0;
    AppendHexStr(sz,p->SocketState.dwPCIAddr);    
    SettingSave(SET_STR,KEYVAL_PCIADDR,(DWORD)sz);
    sz[0]=0;
    AppendHexStr(sz,p->SocketState.dwDeviceId);
    SettingSave(SET_STR,KEYVAL_DEVICE,(DWORD)sz);
    sz[0]=0;
    AppendHexStr(sz,p->SocketState.nSocket);
    SettingSave(SET_STR,KEYVAL_SOCKET,(DWORD)sz);
    SettingFName(0,KEY_VXD);
  }
  SettingFName(IniFName,IniSection);
}

/*************************************************************************/
/** HardwareAcquire()                                                   **/
/**     If already acquired, return error.                              **/
/**     If no CardServices connection yet, try to establish.            **/
/**     Detect presence of card.                                        **/
/**     If no card, return error.                                       **/
/**     return OK.                                                      **/
/*************************************************************************/
static BYTE gfHardwareInUse= 0;

DWORD HardwareAcquire(DWORD *pHndl) {
  DWORD Err= 0;
  int n1;
  *pHndl= 0;
  if(gfHardwareInUse) {
    DbgMsg(DBG_PNPACCESS,"HardwareAcquire()= INUSE\r\n");
    Err= (DWORD)MARGI_ERR_BUSY;
  } else {
    if(!CardServiceConnect()) {
      DbgMsg(DBG_PNPACCESS,"HardwareAcquire()= NOCARDSERVICES\r\n");
      Err= (DWORD)MARGI_ERR_NOTAVAILABLE;
    } else {
      gfHardwareInUse= 1;
      Sleep(5000);              //Give INSERTED message a chance to arrive.
      Err= (DWORD)MARGI_ERR_NODEVICE;
      for(n1=0;n1<NUM_SOCKETS;n1++) {
        if(gCardDevice[n1].State==S_INSERTED) {
          DbgMsg(DBG_PNPACCESS,"HardwareAcquire()= OK\r\n");
          Err= 0;
          *pHndl= 1;
          break;
        }
      }
      if(Err)
        DbgMsg(DBG_PNPACCESS,"HardwareAcquire()= NOHARDWARE\r\n");
    }
  }
  return(Err);
}

DWORD HardwareRelease(DWORD *pHndl) {
  DWORD Err= 0;
  if(gfHardwareInUse) {
    DbgMsg(DBG_PNPACCESS,"HardwareRelease\r\n");
    ReleaseAllCards();
    Err= CardServiceDisconnect();
    gfHardwareInUse= 0;
  }
  return(Err);
}

DWORD HardwareIsInserted(DWORD *pInserted) {
  DWORD Err=0,Hndl,fRelease=0;
  int n1;
  DbgMsg(DBG_PNPACCESS,"HardwareIsInserted()\r\n");
  *pInserted= 0;
  if(!gfHardwareInUse) {
    fRelease= 1;
    if(Err= HardwareAcquire(&Hndl))
      DbgMsg(DBG_PNPACCESS,"HardwareAcquire() failed.\r\n");
  }
  if(!Err) {
    for(n1=0;n1<NUM_SOCKETS;n1++) {
      if(gCardDevice[n1].State==S_INSERTED) {
        *pInserted= 1;
        break;
      }
    }
    if(fRelease)
      HardwareRelease(&Hndl);
  }
  DbgMsg(DBG_PNPACCESS,"HardwareIsInserted()= %u.\r\n",*pInserted);
  return(Err);
}

/**EOF: CSCLIENT.C**/
