/*************************************************************************/
/** Prototype for ring0 DbgMsg.h section.                               **/
/** --  Eventually this code will be embedded in the DbgMsg.h, but for  **/
/**     now it is easier to debug this way.                             **/
/*************************************************************************/

#if _WIN32_WINNT==0x0400
//#if (defined(_WIN32_WINNT))
#include <ntddk.h>
#ifndef DWORD
#define DWORD unsigned long
#define WORD unsigned short
#define MAKEWORD(a, b)      ((WORD)(((BYTE)(a)) | ((WORD)((BYTE)(b))) << 8))
#define MAKELONG(a, b)      ((LONG)(((WORD)(a)) | ((DWORD)((WORD)(b))) << 16))
#define LOWORD(l)           ((WORD)(l))
#define HIWORD(l)           ((WORD)(((DWORD)(l) >> 16) & 0xFFFF))
#define LOBYTE(w)           ((BYTE)(w))
#define HIBYTE(w)           ((BYTE)(((WORD)(w) >> 8) & 0xFF))
#endif //DWORD
#define PRINT(Str) DbgPrint("%s",Str)
#elif (__WDM__)
#include <WDM.h>
#include <WinDef.h>
#include <VMM.h>
#include <VMMReg.h>
//#include "setting.h"
#define PRINT(Str) DbgPrint("%s",Str)
#else
#define PRINT(Str) Out_Debug_String(Str)
#include <BaseDef.h>
#include <VMM.h>
#include <VMMReg.h>
#include <memory.h>
#endif

#include "DbgMsg.h"

//11May98 Chip Doran

#ifndef DUMPFORMATS
#define DUMPFORMATS 0	//Set to 1 to output format strings to debugger if DbgMsg51 server not available.
#endif
#if(!DBGMSG)


#else

static long DbgMsgInit(DWORD Cmd, DWORD dwApi, char *Name);
static DWORD DbgMsgFini(void);
static DWORD DbgMsgSetFilter(DWORD NewFilter);
static void __cdecl DbgMsgDfltCallback(DWORD hDbgClnt, DWORD Msg, DWORD Arg1, DWORD Arg2);
static void DbgMsgCbFini(DWORD hDbgClnt, DWORD Msg, DWORD Arg1, DWORD Arg2);
static long DbgMsgSetCallback(DBGMSGCB pUserCb);

static DWORD hDbgClnt;		//This is the handle for the link between VxD's
static DWORD hDbgMsg;		//This is the handle for DbgMsg commands.
static DWORD DbgMsgFilter;
static DWORD DbgMsgServerEntry;
static DBGMSGCB DbgMsgUserCb;   //User callback function.
static DWORD DbgMsgSanityChk= DBGMSG_SANITY_VALUE;
int    gnEntryCount=0;
DWORD  gdwDbgMsgCmd=0;

/***********************************************************************/
/** Using VXDLDR (VxD services) to link between Vxds causes the       **/
/** system to deny unloads.                                           **/
/** Server will publish HKEY_DYN_DATA key containing the address      **/
/** of the Ring0 entry function.                                      **/
/** If the server unloads before the client, it will send a callback  **/
/** message (DBGCB_BYEBYE) to all clients. The HKEY_DYN_DATA key      **/
/** will have been destroyed by then.                                 **/
/***********************************************************************/
#if (defined(_WIN32_WINNT) || defined(__WDM__))
static long DbgCmdGetEntry(DWORD fInit) {

  long Err;
  RTL_QUERY_REGISTRY_TABLE QueryTbl[2];
  NTSTATUS Status;

#if(__USER__ == 513)  // if compiled on john's machine use DbgMsg51 key for entry
  WCHAR wCharPath[256]= L"\\Registry\\Machine\\Software\\Margi_Systems\\ChipUtil\\DbgMsg51"; 
#else
  WCHAR wCharPath[256]= L"\\Registry\\HKEY_DYN_DATA\\DbgMsg51\\SerVer"; 
#endif
  WCHAR *pName = L"Ring0Entry";

  RtlZeroMemory(QueryTbl,sizeof(RTL_QUERY_REGISTRY_TABLE)*2);
  QueryTbl[0].Flags= RTL_QUERY_REGISTRY_DIRECT;
  QueryTbl[0].Name= pName;
  QueryTbl[0].EntryContext= &DbgMsgServerEntry;
  QueryTbl[0].DefaultType= REG_DWORD;
  QueryTbl[0].DefaultData= 0;
  QueryTbl[0].DefaultLength= sizeof(DWORD);

  Status = RtlQueryRegistryValues(RTL_REGISTRY_ABSOLUTE,wCharPath,QueryTbl,0,0);
  // RtlQueryRegistryValues returns bogus value if key doesn't exist
  if((DbgMsgServerEntry&0xc0000000)==0)
    Status=1;

  if(Status==STATUS_SUCCESS) 
	  Err= 0;
  else
    Err= DBGERR_NOTAVAILABLE;

  return(Err);
}
#else
static long DbgCmdGetEntry(DWORD fInit) {
  long Err;
  VMMHKEY hKey;
  DWORD Type,nBytes;
  static long GetEntryFailed;
  DbgMsgServerEntry= 0;
  if(fInit)
    GetEntryFailed= 0;
  if(GetEntryFailed) {
    Err= GetEntryFailed;
  } else {
    Err= VMM_RegOpenKey(HKEY_DYN_DATA,DBGMSG51_DYNKEY,&hKey);
    if(Err==ERROR_LOCK_FAILED) {    //This may happen if kernel is in a critical section.
      PRINT("DbgMsg51: RegOpenKey() LOCK_FAILED.\r\n");
      Err= DBGERR_BUSY;
    } else if(Err==ERROR_FILE_NOT_FOUND) {  //Server must have gone away
      PRINT("DbgMsg51: RegOpenKey() NOT_FOUND.\r\n");
      Err= GetEntryFailed= DBGERR_NOTAVAILABLE;
    } else if(Err) {
      PRINT("DbgMsg51: RegOpenKey() failed.\r\n");
      Err= GetEntryFailed= DBGERR_NOTAVAILABLE;
    } else {
      nBytes= 4;
      Err= VMM_RegQueryValueEx(hKey,DBGMSG51_DYNKEY_SERVER,0,&Type,(void*)&DbgMsgServerEntry,&nBytes);
      if(Err==ERROR_FILE_NOT_FOUND) {
	PRINT("DbgMsg51: RegQueryValue() NOT_FOUND.\r\n");
	GetEntryFailed= DBGERR_NOTAVAILABLE;
      } else if(Err) {
	PRINT("DbgMsg51: RegQueryValue() failed.\r\n");
	GetEntryFailed= DBGERR_NOTAVAILABLE;
      } else {
	GetEntryFailed= 0;
	Err= 0;
      }
    }
  }
  return(Err);
}
#endif

//Need to get naked in order not to screw up stack args.
//If naked, using return() generates a warning.
//But dropping the return() generates another warning.
//But dropping the long attribute loses my return value.
#pragma warning(disable:4035)
static long __declspec(naked) __cdecl DbgCmdCall(DWORD Hndl, DWORD CmdID, DWORD Arg1, DWORD Arg2) 
{
#ifndef _WIN32_WINNT
  _asm {
;;                jmp     GetEntry                          ;Always get entry from registry in case server unloaded.
;;                cmp     DWORD PTR[DbgMsgServerEntry],0
;;                jnz     ChkJmp
;;GetEntry:       call    DbgCmdGetEntry
;;ChkJmp:	nop
	        cmp     DWORD PTR[DbgMsgServerEntry],0
                jz      Error
                jmp     DWORD PTR[DbgMsgServerEntry]
Error:          mov     eax,DBGERR_LOAD
                ret
;;                jmp     GetEntry                            ;prevent 'unreferenced label' warning when jmp GetEntry is commented out.
  }
#else
  _asm {
                ret
  }
  
#endif
}
#pragma warning(default:4035)

long __cdecl DbgMsgCmd(DWORD Cmd, DWORD Arg1, DWORD Arg2) {
  long Err= DBGERR_BADHNDL;
  gnEntryCount++;
  gdwDbgMsgCmd=Cmd;
  switch(LOWORD(Cmd)) {
    case DBGCMD_INIT:       Err= DbgMsgInit(Cmd,Arg1,(char*)Arg2); break;
    case DBGCMD_FINI:       Err= DbgMsgFini(); break;
    case DBGCMD_FILTER:     Err= DbgMsgSetFilter(Arg1); break;
    case DBGCMD_CALLBACK:   Err= DbgMsgSetCallback((DBGMSGCB)Arg1); break;
    default:                if(hDbgClnt) Err= DbgCmdCall(hDbgClnt,Cmd,Arg1,Arg2);
  }
  gnEntryCount--;
  gdwDbgMsgCmd=0;
  return(Err);
}

int DbgMsg(DWORD MsgClass, char *Format, ...) {
  int fOutput= 0;
  int nChr= 0;
  gnEntryCount++;
  gdwDbgMsgCmd=0xffffffff;
  if(MsgClass & (DBG_CRIT|DBG_INDEXED)) {
    fOutput= 1;
  } else {
    if(MsgClass & (DbgMsgFilter & ~DBG_FILTERS)) {
      DWORD AndFilters= MsgClass & DBG_FILTERS;
      if(!AndFilters || (AndFilters&(DbgMsgFilter & DBG_FILTERS)))
        fOutput= 1;
    }
  }
  if(fOutput) {
    if(hDbgClnt)
      nChr= DbgCmdCall(hDbgClnt,DBGCMD_PRINT,MsgClass,(DWORD)&Format);
    else if(DUMPFORMATS)
      PRINT(Format);
  }
  gnEntryCount--;
  gdwDbgMsgCmd=0;
  return(nChr);
}

static DWORD DbgMsgSetFilter(DWORD NewFilter) {
  DWORD OldFilter= DbgMsgFilter;
  DbgMsgFilter= NewFilter;
  if(hDbgClnt)
    DbgCmdCall(hDbgClnt,DBGCMD_FILTER,NewFilter,(DWORD)&DbgMsgFilter);
  return(OldFilter);
}

//Ring0 clients do not need to acknowledge callback.
static void __cdecl DbgMsgDfltCallback(DWORD hDbgClnt, DWORD Msg, DWORD Arg1, DWORD Arg2) {
  switch(Msg) {
    case DBGCB_FINI:        DbgMsgCbFini(hDbgClnt,Msg,Arg1,Arg2); break;
    case DBGCB_SETFILTER:   DbgMsgFilter= Arg1; break;
  }
  if(DbgMsgUserCb)
    (*DbgMsgUserCb)(hDbgClnt,Msg,Arg1,Arg2);
}

static void DbgMsgCbFini(DWORD hDbgClnt, DWORD Msg, DWORD Arg1, DWORD Arg2) {
  DbgMsgServerEntry= 0;
}

static long DbgMsgSetCallback(DBGMSGCB pUserCb) {
  DbgMsgUserCb= pUserCb;
  return(0);
}

static long DbgMsgInit(DWORD Cmd, DWORD dwApi, char *Name) {
  long Err= 0;
  if(HIWORD(dwApi)!=HIWORD(DBGMSG_VERSION) || LOWORD(dwApi)>LOWORD(DBGMSG_VERSION)) {
    Err= DBGERR_BADVER;
  } else {
    if(Err= DbgCmdGetEntry(1)) {
      PRINT("DbgMsg51: Unable to link to server.\r\n");
    } else if(Err= DbgCmdCall((DWORD)&hDbgClnt,DBGCMD_INIT|DBGCMD_INIT_RING0|Cmd,DBGMSG_VERSION,(DWORD)Name)) {
      PRINT("DbgMsg51: Unable to create ring0 client.\r\n");
    } else {
      DbgCmdCall(hDbgClnt,DBGCMD_SANITY_CHECK,(DWORD)&DbgMsgSanityChk,0);
      DbgCmdCall(hDbgClnt,DBGCMD_CALLBACK,0,(DWORD)DbgMsgDfltCallback);
    }
  }
  return(Err);
}

static DWORD DbgMsgFini(void) {
  long Err= 0;
  if(hDbgClnt) {
    Err= DbgCmdCall(hDbgClnt,DBGCMD_FINI,0,0);
    hDbgClnt= 0;
  }
  return(Err);
}

#endif
/**EOF: DBGMSG.C**/
