#define ININAMES_CODE 1

#include <StrmIni.h>
#include <mmsystem.h>
#include <KsMedia.h>
#include <wdm.h>

//#ifdef _WIN98_ONLY_
//#include <VMM.h>	  //For DrvDbgMsgQuery()
//#include <VMMReg.h>	  //For DrvDbgMsgQuery()
//#endif // _WIN98_ONLY_

#include "DbgMsg.h"
#include "DbgFltr.h"
#include "Idents.h"
#include "Settings.h"

#include "Globals.h"
#include "MidasApi.h"
#include "log.h"
#include "IniNames.h"
#include "../common/WinVer.h"

extern char *VerDateTime;
extern char *VerFile;

static BYTE STREAMAPI DrvIntr(void *pvDevExt);
static void STREAMAPI DrvPktRcv(PHW_STREAM_REQUEST_BLOCK pSrb);
static void STREAMAPI DrvPktCancel(PHW_STREAM_REQUEST_BLOCK pSrb);
static void STREAMAPI DrvPktTimeout(PHW_STREAM_REQUEST_BLOCK pSrb);

static void DrvPktRcvUnhandled(SRB* pSrb);
static void DrvPktRcvUnk(SRB* pSrb);
static void DrvPktRcvHandleIRP(SRB* pSrb);


extern struct IdentEntry_s IdentsKsGuid[];    //From IdentKS.c
extern struct IdentEntry_s IdentsHal[];
extern struct IdentEntry_s IdentsNtStatus[];
extern struct IdentEntry_s IdentsPciDevices[];
extern struct IdentEntry_s IdentsHw[];
extern struct IdentEntry_s IdentsVid[];
extern struct IdentEntry_s IdentsSub[];
extern struct IdentEntry_s IdentsAud[];
extern struct IdentEntry_s IdentsKsGuid[];
extern struct IdentEntry_s IdentifierErrors[];

extern void StealAllIrps(DRIVER_OBJECT *pDrvObj);

ULONG WinVersion=0;
static void  GetVersion();

static struct DbgMsgFilterName_s DbgFilterNames[]= {
    { DBG_SET, "Settings" },
    { DBG_STRMIRP, "StreamClassIRPs"},
    { DBG_LOG, "Logging" },
    { DBG_TODO, "ToDo" },
  { DBG_PNPTITLE, "Plug-and-Play" },
    { DBG_PNPCFG,"Config" },
    { DBG_PNPLOAD, "Load" },
    { DBG_PNPACCESS, "Access" },
    { DBG_PNPIOCTRL, "IoCtrl" },
    { DBG_PNPUNK, "Unhandled" },
    { DBG_PNPERR, "Error" },
    { DBG_PNPMSG, "Message" },
    { DBG_PNPPOWER, "Power States" },
  { DBG_CSTITLE, "CardServices" },
    { DBG_CSEVNT, "Events" },
    { DBG_CSREQ, "Requests" },
    { DBG_CSCLNT, "Client requests" },
  { DBG_HWTITLE, "Midas" },
    { DBG_HWINIT, "Init" },
    { DBG_HWIO, "I/O" },
    { DBG_HWAPI, "API" },
    { DBG_HWSTATE, "State" },
    { DBG_HWSEND, "SendData" },
    { DBG_HWFLUSH, "Flush" },
    { DBG_HWCMD, "Commands" },
    { DBG_HWISR, "Interrupt" },
    { DBG_HWERR, "H/W Error" },
    { DBG_HWSTAT, "Status" },
    { DBG_HWINITSRB, "InitSrb" },
    { DBG_HWBUFCFG, "Buffer config" },
    { DBG_HWREG, "Register dumps" },
    { DBG_HWREGWR, "Register writes" },
  { DBG_SYNCTITLE, "A/V Sync" },
    { DBG_SYNCERR, "Errors" },
    { DBG_SYNCADJ, "Adjustments" },
    { DBG_SYNCHW, "Hardware control" },
    { DBG_SYNCDRIFTA, "Audio drift" },
    { DBG_SYNCDRIFTV, "Video drift" },
    { DBG_SYNCWATCH, "Drift watches" },
    { DBG_SYNCSTART, "AutoStart" },
    { DBG_SYNCUNC, "Uncertainty ptrs" },
    { DBG_SYNCVIDPTS, "Vid PTS" },
    { DBG_SYNCAUDPTS, "Aud PTS" },
//    { DBG_SYNCCFG, "Config" },
    { DBG_SYNCDROP, "Drops" },
    { DBG_SYNCINIT, "Init" },
    { DBG_SYNCCHK, "SyncChecks" },
    { DBG_SYNCMSG, "Messages" },
    { DBG_SYNCTBL, "Table entries" },
    { DBG_SYNCEVENT, "Events" },
  { DBG_MSGTITLE, "Messages" },
    { DBG_MSGVID, "Video" },
    { DBG_MSGVIDFORMAT, "Video Format" },
    { DBG_MSGAUD, "Audio" },
    { DBG_MSGSUB, "SubPicture" },
    { DBG_MSGVPE, "VPE" },
    { DBG_MSGCC, "CloseCaption" },
    { DBG_MSGNTSC, "NTSC" },
    { DBG_MSGEVENT, "Events" },
    { DBG_MSGPKT, "Packets" },
    { DBG_MSGERR, "Error" },
    { DBG_MSGTIMER,"Timer" },
    { DBG_FIRST4BYTES,"First 4 bytes"},
  { DBG_AUXTITLE, "AuxData" },
    { DBG_AUXCMD,	"Commands" },
    { DBG_AUXERR, "Errors" },
    { DBG_AUXREAD, "Reads" },
    { DBG_AUXMISS, "Missed frames" },
    { DBG_AUXLAYER, "Layer Completion" },
    { DBG_AUXPIC, "Picture Types" },
  { DBG_TVTITLE, "TV Out Settings" },
    { DBG_TVREG, "Encoder Register R/W" },
    { DBG_TVOUTMODE, "TV Out Mode" },
    { DBG_TVSET, "TV Out Settings" },
    { DBG_TVAPI, "TVOut API" },
    { DBG_TVINFO, "TVOut Info" },
    { DBG_MACROVISION, "MacroVision Cmds"},
  { DBG_CPTITLE, "Control Panel" },
    { DBG_CP_TIMER, "Timer Checks" },
    { DBG_CP_INFO, "General Info" },
    { DBG_CP_SET, "Set" },
  { DBG_AUDTITLE, "Audio" },
    { DBG_AUDERR, "Errors" },
    { DBG_AUDCMD, "Commands" },
    { DBG_AUDHW, "Hardware control" },
    { DBG_AUDSTATE, "State transitions" },
  { DBG_VIDTITLE, "Video" },
    { DBG_VIDCMD, "Commands" },
    { DBG_VIDPANIC, "Panic control" },
    { DBG_VIDSTATE, "State transitions" },
  { DBG_DDRAWTITLE,  "Direct Draw" },
    { DBG_DDINFO, "DD Info" },
    { DBG_DDEVE, "DD Events" },
    { DBG_DDERR, "DD Errors" },
  { DBG_SUBTITLE, "Subpicture" },
    { DBG_SUBMSG, "Messages" },
    { DBG_SUBPOS, "Position" },
    { DBG_SUBHI,  "HiLite enable" },
    { DBG_SUBSTATE, "State Transitions" },
  { DBG_CSSTITLE, "CSS"},
    {DBG_CSSKEYS,	"Report CSS Keys"},
    {DBG_CSSTITLEKEY, "Report Title Keys"},

  { 0,0 }
};

static struct DbgMsgFilterName_s DbgChannelNames[]= {
  { DBGPRF_TIMER, "Timer" },
  { DBGPRF_WRITEVID, "WriteVid" },
  { DBGPRF_SYNCPROC, "SyncProc" }
};
static struct DbgMsgOpt_s {
  union {
    struct {
      DWORD Running:1;		//DbgMsg linked & running
      DWORD Disable:1;		//Do not try to link
    };
    DWORD Flags;
  };
} DbgMsgOpt;

#define Filter Mask

long DrvDbgMsgInit(DWORD fInit) {
  long Err= 0;
  DWORD DbgFilter;
  struct DbgMsgFilterName_s *pFilter;
  if(fInit) {
    if(!DbgMsgOpt.Disable && !DbgMsgOpt.Running) {
      SettingFName(0,IniSectionDbgMsg);
      if(!(DbgMsgOpt.Disable= !SettingLoad(SET_DWORD,IniDbgMsg,0,1))) {
	      if(!DbgMsgCmd(DBGCMD_INIT,DBGMSG_VERSION,(DWORD)"ScenarioWDM")) {
	        DbgMsgOpt.Running= 1;
      //	  DbgMsgCmd(DBGCMD_PROF_INIT,0,0);
	        DbgMsgCmd(DBGCMD_FILTERNAMES,(DWORD)DbgFilterNames,0);
      //	  DbgMsgCmd(DBGCMD_PROF_NAMES,(DWORD)DbgChannelNames,sizeof(DbgChannelNames)/sizeof(DbgChannelNames[0]));
	        DbgMsgCmd(DBGCMD_FILTER,SettingLoad(SET_DWORD,IniDbgFilter,0,0),0);
	        for(pFilter=DbgFilterNames;pFilter->DMFilter;pFilter++) {
	          if((pFilter->DMFilter & DBG_INDEXED) && !DBGMSG51_FILTERMASK(pFilter->DMFilter)) {
	            DbgFilter= DBGMSG51_INDEXFILTER(DBGMSG51_FILTERINDEX(pFilter->DMFilter),SettingLoad(SET_DWORD,pFilter->Name,0,0));
	            DbgMsgCmd(DBGCMD_FILTER,DbgFilter,0);
	          }
	        }
	      }
      }
      SettingFName(0,IniSection);
    }
  } else {
    if(DbgMsgOpt.Running) {
#if(1)
      SettingFName(0,IniSectionDbgMsg);
      if(!DbgMsgCmd(DBGCMD_GETFILTER,(DWORD)&DbgFilter,0))
	      SettingSave(SET_DWORD,IniDbgFilter,DbgFilter);
      for(pFilter=DbgFilterNames;pFilter->DMFilter ;pFilter++) {
	      if((pFilter->DMFilter & DBG_INDEXED) && !DBGMSG51_FILTERMASK(pFilter->DMFilter)) {
	        if(!DbgMsgCmd(DBGCMD_GETFILTER,(DWORD)&DbgFilter,pFilter->DMFilter)) {
	          SettingSave(SET_DWORD,pFilter->Name,DBGMSG51_FILTERMASK(DbgFilter));
	        }
	      }
      }
#endif
//      DbgMsgCmd(DBGCMD_PROF_FINI,0,0);
      DbgMsgCmd(DBGCMD_FINI,0,0);
      DbgMsgOpt.Running= 0;
      SettingFName(0,IniSection);
    }
  }
  return(Err);
}

// {A16E1141-D847-11d3-9A68-00104B3342B6}
static const GUID GUID_MARGI_DVD = 
{ 0xa16e1141, 0xd847, 0x11d3, { 0x9a, 0x68, 0x0, 0x10, 0x4b, 0x33, 0x42, 0xb6 } };


PDRIVER_ADD_DEVICE StreamClassAddDevice;

NTSTATUS MargiAddDevice(IN PDRIVER_OBJECT pDrvObj,IN PDEVICE_OBJECT pPhysDevObj) {
  NTSTATUS Status;
  PDEVICE_EXTENSION pdx=pPhysDevObj->DeviceExtension;
  Status=(*StreamClassAddDevice)(pDrvObj,pPhysDevObj);
  if(NT_SUCCESS(Status)) {
    Status=IoRegisterDeviceInterface(pPhysDevObj,&GUID_MARGI_DVD,NULL,&pdx->SymbolicLinkName);
    if(NT_SUCCESS(Status)) {
      IoSetDeviceInterfaceState(&pdx->SymbolicLinkName, TRUE);
    }                       
  }
  return Status;
}

DWORD DriverEntry(DRIVER_OBJECT *pDriverObj, UNICODE_STRING *pRegEntry) {
  HW_INITIALIZATION_DATA HwInitData;
  DWORD Status;
  MIDASCMD Cmd;
  GetVersion();
  if (WinVersion==WIN98_VERSION)
  {
    IdentAddClass(IdentsKsGuid);
    IdentAddClass(IdentsHal);
    IdentAddClass(IdentsNtStatus);
    IdentAddClass(IdentsPciDevices);
    IdentAddClass(IdentsHw);
    IdentAddClass(IdentsVid);
    IdentAddClass(IdentsAud);
    IdentAddClass(IdentsSub);
    IdentAddClass(IdentsKsGuid);
    IdentAddClass(IdentifierErrors);
  }
  SettingFName(IniFName,IniSection);
  DrvDbgMsgInit(1);
  DbgMsg(DBG_CRIT,"***************************************\r\n");
  DbgMsg(DBG_CRIT,"Midas WDM: DriverEntry [%08X] %s %s\r\n",DriverEntry,VerFile,VerDateTime);
  
  Cmd.cmd= MDS_INITDRIVER;
  MidasEntry(&Cmd);
  
  RtlZeroMemory(&HwInitData, sizeof(HW_INITIALIZATION_DATA));
  HwInitData.HwInitializationDataSize = sizeof(HwInitData);
  HwInitData.HwInterrupt = 0; //DrvIntr;
  HwInitData.HwReceivePacket = DrvPktRcv;
  HwInitData.HwCancelPacket = DrvPktCancel;
  HwInitData.HwRequestTimeoutHandler = DrvPktTimeout;
  HwInitData.TurnOffSynchronization=KS_SYNC_OFF;
  HwInitData.BusMasterDMA=0;        // Adapter uses bus master DMA
  HwInitData.Dma24BitAddresses=1;   // TRUE indicates 24 bit DMA only(ISA)
  HwInitData.BufferAlignment=4;     // buffer alignment mask
  HwInitData.DmaBufferSize=DMA_BUFFER_SIZE*2;// Sizeof DMA buffer to use (times 2 incase buffer stradles 128K boundary just use 2 second 1/2)

//  Cmd.cmd= MDS_GETDATASIZE;
//  HwInitData.DeviceExtensionSize = sizeof(DEVICE_EXTENSION) + MidasEntry(&Cmd);
  HwInitData.DeviceExtensionSize = sizeof(DEVICE_EXTENSION);
  HwInitData.PerRequestExtensionSize = sizeof(SRB_EXTENSION);
  HwInitData.PerStreamExtensionSize = sizeof(STREAM_EXTENSION);

  Status= StreamClassRegisterAdapter(pDriverObj,pRegEntry,&HwInitData);

  StreamClassAddDevice=pDriverObj->DriverExtension->AddDevice;
#if(0)
  pDriverObj->DriverExtension->AddDevice=MargiAddDevice;
#endif

#if(0)
  Status=IoCreateDevice(pDriverObj,
                    128,    //DeviceExtensionSize
                    NULL,   //DeviceName OPTIONAL,
                    FILE_DEVICE_UNKNOWN,  // DeviceType,
                    0,      //DeviceCharacteristics,
                    0,      //Exclusive,
                    &pDmaDev);
#endif
#if (1)
#pragma message("Stealing all IRP's")
  if(Status==STATUS_SUCCESS)
    StealAllIrps(pDriverObj);
#endif
  return(Status);
}

static void STREAMAPI DrvPktRcv(PHW_STREAM_REQUEST_BLOCK pSrb) {
  static BYTE DbgMsgInitDone;
  logSrb("DrvPktRcv",pSrb);
  switch (pSrb->Command) {
    case SRB_OPEN_STREAM:             StreamOpen(pSrb); break;
    case SRB_CLOSE_STREAM:            StreamClose(pSrb); break;
    case SRB_GET_STREAM_INFO:         StreamInfo(pSrb); break;
    case SRB_INITIALIZE_DEVICE:       DeviceInitialize(pSrb); break;
    case SRB_PAGING_OUT_DRIVER:       DevicePagingOut(pSrb); break;
    case SRB_UNINITIALIZE_DEVICE:     DeviceClose(pSrb); break;
    case SRB_GET_DATA_INTERSECTION:   StreamGetIntersection(pSrb); break;
    case SRB_INITIALIZATION_COMPLETE: DeviceInitComplete(pSrb); break;
    case SRB_CHANGE_POWER_STATE:      DeviceChangePowerState(pSrb); break;
    case SRB_SURPRISE_REMOVAL:        DeviceSurpriseRemoval(pSrb); break;
    case SRB_OPEN_DEVICE_INSTANCE:      // Here are all of the other Device SRBs
    case SRB_CLOSE_DEVICE_INSTANCE:     // Just in case
    case SRB_GET_DEVICE_PROPERTY:
    case SRB_SET_DEVICE_PROPERTY:
    case SRB_UNKNOWN_DEVICE_COMMAND:  DrvPktRcvUnhandled(pSrb); break;
    default:                          DrvPktRcvUnk(pSrb); break;
  }
  unlogSrb("DrvPktRcv", pSrb);
  if(pSrb->Status!=STATUS_PENDING) {
    SignalDeviceRequestComplete(pSrb);
  } else {
    //DbgMsg(DBG_CRIT|DBG_INFO,"Returning Status Pending %s\r\n",Ident(ID_STRM_REQ,pSrb->Command));
  }
}

static void DrvPktRcvHandleIRP(SRB* pSrb) {
   PDEVICE_EXTENSION pDev=(PDEVICE_EXTENSION)pSrb->HwDeviceExtension;
   PIRP pIrp = pSrb->Irp;
   PIO_STACK_LOCATION IrpStack=IoGetCurrentIrpStackLocation(pIrp);
   
   switch ( IrpStack->MajorFunction ) {
    case IRP_MJ_PNP:
      DeviceHandlePNPIrp(pDev->PhysicalDeviceObject,pIrp); break;
    default:
      pSrb->Status = STATUS_NOT_SUPPORTED;
   }
}

static void DrvPktRcvUnhandled(SRB* pSrb) {
  DbgMsg(DBG_ERR,"Unhandled SRB message: %s.\r\n",Ident(ID_STRM_REQ,pSrb->Command));

  pSrb->Status = STATUS_NOT_IMPLEMENTED;
}

static void DrvPktRcvUnk(SRB* pSrb) {
  DbgMsg(DBG_TODO|DBG_ERR,"Unknown DeviceSRB msg: %s.\r\n",Ident(ID_STRM_REQ,pSrb->Command));
  pSrb->Status = STATUS_NOT_IMPLEMENTED;
}

//Return 0 if interrupt is not handled. (Not generated by my device.)
static BYTE STREAMAPI DrvIntr(void *pvDevExt) {
  PDEVICE_EXTENSION pDevice= pvDevExt;
  long retvalue;
  MIDASCMD Cmd;
  DbgMsg(DBG_INFO,"DrvIntr entry: pDevice %08x\n",pDevice);
  Cmd.hMidas= pDevice->hMidas;
  Cmd.cmd = MDS_ISR;
  retvalue = MidasEntry(&Cmd);
  if(retvalue) {
    Cmd.cmd = MDS_ISRCOMPLETE;
    MidasEntry(&Cmd);
  }
  DbgMsg(DBG_INFO, "DrvIntr exit: %08x\n", retvalue);
  return (BYTE)retvalue;
}

static void STREAMAPI DrvPktCancel(PHW_STREAM_REQUEST_BLOCK pSrb) {
//  MIDASCMD Cmd;
//  PSTREAM_EXTENSION pStream;
//  PDEVICE_EXTENSION pDevice;
//  int n;

//  pDevice = (PDEVICE_EXTENSION)pSrb->HwDeviceExtension;
  pSrb->Status = STATUS_CANCELLED;
  if((pSrb->Flags & (SRB_HW_FLAGS_DATA_TRANSFER | SRB_HW_FLAGS_STREAM_REQUEST)) !=
        (SRB_HW_FLAGS_DATA_TRANSFER | SRB_HW_FLAGS_STREAM_REQUEST)) {
    DEBUG_BREAKPOINT();
  } else {
    MIDASCMD Cmd;
    PDEVICE_EXTENSION pDevice= (PDEVICE_EXTENSION)pSrb->HwDeviceExtension;
    PSTREAM_EXTENSION pStream= (void*)pSrb->StreamObject->HwStreamExtension; 
    PMDS_DATA_BLOCK  pMdb=&((PSRB_EXTENSION)pSrb->SRBExtension)->Mdb;
    Cmd.hMidas=pDevice->hMidas;
    Cmd.cmd = MDS_CANCELDATA;
    Cmd.wCurrStream=pStream->internal_streamid;
    Cmd.u.pMdb=pMdb;
    MidasEntry(&Cmd);
  }
}



static int IsStreamRecentlyPaused(PSTREAM_EXTENSION pStrm) {
  int fPaused=0;
    
  if(pStrm->stream_state==KSSTATE_PAUSE  && pStrm->prev_stream_state==KSSTATE_RUN)
    return 1;

  // If the state is RUN but it changed less than 2 secs ago then report pause
  if((pStrm->stream_state==KSSTATE_RUN)&& (pStrm->dwStateChangeTime+2000 > MargiGetTime()))
    return 1;

  return 0;
}


static void STREAMAPI DrvPktTimeout(PHW_STREAM_REQUEST_BLOCK pSrb) {
  PDEVICE_EXTENSION pDevice=(PDEVICE_EXTENSION)pSrb->HwDeviceExtension;
  PSRB_EXTENSION    pSrbEx= (PSRB_EXTENSION) pSrb->SRBExtension;
  PSTREAM_EXTENSION pStream =0;
  PSTREAM_EXTENSION pVidStrm=0;
  PSTREAM_EXTENSION pAudStrm=0;
#if CCOUTPIN
  PSTREAM_EXTENSION pCCStrm =0;
#endif
  int IsMidasSrb=(pSrbEx->Mdb.nSize!=0);

  if(pSrb->StreamObject)
    pStream=(PSTREAM_EXTENSION)(pSrb->StreamObject->HwStreamExtension);

  if(pDevice && pStream) {
    if(pDevice->pStream[InMpeg2Video])
      pVidStrm=(PSTREAM_EXTENSION)pDevice->pStream[InMpeg2Video]->HwStreamExtension;

    if(pDevice->pStream[InMpeg2Ac3])
      pAudStrm=(PSTREAM_EXTENSION)pDevice->pStream[InMpeg2Ac3]->HwStreamExtension;
  #if CCOUTPIN
    if(pDevice->pStream[OutCloseCaption])
      pCCStrm= (PSTREAM_EXTENSION)pDevice->pStream[OutCloseCaption]->HwStreamExtension;
  #endif

    // If the SRB was sent to Midas layer and we still have vid and aud streams
    // then decide if we should cancel this SRB
    if(IsMidasSrb && pVidStrm && pAudStrm) {
      // if we timeout while playing, then we need to consider this
      // condition an error, and reset the hardware, and reset everything
      // as well as cancelling this and all requests
      // if this is a data request, and the device is paused, we probably have
      // run out of data buffer, and need more time, so just reset the timer,
      // and let the packet continue
      //
    #if CCOUTPIN
      if(pCCStrm && (pStream==pCCStrm) && pCCStrm->stream_state!=KSSTATE_STOP) {
        pSrb->TimeoutCounter=pSrb->TimeoutOriginal;
        DbgMsg(DBG_INFO,"DeviceTimeoutPacket SRB %d - Ignore because not in Stop Mode.\n",pSrbEx->srbnumber);
        return;
      }
    #endif

      if(IsStreamRecentlyPaused(pVidStrm) || IsStreamRecentlyPaused(pAudStrm)) {
        pSrb->TimeoutCounter=pSrb->TimeoutOriginal;
        DbgMsg(DBG_INFO,"DeviceTimeoutPacket SRB %d - Ignore because in Pause Mode.\n",pSrbEx->srbnumber);
        return;
      }
    }
  }

  if(pDevice && pDevice->hMidas) {
    // If we didn't return above the we should cancel everything.
    // cancel all MIDAS stuff 1st the cancel everything
    CancelStream(pDevice->hMidas,STRM_VID);
    CancelStream(pDevice->hMidas,STRM_AUD);
    CancelStream(pDevice->hMidas,STRM_SUB);
    CancelStream(pDevice->hMidas,STRM_CC);


#if(0)
    //If we end up here then may be because of MS bug in packet times when
    //SCR wraps to 33rd bit.  Reset Stream Time will fix problem eventually
    // Update:
    // Removing this improves things in Win98_SE and Win2k - I have no idea what is going on
    // If the time
    // 
    {
      MIDASCMD Cmd;
      Cmd.cmd=MDS_SET_STREAM_TIME;
      Cmd.u.SetTime.NewTime=0;
      Cmd.u.SetTime.OldTime=0;
      Cmd.hMidas=pDevice->hMidas;                    
      MidasEntry(&Cmd);
      pDevice->ddLastStreamTime=0;
    }
#endif
  }
  
  // kill all outstanding requests for the entire device!
  // NOTE: we don't need to call any requests back, they are all aborted
  // at the stream class driver
  StreamClassAbortOutstandingRequests(pSrb->HwDeviceExtension, NULL,STATUS_CANCELLED);
  unlogSrb("DeviceReceivePacket Timeout", pSrb);
}

static void  GetVersion()
{
//  PULONG MajorVersion;
// PULONG MinorVersion;
//  PULONG BuildNumber;
//  PUNICODE_STRING CSDVersion OPTIONAL
//  PsGetVersion(&MajorVersion,&MinorVersion,&BuildNumber,NULL);

  SettingFName(IniFName,IniSection);
  WinVersion = SettingLoad(SET_DWORD,IniOSVersion,0,0);
//  WinVersion = WIN98_VERSION;
}

void MargiSleep(int nMs)
{
  LARGE_INTEGER Time1,Time2;
  KIRQL Irql;
  KIRQL kIrql= KeGetCurrentIrql();
  KeQuerySystemTime(&Time1);
  
  if(kIrql==DISPATCH_LEVEL)
    KeLowerIrql(PASSIVE_LEVEL);

  Time1.QuadPart+=nMs*10000;
  while(1) {
    KeQuerySystemTime(&Time2);
    if(Time2.QuadPart>=Time1.QuadPart)
      break;
  }
  if(kIrql==DISPATCH_LEVEL)
    KeRaiseIrql (kIrql, &Irql);
}


/**EOF: DRVENTRY.C**/
