#include <StrmIni.h>
#include <KS.h>
#include <KsMedia.h>
#include "Idents.h"
#include "Globals.h"

static GUID GuidDvdEncryptedPack= { STATIC_KSDATAFORMAT_TYPE_DVD_ENCRYPTED_PACK };
static GUID GuidSubTypeMpeg2Video= { STATIC_KSDATAFORMAT_SUBTYPE_MPEG2_VIDEO };
static GUID GuidSpecifierMpeg2Video= { STATIC_KSDATAFORMAT_SPECIFIER_MPEG2_VIDEO };
static GUID GuidSubTypeAc3Audio= { STATIC_KSDATAFORMAT_SUBTYPE_AC3_AUDIO };
static GUID GuidSpecifierWaveFormatex= { STATIC_KSDATAFORMAT_SPECIFIER_WAVEFORMATEX };
static GUID GuidNull= { STATIC_GUID_NULL };
static GUID GuidTypeVideo= { STATIC_KSDATAFORMAT_TYPE_VIDEO };
static GUID GuidSubTypeVPVideo= { STATIC_KSDATAFORMAT_SUBTYPE_VPVideo };
static GUID GuidSpecifierNone= { STATIC_KSDATAFORMAT_SPECIFIER_NONE };
static GUID GuidAuxLine21Data= { STATIC_KSDATAFORMAT_TYPE_AUXLine21Data };
static GUID GuidLine21GOPPacket= { STATIC_KSDATAFORMAT_SUBTYPE_Line21_GOPPacket };
static GUID GuidSpecifierVideoInfo= { STATIC_KSDATAFORMAT_SPECIFIER_VIDEOINFO };
static GUID GuidSubTypeSubPict= { STATIC_KSDATAFORMAT_SUBTYPE_SUBPICTURE };
static GUID GuidPropIdMpeg2Vid= { STATIC_KSPROPSETID_Mpeg2Vid };
static GUID GuidPropIdCopyProt= { STATIC_KSPROPSETID_CopyProt };
static GUID GuidPropIdAudDecOut= { STATIC_KSPROPSETID_AudioDecoderOut };
static GUID GuidPropIDVPConfig= { STATIC_KSPROPSETID_VPConfig };
static GUID GuidPropIDVPVBIConfig= { STATIC_KSPROPSETID_VPVBIConfig };
static GUID GuidSubTypeLPCMAudio= { STATIC_KSDATAFORMAT_SUBTYPE_LPCM_AUDIO };
static GUID GuidSubTypeMPEGAudio= { STATIC_KSDATAFORMAT_SUBTYPE_MPEG2_AUDIO };

struct IdentEntry_s IdentsKsGuid[]= {
  { ID_GUID_KS, 0 },
    { (DWORD)&GuidDvdEncryptedPack, "DvdEncryptedPack" },
    { (DWORD)&GuidSubTypeMpeg2Video, "SubTypeMpeg2Video" },
    { (DWORD)&GuidSpecifierMpeg2Video, "SpecifierMpeg2Video" },
    { (DWORD)&GuidSubTypeAc3Audio, "SubTypeAc3Audio" },
    { (DWORD)&GuidSpecifierWaveFormatex, "SpecifierWaveFormatex" },
    { (DWORD)&GuidNull, "GuidNull" },
    { (DWORD)&GuidTypeVideo, "TypeVideo" },
    { (DWORD)&GuidSubTypeVPVideo, "SubTypeVPVideo" },
    { (DWORD)&GuidSpecifierNone, "SpecifierNone" },
    { (DWORD)&GuidAuxLine21Data, "AuxLine21Data" },
    { (DWORD)&GuidLine21GOPPacket, "Line21GOPPacket" },
    { (DWORD)&GuidSpecifierVideoInfo, "SpecifierVideoInfo" },
    { (DWORD)&GuidSubTypeSubPict, "SubTypeSubPict" },
    { (DWORD)&GuidPropIdMpeg2Vid, "PropID_Mpeg2Vid" },
    { (DWORD)&GuidPropIdCopyProt, "PropID_CopyProt" },
    { (DWORD)&GuidPropIdAudDecOut, "PropID_AudDecOut" },
    { (DWORD)&GuidPropIDVPConfig, "PropID_VPConfig" },
    { (DWORD)&GuidPropIDVPVBIConfig, "PropID_VPVBIConfig" },
    { (DWORD)&GuidSubTypeLPCMAudio, "SubTypeLPCMAudio" },
    { (DWORD)&GuidSubTypeMPEGAudio, "SubTypeMPEGAudio" },
  { ID_PIN_ID,  0 },
    { InMpeg2Video, "Mpeg2VideoPin" },
    { InMpeg2Ac3, "Ac3Pin" },
#if TVOUTPIN
    { OutNTSCVideo, "NTSCOutPin" },
#endif
    { InMpeg2Subpicture, "SubPicturePin" },
    { OutVideoPort, "OutVideo(VP)Pin" },
#if CCOUTPIN
    { OutCloseCaption, "OutCCPin" },
#endif
  { ID_KSPROP_VID, 0},
    { KSPROPERTY_MPEG2VID_MODES, "Mpeg2VidModes" },
    { KSPROPERTY_MPEG2VID_CUR_MODE, "Mpeg2VidCurrMode" },
    { KSPROPERTY_MPEG2VID_4_3_RECT, "Mpeg2Vid 4 by 3" },
    { KSPROPERTY_MPEG2VID_16_9_RECT, "Mpeg2Vid 16 by 9" },
    { KSPROPERTY_MPEG2VID_16_9_PANSCAN, "Mpeg2Vid 16by9 PanScan" },
  { ID_KSPROP_VIDF, 0},
    { KSMPEGVIDMODE_PANSCAN, "VidMode PanScan" },
    { KSMPEGVIDMODE_LTRBOX, "VidMode LetterBox" },
    { KSMPEGVIDMODE_SCALE, "VidMode Scale" },
  { ID_KSPROP_CSS, 0 },
    { KSPROPERTY_DVDCOPY_CHLG_KEY, "CssChlgKey" },
    { KSPROPERTY_DVDCOPY_DVD_KEY1, "CssKey1" },
    { KSPROPERTY_DVDCOPY_DEC_KEY2, "CssDecKey2" },
    { KSPROPERTY_DVDCOPY_TITLE_KEY, "CssTitleKey" },
    { KSPROPERTY_COPY_MACROVISION, "CssMacroVision" },
    { KSPROPERTY_DVDCOPY_REGION, "CssRegion" },
    { KSPROPERTY_DVDCOPY_SET_COPY_STATE, "CssSetCopyState" },
    { KSPROPERTY_DVDCOPY_DISC_KEY, "CssDiscKey" },
  { ID_KSPROP_CSSF, 0 },
    { KS_DVD_CGMS_COPY_PROTECT_MASK, "CssCGMS CopyProtectMask" },
    { KS_DVD_CGMS_COPY_PERMITTED, "CssCGMSCopyPermitted" },
    { KS_DVD_CGMS_COPY_ONCE, "CssCGMSCopyOnce" },
    { KS_DVD_CGMS_NO_COPY, "CssCGMSNoCopy" },
    { KS_DVD_COPYRIGHT_MASK, "CssCopyRigthtMask" },
    { KS_DVD_NOT_COPYRIGHTED, "CssNOTCopyRighted" },
    { KS_DVD_COPYRIGHTED, "CssCopyRighted" },
    { KS_DVD_SECTOR_PROTECT_MASK, "CssSectorProtectMask" },
    { KS_DVD_SECTOR_NOT_PROTECTED, "CssSectorNotProtected" },
    { KS_DVD_SECTOR_PROTECTED, "CssSectorProtected" },
  { ID_KSPROP_AUD, 0 },
    { KSPROPERTY_AUDDECOUT_MODES, "AudDecOut Modes" },
    { KSPROPERTY_AUDDECOUT_CUR_MODE, "SudDecOut Cur Mode" },
  { ID_KSPROP_AUDF, 0 },
    { KSAUDDECOUTMODE_STEREO_ANALOG, "AudOut StereoAnalog" },
    { KSAUDDECOUTMODE_PCM_51, "AudOut PCM 51" },
    { KSAUDDECOUTMODE_SPDIFF, "AudOut Spdiff" },
  { ID_KS_STATE, 0},
    { KSSTATE_STOP, "Stop" },
    { KSSTATE_ACQUIRE, "Acquire" },
    { KSSTATE_PAUSE, "Pause" },
    { KSSTATE_RUN, "Run" },
  { ID_KSPROP_VPE, 0 },
    { KSPROPERTY_VPCONFIG_NUMCONNECTINFO, "VPNumConnectInfo" },
    { KSPROPERTY_VPCONFIG_GETCONNECTINFO, "VPGetConnectInfo" },
    { KSPROPERTY_VPCONFIG_SETCONNECTINFO, "VPSetConnectInfo" },
    { KSPROPERTY_VPCONFIG_VPDATAINFO, "VPDataInfo" },
    { KSPROPERTY_VPCONFIG_MAXPIXELRATE, "VPMaxPixelRate" },
    { KSPROPERTY_VPCONFIG_INFORMVPINPUT, "VPInformVPInput" },
    { KSPROPERTY_VPCONFIG_NUMVIDEOFORMAT, "VPNumVidFmt" },
    { KSPROPERTY_VPCONFIG_GETVIDEOFORMAT, "VPGetVidFmt" },
    { KSPROPERTY_VPCONFIG_SETVIDEOFORMAT, "VPSetVidFmt" },
    { KSPROPERTY_VPCONFIG_INVERTPOLARITY, "VPInvPolarity" },
    { KSPROPERTY_VPCONFIG_DECIMATIONCAPABILITY, "VPDecimationCapability" },   // E_NOTIMPL for VBI
    { KSPROPERTY_VPCONFIG_SCALEFACTOR, "VPScaleFactor" },            // E_NOTIMPL for VBI
    { KSPROPERTY_VPCONFIG_DDRAWHANDLE, "VPDDHandle" },
    { KSPROPERTY_VPCONFIG_VIDEOPORTID, "VPVidPortID" },
    { KSPROPERTY_VPCONFIG_DDRAWSURFACEHANDLE, "VPDDSurfaceHandle" },
    { KSPROPERTY_VPCONFIG_SURFACEPARAMS, "VPSurfaceParams" },
  { ID_KSAM_ASPECT, 0 },
    { KS_PixAspectRatio_NTSC4x3, "AspectNTSC4x3" },
    { KS_PixAspectRatio_NTSC16x9, "AspectNTSC16x9" },
    { KS_PixAspectRatio_PAL4x3, "AspectPAL4x3" },
    { KS_PixAspectRatio_PAL16x9, "AspectPAL16x9" },
  { ID_KSAM_FMT1, 0 },
    { KS_AMVP_DO_NOT_CARE, "AMFmt.Don'tCare" },
    { KS_AMVP_BEST_BANDWIDTH, "AMFmt.BestBandwidth" },
    { KS_AMVP_INPUT_SAME_AS_OUTPUT, "AMFmt.InpSameAsOut" },
  { ID_KSAM_MODE1, 0 },
    { KS_AMVP_MODE_WEAVE, "AMVPmode.Weave" },
    { KS_AMVP_MODE_BOBINTERLEAVED, "AMVPmode.bobInter" },
    { KS_AMVP_MODE_BOBNONINTERLEAVED, "AMVPmode.bobNonInter" },
    { KS_AMVP_MODE_SKIPEVEN, "AMVPmode.SkipEven" },
    { KS_AMVP_MODE_SKIPODD, "AMVPmode.SkipOdd" },
  { ID_KS_AMINTERLACE, 0 },
    { KS_INTERLACE_IsInterlaced,"Interlaced"},
    { KS_INTERLACE_1FieldPerSample,"1 Field persample"},
    { KS_INTERLACE_Field1First,"Top Field is 2/1 in NTSC/PAL"},
    { KS_INTERLACE_UNUSED,"Unused Flag Bit"},
    { KS_INTERLACE_FieldPatternMask,"FieldPatternMask"}, 
    { KS_INTERLACE_FieldPatField1Only,"NoField2"},
    { KS_INTERLACE_FieldPatField2Only,"NoFiled1"},
    { KS_INTERLACE_FieldPatBothRegular,"Field2 for every Field1(for Weave)"},
    { KS_INTERLACE_FieldPatBothIrregular,"Random Filed1's and Field2's"},
    { KS_INTERLACE_DisplayModeMask,"DisplayModeMask"},
    { KS_INTERLACE_DisplayModeBobOnly,"BobOnly"},
    { KS_INTERLACE_DisplayModeWeaveOnly,"WeaveOnly"},
    { KS_INTERLACE_DisplayModeBobOrWeave,"BobOrWeave"},
  { ID_KS_MPEG2LEVEL, 0},
    { KS_MPEG2Level_Low,"Low"},
    { KS_MPEG2Level_Main,"Main"},
    { KS_MPEG2Level_High1440,"High1440"},
    { KS_MPEG2Level_High,"High"},
  { ID_KS_MPEG2PROFILE, 0},
    { KS_MPEG2Profile_Simple,"Simple"},
    { KS_MPEG2Profile_Main,"Main"},
    { KS_MPEG2Profile_SNRScalable,"SNRScalable"},
    { KS_MPEG2Profile_SpatiallyScalable,"SpatiallyScalable"},
    { KS_MPEG2Profile_High,"High"},
  { ID_KS_MPEG2VIDFLAG, 0},
    { KS_MPEG2_DoPanScan,"DoPanScan"},
    { KS_MPEG2_DVDLine21Field1,"Line21Field1"},
    { KS_MPEG2_DVDLine21Field2,"Line21Field2"},
    { KS_MPEG2_SourceIsLetterboxed,"LetterBox"},
    { KS_MPEG2_FilmCameraMode,"FilmMode(625.50)"},
    { KS_MPEG2_DSS_UserData,"DSSstyleUserData"},
    { KS_MPEG2_27MhzTimebase,"27MHz clock for PTS/DTS"},
  {ID_KS_MPEG2AUDFLAG, 0},
    { KS_MPEGAUDIOINFO_27MhzTimebase,"27MHz clock for PTS/DTS"},
  {0 ,0}  
};

/**EOF: IDENTUID.C**/
