

#include <strmini.h>
#include <ksmedia.h>
#include <ddkmapi.h>
//#include <ddrawi.h>
//#include <ddkernel.h>

#include "dbgmsg.h"
#include "globals.h"
#include "DbgFltr.h"
#include "Idents.h"
#include "mddraw.h"

//#pragma message("Ddraw.c: Optimizer disabled.")
//#pragma optimize("",off)

static long MargiDDChkApiVer(void);
static long MargiDDGetRing0DDHandle(PSTREAM_EXTENSION pStream);
static long MargiDDGetRing0VPHandle(PSTREAM_EXTENSION pStream);
static long MargiDDGetRing0SurfaceHandle(PSTREAM_EXTENSION pStream);
static long MargiDDGetKernelCaps(PSTREAM_EXTENSION pStream);
static long MargiDDRegisterVPVSyncEvent(PSTREAM_EXTENSION pStream);

DWORD FAR PASCAL MargiDDEventProc(DWORD dwFlags,PDEVICE_EXTENSION pDevice,DWORD dwParam1,DWORD dwParam2);

long MargiDDrawProc(DWORD dwMsg,PSTREAM_EXTENSION pStream) {
  long Err= 0;
  return Err;
  switch(dwMsg) {
    case MARGIDD_CHECKDDAPIVER:       Err= MargiDDChkApiVer(); break;
    case MARGIDD_GETDDHANDLE:         Err= MargiDDGetRing0DDHandle(pStream); break;
    case MARGIDD_GETVPHANDLE:         Err= MargiDDGetRing0VPHandle(pStream); break;
    case MARGIDD_GETSURFHANDLE:       Err= MargiDDGetRing0SurfaceHandle(pStream); break;
    case MARGIDD_GETCAPS:             Err= MargiDDGetKernelCaps(pStream); break;
    case MARGIDD_REGISTERVPSYNC:      Err= MargiDDRegisterVPVSyncEvent(pStream); break;
    default:                          Err= 0xFFFFFFFF; break;
  }
  return Err;
}


static long MargiDDChkApiVer(void) {
  long Err= 0xFFFFFFFF;
  DDGETVERSIONNUMBER DDVerNum;
  RtlZeroMemory(&DDVerNum,sizeof(DDGETVERSIONNUMBER));
  Err= DxApi(DD_DXAPI_GETVERSIONNUMBER,0,0,(DWORD*)&DDVerNum,sizeof(DDGETVERSIONNUMBER));
  DbgMsg(DBG_DDINFO,"Ring 0 DirectDraw API Version: Major=%d, Minor=%d \r\n",
    DDVerNum.dwMajorVersion,DDVerNum.dwMinorVersion);
  return 0;
}

static long MargiDDGetRing0DDHandle(PSTREAM_EXTENSION pStream) {
  long Err= 0xFFFFFFFF;
  DDOPENDIRECTDRAWIN  ddOpenIn;
  DDOPENDIRECTDRAWOUT ddOpenOut;
  if(!pStream->u.vp.ddrawHandle_Ring0) {
    RtlZeroMemory(&ddOpenIn,sizeof(DDOPENDIRECTDRAWIN));
    RtlZeroMemory(&ddOpenOut,sizeof(DDOPENDIRECTDRAWOUT));
    ddOpenIn.dwDirectDrawHandle= pStream->u.vp.ddrawHandle_Ring3;
    ddOpenIn.pfnDirectDrawClose= MargiDDEventProc;
    ddOpenIn.pContext= pStream->pDevice;

    DxApi(DD_DXAPI_OPENDIRECTDRAW,(DWORD*)&ddOpenIn,sizeof(ddOpenIn),(DWORD*)&ddOpenOut,sizeof(ddOpenOut));
    Err= ddOpenOut.ddRVal;

    if(Err) {
      DbgMsg(DBG_DDERR,"OpenDD failed Err=0x%08x \r\n",Err);
      pStream->u.vp.ddrawHandle_Ring0= 0;
    } else {
      pStream->u.vp.ddrawHandle_Ring0= ddOpenOut.hDirectDraw;
      DbgMsg(DBG_DDERR,"DD Ring 0 Handle = 0x%08x (Ring3=0x%08x) \r\n",
        pStream->u.vp.ddrawHandle_Ring0,pStream->u.vp.ddrawHandle_Ring3);
    }
  } else {
    DbgMsg(DBG_DDERR,"Already have Ring0 DD Handle. Cannot get again ??\r\n");
  }
  return Err;
}

static long MargiDDGetRing0VPHandle(PSTREAM_EXTENSION pStream) {
  long Err= 0xFFFFFFFF;
  DDOPENVIDEOPORTIN  ddOpenVPIn;
  DDOPENVIDEOPORTOUT ddOpenVPOut;
  if(!pStream->u.vp.VidPortHandle_Ring0) {
    RtlZeroMemory(&ddOpenVPIn,sizeof(ddOpenVPIn));
    RtlZeroMemory(&ddOpenVPOut,sizeof(ddOpenVPOut));
    ddOpenVPIn.hDirectDraw= pStream->u.vp.ddrawHandle_Ring0;
    ddOpenVPIn.pfnVideoPortClose = MargiDDEventProc;
    ddOpenVPIn.pContext= pStream->pDevice;
    ddOpenVPIn.dwVideoPortHandle = pStream->u.vp.VidPortHandle_Ring3;
        
    DxApi(DD_DXAPI_OPENVIDEOPORT,(DWORD*)&ddOpenVPIn,sizeof(ddOpenVPIn),(DWORD*)&ddOpenVPOut,sizeof(ddOpenVPOut));
    Err= ddOpenVPOut.ddRVal;

    if(Err) {
      DbgMsg(DBG_DDERR,"OpenVPort failed Err=0x%08x \r\n",Err);
      pStream->u.vp.VidPortHandle_Ring0= 0;
    } else {
      pStream->u.vp.VidPortHandle_Ring0= ddOpenVPOut.hVideoPort;
      DbgMsg(DBG_DDERR,"VPort Ring 0 Handle = 0x%08x (Ring3=0x%08x) \r\n",
        pStream->u.vp.VidPortHandle_Ring0,pStream->u.vp.VidPortHandle_Ring3);
    } 
  } else {
    DbgMsg(DBG_DDERR,"Already have VP Handle (Ring 0) \r\n");
  }
  return Err;
}

static long MargiDDGetRing0SurfaceHandle(PSTREAM_EXTENSION pStream) {
  long Err= 0xFFFFFFFF;
  DDOPENSURFACEIN ddOpenSurfaceIn;
  DDOPENSURFACEOUT ddOpenSurfaceOut;
  if(!pStream->u.vp.SurfaceHandle_Ring0) {
    RtlZeroMemory(&ddOpenSurfaceIn,sizeof(ddOpenSurfaceIn));
    RtlZeroMemory(&ddOpenSurfaceOut,sizeof(ddOpenSurfaceOut));
    ddOpenSurfaceIn.hDirectDraw = pStream->u.vp.ddrawHandle_Ring0;
    ddOpenSurfaceIn.pfnSurfaceClose = MargiDDEventProc;
    ddOpenSurfaceIn.pContext = pStream->pDevice;
    ddOpenSurfaceIn.dwSurfaceHandle = pStream->u.vp.SurfaceHandle_Ring3;

    DxApi(DD_DXAPI_OPENSURFACE,(DWORD*)&ddOpenSurfaceIn,sizeof(ddOpenSurfaceIn),(DWORD*)&ddOpenSurfaceOut, sizeof(ddOpenSurfaceOut));
    Err= ddOpenSurfaceOut.ddRVal;

    if(Err) {
      DbgMsg(DBG_DDERR,"Opensurface failed Err=0x%08x \r\n",Err);
      pStream->u.vp.SurfaceHandle_Ring0= 0;
    } else {
      pStream->u.vp.SurfaceHandle_Ring0= ddOpenSurfaceOut.hSurface;
      DbgMsg(DBG_DDERR,"Surface Ring 0 Handle = 0x%08x (Ring3=0x%08x) \r\n",pStream->u.vp.SurfaceHandle_Ring0,pStream->u.vp.SurfaceHandle_Ring3);
      {
        DDGETSURFACESTATEIN  In;
        DDGETSURFACESTATEOUT Out;

        In.hDirectDraw=pStream->u.vp.ddrawHandle_Ring0;
	      In.hSurface=   pStream->u.vp.SurfaceHandle_Ring0;

#if(0)
    {
	    DWORD	ddRVal;
	    DWORD	dwStateCaps;
	    DWORD	dwStateStatus;
    }
#endif
        DxApi(DD_DXAPI_GET_SURFACE_STATE,(DWORD*)&In,sizeof(In),(DWORD*)&Out,sizeof(Out));
      }
    } 
  } else {
    DbgMsg(DBG_DDERR,"Already have the Surface Handle \r\n");
  }
  return Err;
}

static long MargiDDGetKernelCaps(PSTREAM_EXTENSION pStream) {
  long Err= 0xFFFFFFFF;
  DDGETKERNELCAPSOUT DdCaps;

  RtlZeroMemory(&DdCaps,sizeof(DdCaps));
  if(pStream->u.vp.ddrawHandle_Ring0) {
    DxApi(DD_DXAPI_GETKERNELCAPS,(DWORD*)&pStream->u.vp.ddrawHandle_Ring0,sizeof(HANDLE),(DWORD*)&DdCaps, sizeof(DdCaps));
    Err= DdCaps.ddRVal;
    if(Err) {
      DbgMsg(DBG_DDERR,"GetKernelDDCaps returns Err 0x%08x \r\n",Err);
    } else {
      DbgMsg(DBG_DDINFO,"GetKernelDDCaps: Caps=0x%08x, IRQCaps=0x%08x \r\n",DdCaps.dwCaps,DdCaps.dwIRQCaps);
    }
  } else {
    DbgMsg(DBG_DDERR,"GetKernelCaps: No DD Handle available \r\n");
  }

  return Err;
}

static long MargiDDRegisterVPVSyncEvent(PSTREAM_EXTENSION pStream) {
  long Err= 0;
  DDREGISTERCALLBACK ddRegisterCallback;
  RtlZeroMemory(&ddRegisterCallback, sizeof(ddRegisterCallback));
  ddRegisterCallback.hDirectDraw = pStream->u.vp.ddrawHandle_Ring0;
  ddRegisterCallback.dwEvents = DDEVENT_VP_VSYNC;
//  ddRegisterCallback.dwEvents = DDEVENT_DISPLAY_VSYNC ;
  ddRegisterCallback.pfnCallback = MargiDDEventProc;
  ddRegisterCallback.dwParam1 = (DWORD)pStream->u.vp.VidPortHandle_Ring0;
  ddRegisterCallback.pContext = pStream->pDevice;
  DxApi(DD_DXAPI_REGISTER_CALLBACK,(DWORD*)&ddRegisterCallback,sizeof(ddRegisterCallback),(DWORD*)&Err,sizeof(Err));
  if(Err) {
    DbgMsg(DBG_DDERR,"RegisterDDEvent: For VP VSync failed 0x%08x \r\n",Err);
  } else {
    DbgMsg(DBG_DDERR,"RegisterDDEvent: For VP VSync succeded\r\n");
  }
  return Err;
}


//******
//***   Callback Handler.....
//******
static long MargiDDEventVPClose(PDEVICE_EXTENSION pDevice);
static long MargiDDEventSurfClose(PDEVICE_EXTENSION pDevice);
static long MargiDDEventDDClose(PDEVICE_EXTENSION pDevice);
static long MargiDDEventUnk(DWORD dwFlags);
static long MargiDDEventVPVsync(PDEVICE_EXTENSION pDevice);

DWORD FAR PASCAL MargiDDEventProc(DWORD dwFlags,PDEVICE_EXTENSION pDevice,DWORD dwParam1,DWORD dwParam2) {
  long Err= 0;
  switch(dwFlags) {
    case DDNOTIFY_CLOSEVIDEOPORT:     Err= MargiDDEventVPClose(pDevice); break;
    case DDNOTIFY_CLOSESURFACE:       Err= MargiDDEventSurfClose(pDevice); break;
    case DDNOTIFY_CLOSEDIRECTDRAW:    Err= MargiDDEventDDClose(pDevice); break;
    case DDNOTIFY_VP_VSYNC:           Err= MargiDDEventVPVsync(pDevice); break;
    case DDNOTIFY_DISPLAY_VSYNC:       Err=0; break;
    default:                          Err= MargiDDEventUnk(dwFlags); break;
  }
  return Err;
}

static long MargiDDEventVPClose(PDEVICE_EXTENSION pDevice) {
  PSTREAM_EXTENSION pStream;
  if(pDevice->pStream[OutVideoPort]) {
    pStream= (PSTREAM_EXTENSION) pDevice->pStream[OutVideoPort]->HwStreamExtension;
    pStream->u.vp.VidPortHandle_Ring0= 0;
    DbgMsg(DBG_DDEVE,"DDEvent: Closing Video Port (VPE Pin StillOpen)\r\n");
  } else {
    DbgMsg(DBG_DDEVE,"DDEvent: Closing Video Port (VPE Pin Closed)\r\n");
  }
  return 0;
}

static long MargiDDEventSurfClose(PDEVICE_EXTENSION pDevice) {
  PSTREAM_EXTENSION pStream;
  if(pDevice->pStream[OutVideoPort]) {
    pStream= (PSTREAM_EXTENSION) pDevice->pStream[OutVideoPort]->HwStreamExtension;
    pStream->u.vp.SurfaceHandle_Ring0= 0;
    DbgMsg(DBG_DDEVE,"DDEvent: Closing Surface (VPE Pin StillOpen)\r\n");
  } else {
    DbgMsg(DBG_DDEVE,"DDEvent: Closing Surface (VPE Pin Closed)\r\n");
  }
  return 0;
}

static long MargiDDEventDDClose(PDEVICE_EXTENSION pDevice) {
  PSTREAM_EXTENSION pStream;
  if(pDevice->pStream[OutVideoPort]) {
    pStream= (PSTREAM_EXTENSION) pDevice->pStream[OutVideoPort]->HwStreamExtension;
    pStream->u.vp.ddrawHandle_Ring0= 0;
    DbgMsg(DBG_DDEVE,"DDEvent: Closing DirectDraw (VPE Pin StillOpen)\r\n");
  } else {
    DbgMsg(DBG_DDEVE,"DDEvent: Closing DirectDraw (VPE Pin Closed)\r\n");
  }
  return 0;
}

static long MargiDDEventVPVsync(PDEVICE_EXTENSION pDevice) {
  DbgMsg(DBG_DDEVE|DBG_HIFREQ,"DDEvent: VP Vsync \r\n");
  return 0;
}

static long MargiDDEventUnk(DWORD dwFlags) {
  DbgMsg(DBG_DDEVE,"DDEvent: Unknown (%d) \r\n",dwFlags);
  return 0;
}


/* EOF : MDDRAW.C */


