
#include <Strmini.h>
#include <tchar.h>
#include "settings.h"
#include "WinVer.h"

#pragma message("Nt5_stub.c: Optimizer disabled.")
#pragma optimize("",off)

static DWORD SettingSavePassiveDWord(char* Entry,DWORD dwValue);
static DWORD SettingSavePassiveStr(char* Entry,DWORD dwValue);
static DWORD SettingLoadPassiveStr(char *Entry, void *pDst, DWORD dwDefault);
static DWORD SettingLoadPassiveDWord(char *Entry, DWORD *pDst, DWORD dwDefault);
static DWORD SettingSaveDispatchDWord(char* Entry,DWORD dwValue);
static DWORD SettingSaveDispatchStr(char* Entry,DWORD dwValue);
static DWORD SettingLoadDispatchStr(char *Entry, void *pDst, DWORD dwDefault);
static DWORD SettingLoadDispatchDWord(char *Entry, DWORD *pDst, DWORD dwDefault);
static DWORD SettingSavePassiveBinary(char* Entry,DWORD* pdwValue,DWORD dwLength);


static void BuildFullPath(WCHAR *pwBuff);
static void M_AnsiToUniCode(WCHAR *pDst,char *pSrc);
static void M_UniCodeToAnsi(char *pDst,WCHAR *pSrc);
static WCHAR wCharOne[256];
static WCHAR wCharTwo[256];
//static WCHAR wRootPath[256]= L"Software\\Margi_Systems\\";
static WCHAR wCurrRootPath[256];
static WCHAR wIniFName[256];
static WCHAR wIniSection[256];


void SettingFName(char *IniFName, char *IniSection) {
  if(IniFName)
    M_AnsiToUniCode(wIniFName,IniFName);
  if(IniSection)
    M_AnsiToUniCode(wIniSection,IniSection);
  return;
}


DWORD SettingLoad(DWORD dwType, char *Entry, void *pDst, DWORD dwDefault) {
  DWORD Val;
  KIRQL kIrql= KeGetCurrentIrql();
//  return 0;
  if(kIrql==PASSIVE_LEVEL) {
    switch(dwType & 0x00FF) {
      case SET_DWORD:   Val= SettingLoadPassiveDWord(Entry,pDst,dwDefault); break;
      case SET_STR:     Val= SettingLoadPassiveStr(Entry,pDst,dwDefault); break;
    }
  } else if(kIrql==DISPATCH_LEVEL) {
    switch(dwType & 0x00FF) {
      case SET_DWORD:   Val= SettingLoadDispatchDWord(Entry,pDst,dwDefault); break;
      case SET_STR:     Val= SettingLoadDispatchStr(Entry,pDst,dwDefault); break;
    }
  } else {
    DbgPrint("IRQL Now is %d\r\n",kIrql);
  }
  return Val;
}

DWORD SettingLoadPassiveStr(char *Entry, void *pDst, DWORD dwDefault) {

  RTL_QUERY_REGISTRY_TABLE QueryTbl[2];
  UNICODE_STRING wOutBuff;
  WCHAR pwInBuff[256];
  NTSTATUS Status;


    RtlInitUnicodeString(&wOutBuff,0);
    wOutBuff.MaximumLength= 256;
    wOutBuff.Length= 0;
    wOutBuff.Buffer= wCharTwo;


    M_AnsiToUniCode(pwInBuff,Entry);
    RtlZeroMemory(QueryTbl,sizeof(RTL_QUERY_REGISTRY_TABLE)*2);
    QueryTbl[0].Flags= RTL_QUERY_REGISTRY_DIRECT;
    QueryTbl[0].Name= pwInBuff;
    QueryTbl[0].EntryContext= &wOutBuff;
    QueryTbl[0].DefaultType= REG_SZ; //REG_DWORD;
    QueryTbl[0].DefaultData= 0;
    QueryTbl[0].DefaultLength= 0;

    BuildFullPath(wCharOne);

    Status= RtlQueryRegistryValues(RTL_REGISTRY_ABSOLUTE,wCharOne,QueryTbl,0,0);

    if(Status==STATUS_SUCCESS) {
      M_UniCodeToAnsi(pDst,wCharTwo);
    } else {

    }

  return Status;
}

static void M_AnsiToUniCode(WCHAR *pDst,char *pSrc) {
  DWORD dwLen= strlen(pSrc);
  RtlZeroMemory(pDst,512);
  while(dwLen--) {
    *(pDst++)= *(pSrc++);
  }
}

static void M_UniCodeToAnsi(char *pDst,WCHAR *pSrc) {
  DWORD dwLen= wcslen(pSrc);
  RtlZeroMemory(pDst,strlen(pDst)+1);
  while(dwLen--) {
    *(pDst++)= (char)(*(pSrc++));
  }
}

static void BuildFullPath(WCHAR *pwBuff) {
  WCHAR *Src;
  WCHAR wRootPath[256]= L"\\Registry\\Machine\\Software\\Margi_Systems\\"; 

  RtlZeroMemory(pwBuff,512);
  for(Src=wRootPath;*Src;*pwBuff++=*Src++);
  for(Src=wIniFName;*Src && *Src!='.';*pwBuff++= *Src++);
  for(*pwBuff++='\\',Src=wIniSection;*Src;*pwBuff++= *Src++);
}


static DWORD SettingLoadPassiveDWord(char *Entry, DWORD *pDst, DWORD dwDefault) {

  RTL_QUERY_REGISTRY_TABLE QueryTbl[2];
  WCHAR pwInBuff[256];
  NTSTATUS Status;
  DWORD dwOut= 1000;

  M_AnsiToUniCode(pwInBuff,Entry);
  RtlZeroMemory(QueryTbl,sizeof(RTL_QUERY_REGISTRY_TABLE)*2);
  QueryTbl[0].Flags= RTL_QUERY_REGISTRY_DIRECT|RTL_QUERY_REGISTRY_REQUIRED;
  QueryTbl[0].Name= pwInBuff;
  QueryTbl[0].EntryContext= &dwOut;
  QueryTbl[0].DefaultType= REG_DWORD;
  QueryTbl[0].DefaultData= &dwDefault;
  QueryTbl[0].DefaultLength= sizeof(DWORD);
  BuildFullPath(wCharOne);

  Status= RtlQueryRegistryValues(RTL_REGISTRY_ABSOLUTE,wCharOne,QueryTbl,0,0);

  if(Status==STATUS_SUCCESS) {
    if(pDst)
      *pDst= dwOut;
    else
      Status= dwOut;
    //DbgPrint("Read DWORD registry setting %s, 0x%08x \r\n",Entry,dwOut);

  } else {
    Status= dwDefault;
  }

  return Status;
}

void SettingSave(DWORD dwType, char *Entry, DWORD dwValue) {
  KIRQL kIrql= KeGetCurrentIrql();
  KIRQL Irql;
//  return;
  if(kIrql==PASSIVE_LEVEL) {
    switch(dwType & 0x00FF) {
      case SET_DWORD:   SettingSavePassiveDWord(Entry,dwValue); break;
      case SET_STR:     SettingSavePassiveStr(Entry,dwValue); break;
    }
  } else if(kIrql==DISPATCH_LEVEL) {
    KeLowerIrql (PASSIVE_LEVEL);
    switch(dwType & 0x00FF) {
      case SET_DWORD:   SettingSaveDispatchDWord(Entry,dwValue); break;
      case SET_STR:     SettingSaveDispatchStr(Entry,dwValue); break;
    }
    KeRaiseIrql (kIrql, &Irql);
  } else {
    DbgPrint("IRQL Now is %d\r\n",kIrql);
  }
  return;
}

static DWORD SettingSavePassiveDWord(char* Entry,DWORD dwValue) {
  NTSTATUS Status= 0;
  WCHAR pwInBuff[256];
  M_AnsiToUniCode(pwInBuff,Entry);
  BuildFullPath(wCharOne);
  Status= RtlWriteRegistryValue(RTL_REGISTRY_ABSOLUTE,wCharOne,pwInBuff,
                REG_DWORD,&dwValue,sizeof(DWORD));
  return Status;
}

static DWORD SettingSavePassiveStr(char* Entry,DWORD dwValue) {
  NTSTATUS Status;
  WCHAR pwInBuff[256];
  M_AnsiToUniCode(pwInBuff,Entry);
  M_AnsiToUniCode(wCharTwo,(char*)dwValue);
  BuildFullPath(wCharOne);
  Status= RtlWriteRegistryValue(RTL_REGISTRY_ABSOLUTE,wCharOne,pwInBuff,
                REG_SZ,wCharTwo,wcslen(wCharTwo));
  return Status;
}


static DWORD SettingSavePassiveBinary(char* Entry,DWORD* pdwValue,DWORD dwLength) {
  NTSTATUS Status;
  WCHAR pwInBuff[256];
  M_AnsiToUniCode(pwInBuff,Entry);
  BuildFullPath(wCharOne);
  Status= RtlWriteRegistryValue(RTL_REGISTRY_ABSOLUTE,wCharOne,pwInBuff,
                REG_BINARY,pdwValue,dwLength);
  return Status;
}

void SettingSaveB(DWORD dwType, char *Entry, DWORD  Arg, DWORD dwLength) {
  KIRQL kIrql= KeGetCurrentIrql();
  KIRQL Irql;
  DWORD* pdwValue = (DWORD*) Arg; 
//  return;
  if(kIrql==PASSIVE_LEVEL) {
    switch(dwType & 0x00FF) {
      case SET_DATA:    SettingSavePassiveBinary(Entry,pdwValue,dwLength); break;
    }
  } else if(kIrql==DISPATCH_LEVEL) {
    KeLowerIrql (PASSIVE_LEVEL);
    switch(dwType & 0x00FF) {
      case SET_DATA:    SettingSavePassiveBinary(Entry,pdwValue,dwLength); break;
    }
    KeRaiseIrql (kIrql, &Irql);
  } else {
    DbgPrint("IRQL Now is %d\r\n",kIrql);
  }
  return;
}

static DWORD SettingSaveDispatchDWord(char* Entry,DWORD dwValue) {
  NTSTATUS Status= STATUS_SUCCESS;
  Status= SettingSavePassiveDWord(Entry,dwValue);
  return Status;
}

static DWORD SettingSaveDispatchStr(char* Entry,DWORD dwValue) {
  NTSTATUS Status= STATUS_SUCCESS;
  Status= SettingSavePassiveStr(Entry,dwValue);
  return Status;
}

static DWORD SettingLoadDispatchStr(char *Entry, void *pDst, DWORD dwDefault) {
  NTSTATUS Status= STATUS_SUCCESS;
  Status= SettingLoadPassiveStr(Entry,pDst,dwDefault);
  return Status;
}

static DWORD SettingLoadDispatchDWord(char *Entry, DWORD *pDst, DWORD dwDefault) {
  NTSTATUS Status= STATUS_SUCCESS;
  Status= SettingLoadPassiveDWord(Entry,pDst,dwDefault);
  return Status;
}


#if (0)
int DbgMsg(DWORD MsgClass, char *Format, ...) {
  return 0xDEAD;
}
long __cdecl DbgMsgCmd(DWORD Cmd, DWORD Arg1, DWORD Arg2) {
  return 0xDEADBEEF;
}
#endif

/* EOF : NT5_STUB.c */