/***************************************************
File: PciDefs.h
****************************************************/

#ifndef INCLUDE_PCIDEFS
#define INCLUDE_PCIDEFS

#define PCI_FUNCTION_ID         0xb100
#define PCI_BIOS_PRESENT        0xb101
#define FIND_PCI_DEVICE         0xb102
#define FIND_PCI_CLASS_CODE     0xb103
#define GENERATE_SPECIAL_CYLCLE 0xb106
#define READ_CONFIG_BYTE        0xb108
#define READ_CONFIG_WORD        0xb109
#define READ_CONFIG_DWORD       0xb10a
#define WRITE_CONFIG_BYTE       0xb10b
#define WRITE_CONFIG_WORD       0xb10c
#define WRITE_CONFIG_DWORD      0xb10d

#define SUCCESSFUL              0x00
#define FUNC_NOT_SUPPORTED      0x81
#define BAD_VENDOR_ID           0x83
#define DEVICE_NOT_FOUND        0x86
#define BAD_REGISTER_NUMBER     0x87

#define PCI_FUNCTION_ID         0xb100
#define PCI_BIOS_PRESENT        0xb101
#define FIND_PCI_DEVICE         0xb102
#define FIND_PCI_CLASS_CODE     0xb103
#define GENERATE_SPECIAL_CYLCLE 0xb106
#define READ_CONFIG_BYTE        0xb108
#define READ_CONFIG_WORD        0xb109
#define READ_CONFIG_DWORD       0xb10a
#define WRITE_CONFIG_BYTE       0xb10b
#define WRITE_CONFIG_WORD       0xb10c
#define WRITE_CONFIG_DWORD      0xb10d

#define SUCCESSFUL              0x00
#define FUNC_NOT_SUPPORTED      0x81
#define BAD_VENDOR_ID           0x83
#define DEVICE_NOT_FOUND        0x86
#define BAD_REGISTER_NUMBER     0x87

#define cirrus      1
#define toshiba     2         
#define ti          3         
#define databook    4
#define o2Micro     5
#define omega       6
#define ricoh       7

#define NUM_PCI 14

#ifdef _PCI_DECLARE

WORD gPCITypeList[NUM_PCI] = 
                  { cirrus,
                    cirrus,
                    toshiba,
                    toshiba,
                    ti,         
                    ti,         
                    databook,
                    o2Micro,
                    o2Micro,   
                    omega,
                    ricoh,
                    ricoh,
                    ricoh,
                    0};

WORD gPCISubTypeList[NUM_PCI]=
                  { 6729,
                    6832,                
                    0,
                    0,
                    1130,
                    1131,
                    0,
                    0,
                    0,
                    0,
                    465,
                    466,
                    0};

WORD gPCIVendorIdList[NUM_PCI]=
                     {  0x1013,         //cirrus for 6729
                        0x1013,         //cirrus for 6832
                        0x0000,         //toshiba (not PCI)
                        0x0000,         //toshiba Topics 95
                        0x104c,         //ti for 1130
                        0x104c,         //ti for 1131
                        0x10b3,         //databook
                        0x1217,         //O2Micro
                        0x1217,         //O2Micro
                        0x119b,         //Trident-Omega
                        0x0000,         //ricoh (not PCI)
                        0x1180,         //ricoh RL5C465
                        0x1180,         //ricoh RL5C466
                        0x0000};
                        
WORD gPCIDeviceIdList[NUM_PCI]=
                     {  0x1100,         //cirrus for 6729
                        0x1110,         //cirrus for 6832
                        0x0000,         //toshiba (not PCI)
                        0x0000,         //toshiba Topics 95
                        0xac12,         //ti 1130
                        0xac15,         //ti 1131
                        0x3106,         //databook
                        0x673a,         //O2Micro
                        0x6729,         //O2Micro
                        0x1221,         //Trident-Omega
                        0x0000,         //ricoh (not PCI)
                        0x0465,         //ricoh RL5C465
                        0x0466,         //ricoh RL5C466
                        0x0000};
#else
extern WORD gPCITypeList[NUM_PCI];
extern WORD gPCISubTypeList[NUM_PCI];
extern WORD gPCIVendorIdList[NUM_PCI];
extern WORD gPCIDeviceIdList[NUM_PCI];
#endif

#endif

/* eof: PciDefs.h */
