#include <Strmini.h>
#include <mmsystem.h>
#include <KsMedia.h>
#include <ntddk.h>
#include "DbgMsg.h"
#include "DbgFltr.h"
#include "Idents.h"
#include "Settings.h"

#include "Globals.h"
//#include "lsihal.h"
#include "log.h"
#include "IniNames.h"

//#pragma message("steal.c: Optimizer disabled.")
//#pragma optimize("",off)

NTSTATUS Margi_IRP_MJ_CREATE(PDEVICE_OBJECT pDevObj,PIRP pIrp);
NTSTATUS Margi_IRP_MJ_CREATE_NAMED_PIPE(PDEVICE_OBJECT pDevObj,PIRP pIrp);
NTSTATUS Margi_IRP_MJ_CLOSE(PDEVICE_OBJECT pDevObj,PIRP pIrp);
NTSTATUS Margi_IRP_MJ_READ(PDEVICE_OBJECT pDevObj,PIRP pIrp);
NTSTATUS Margi_IRP_MJ_WRITE(PDEVICE_OBJECT pDevObj,PIRP pIrp);
NTSTATUS Margi_IRP_MJ_QUERY_INFORMATION(PDEVICE_OBJECT pDevObj,PIRP pIrp);
NTSTATUS Margi_IRP_MJ_SET_INFORMATION(PDEVICE_OBJECT pDevObj,PIRP pIrp);
NTSTATUS Margi_IRP_MJ_QUERY_EA(PDEVICE_OBJECT pDevObj,PIRP pIrp);
NTSTATUS Margi_IRP_MJ_SET_EA(PDEVICE_OBJECT pDevObj,PIRP pIrp);
NTSTATUS Margi_IRP_MJ_FLUSH_BUFFERS(PDEVICE_OBJECT pDevObj,PIRP pIrp);
NTSTATUS Margi_IRP_MJ_QUERY_VOLUME_INFORMATION(PDEVICE_OBJECT pDevObj,PIRP pIrp);
NTSTATUS Margi_IRP_MJ_SET_VOLUME_INFORMATION(PDEVICE_OBJECT pDevObj,PIRP pIrp);
NTSTATUS Margi_IRP_MJ_DIRECTORY_CONTROL(PDEVICE_OBJECT pDevObj,PIRP pIrp);
NTSTATUS Margi_IRP_MJ_FILE_SYSTEM_CONTROL(PDEVICE_OBJECT pDevObj,PIRP pIrp);
NTSTATUS Margi_IRP_MJ_DEVICE_CONTROL(PDEVICE_OBJECT pDevObj,PIRP pIrp);
NTSTATUS Margi_IRP_MJ_INTERNAL_DEVICE_CONTROL(PDEVICE_OBJECT pDevObj,PIRP pIrp);
NTSTATUS Margi_IRP_MJ_SHUTDOWN(PDEVICE_OBJECT pDevObj,PIRP pIrp);
NTSTATUS Margi_IRP_MJ_LOCK_CONTROL(PDEVICE_OBJECT pDevObj,PIRP pIrp);
NTSTATUS Margi_IRP_MJ_CLEANUP(PDEVICE_OBJECT pDevObj,PIRP pIrp);
NTSTATUS Margi_IRP_MJ_CREATE_MAILSLOT(PDEVICE_OBJECT pDevObj,PIRP pIrp);
NTSTATUS Margi_IRP_MJ_QUERY_SECURITY(PDEVICE_OBJECT pDevObj,PIRP pIrp);
NTSTATUS Margi_IRP_MJ_SET_SECURITY(PDEVICE_OBJECT pDevObj,PIRP pIrp);
NTSTATUS Margi_IRP_MJ_POWER(PDEVICE_OBJECT pDevObj,PIRP pIrp);
NTSTATUS Margi_IRP_MJ_SYSTEM_CONTROL(PDEVICE_OBJECT pDevObj,PIRP pIrp);
NTSTATUS Margi_IRP_MJ_DEVICE_CHANGE(PDEVICE_OBJECT pDevObj,PIRP pIrp);
NTSTATUS Margi_IRP_MJ_QUERY_QUOTA(PDEVICE_OBJECT pDevObj,PIRP pIrp);
NTSTATUS Margi_IRP_MJ_SET_QUOTA(PDEVICE_OBJECT pDevObj,PIRP pIrp);
NTSTATUS Margi_IRP_MJ_PNP(PDEVICE_OBJECT pDevObj,PIRP pIrp);
NTSTATUS Margi_IRP_MJ_PNP_POWER(PDEVICE_OBJECT pDevObj,PIRP pIrp);


struct IrpReceive_s {
  DWORD dwOffset;
  PDRIVER_DISPATCH Microsoft;
  PDRIVER_DISPATCH Margi;
};

struct IrpReceive_s IrpReceive[] = {
  { IRP_MJ_CREATE,                          0,    Margi_IRP_MJ_CREATE   },
  { IRP_MJ_CREATE_NAMED_PIPE,               0,    Margi_IRP_MJ_CREATE_NAMED_PIPE   },
  { IRP_MJ_CLOSE,                           0,    Margi_IRP_MJ_CLOSE   },
  { IRP_MJ_READ,                            0,    Margi_IRP_MJ_READ   },
  { IRP_MJ_WRITE,                           0,    Margi_IRP_MJ_WRITE   },
  { IRP_MJ_QUERY_INFORMATION,               0,    Margi_IRP_MJ_QUERY_INFORMATION   },
  { IRP_MJ_SET_INFORMATION,                 0,    Margi_IRP_MJ_SET_INFORMATION   },
  { IRP_MJ_QUERY_EA,                        0,    Margi_IRP_MJ_QUERY_EA   },
  { IRP_MJ_SET_EA,                          0,    Margi_IRP_MJ_SET_EA   },
  { IRP_MJ_FLUSH_BUFFERS,                   0,    Margi_IRP_MJ_FLUSH_BUFFERS   },
  { IRP_MJ_QUERY_VOLUME_INFORMATION,        0,    Margi_IRP_MJ_QUERY_VOLUME_INFORMATION   },
  { IRP_MJ_SET_VOLUME_INFORMATION,          0,    Margi_IRP_MJ_SET_VOLUME_INFORMATION   },
  { IRP_MJ_DIRECTORY_CONTROL,               0,    Margi_IRP_MJ_DIRECTORY_CONTROL   },
  { IRP_MJ_FILE_SYSTEM_CONTROL,             0,    Margi_IRP_MJ_FILE_SYSTEM_CONTROL   },
  { IRP_MJ_DEVICE_CONTROL,                  0,    Margi_IRP_MJ_DEVICE_CONTROL   },
  { IRP_MJ_INTERNAL_DEVICE_CONTROL,         0,    Margi_IRP_MJ_INTERNAL_DEVICE_CONTROL   },
  { IRP_MJ_SHUTDOWN,                        0,    Margi_IRP_MJ_SHUTDOWN   },
  { IRP_MJ_LOCK_CONTROL,                    0,    Margi_IRP_MJ_LOCK_CONTROL   },
  { IRP_MJ_CLEANUP,                         0,    Margi_IRP_MJ_CLEANUP   },
  { IRP_MJ_CREATE_MAILSLOT,                 0,    Margi_IRP_MJ_CREATE_MAILSLOT   },
  { IRP_MJ_QUERY_SECURITY,                  0,    Margi_IRP_MJ_QUERY_SECURITY   },
  { IRP_MJ_SET_SECURITY,                    0,    Margi_IRP_MJ_SET_SECURITY   },
  { IRP_MJ_POWER,                           0,    Margi_IRP_MJ_POWER   },
  { IRP_MJ_SYSTEM_CONTROL,                  0,    Margi_IRP_MJ_SYSTEM_CONTROL   },
  { IRP_MJ_DEVICE_CHANGE,                   0,    Margi_IRP_MJ_DEVICE_CHANGE   },
  { IRP_MJ_QUERY_QUOTA,                     0,    Margi_IRP_MJ_QUERY_QUOTA   },
  { IRP_MJ_SET_QUOTA,                       0,    Margi_IRP_MJ_SET_QUOTA   },
  { IRP_MJ_PNP,                             0,    Margi_IRP_MJ_PNP   },
};



void  DbgDispIrp(PDEVICE_OBJECT pDevObj,PIRP pIrp) {
  PIO_STACK_LOCATION IrpStack = IoGetCurrentIrpStackLocation(pIrp);
  DbgMsg(DBG_STRMIRP|DBG_HIFREQ,"IRP: Major=%s, Minor=%x (0x%08x)\r\n",
    Ident(ID_IRP,IrpStack->MajorFunction),IrpStack->MinorFunction,
    IrpStack->Parameters.DeviceIoControl.IoControlCode);
}



NTSTATUS Margi_IRP_MJ_CREATE(PDEVICE_OBJECT pDevObj,PIRP pIrp) {
  NTSTATUS Status;
  DbgDispIrp(pDevObj,pIrp);
  if(IrpReceive[IRP_MJ_CREATE].Microsoft) {
    Status= ((PDRIVER_DISPATCH)IrpReceive[IRP_MJ_CREATE].Microsoft)(pDevObj,pIrp);
  }
  return Status;
}

NTSTATUS Margi_IRP_MJ_CREATE_NAMED_PIPE(PDEVICE_OBJECT pDevObj,PIRP pIrp) {
  NTSTATUS Status;
  DbgDispIrp(pDevObj,pIrp);
  if(IrpReceive[IRP_MJ_CREATE_NAMED_PIPE].Microsoft) {
    Status= ((PDRIVER_DISPATCH)IrpReceive[IRP_MJ_CREATE_NAMED_PIPE].Microsoft)(pDevObj,pIrp);
  }
  return Status;
}

NTSTATUS Margi_IRP_MJ_CLOSE(PDEVICE_OBJECT pDevObj,PIRP pIrp) {
  NTSTATUS Status;
  DbgDispIrp(pDevObj,pIrp);
  if(IrpReceive[IRP_MJ_CLOSE].Microsoft) {
    Status= ((PDRIVER_DISPATCH)IrpReceive[IRP_MJ_CLOSE].Microsoft)(pDevObj,pIrp);
  }
  return Status;
}

NTSTATUS Margi_IRP_MJ_READ(PDEVICE_OBJECT pDevObj,PIRP pIrp) {
  NTSTATUS Status;
  DbgDispIrp(pDevObj,pIrp);
  if(IrpReceive[IRP_MJ_READ].Microsoft) {
    Status= ((PDRIVER_DISPATCH)IrpReceive[IRP_MJ_READ].Microsoft)(pDevObj,pIrp);
  }
  return Status;
}

NTSTATUS Margi_IRP_MJ_WRITE(PDEVICE_OBJECT pDevObj,PIRP pIrp) {
  NTSTATUS Status;
  DbgDispIrp(pDevObj,pIrp);
  if(IrpReceive[IRP_MJ_WRITE].Microsoft) {
    Status= ((PDRIVER_DISPATCH)IrpReceive[IRP_MJ_WRITE].Microsoft)(pDevObj,pIrp);
  }
  return Status;
}

NTSTATUS Margi_IRP_MJ_QUERY_INFORMATION(PDEVICE_OBJECT pDevObj,PIRP pIrp) {
  NTSTATUS Status;
  DbgDispIrp(pDevObj,pIrp);
  if(IrpReceive[IRP_MJ_QUERY_INFORMATION].Microsoft) {
    Status= ((PDRIVER_DISPATCH)IrpReceive[IRP_MJ_QUERY_INFORMATION].Microsoft)(pDevObj,pIrp);
  }
  return Status;
}

NTSTATUS Margi_IRP_MJ_SET_INFORMATION(PDEVICE_OBJECT pDevObj,PIRP pIrp) {
  NTSTATUS Status;
  DbgDispIrp(pDevObj,pIrp);
  if(IrpReceive[IRP_MJ_SET_INFORMATION].Microsoft) {
    Status= ((PDRIVER_DISPATCH)IrpReceive[IRP_MJ_SET_INFORMATION].Microsoft)(pDevObj,pIrp);
  }
  return Status;
}

NTSTATUS Margi_IRP_MJ_QUERY_EA(PDEVICE_OBJECT pDevObj,PIRP pIrp) {
  NTSTATUS Status;
  DbgDispIrp(pDevObj,pIrp);
  if(IrpReceive[IRP_MJ_QUERY_EA].Microsoft) {
    Status= ((PDRIVER_DISPATCH)IrpReceive[IRP_MJ_QUERY_EA].Microsoft)(pDevObj,pIrp);
  }
  return Status;
}

NTSTATUS Margi_IRP_MJ_SET_EA(PDEVICE_OBJECT pDevObj,PIRP pIrp) {
  NTSTATUS Status;
  DbgDispIrp(pDevObj,pIrp);
  if(IrpReceive[IRP_MJ_SET_EA].Microsoft) {
    Status= ((PDRIVER_DISPATCH)IrpReceive[IRP_MJ_SET_EA].Microsoft)(pDevObj,pIrp);
  }
  return Status;
}

NTSTATUS Margi_IRP_MJ_FLUSH_BUFFERS(PDEVICE_OBJECT pDevObj,PIRP pIrp) {
  NTSTATUS Status;
  DbgDispIrp(pDevObj,pIrp);
  if(IrpReceive[IRP_MJ_FLUSH_BUFFERS].Microsoft) {
    Status= ((PDRIVER_DISPATCH)IrpReceive[IRP_MJ_FLUSH_BUFFERS].Microsoft)(pDevObj,pIrp);
  }
  return Status;
}

NTSTATUS Margi_IRP_MJ_QUERY_VOLUME_INFORMATION(PDEVICE_OBJECT pDevObj,PIRP pIrp) {
  NTSTATUS Status;
  DbgDispIrp(pDevObj,pIrp);
  if(IrpReceive[IRP_MJ_QUERY_VOLUME_INFORMATION].Microsoft) {
    Status= ((PDRIVER_DISPATCH)IrpReceive[IRP_MJ_QUERY_VOLUME_INFORMATION].Microsoft)(pDevObj,pIrp);
  }
  return Status;
}

NTSTATUS Margi_IRP_MJ_SET_VOLUME_INFORMATION(PDEVICE_OBJECT pDevObj,PIRP pIrp) {
  NTSTATUS Status;
  DbgDispIrp(pDevObj,pIrp);
  if(IrpReceive[IRP_MJ_SET_VOLUME_INFORMATION].Microsoft) {
    Status= ((PDRIVER_DISPATCH)IrpReceive[IRP_MJ_SET_VOLUME_INFORMATION].Microsoft)(pDevObj,pIrp);
  }
  return Status;
}

NTSTATUS Margi_IRP_MJ_DIRECTORY_CONTROL(PDEVICE_OBJECT pDevObj,PIRP pIrp) {
  NTSTATUS Status;
  DbgDispIrp(pDevObj,pIrp);
  if(IrpReceive[IRP_MJ_DIRECTORY_CONTROL].Microsoft) {
    Status= ((PDRIVER_DISPATCH)IrpReceive[IRP_MJ_DIRECTORY_CONTROL].Microsoft)(pDevObj,pIrp);
  }
  return Status;
}

NTSTATUS Margi_IRP_MJ_FILE_SYSTEM_CONTROL(PDEVICE_OBJECT pDevObj,PIRP pIrp) {
  NTSTATUS Status;
  DbgDispIrp(pDevObj,pIrp);
  if(IrpReceive[IRP_MJ_FILE_SYSTEM_CONTROL].Microsoft) {
    Status= ((PDRIVER_DISPATCH)IrpReceive[IRP_MJ_FILE_SYSTEM_CONTROL].Microsoft)(pDevObj,pIrp);
  }
  return Status;
}

NTSTATUS Margi_IRP_MJ_DEVICE_CONTROL(PDEVICE_OBJECT pDevObj,PIRP pIrp) {
  NTSTATUS Status;
  DbgDispIrp(pDevObj,pIrp);
  if(IrpReceive[IRP_MJ_DEVICE_CONTROL].Microsoft) {
    Status= ((PDRIVER_DISPATCH)IrpReceive[IRP_MJ_DEVICE_CONTROL].Microsoft)(pDevObj,pIrp);
  }
  return Status;
}

NTSTATUS Margi_IRP_MJ_INTERNAL_DEVICE_CONTROL(PDEVICE_OBJECT pDevObj,PIRP pIrp) {
  NTSTATUS Status;
  DbgDispIrp(pDevObj,pIrp);
  if(IrpReceive[IRP_MJ_INTERNAL_DEVICE_CONTROL].Microsoft) {
    Status= ((PDRIVER_DISPATCH)IrpReceive[IRP_MJ_INTERNAL_DEVICE_CONTROL].Microsoft)(pDevObj,pIrp);
  }
  return Status;
}

NTSTATUS Margi_IRP_MJ_SHUTDOWN(PDEVICE_OBJECT pDevObj,PIRP pIrp) {
  NTSTATUS Status;
  DbgDispIrp(pDevObj,pIrp);
  if(IrpReceive[IRP_MJ_SHUTDOWN].Microsoft) {
    Status= ((PDRIVER_DISPATCH)IrpReceive[IRP_MJ_SHUTDOWN].Microsoft)(pDevObj,pIrp);
  }
  return Status;
}

NTSTATUS Margi_IRP_MJ_LOCK_CONTROL(PDEVICE_OBJECT pDevObj,PIRP pIrp) {
  NTSTATUS Status;
  DbgDispIrp(pDevObj,pIrp);
  if(IrpReceive[IRP_MJ_LOCK_CONTROL].Microsoft) {
    Status= ((PDRIVER_DISPATCH)IrpReceive[IRP_MJ_LOCK_CONTROL].Microsoft)(pDevObj,pIrp);
  }
  return Status;
}

NTSTATUS Margi_IRP_MJ_CLEANUP(PDEVICE_OBJECT pDevObj,PIRP pIrp) {
  NTSTATUS Status;
  DbgDispIrp(pDevObj,pIrp);
  if(IrpReceive[IRP_MJ_CLEANUP].Microsoft) {
    Status= ((PDRIVER_DISPATCH)IrpReceive[IRP_MJ_CLEANUP].Microsoft)(pDevObj,pIrp);
  }
  return Status;
}

NTSTATUS Margi_IRP_MJ_CREATE_MAILSLOT(PDEVICE_OBJECT pDevObj,PIRP pIrp) {
  NTSTATUS Status;
  DbgDispIrp(pDevObj,pIrp);
  if(IrpReceive[IRP_MJ_CREATE_MAILSLOT].Microsoft) {
    Status= ((PDRIVER_DISPATCH)IrpReceive[IRP_MJ_CREATE_MAILSLOT].Microsoft)(pDevObj,pIrp);
  }
  return Status;
}

NTSTATUS Margi_IRP_MJ_QUERY_SECURITY(PDEVICE_OBJECT pDevObj,PIRP pIrp) {
  NTSTATUS Status;
  DbgDispIrp(pDevObj,pIrp);
  if(IrpReceive[IRP_MJ_QUERY_SECURITY].Microsoft) {
    Status= ((PDRIVER_DISPATCH)IrpReceive[IRP_MJ_QUERY_SECURITY].Microsoft)(pDevObj,pIrp);
  }
  return Status;
}

NTSTATUS Margi_IRP_MJ_SET_SECURITY(PDEVICE_OBJECT pDevObj,PIRP pIrp) {
  NTSTATUS Status;
  DbgDispIrp(pDevObj,pIrp);
  if(IrpReceive[IRP_MJ_SET_SECURITY].Microsoft) {
    Status= ((PDRIVER_DISPATCH)IrpReceive[IRP_MJ_SET_SECURITY].Microsoft)(pDevObj,pIrp);
  }
  return Status;
}

typedef struct Power_s {
  ULONG SystemContext;
  POWER_STATE_TYPE Type;
  POWER_STATE State;
  POWER_ACTION ShutdownType;
};

NTSTATUS Margi_IRP_MJ_POWER(PDEVICE_OBJECT pDevObj,PIRP pIrp) {
  NTSTATUS Status;
  static DWORD dwCnt= 0;
  UCHAR  bDenySuspend;   
  PDEVICE_EXTENSION pdx=(PDEVICE_EXTENSION)pDevObj->DeviceExtension;
  PIO_STACK_LOCATION pIrpStack = IoGetCurrentIrpStackLocation(pIrp);
//  struct Power_s* pPower= (struct Power_s*)&pIrpStack->Parameters.Power;
  POWER_STATE_TYPE PowerType=pIrpStack->Parameters.Power.Type;
  POWER_STATE      PowerState=pIrpStack->Parameters.Power.State;
  dwCnt++;
  DbgDispIrp(pDevObj,pIrp);
  DbgMsg(DBG_CRIT,"PowerIRP IN: Maj=%s, Min=%x ",Ident(ID_IRP,pIrpStack->MajorFunction),pIrpStack->MinorFunction);
  DbgMsg(DBG_CRIT,"Type=%d, State=%d, Cnt=%d \r\n",PowerType,PowerState,dwCnt);
  switch (pIrpStack->MinorFunction)
  {
    case IRP_MN_QUERY_POWER:
      SettingFName(IniNavigatName,IniNavigatSection);
      bDenySuspend = (BYTE) SettingLoad(SET_DWORD,IniDonotSuspend,0,0);
      bDenySuspend = (BYTE)0;
	    if (bDenySuspend) {
          Status = STATUS_UNSUCCESSFUL;
      } else {
          if(IrpReceive[IRP_MJ_POWER].Microsoft)
            Status= ((PDRIVER_DISPATCH)IrpReceive[IRP_MJ_POWER].Microsoft)(pDevObj,pIrp);
          dwCnt--;
	    }
	    break;
    case IRP_MN_SET_POWER:
      if(PowerType==DevicePowerState) {
        if(PowerState.DeviceState!=PowerDeviceD0)
          DevicePrepareForPowerDown(pdx);
      }
      if(IrpReceive[IRP_MJ_POWER].Microsoft)
        Status= ((PDRIVER_DISPATCH)IrpReceive[IRP_MJ_POWER].Microsoft)(pDevObj,pIrp);
      dwCnt--;
      break;
    case IRP_MN_WAIT_WAKE:
  	default:
      if(IrpReceive[IRP_MJ_POWER].Microsoft) {
        Status= ((PDRIVER_DISPATCH)IrpReceive[IRP_MJ_POWER].Microsoft)(pDevObj,pIrp);
	    }
      DbgMsg(DBG_CRIT,"PowerIRP OUT: Maj=%s, Min=%x ",Ident(ID_IRP,pIrpStack->MajorFunction),pIrpStack->MinorFunction);
      dwCnt--;
      break;
  }  
  return Status;
}

NTSTATUS Margi_IRP_MJ_SYSTEM_CONTROL(PDEVICE_OBJECT pDevObj,PIRP pIrp) {
  NTSTATUS Status;
  DbgDispIrp(pDevObj,pIrp);
  if(IrpReceive[IRP_MJ_SYSTEM_CONTROL].Microsoft) {
    Status= ((PDRIVER_DISPATCH)IrpReceive[IRP_MJ_SYSTEM_CONTROL].Microsoft)(pDevObj,pIrp);
  }
  return Status;
}

NTSTATUS Margi_IRP_MJ_DEVICE_CHANGE(PDEVICE_OBJECT pDevObj,PIRP pIrp) {
  NTSTATUS Status;
  DbgDispIrp(pDevObj,pIrp);
  if(IrpReceive[IRP_MJ_DEVICE_CHANGE].Microsoft) {
    Status= ((PDRIVER_DISPATCH)IrpReceive[IRP_MJ_DEVICE_CHANGE].Microsoft)(pDevObj,pIrp);
  }
  return Status;
}

NTSTATUS Margi_IRP_MJ_QUERY_QUOTA(PDEVICE_OBJECT pDevObj,PIRP pIrp) {
  NTSTATUS Status;
  DbgDispIrp(pDevObj,pIrp);
  if(IrpReceive[IRP_MJ_QUERY_QUOTA].Microsoft) {
    Status= ((PDRIVER_DISPATCH)IrpReceive[IRP_MJ_QUERY_QUOTA].Microsoft)(pDevObj,pIrp);
  }
  return Status;
}

NTSTATUS Margi_IRP_MJ_SET_QUOTA(PDEVICE_OBJECT pDevObj,PIRP pIrp) {
  NTSTATUS Status;
  DbgDispIrp(pDevObj,pIrp);
  if(IrpReceive[IRP_MJ_SET_QUOTA].Microsoft) {
    Status= ((PDRIVER_DISPATCH)IrpReceive[IRP_MJ_SET_QUOTA].Microsoft)(pDevObj,pIrp);
  }
  return Status;
}

NTSTATUS Margi_IRP_MJ_PNP_Complete(PDEVICE_OBJECT pDevObj,PIRP pIrp,void* pContext) {
  NTSTATUS Status=0;
  return Status;
}

NTSTATUS Margi_IRP_MJ_PNP(PDEVICE_OBJECT pDevObj,PIRP pIrp) {
  NTSTATUS Status=STATUS_SUCCESS;
  PIO_STACK_LOCATION pIrpStack = IoGetCurrentIrpStackLocation(pIrp);
  PCM_RESOURCE_LIST pCmRscList;
  PIO_RESOURCE_REQUIREMENTS_LIST pIoResourceRequirementList;
  PDEVICE_CAPABILITIES pDevCaps=0;
  PDEVICE_EXTENSION pdx=(PDEVICE_EXTENSION)pDevObj->DeviceExtension;

  DbgDispIrp(pDevObj,pIrp);

  switch(pIrpStack->MinorFunction) {
    case IRP_MN_QUERY_CAPABILITIES:
      pDevCaps=pIrpStack->Parameters.DeviceCapabilities.Capabilities;
      break;
    case IRP_MN_QUERY_DEVICE_RELATIONS:
      break;
    case IRP_MN_FILTER_RESOURCE_REQUIREMENTS:
      pIoResourceRequirementList=pIrpStack->Parameters.FilterResourceRequirements.IoResourceRequirementList;
      pIoResourceRequirementList->List[0].Descriptors[0].u.Port.Length=0x20;
      break;
    case IRP_MN_START_DEVICE:
      pCmRscList=pIrpStack->Parameters.StartDevice.AllocatedResources;
      // activate the interface...
//      Status=IoSetDeviceInterfaceState(&pdx->SymbolicLinkName,TRUE);
      break;
    case IRP_MN_REMOVE_DEVICE:
      // deactivate the interface...
//      Status=IoSetDeviceInterfaceState(&pdx->SymbolicLinkName,FALSE);
//      RtlFreeUnicodeString(&pdx->SymbolicLinkName);
      break;

  }
  if(IrpReceive[IRP_MJ_PNP].Microsoft) {
    Status=((PDRIVER_DISPATCH)IrpReceive[IRP_MJ_PNP].Microsoft)(pDevObj,pIrp);
  }
  if(Status==STATUS_SUCCESS && pDevCaps)
    pDevCaps->SurpriseRemovalOK=0;          // Causes DVD player to apear in Eject Hardware Dialog box.

  return Status;
}

void StealAllIrps(DRIVER_OBJECT *pDrvObj) {
  DWORD dwTemp= 0;
  while(dwTemp<=IRP_MJ_MAXIMUM_FUNCTION+1) {
    if(dwTemp==IrpReceive[dwTemp].dwOffset){
	    if(dwTemp==IRP_MJ_POWER || dwTemp==IRP_MJ_PNP)
      {
        IrpReceive[dwTemp].Microsoft= pDrvObj->MajorFunction[dwTemp];
        pDrvObj->MajorFunction[dwTemp]= IrpReceive[dwTemp].Margi;
      }
    }
    dwTemp++;
  }
  return;
}



/* EOF : STEAL.C */