#include <StrmIni.h>
#include <mmsystem.h>
#include <KsMedia.h>
//#include <ntddk.h>
//#include <basedef.h>
#if(0)
#define DWORD ULONG
#define WORD  USHORT
#define BYTE  UCHAR
#define BOOL  int
#endif

#include "globals.h"
#include "DeviceId.h"
#include "ZvNT.h"
#include "settings.h"
#include "IniNames.h"

// Move to ZVNT
#define   MAXNUMBEROFDEVICE    32
#define TAKEDEVICEID(D)   ((WORD) (D & 0xffff))

typedef struct  tag_SpeSocket
{
  char   sComputerFacture[10];
  WORD   wMfacture;
  WORD   wDeviceId;
} SPECIALSOCKET, PSPECIALSOCKET;

static SPECIALSOCKET  SpecialSocket[] = {
  {"IBMSe", MANUF_ALI, TAKEDEVICEID(DEVICE_ALIM7101) },
  {"Xn500", MANUF_TI,  TAKEDEVICEID(DEVICE_TI1211)   }
};

#define NUM_OF_SPECIALSOCKET  (long)(sizeof(SpecialSocket)/sizeof(SPECIALSOCKET))

typedef struct  tag_Socket
{
  WORD          wMfacture;
  WORD          wDeviceId;	
  BOOL          PcmciaSet;
  DWORD         dwPCIAddr;
  DWORD         dWBaseMemAddr;
  int           nSocket;
  DWORD         dwComReg;
  DWORD         dwTIReg84;
  DWORD         dwTIReg90;
  DWORD         dwTIReg90En;
  DWORD         dwRicoh82f;
  DWORD			    dwCompaqZVState;
  WORD          wESSState;
  BYTE          bCLReg16;
  BYTE          bTopReg3C;
  WORD			    socket1_timing[3];
  WORD			    socket2_timing[3];
  BYTE          fDma;
} SOCKETWIN2K, *PSOCKETWIN2K;

SOCKETWIN2K   SocketWin2k; //, *pSocketWin2k;

typedef struct  tag_IBMAcer
{
  DWORD   dBaseIOAddr;
  DWORD   fSpeSocket;  // Is special socket
  DWORD   dOrigValue[2];
  BOOL    fIsChangeData;
  WORD    wSpeSocket;  // The order of special socket
  BOOL    fSet;
} IBMACERSETTING, IBMACERSETTING;

IBMACERSETTING   SIbmAcerSetting;

void NTSetAudio(DWORD dwNode)
{
  WORD   wWordIn;
  UCHAR  cSetIn;
  WORD   cIOPort=0x224;
  WORD   cIOPort2=0x225;

  WRITE_PORT_UCHAR((PUCHAR) (cIOPort), 0x40);
  wWordIn = (WORD) READ_PORT_UCHAR ((PUCHAR) (cIOPort2)) << 8;
  wWordIn +=(WORD) READ_PORT_UCHAR ((PUCHAR) (cIOPort2));

  // For Es 1879 Audio setting.
  if (wWordIn == 0x1879)
  {
    wWordIn = (WORD) READ_PORT_UCHAR ((PUCHAR) (cIOPort2)) << 8;
	  wWordIn += (WORD) READ_PORT_UCHAR ((PUCHAR) (cIOPort2));
    WRITE_PORT_UCHAR((PUCHAR) (wWordIn), 0x29);
	  wWordIn ++;
    cSetIn = READ_PORT_UCHAR ((PUCHAR) wWordIn);
    cSetIn |= 0x60;
    WRITE_PORT_UCHAR((PUCHAR) wWordIn, cSetIn);
  }
  else if (wWordIn == 0x1879)
  {
    cSetIn = READ_PORT_UCHAR ((PUCHAR) (cIOPort));
    cSetIn |= 0x1;
    WRITE_PORT_UCHAR((PUCHAR) (cIOPort2), cSetIn);
  } 
}



static void ReadPciConfig(SOCKETWIN2K  *pSocketWin2k, int nRegister, DWORD *dZVReg)
{
  ULONG   AddrAdd = 0xcf8;
  ULONG   DataAdd = 0xcfc;

  WRITE_PORT_ULONG((PULONG) AddrAdd, pSocketWin2k->dwPCIAddr + nRegister);
  *dZVReg = READ_PORT_ULONG((PULONG) DataAdd);

}


static void WritePciConfig(SOCKETWIN2K  *pSocketWin2k, int nRegister, DWORD *dZVReg)
{
  ULONG   AddrAdd = 0xcf8;
  ULONG   DataAdd = 0xcfc;

  WRITE_PORT_ULONG((PULONG) AddrAdd, pSocketWin2k->dwPCIAddr + nRegister);
  WRITE_PORT_ULONG((PULONG) DataAdd, *dZVReg);
}



static BOOL Config_TI(SOCKETWIN2K  *pSocketWin2k, ULONG BaseAddr, WORD IOAddr) {

  UCHAR   *add;
  PHYSICAL_ADDRESS    PhysAdd;
  ULONG   Range = 0x900;
  BOOL    Success;
  DWORD   dwZVReg;

  PhysAdd.LowPart = BaseAddr;
  PhysAdd.HighPart = 0;
  pSocketWin2k->dWBaseMemAddr = BaseAddr;

  // Set 16 bits ZV.
  add = (UCHAR*) MmMapIoSpace(PhysAdd, Range, (MEMORY_CACHING_TYPE) FALSE);

  if (((WORD) *(add + 0x808) + (WORD) *(add+0x809) * 0x100) == IOAddr)
  {
    pSocketWin2k->dwComReg = READ_REGISTER_UCHAR((PUCHAR) (add + 0x807));
    pSocketWin2k->PcmciaSet = TRUE;
	  WRITE_REGISTER_UCHAR((PUCHAR)(add+0x802),0x91);   // Make sure 5V
	  WRITE_REGISTER_UCHAR((PUCHAR)(add+0x807),0x01);   // Make sure 16 bit
	  Success = TRUE;
  }
  else
    Success = FALSE;

  MmUnmapIoSpace( add, Range);

  if (!Success)
    return FALSE;
  // Set ZV Slot
  if ((pSocketWin2k->wDeviceId == TAKEDEVICEID(DEVICE_TI1250)) ||
      (pSocketWin2k->wDeviceId == TAKEDEVICEID(DEVICE_TI1251A)) ||
      (pSocketWin2k->wDeviceId == TAKEDEVICEID(DEVICE_TI1251B)) ||
      (pSocketWin2k->wDeviceId == TAKEDEVICEID(DEVICE_TI1450)) ||
      (pSocketWin2k->wDeviceId == TAKEDEVICEID(DEVICE_TI4450)) ||
      (pSocketWin2k->wDeviceId == TAKEDEVICEID(DEVICE_TI1451)) ||
      (pSocketWin2k->wDeviceId == TAKEDEVICEID(DEVICE_TI4451)) )
  {
	  ReadPciConfig(pSocketWin2k, 0x84, &dwZVReg);
    pSocketWin2k->dwTIReg84 = dwZVReg;
    dwZVReg &= ~0x000000C3;
	  dwZVReg |= (DWORD) pSocketWin2k->nSocket ? 0xc2 : 0x81;
	  WritePciConfig(pSocketWin2k, 0x84, &dwZVReg);
  }
  switch(pSocketWin2k->wDeviceId) {
    case TAKEDEVICEID(DEVICE_TI1221):
#ifdef DISABLE_1450_DMA
    case TAKEDEVICEID(DEVICE_TI1450):
    case TAKEDEVICEID(DEVICE_TI4450):
#endif
      pSocketWin2k->fDma=0;
      break;
    default:
      pSocketWin2k->fDma=1;
      break;
  }
  return TRUE;
}


BOOL UnConfig_TI(SOCKETWIN2K  *pSocketWin2k)
{

  UCHAR   *add;
  PHYSICAL_ADDRESS    PhysAdd;
  ULONG         Range = 0x900;
  DWORD   dwZVReg;

  PhysAdd.LowPart = pSocketWin2k->dWBaseMemAddr;
  PhysAdd.HighPart = 0;

  // Set ZV bits.
  add = (UCHAR*) MmMapIoSpace(PhysAdd, Range, (MEMORY_CACHING_TYPE) FALSE);
  pSocketWin2k->PcmciaSet = FALSE;
  WRITE_REGISTER_UCHAR((PUCHAR) (add + 0x807), (UCHAR) pSocketWin2k->dwComReg);
  MmUnmapIoSpace( add, Range);

  if ((pSocketWin2k->wDeviceId == TAKEDEVICEID(DEVICE_TI1250)) ||
      (pSocketWin2k->wDeviceId == TAKEDEVICEID(DEVICE_TI1251A)) ||
      (pSocketWin2k->wDeviceId == TAKEDEVICEID(DEVICE_TI1251B)) ||
      (pSocketWin2k->wDeviceId == TAKEDEVICEID(DEVICE_TI1450)) ||
      (pSocketWin2k->wDeviceId == TAKEDEVICEID(DEVICE_TI4450)) ||
      (pSocketWin2k->wDeviceId == TAKEDEVICEID(DEVICE_TI1451)) ||
      (pSocketWin2k->wDeviceId == TAKEDEVICEID(DEVICE_TI4451)) )
  {
	  dwZVReg = pSocketWin2k->dwTIReg84;
	  WritePciConfig(pSocketWin2k, 0x84, &dwZVReg);
  }
  // Cleanup after Win2k - they appear to leave ZVEnable set and Spkrout clear
  ReadPciConfig(pSocketWin2k,0x90,&dwZVReg);
  dwZVReg &= ~0x00004000;   // Clear ZVENABLE
  dwZVReg |=  0x00000200;   // Set SPKROUT
  WritePciConfig(pSocketWin2k,0x90,&dwZVReg);
 
  return TRUE;
}


static BOOL Config_RICOH(SOCKETWIN2K  *pSocketWin2k, ULONG BaseAddr, WORD IOAddr) {

  UCHAR   *add;
  PHYSICAL_ADDRESS    PhysAdd;
  ULONG         Range = 0x900;
  BOOL    Success;
  UCHAR   TempWord;

  PhysAdd.LowPart = BaseAddr;
  PhysAdd.HighPart = 0;
  pSocketWin2k->dWBaseMemAddr = BaseAddr;

  add = (UCHAR*) MmMapIoSpace(PhysAdd, Range, (MEMORY_CACHING_TYPE) FALSE);

  if (((WORD) *(add + 0x808) + (WORD) *(add+0x809) * 0x100) == IOAddr)
  {

    TempWord = READ_REGISTER_UCHAR((PUCHAR) (add + 0x807));
    pSocketWin2k->dwComReg = TempWord;
	TempWord &= 0xf1;
    TempWord |= 0x8;
	WRITE_REGISTER_UCHAR((PUCHAR) (add + 0x807), TempWord);
    pSocketWin2k->dwRicoh82f = READ_REGISTER_UCHAR((PUCHAR) (add + 0x82f));
	WRITE_REGISTER_UCHAR((PUCHAR) (add + 0x82f), 0x8);
    pSocketWin2k->PcmciaSet = TRUE;
	Success = TRUE;
  }
  else
	Success = FALSE;


  MmUnmapIoSpace( add, Range);

 return Success;
}

static BOOL UnConfig_RICOH(SOCKETWIN2K  *pSocketWin2k){

  UCHAR   *add;
  PHYSICAL_ADDRESS    PhysAdd;
  ULONG         Range = 0x900;

  PhysAdd.LowPart = pSocketWin2k->dWBaseMemAddr;
  PhysAdd.HighPart = 0;

  add = (UCHAR*) MmMapIoSpace(PhysAdd, Range, (MEMORY_CACHING_TYPE) FALSE);
  pSocketWin2k->PcmciaSet = FALSE;

  WRITE_REGISTER_UCHAR((PUCHAR) (add + 0x807), (UCHAR) pSocketWin2k->dwComReg);
  WRITE_REGISTER_UCHAR((PUCHAR) (add + 0x82f), (UCHAR) pSocketWin2k->dwRicoh82f);

  MmUnmapIoSpace( add, Range);

 return TRUE;
}


static BOOL Config_CIRRUS(SOCKETWIN2K  *pSocketWin2k, ULONG BaseAddr, WORD IOAddr) {

  UCHAR   *add;
  PHYSICAL_ADDRESS    PhysAdd;
  ULONG         Range = 0x900;
  BOOL    Success;

  PhysAdd.LowPart = BaseAddr;
  PhysAdd.HighPart = 0;
  pSocketWin2k->dWBaseMemAddr = BaseAddr;

  // Set 16 bits ZV.
  add = (UCHAR*) MmMapIoSpace(PhysAdd, Range, (MEMORY_CACHING_TYPE) FALSE);

  if (((WORD) *(add + 0x808) + (WORD) *(add+0x809) * 0x100) == IOAddr)
  {
    pSocketWin2k->dwComReg = READ_REGISTER_UCHAR((PUCHAR) (add + 0x807));
    pSocketWin2k->PcmciaSet = TRUE;
	WRITE_REGISTER_UCHAR((PUCHAR) (add + 0x807), 0x01);
	Success = TRUE;
  }
  else
	Success = FALSE;

  MmUnmapIoSpace( add, Range);

  if (Success == FALSE)
	return FALSE;

 return TRUE;
}


BOOL UnConfig_CIRRUS(SOCKETWIN2K  *pSocketWin2k)
{

  UCHAR   *add;
  PHYSICAL_ADDRESS    PhysAdd;
  ULONG         Range = 0x900;

  PhysAdd.LowPart = pSocketWin2k->dWBaseMemAddr;
  PhysAdd.HighPart = 0;

  // Set ZV bits.
  add = (UCHAR*) MmMapIoSpace(PhysAdd, Range, (MEMORY_CACHING_TYPE) FALSE);
  pSocketWin2k->PcmciaSet = FALSE;
  WRITE_REGISTER_UCHAR((PUCHAR) (add + 0x807), (UCHAR) pSocketWin2k->dwComReg);
  MmUnmapIoSpace( add, Range);

 return TRUE;
}


static BOOL Config_TOSHIBA(SOCKETWIN2K  *pSocketWin2k, ULONG BaseAddr, WORD IOAddr) {

  UCHAR   *add;
  PHYSICAL_ADDRESS    PhysAdd;
  ULONG         Range = 0x900;
  BOOL    Success;

  PhysAdd.LowPart = BaseAddr;
  PhysAdd.HighPart = 0;
  pSocketWin2k->dWBaseMemAddr = BaseAddr;

  // Set 16 bits ZV.
  add = (UCHAR*) MmMapIoSpace(PhysAdd, Range, (MEMORY_CACHING_TYPE) FALSE);

  if (((WORD) *(add + 0x808) + (WORD) *(add+0x809) * 0x100) == IOAddr)
  {
    pSocketWin2k->dwComReg = READ_REGISTER_UCHAR((PUCHAR) (add + 0x807));
    pSocketWin2k->PcmciaSet = TRUE;
	WRITE_REGISTER_UCHAR((PUCHAR) (add + 0x807), 0x01);
	Success = TRUE;
  }
  else
	Success = FALSE;

  MmUnmapIoSpace( add, Range);

  if (Success == FALSE)
	return FALSE;

 return TRUE;
}


static BOOL UnConfig_TOSHIBA(SOCKETWIN2K  *pSocketWin2k)
{

  UCHAR   *add;
  PHYSICAL_ADDRESS    PhysAdd;
  ULONG         Range = 0x900;

  PhysAdd.LowPart = pSocketWin2k->dWBaseMemAddr;
  PhysAdd.HighPart = 0;

  // Set ZV bits.
  add = (UCHAR*) MmMapIoSpace(PhysAdd, Range, (MEMORY_CACHING_TYPE) FALSE);
  pSocketWin2k->PcmciaSet = FALSE;
  WRITE_REGISTER_UCHAR((PUCHAR) (add + 0x807), (UCHAR) pSocketWin2k->dwComReg);
  MmUnmapIoSpace( add, Range);

 return TRUE;
}

static BOOL Config_SMC(SOCKETWIN2K  *pSocketWin2k, ULONG BaseAddr, WORD IOAddr) {

  UCHAR   *add;
  PHYSICAL_ADDRESS    PhysAdd;
  ULONG         Range = 0x900;
  BOOL    Success;

  PhysAdd.LowPart = BaseAddr;
  PhysAdd.HighPart = 0;
  pSocketWin2k->dWBaseMemAddr = BaseAddr;

  // Set 16 bits ZV.
  add = (UCHAR*) MmMapIoSpace(PhysAdd, Range, (MEMORY_CACHING_TYPE) FALSE);

  if (((WORD) *(add + 0x808) + (WORD) *(add+0x809) * 0x100) == IOAddr)
  {
    pSocketWin2k->dwComReg = READ_REGISTER_UCHAR((PUCHAR) (add + 0x807));
    pSocketWin2k->PcmciaSet = TRUE;
	WRITE_REGISTER_UCHAR((PUCHAR) (add + 0x807), 0x01);
	Success = TRUE;
  }
  else
	Success = FALSE;

  MmUnmapIoSpace( add, Range);

  if (Success == FALSE)
	return FALSE;

 return TRUE;
}


static BOOL UnConfig_SMC(SOCKETWIN2K  *pSocketWin2k)
{

  UCHAR   *add;
  PHYSICAL_ADDRESS    PhysAdd;
  ULONG         Range = 0x900;

  PhysAdd.LowPart = pSocketWin2k->dWBaseMemAddr;
  PhysAdd.HighPart = 0;

  // Set ZV bits.
  add = (UCHAR*) MmMapIoSpace(PhysAdd, Range, (MEMORY_CACHING_TYPE) FALSE);
  pSocketWin2k->PcmciaSet = FALSE;
  WRITE_REGISTER_UCHAR((PUCHAR) (add + 0x807), (UCHAR) pSocketWin2k->dwComReg);
  MmUnmapIoSpace( add, Range);

 return TRUE;
}

static BOOL Config_O2(SOCKETWIN2K  *pSocketWin2k, ULONG BaseAddr, WORD IOAddr) {

  UCHAR   *add;
  PHYSICAL_ADDRESS    PhysAdd;
  ULONG         Range = 0x900;
  BOOL    Success;

  PhysAdd.LowPart = BaseAddr;
  PhysAdd.HighPart = 0;
  pSocketWin2k->dWBaseMemAddr = BaseAddr;

  // Set 16 bits ZV.
  add = (UCHAR*) MmMapIoSpace(PhysAdd, Range, (MEMORY_CACHING_TYPE) FALSE);

  if (((WORD) *(add + 0x808) + (WORD) *(add+0x809) * 0x100) == IOAddr)
  {
    pSocketWin2k->dwComReg = READ_REGISTER_UCHAR((PUCHAR) (add + 0x807));
    pSocketWin2k->PcmciaSet = TRUE;
	WRITE_REGISTER_UCHAR((PUCHAR) (add + 0x807), 0x01);
	Success = TRUE;
  }
  else
	Success = FALSE;

  MmUnmapIoSpace( add, Range);

  if (Success == FALSE)
	return FALSE;

 return TRUE;
}


static BOOL UnConfig_O2(SOCKETWIN2K  *pSocketWin2k)
{

  UCHAR   *add;
  PHYSICAL_ADDRESS    PhysAdd;
  ULONG         Range = 0x900;

  PhysAdd.LowPart = pSocketWin2k->dWBaseMemAddr;
  PhysAdd.HighPart = 0;

  // Set ZV bits.
  add = (UCHAR*) MmMapIoSpace(PhysAdd, Range, (MEMORY_CACHING_TYPE) FALSE);
  pSocketWin2k->PcmciaSet = FALSE;
  WRITE_REGISTER_UCHAR((PUCHAR) (add + 0x807), (UCHAR) pSocketWin2k->dwComReg);
  MmUnmapIoSpace( add, Range);

 return TRUE;
}

static BOOL Config_TRIDENT(SOCKETWIN2K  *pSocketWin2k, ULONG BaseAddr, WORD IOAddr) {

  UCHAR   *add;
  PHYSICAL_ADDRESS    PhysAdd;
  ULONG         Range = 0x900;
  BOOL    Success;

  PhysAdd.LowPart = BaseAddr;
  PhysAdd.HighPart = 0;
  pSocketWin2k->dWBaseMemAddr = BaseAddr;

  // Set 16 bits ZV.
  add = (UCHAR*) MmMapIoSpace(PhysAdd, Range, (MEMORY_CACHING_TYPE) FALSE);

  if (((WORD) *(add + 0x808) + (WORD) *(add+0x809) * 0x100) == IOAddr)
  {
    pSocketWin2k->dwComReg = READ_REGISTER_UCHAR((PUCHAR) (add + 0x807));
    pSocketWin2k->PcmciaSet = TRUE;
	WRITE_REGISTER_UCHAR((PUCHAR) (add + 0x807), 0x01);
	Success = TRUE;
  }
  else
	Success = FALSE;

  MmUnmapIoSpace( add, Range);

  if (Success == FALSE)
	return FALSE;

 return TRUE;
}


static BOOL UnConfig_TRIDENT(SOCKETWIN2K  *pSocketWin2k)
{

  UCHAR   *add;
  PHYSICAL_ADDRESS    PhysAdd;
  ULONG         Range = 0x900;

  PhysAdd.LowPart = pSocketWin2k->dWBaseMemAddr;
  PhysAdd.HighPart = 0;

  // Set ZV bits.
  add = (UCHAR*) MmMapIoSpace(PhysAdd, Range, (MEMORY_CACHING_TYPE) FALSE);
  pSocketWin2k->PcmciaSet = FALSE;
  WRITE_REGISTER_UCHAR((PUCHAR) (add + 0x807), (UCHAR) pSocketWin2k->dwComReg);
  MmUnmapIoSpace( add, Range);

 return TRUE;
}

#define  NMA2DEFAULAUDIOADR   0x320
static BOOL Config_NM2Audio()
{
  WORD   NMA2Adr;
  NMA2Adr = (WORD) SettingLoad(SET_DWORD, IniAudioAdr, NULL, NMA2DEFAULAUDIOADR);
  outp(NMA2Adr, (BYTE) 0x18);
  outp(NMA2Adr + 1, (BYTE) 0x00);
  outp(NMA2Adr, (BYTE) 0x02);
  outp(NMA2Adr + 1, (BYTE) 0x01);

  return  TRUE;
}


static BOOL SetSocket(SOCKETWIN2K  *pSocketWin2k, ULONG BaseAddr, WORD IOAddr) 
{
  switch (pSocketWin2k->wMfacture)
  {
    case  MANUF_RICOH:  return Config_RICOH(pSocketWin2k, BaseAddr, IOAddr);
    case  MANUF_CIRRUS: return Config_CIRRUS(pSocketWin2k, BaseAddr, IOAddr);
    case  MANUF_TOSHIBA:return Config_TOSHIBA(pSocketWin2k, BaseAddr, IOAddr);
    case  MANUF_SMC:    return Config_SMC(pSocketWin2k, BaseAddr, IOAddr);
    case  MANUF_O2: 	  return Config_O2(pSocketWin2k, BaseAddr, IOAddr);
    case  MANUF_TRIDENT:return Config_TRIDENT(pSocketWin2k, BaseAddr, IOAddr);
    case  MANUF_TI :    return Config_TI(pSocketWin2k, BaseAddr, IOAddr);
  }
  return TRUE;
}



//  0000ffff    Manufacture.
//  ffff0000    Device
static BOOL CheckValidSocket(SOCKETWIN2K  *pSocketWin2k)
{
  if (pSocketWin2k->wMfacture == MANUF_TI) 
  {
	  if ((pSocketWin2k->wDeviceId == TAKEDEVICEID(DEVICE_TI1031)) ||
        (pSocketWin2k->wDeviceId == TAKEDEVICEID(DEVICE_TI1130)) || 
        (pSocketWin2k->wDeviceId == TAKEDEVICEID(DEVICE_TI1131)) ||
        (pSocketWin2k->wDeviceId == TAKEDEVICEID(DEVICE_TI1220)) ||
        (pSocketWin2k->wDeviceId == TAKEDEVICEID(DEVICE_TI1250)) ||
        (pSocketWin2k->wDeviceId == TAKEDEVICEID(DEVICE_TI1260)) ||
        (pSocketWin2k->wDeviceId == TAKEDEVICEID(DEVICE_TI1221)) ||
        (pSocketWin2k->wDeviceId == TAKEDEVICEID(DEVICE_TI1210)) ||
        (pSocketWin2k->wDeviceId == TAKEDEVICEID(DEVICE_TI1211)) ||
        (pSocketWin2k->wDeviceId == TAKEDEVICEID(DEVICE_TI1225)) ||
        (pSocketWin2k->wDeviceId == TAKEDEVICEID(DEVICE_TI1251A)) ||
        (pSocketWin2k->wDeviceId == TAKEDEVICEID(DEVICE_TI1251B)) ||
        (pSocketWin2k->wDeviceId == TAKEDEVICEID(DEVICE_TI1450)) ||
        (pSocketWin2k->wDeviceId == TAKEDEVICEID(DEVICE_TI1410)) ||
        (pSocketWin2k->wDeviceId == TAKEDEVICEID(DEVICE_TI1420)) ||
        (pSocketWin2k->wDeviceId == TAKEDEVICEID(DEVICE_TI1421)) ||
        (pSocketWin2k->wDeviceId == TAKEDEVICEID(DEVICE_TI1451)) ||
        (pSocketWin2k->wDeviceId == TAKEDEVICEID(DEVICE_TI4410)) ||
        (pSocketWin2k->wDeviceId == TAKEDEVICEID(DEVICE_TI4450)) ||
        (pSocketWin2k->wDeviceId == TAKEDEVICEID(DEVICE_TI4451)) ||
        (pSocketWin2k->wDeviceId == TAKEDEVICEID(DEVICE_TI4510)) ||
        (pSocketWin2k->wDeviceId == TAKEDEVICEID(DEVICE_TI4550)) ||
        (pSocketWin2k->wDeviceId == TAKEDEVICEID(DEVICE_TI4620)))
	  {
	    return  TRUE;
	  }
  }
  else if (pSocketWin2k->wMfacture == MANUF_RICOH) 
  {
	  if ((pSocketWin2k->wDeviceId == TAKEDEVICEID(DEVICE_RL5C465)) || 
        (pSocketWin2k->wDeviceId == TAKEDEVICEID(DEVICE_RL5C466)) ||
        (pSocketWin2k->wDeviceId == TAKEDEVICEID(DEVICE_RL5C475)) ||
        (pSocketWin2k->wDeviceId == TAKEDEVICEID(DEVICE_RL5C476)) ||
        (pSocketWin2k->wDeviceId == TAKEDEVICEID(DEVICE_RL5C478)) )
	  {
	    return TRUE;
	  }
  }
  else if (pSocketWin2k->wMfacture == MANUF_CIRRUS)
  {
  	if ((pSocketWin2k->wDeviceId == TAKEDEVICEID(DEVICE_6729)) || 
        (pSocketWin2k->wDeviceId == TAKEDEVICEID(DEVICE_6832))  )
	  {
	    return TRUE;
	  }
  }
  else if (pSocketWin2k->wMfacture == MANUF_TOSHIBA) 
  {
  	if ((pSocketWin2k->wDeviceId == TAKEDEVICEID(DEVICE_TOPIC)) || 
        (pSocketWin2k->wDeviceId == TAKEDEVICEID(DEVICE_TOPIC95)) ||
        (pSocketWin2k->wDeviceId == TAKEDEVICEID(DEVICE_TOPIC97)) )
    {
	    return TRUE;
    }
  }
  else if (pSocketWin2k->wMfacture == MANUF_SMC) 
  {
	if ((pSocketWin2k->wDeviceId == TAKEDEVICEID(DEVICE_DATABOOK)) || 
        (pSocketWin2k->wDeviceId == TAKEDEVICEID(DEVICE_SMC)) )
    {
	    return TRUE;
    }
  }
  else if (pSocketWin2k->wMfacture == MANUF_O2) 
  {
    if((pSocketWin2k->wDeviceId == TAKEDEVICEID(DEVICE_O26729)) || 
       (pSocketWin2k->wDeviceId == TAKEDEVICEID(DEVICE_O2673A)) ||
       (pSocketWin2k->wDeviceId == TAKEDEVICEID(DEVICE_O26812)) ||
       (pSocketWin2k->wDeviceId == TAKEDEVICEID(DEVICE_O26832)) ||
       (pSocketWin2k->wDeviceId == TAKEDEVICEID(DEVICE_O26834)) ||
       (pSocketWin2k->wDeviceId == TAKEDEVICEID(DEVICE_O26836)) || 
       (pSocketWin2k->wDeviceId == TAKEDEVICEID(DEVICE_O26860)) ||
       (pSocketWin2k->wDeviceId == TAKEDEVICEID(DEVICE_O26912)) ||
       (pSocketWin2k->wDeviceId == TAKEDEVICEID(DEVICE_O26933)) )
       return TRUE;
  }
  else if (pSocketWin2k->wMfacture == MANUF_TRIDENT) 
  {
    if ((pSocketWin2k->wDeviceId == TAKEDEVICEID(DEVICE_TRIDENT)) )
    {
	    return TRUE;
    }
  }
  return  FALSE;
}


BOOL EnableIBMAcer()
{
  ULONG   CfgIx = 0xcf8;
  ULONG   CfgDat= 0xcfc;
  ULONG   OutData;
  WORD    wIndex;
  DWORD   bTemData;
  DWORD   dFactory;
  if ((!SIbmAcerSetting.fSpeSocket) || (SIbmAcerSetting.fSet))
    return FALSE;
  SettingFName(IniFName,IniSection);
  dFactory=SettingLoad(SET_DWORD,InitSFactory,0,0);
  if (dFactory)
  {
    wIndex = SIbmAcerSetting.wSpeSocket;
    SIbmAcerSetting.fIsChangeData = FALSE;
    switch (wIndex)
    {
      case  0:  // IBM Series
        WRITE_PORT_ULONG((PULONG)CfgIx,SIbmAcerSetting.dBaseIOAddr + 0xc0);
        OutData = READ_PORT_ULONG((PULONG)CfgDat);
        SIbmAcerSetting.dOrigValue[0] = OutData;
        if (OutData & 0x2000)
        {
          OutData &= 0xFFFFDFFF;
          WRITE_PORT_ULONG((PULONG)CfgDat,OutData);
          SIbmAcerSetting.fIsChangeData = TRUE;
        }
        break;
      case  1:  // Xn500
        WRITE_PORT_ULONG((PULONG)CfgIx,SIbmAcerSetting.dBaseIOAddr + 0x8c);
        bTemData = READ_PORT_ULONG((PULONG)CfgDat);
        SIbmAcerSetting.dOrigValue[0] = bTemData;
        if (!(bTemData & 0x100))
        {
          bTemData |= 0x100;
          WRITE_PORT_ULONG((PULONG)CfgDat,bTemData);
          SIbmAcerSetting.fIsChangeData = TRUE;
        }        
        WRITE_PORT_ULONG((PULONG)CfgIx,SIbmAcerSetting.dBaseIOAddr + 0xac);
        bTemData = READ_PORT_ULONG((PULONG)CfgDat);
        SIbmAcerSetting.dOrigValue[1] = bTemData;
        if (bTemData & 0x40000)
        {
          bTemData &= 0xFFFBFFFF;
          WRITE_PORT_ULONG((PULONG)CfgDat,bTemData);
          SIbmAcerSetting.fIsChangeData = TRUE;
        }
        break;
      default:  return FALSE;
    }
    SIbmAcerSetting.fSet = FALSE;
  }
  else
  {
    SIbmAcerSetting.fSpeSocket = FALSE;
  }
  return  TRUE;
}

BOOL DisnableIBMAcer()
{
  ULONG   CfgIx = 0xcf8;
  ULONG   CfgDat= 0xcfc;
  WORD    wIndex;

  if (SIbmAcerSetting.fSpeSocket && SIbmAcerSetting.fIsChangeData)
  {
    wIndex = SIbmAcerSetting.wSpeSocket;
    switch (wIndex)
    {
      case  0:  // IBM Series
        WRITE_PORT_ULONG((PULONG)CfgIx,SIbmAcerSetting.dBaseIOAddr + 0xc0);
        WRITE_PORT_ULONG((PULONG)CfgDat,SIbmAcerSetting.dOrigValue[0]);
        SIbmAcerSetting.fIsChangeData = FALSE;
        break;
      case  1:  //Xn500
        WRITE_PORT_ULONG((PULONG)CfgIx,SIbmAcerSetting.dBaseIOAddr + 0x8c);
        WRITE_PORT_ULONG((PULONG)CfgDat,SIbmAcerSetting.dOrigValue[0]);
        WRITE_PORT_ULONG((PULONG)CfgIx,SIbmAcerSetting.dBaseIOAddr + 0xac);
        WRITE_PORT_ULONG((PULONG)CfgDat,SIbmAcerSetting.dOrigValue[1]);
        SIbmAcerSetting.fIsChangeData = FALSE;
        break;
    }
  }
  return  TRUE;
}


DWORD NTGetSocket(WORD dlIoAddr)
{
  ULONG   CfgIx = 0xcf8;
  ULONG   CfgDat= 0xcfc;
  ULONG   OutData, PhysAdd;
  PSOCKETWIN2K pSocketWin2k;
  BOOL fVFound = 0;
  BOOL fAfound = 0;
  DWORD   DwPCIAddr;
  ULONG   Bus,Dev,Func;

  pSocketWin2k= &SocketWin2k;
  memset(pSocketWin2k,0,sizeof(*pSocketWin2k));

  // Search for Known Socket Controller on PCI Bus 0
  for (fVFound=Bus=Dev=0;!fVFound&&(Dev<MAXNUMBEROFDEVICE);Dev++)
  {
    for(Func=0;!fVFound&&(Func<3);Func++) {
	    pSocketWin2k->dwPCIAddr=0x80000000|(Bus<<16)|(Dev<<11)|(Func<<8); 
	    WRITE_PORT_ULONG((PULONG)CfgIx,pSocketWin2k->dwPCIAddr);
      OutData = READ_PORT_ULONG((PULONG)CfgDat);
      pSocketWin2k->wMfacture=(WORD)(OutData & 0xffff);
      pSocketWin2k->wDeviceId=(WORD)((OutData & 0xffff0000) >> 16); 
      // Check if PCI device is Known PCMCIA Socket Controller
      if (CheckValidSocket(pSocketWin2k))
      {
        //Get ExCA base address
	      WRITE_PORT_ULONG((PULONG)CfgIx,pSocketWin2k->dwPCIAddr+0x10);
        PhysAdd = READ_PORT_ULONG((PULONG)CfgDat);
        pSocketWin2k->nSocket=(int)Func;
        if(SetSocket(pSocketWin2k,PhysAdd,dlIoAddr)) {
          fVFound=1;
        }
      } else
        Func=4;
    }
  }

  GetSpecialSocket(dlIoAddr);

  for(Bus =1,Dev=0,Func=1; (!fAfound) && (Func<3); Func++) 
  {
    DwPCIAddr=0x80000000|(Bus<<16)|(Dev<<11)|(Func<<8); 
	WRITE_PORT_ULONG((PULONG)CfgIx,DwPCIAddr);
    OutData = READ_PORT_ULONG((PULONG)CfgDat);

    if (((WORD) (OutData & 0xffff) == MANUF_NEO) && 
       ((WORD) ((OutData & 0xffff0000) >> 16)) == TAKEDEVICEID(DEVICE_NMA2))
    {
        Config_NM2Audio();
       fAfound = 1;
    }
  }
  return (DWORD)pSocketWin2k;
}

int CheckSpecialSocket(DWORD  OutData)
{
  int  i;
  for (i = 0; i < NUM_OF_SPECIALSOCKET; i++)
  {
    if (((WORD) (OutData & 0xffff) == SpecialSocket[i].wMfacture) && 
       ((WORD) ((OutData & 0xffff0000) >> 16)) == SpecialSocket[i].wDeviceId)
    {
      SIbmAcerSetting.wSpeSocket = i;
      return TRUE;
    }
  }
  return  FALSE;
}

BOOL GetSpecialSocket(WORD dlIoAddr)
{
  ULONG   CfgIx = 0xcf8;
  ULONG   CfgDat= 0xcfc;
  ULONG   OutData;
  BOOL    fVFound = 0;
  DWORD   DwPCIAddr;
  ULONG   Bus,Dev,Func;

  for(fVFound=Bus=Dev=0;!fVFound&&(Dev<MAXNUMBEROFDEVICE);Dev++)
  {
    for(Func=0;!fVFound&&(Func<3);Func++) 
    {
      DwPCIAddr=0x80000000|(Bus<<16)|(Dev<<11)|(Func<<8); 
      WRITE_PORT_ULONG((PULONG)CfgIx,DwPCIAddr);
      OutData = READ_PORT_ULONG((PULONG)CfgDat);
      if (CheckSpecialSocket(OutData))
      {
        SIbmAcerSetting.dBaseIOAddr = DwPCIAddr;
        SIbmAcerSetting.fSpeSocket = TRUE;
        SIbmAcerSetting.fSet = FALSE;
        fVFound=1;
      }
      else
        fVFound=0;
    }
  }

  if (!fVFound) SIbmAcerSetting.fSpeSocket = FALSE;
  return  TRUE;
}

int  NTCheckDma(DWORD dwNode) {
  PSOCKETWIN2K pSocketWin2k=(PSOCKETWIN2K)dwNode;
  return pSocketWin2k->fDma;
}

int NTConfigDma(DWORD dwNode, DWORD dwIoBase) {
  ULONG   CfgIx = 0xcf8;
  ULONG   CfgDat= 0xcfc;
  PSOCKETWIN2K pSocketWin2k=(PSOCKETWIN2K)dwNode;

  WRITE_PORT_ULONG((PULONG)CfgIx,pSocketWin2k->dwPCIAddr+0x94);
  WRITE_PORT_ULONG((PULONG)CfgDat,0);

  WRITE_PORT_ULONG((PULONG)CfgIx,pSocketWin2k->dwPCIAddr+0x98);
  WRITE_PORT_ULONG((PULONG)CfgDat,dwIoBase|3);
  return 1;
}

void NTReleaseDma(DWORD dwNode) {
  ULONG   CfgIx = 0xcf8;
  ULONG   CfgDat= 0xcfc;
  PSOCKETWIN2K pSocketWin2k=(PSOCKETWIN2K)dwNode;

  if(pSocketWin2k->fDma) {
    WRITE_PORT_ULONG((PULONG)CfgIx,pSocketWin2k->dwPCIAddr+0x94);
    WRITE_PORT_ULONG((PULONG)CfgDat,0);

    WRITE_PORT_ULONG((PULONG)CfgIx,pSocketWin2k->dwPCIAddr+0x98);
    WRITE_PORT_ULONG((PULONG)CfgDat,0);
    pSocketWin2k->fDma=0;
  }
}

BOOL NTReleaseSocket(DWORD dwNode)
{
  PSOCKETWIN2K pSocketWin2k=(PSOCKETWIN2K)dwNode;

  if (pSocketWin2k==0 || !pSocketWin2k->PcmciaSet)
	  return TRUE;

  NTReleaseDma(dwNode);

  switch (pSocketWin2k->wMfacture)
  {
    case  MANUF_RICOH:
	  return UnConfig_RICOH(pSocketWin2k);
    case  MANUF_CIRRUS:
	  return UnConfig_CIRRUS(pSocketWin2k);
    case  MANUF_TOSHIBA:
	  return UnConfig_TOSHIBA(pSocketWin2k);
    case  MANUF_SMC:
	  return UnConfig_SMC(pSocketWin2k);
    case  MANUF_O2:
	  return UnConfig_O2(pSocketWin2k);
    case  MANUF_TRIDENT:
	  return UnConfig_TRIDENT(pSocketWin2k);
    case  MANUF_TI :
      return UnConfig_TI(pSocketWin2k);
//	case  MANUF_ESS:
//	  break;
  }

 return TRUE;
}


//  0000ffff    Manufacture.
//  ffff0000    Device
static BOOL CheckValidVga(SVGAVENDER *pVgaVender, BOOL *pMnufactory)
{
  if (pVgaVender->wMfacture == MANUF_ATI) 
  {
	  if (pVgaVender->wDeviceId == DEVICE_RAGE || pVgaVender->wDeviceId == DEVICE_MOBILITY)
	  {
        *pMnufactory = ATIDMA;
	    return  TRUE;
	  }
  }
  else if (pVgaVender->wMfacture == MANUF_NEO) 
  {
	  if (pVgaVender->wDeviceId == DEVICE_NMG5 || pVgaVender->wDeviceId == DEVICE_NMG6)
	  {
        *pMnufactory = NEOMAGIC;
	    return TRUE;
	  }
  }
  else if (pVgaVender->wMfacture == MANUF_S3)
  {
	  if (pVgaVender->wDeviceId == DEVICE_SAVAGE_8c12 || pVgaVender->wDeviceId == DEVICE_SAVAGE_8c10)
	  {
        *pMnufactory = S3SAVAGE;
	    return TRUE;
	  }
  }

  return  FALSE;
}

// Return  0,  ATI  use busMaster
// Return  1,  NeoMagic   use CPU.
// Retrrn  10,  No VGA find.
int GetVgaVender(WORD dlIoAddr)
{
  ULONG   CfgIx = 0xcf8;
  ULONG   CfgDat= 0xcfc;
  ULONG   OutData;
  SVGAVENDER  VgaVender;
  int     pMnufactory;
  ULONG   Bus,Dev,Func;
  Func = 0;
  memset(&VgaVender,0,sizeof(SVGAVENDER));

  // Search for known VGA on PCI Bus 0 or 1
  for (Bus = 0; Bus < 4; Bus ++)
  {
    for (Dev = 0; Dev < MAXNUMBEROFDEVICE;Dev++)
    {
	    VgaVender.dwPCIAddr=0x80000000|(Bus<<16)|(Dev<<11)|(Func<<8);
	    WRITE_PORT_ULONG((PULONG)CfgIx,VgaVender.dwPCIAddr);
        OutData = READ_PORT_ULONG((PULONG)CfgDat);
        VgaVender.wMfacture=(WORD)(OutData & 0xffff);
        VgaVender.wDeviceId=(WORD)((OutData & 0xffff0000) >> 16); 
        // Check if VGA device is known
        if (CheckValidVga(&VgaVender, &pMnufactory))
        {
          return (pMnufactory);
        }
    }
  }
  return UNKNOW;
}
