#include <StrmIni.h>
#include <mmsystem.h>
#include <KsMedia.h>
#include "MidasApi.h"
#include "Globals.h"

static void CPGet_ChlgKey(SRB* pSrb);
static void CPSet_DecKey2(SRB* pSrb);
static void CPGet_DecKey2(SRB* pSrb);
static void CPGet_Region(SRB* pSrb);
static void CPSet_ChlgKey(SRB* pSrb);
static void CPSet_DVDkey1(SRB* pSrb);
static void CPSet_TitleKey(SRB* pSrb);
static void CPSet_DiscKey(SRB* pSrb);
static void CPGet_CopyState(SRB* pSrb);
static int  CPSet_CopyState(SRB* pSrb);
static void CPGet_CopyDVDKey1(SRB* pSrb);
static void CPGet_CopyDVDKey2(SRB* pSrb);
static void CPGet_CopyTitleKey(SRB* pSrb);
static void CPGet_CopyDiscKey(SRB* pSrb);
static void CPSet_CopyState_Initialize(SRB* pSrb);
static void CPSet_CopyState_Default(SRB* pSrb);
static int  CPSet_CopyState_InitializeTitle(SRB* pSrb);
static void CPSet_CopyState_Initialize_LowPriority(SRB* pSrb);
static int  CPSet_CopyState_Required(SRB* pSrb);

void CopyProtectionGet(PHW_STREAM_REQUEST_BLOCK pSrb) {
  switch(pSrb->CommandData.PropertyInfo->Property->Id) {
    case KSPROPERTY_DVDCOPY_CHLG_KEY:   CPGet_ChlgKey(pSrb); break;
    case KSPROPERTY_DVDCOPY_DEC_KEY2:   CPGet_DecKey2(pSrb); break;
    case KSPROPERTY_DVDCOPY_REGION:     CPGet_Region(pSrb); break;
    case KSPROPERTY_DVDCOPY_SET_COPY_STATE: CPGet_CopyState(pSrb); break;
    case KSPROPERTY_DVDCOPY_DVD_KEY1:   CPGet_CopyDVDKey1(pSrb); break;
    case KSPROPERTY_DVDCOPY_TITLE_KEY:  CPGet_CopyTitleKey(pSrb); break;
    case KSPROPERTY_DVDCOPY_DISC_KEY:   CPGet_CopyDiscKey(pSrb); break;
  }
}

int CopyProtectionSet(PHW_STREAM_REQUEST_BLOCK pSrb) {
  int fSignaled=0;
  switch(pSrb->CommandData.PropertyInfo->Property->Id) {
    case KSPROPERTY_DVDCOPY_CHLG_KEY:   CPSet_ChlgKey(pSrb); break;
    case KSPROPERTY_DVDCOPY_DVD_KEY1:   CPSet_DVDkey1(pSrb); break;
    case KSPROPERTY_DVDCOPY_DEC_KEY2:   CPSet_DecKey2(pSrb); break;
    case KSPROPERTY_DVDCOPY_TITLE_KEY:  CPSet_TitleKey(pSrb); break;
    case KSPROPERTY_DVDCOPY_DISC_KEY:   CPSet_DiscKey(pSrb); break;
    case KSPROPERTY_DVDCOPY_SET_COPY_STATE: fSignaled=CPSet_CopyState(pSrb); break;
  }
  return fSignaled;
}

static int CPSet_CopyState(SRB* pSrb) {
  int fSignaled=0;
  PKS_DVDCOPY_SET_COPY_STATE pCopyState;
  pCopyState = (PKS_DVDCOPY_SET_COPY_STATE)pSrb->CommandData.PropertyInfo->PropertyInfo;
  pSrb->Status = STATUS_SUCCESS;
  switch(pCopyState->DVDCopyState) {
    case KS_DVDCOPYSTATE_INITIALIZE:          CPSet_CopyState_Initialize(pSrb); break;
    case KS_DVDCOPYSTATE_INITIALIZE_TITLE:    if(CPSet_CopyState_InitializeTitle(pSrb)==0)
                                                fSignaled=1;
                                              break;
    case KS_DVDCOPYSTATE_AUTHENTICATION_NOT_REQUIRED:
    case KS_DVDCOPYSTATE_AUTHENTICATION_REQUIRED:
                                              CPSet_CopyState_Required(pSrb); 
                                              break;  
    default:                                  CPSet_CopyState_Default(pSrb); break;
  }
  return fSignaled;
}

ULONGLONG LastInitTime=0;
ULONGLONG LastLPInitTime=0;
ULONGLONG LastInitTitle=0;
ULONGLONG LastSetTitle=0;

#if(1)
static void CPSet_CopyState_Initialize(SRB* pSrb) {
  PDEVICE_EXTENSION pDevice= pSrb->HwDeviceExtension;
  pSrb->Status= STATUS_PENDING;
  KeQuerySystemTime((PLARGE_INTEGER)&LastInitTime);

  StreamClassCallAtNewPriority(pSrb->StreamObject,pDevice,Low,CPSet_CopyState_Initialize_LowPriority,pSrb);
}

static void CPSet_CopyState_Initialize_LowPriority(SRB* pSrb) {
  PDEVICE_EXTENSION pDevice=(PDEVICE_EXTENSION)pSrb->HwDeviceExtension;
  PSTREAM_EXTENSION pStream=(PSTREAM_EXTENSION)pSrb->StreamObject->HwStreamExtension;
  MIDASCMD Cmd;
  KeQuerySystemTime((PLARGE_INTEGER)&LastLPInitTime);
  
  // Init Midas CSS 
  Cmd.hMidas=pDevice->hMidas;
  Cmd.cmd = MDS_CSS_INITHW;
  Cmd.wCurrStream= pStream->internal_streamid;
  MidasEntry(&Cmd);

  // Enable Midas CSS
  Cmd.hMidas=pDevice->hMidas;
  Cmd.cmd= MDS_CSS_ENABLE_CHANNEL;
  Cmd.u.M.Arg1=1;
  Cmd.u.M.Arg2=0;
  MidasEntry(&Cmd);
  
  pSrb->Status = STATUS_SUCCESS;
  StreamClassCallAtNewPriority(pSrb->StreamObject,pDevice,LowToHigh,SignalStreamRequestCompleteReadyForNextControl,pSrb);
}
#else
static void CPSet_CopyState_Initialize(SRB* pSrb) {
  PDEVICE_EXTENSION pDevice=(PDEVICE_EXTENSION)pSrb->HwDeviceExtension;
  PSTREAM_EXTENSION pStream=(PSTREAM_EXTENSION)pSrb->StreamObject->HwStreamExtension;
  MIDASCMD Cmd;
  Cmd.hMidas=pDevice->hMidas;
  Cmd.cmd = MDS_CSS_INITHW;
  Cmd.wCurrStream= pStream->internal_streamid;
  MidasEntry(&Cmd);
  pSrb->Status = STATUS_SUCCESS;
}
#endif

static void CPSet_CopyState_Default(SRB* pSrb) {
  pSrb->Status = STATUS_SUCCESS;
}

void __stdcall CssCallback(PMDS_DATA_BLOCK pMdb) {
  SRB* pSrb=(SRB*)pMdb->hRef;
  PDEVICE_EXTENSION pDevice=(PDEVICE_EXTENSION)pSrb->HwDeviceExtension;
  PSTREAM_EXTENSION pStream=(PSTREAM_EXTENSION)pSrb->StreamObject->HwStreamExtension;
  if(pSrb) {
    switch(pMdb->dwStatus) {
      case MDS_Success: pSrb->Status= STATUS_SUCCESS;     break;
      case MDS_Cancel:  pSrb->Status= STATUS_CANCELLED;   break;
      default:          pSrb->Status= STATUS_UNSUCCESSFUL;break;
    }
    SignalStreamRequestCompleteReadyForNextControl(pSrb);
  }
}

static int CPSet_CopyState_InitializeTitle(SRB* pSrb) {
  int err=1;
  MIDASCMD Cmd;
  PDEVICE_EXTENSION pDevice= (PDEVICE_EXTENSION)pSrb->HwDeviceExtension;
  PSTREAM_EXTENSION pStream= (void*)pSrb->StreamObject->HwStreamExtension; 
  PMDS_DATA_BLOCK  pMdb=&((PSRB_EXTENSION)pSrb->SRBExtension)->Mdb;
  KeQuerySystemTime((PLARGE_INTEGER)&LastInitTitle);
  pSrb->Status= STATUS_SUCCESS;
  if(pStream->stream_state!=KSSTATE_STOP) {
    pMdb->nSize=sizeof(MDS_DATA_BLOCK);
    pMdb->dwStatus=MDS_NoStatus;
    pMdb->dwStrmType=pStream->internal_streamid;
    pMdb->dwTotalPackets=0;
    pMdb->pPackets=0;
    pMdb->pNextMdb=0;
    pMdb->hRef=(void*)pSrb;
    pMdb->pfnCallback=CssCallback;
    pSrb->Status= STATUS_PENDING;

    Cmd.hMidas=pDevice->hMidas;
    Cmd.cmd = MDS_CSS_SYNCTITLE;
    Cmd.wCurrStream=pStream->internal_streamid;
    Cmd.u.pMdb=pMdb;
    err=MidasEntry(&Cmd);
  }
  return err;
}

static int CPSet_CopyState_Required(SRB* pSrb) {
  int err;
  MIDASCMD Cmd;
  PDEVICE_EXTENSION pDevice= (PDEVICE_EXTENSION)pSrb->HwDeviceExtension;
  PKS_DVDCOPY_SET_COPY_STATE pCopyState;
  int fCssEnable=0;
  pCopyState = (PKS_DVDCOPY_SET_COPY_STATE)pSrb->CommandData.PropertyInfo->PropertyInfo;
  pSrb->Status = STATUS_SUCCESS;

  if(pCopyState->DVDCopyState==KS_DVDCOPYSTATE_AUTHENTICATION_REQUIRED)
    fCssEnable=1;

  Cmd.hMidas=pDevice->hMidas;
  Cmd.cmd= MDS_CSS_ENABLE_CHANNEL;
  Cmd.u.M.Arg1=1;
  Cmd.u.M.Arg2=fCssEnable;
  err=MidasEntry(&Cmd);

  return err;
}

 
static void CPSet_DecKey2(SRB* pSrb) {
  pSrb->Status = STATUS_SUCCESS;
}

static void CPGet_CopyDVDKey1(SRB* pSrb) {
  pSrb->Status = STATUS_SUCCESS;
}

static void CPGet_CopyTitleKey(SRB* pSrb) {
  pSrb->Status = STATUS_SUCCESS;
}

static void CPGet_CopyDiscKey(SRB* pSrb) {
  pSrb->Status = STATUS_SUCCESS;
}

static void CPGet_CopyState(SRB* pSrb) {
  PSTREAM_EXTENSION pStream= (PSTREAM_EXTENSION) pSrb->StreamObject->HwStreamExtension;
  if(pStream->internal_streamid==STRM_VID) {
    ((PKS_DVDCOPY_SET_COPY_STATE)(pSrb->CommandData.PropertyInfo->PropertyInfo))->DVDCopyState= KS_DVDCOPYSTATE_AUTHENTICATION_REQUIRED;
    pStream->fCssReqd=1;
  } else  {
    ((PKS_DVDCOPY_SET_COPY_STATE)(pSrb->CommandData.PropertyInfo->PropertyInfo))->DVDCopyState= KS_DVDCOPYSTATE_AUTHENTICATION_NOT_REQUIRED;
    pStream->fCssReqd=0;
  }
  pSrb->ActualBytesTransferred = sizeof( KS_DVDCOPY_SET_COPY_STATE );
  pSrb->Status = STATUS_SUCCESS;
}

static void CPGet_ChlgKey(SRB* pSrb) {
  // Working with a new DVD Disk.
  MIDASCMD cmd;
  PDEVICE_EXTENSION pDevice;
  pDevice = pSrb->HwDeviceExtension;
                                        // sometimes get stuck in loop of bus authentication
  if(pDevice->nBusAuthCount++<5) {      // if we come here 5 times without getting title key then fail
    cmd.hMidas=pDevice->hMidas;
    cmd.cmd= MDS_CSS_GETCHALLENGE;
    cmd.u.pCHLGKEY= (PKS_DVDCOPY_CHLGKEY)(pSrb->CommandData.PropertyInfo->PropertyInfo);
    if(!MidasEntry(&cmd)) {
      pSrb->ActualBytesTransferred = sizeof (KS_DVDCOPY_CHLGKEY);
      pSrb->Status = STATUS_SUCCESS;
    }
  } else {
    pSrb->Status = STATUS_UNSUCCESSFUL;
    pDevice->nBusAuthCount=0;
  }
}

static void CPGet_DecKey2(SRB* pSrb) {
  // get DVD Key2 provides the dvd drive with bus key 2 from the decoer
  MIDASCMD cmd;
  PDEVICE_EXTENSION pDevice;
  pDevice = pSrb->HwDeviceExtension;
  cmd.hMidas=pDevice->hMidas;
  cmd.cmd= MDS_CSS_GETRESPONSE;
  cmd.u.pBUSKEY= (PKS_DVDCOPY_BUSKEY)(pSrb->CommandData.PropertyInfo->PropertyInfo);
  if(!MidasEntry(&cmd)) {
    pSrb->ActualBytesTransferred = sizeof (KS_DVDCOPY_BUSKEY);
    pSrb->Status = STATUS_SUCCESS;
  }
}

static void CopyProtReadRegionCode(SRB* pSrb) {
  MIDASCMD Cmd;
  PDEVICE_EXTENSION pDevice= pSrb->HwDeviceExtension;
  Cmd.hMidas=pDevice->hMidas;
  Cmd.cmd= MDS_CSS_GETREGIONCODE;
  Cmd.u.pRegionInfo= ((PKS_DVDCOPY_REGION)(pSrb->CommandData.PropertyInfo->PropertyInfo));
  MidasEntry(&Cmd);
  pSrb->ActualBytesTransferred = sizeof (KS_DVDCOPY_REGION);
  pSrb->Status = STATUS_SUCCESS;
  StreamClassCallAtNewPriority(pSrb->StreamObject,pDevice,LowToHigh,SignalStreamRequestCompleteReadyForNextControl,pSrb);
}

static void CPGet_Region(SRB* pSrb) {
  PDEVICE_EXTENSION pDevice= pSrb->HwDeviceExtension;
  pSrb->Status= STATUS_PENDING;
  StreamClassCallAtNewPriority(pSrb->StreamObject,pDevice,Low,CopyProtReadRegionCode,pSrb);
}

static void CPSet_ChlgKey(SRB* pSrb) {
  // set property for challenge key.  This provides the dvd drive
  // challenge key for the decoder
  MIDASCMD cmd;
  PDEVICE_EXTENSION pDevice;
  pDevice = pSrb->HwDeviceExtension;
  cmd.hMidas=pDevice->hMidas;
  cmd.cmd= MDS_CSS_SETCHALLENGE;
  cmd.u.pCHLGKEY= (PKS_DVDCOPY_CHLGKEY)(pSrb->CommandData.PropertyInfo->PropertyInfo);
  if(!MidasEntry(&cmd)) {
    pSrb->Status= STATUS_SUCCESS;
  }
}

static void CPSet_DVDkey1(SRB* pSrb) {
  // set DVD Key1 provides the dvd drive bus key 1 for the decoer
  MIDASCMD cmd;
  PDEVICE_EXTENSION pDevice;
  pDevice = pSrb->HwDeviceExtension;
  cmd.hMidas=pDevice->hMidas;
  cmd.cmd = MDS_CSS_SETRESPONSE;
  cmd.u.pBUSKEY = (PKS_DVDCOPY_BUSKEY)(pSrb->CommandData.PropertyInfo->PropertyInfo);
  if(!MidasEntry(&cmd)) {
    pSrb->Status = STATUS_SUCCESS;
  }
}

static void CPSet_TitleKey(SRB* pSrb) {
  // set DVD title key, provides the dvd drive title key to the decoder
  MIDASCMD cmd;
  PSTREAM_EXTENSION pStream= (PSTREAM_EXTENSION)pSrb->StreamObject->HwStreamExtension;
  PDEVICE_EXTENSION pDevice= (PDEVICE_EXTENSION)pSrb->HwDeviceExtension;
  KeQuerySystemTime((PLARGE_INTEGER)&LastSetTitle);
  pDevice->nBusAuthCount=0;     // clear count of successive bus auth calls
  cmd.hMidas=pDevice->hMidas;
  cmd.cmd= MDS_CSS_SETTITLE;
  cmd.u.pTITLEKEY= (PKS_DVDCOPY_TITLEKEY)(pSrb->CommandData.PropertyInfo->PropertyInfo);
  if(!MidasEntry(&cmd)) {
    pSrb->Status= STATUS_SUCCESS;
  }
  pDevice->nCssKeyPhase++;
}

static void CPSet_DiscKey(SRB* pSrb) {
  // set the DVD disc key.  provides the dvd disc key to the decoder
  MIDASCMD cmd;
  PDEVICE_EXTENSION pDevice;
  pDevice = pSrb->HwDeviceExtension;
  cmd.hMidas=pDevice->hMidas;
  cmd.cmd = MDS_CSS_SETDISCKEY;
  cmd.u.pDISCKEY = (PKS_DVDCOPY_DISCKEY)(pSrb->CommandData.PropertyInfo->PropertyInfo);
  if(!MidasEntry(&cmd)) {
    pSrb->Status = STATUS_SUCCESS;
  }
}


/* EOF : COPYPROT.C */