#include <Strmini.h>
#include <KsMedia.h>
#include "DbgMsg.h"
#include "DbgFltr.h"
#include "Idents.h"
#include "Log.h"
#include "Globals.h"
#include "DbgOut.h"

//#pragma message("DbgOut.c: Optimizer disabled.")
//#pragma optimize("",off)

long dvHwParsePacket(LPBYTE lpData, DWORD nBytes, DWORD *pSCR, DWORD *pPTS);

void DbgDispKsDataFormat(DWORD dwDbgFilt,PKSDATAFORMAT pFmt);
void DbgDispMpeg2VideoFormat(DWORD dwDbgFilt,KS_MPEGVIDEOINFO2* pFmt);
void DbgDispMpeg2AudioFormat(DWORD dwDbgFilt,KS_MPEGAUDIOINFO* pFmt);
void DbgDispDataIntersectInfo(DWORD dwDbgFilt,PSTREAM_DATA_INTERSECT_INFO pFmt);
void DbgDispStreamExtension(DWORD dwDbgFilt,PSTREAM_EXTENSION pFmt);
void DbgDispAudioStruct(DWORD dwDbgFilt,struct audio_struct* pFmt);
void DbgDispKsPropertyCss(DWORD dwDbgFilt,PKSPROPERTY pFmt);
void DbgDispKsPropertyVid(DWORD dwDbgFilt,PKSPROPERTY pFmt);
void DbgDispKsPropertyAud(DWORD dwDbgFilt,PKSPROPERTY pFmt);
void DbgDispKsStreamHeaders(DWORD dwDbgFilt,SRB *pSrb);
void DbgDispKsVPEDataInfo(DWORD dwDbgFilt,PKS_AMVPDATAINFO pFmt);
void DbgDispKsVPMaxPixRate(DWORD dwDbgFilt,PKSVPMAXPIXELRATE pFmt);
void DbgDispKsVidPropertyInfo(DWORD dwDbgFilt,PVOID pFmt,ULONG pFmtID);
void DbgDispKsVPEPropertyInfo(DWORD dwDbgFilt,PVOID pFmt,ULONG pFmtID);
void DbgDispKsCssPropertyInfo(DWORD dwDbgFilt,PVOID pFmt,ULONG pFmtID);
void DbgDispKsRateChangeInfo(DWORD dwDbgFilt,PVOID pFmt,ULONG pFmtID);

void DbgDispKsCssChlgKey(DWORD dwDbgFilt,PKS_DVDCOPY_CHLGKEY pFmt);
void DbgDispKsCssTitleKey(DWORD dwDbgFilt,PKS_DVDCOPY_TITLEKEY pFmt);
void DbgDispKsCssAPS(DWORD dwDbgFilt,PKS_COPY_MACROVISION pFmt);
void DbgDispKsCssRegion(DWORD dwDbgFilt,PKS_DVDCOPY_REGION pFmt);
void DbgDispKsCssSetCpySt(DWORD dwDbgFilt,PKS_DVDCOPY_SET_COPY_STATE pFmt);
void DbgDispKsCssDiscKey(DWORD dwDbgFilt,PKS_DVDCOPY_DISCKEY pFmt);
void DbgDispKsVPENumCntInfo(DWORD dwDbgFilt,PULONG pFmt);
void DbgDispKsVPEGetCntInfo(DWORD dwDbgFilt,LPDDVIDEOPORTCONNECT pFmt);
void DbgDispKsVPEDataInfo(DWORD dwDbgFilt,PKS_AMVPDATAINFO pFmt);
void DbgDispKsVPEMaxPixRate(DWORD dwDbgFilt,PKSVPMAXPIXELRATE pFmt);
void DbgDispKsVPENumVidFmt(DWORD dwDbgFilt,PULONG pFmt);
void DbgDispKsVPEGetVidFmt(DWORD dwDbgFilt,LPDDPIXELFORMAT pFmt);
void DbgDispKsVPEDecComp(DWORD dwDbgFilt,PBOOL pFmt);
void DbgDispKsVPEScaleFactor(DWORD dwDbgFilt,PKS_AMVPSIZE pFmt);
void DbgDispKsVPEDDHandle(DWORD dwDbgFilt,PULONG pFmt);
void DbgDispKsVPEVPID(DWORD dwDbgFilt,PULONG pFmt);
void DbgDispKsVPESurfHandle(DWORD dwDbgFilt,PULONG pFmt);
void DbgDispKsVPESurfParams(DWORD dwDbgFilt,PKSVPSURFACEPARAMS pFmt);
void DbgDispKsVPESetCntInfo(DWORD dwDbgFilt,PULONG pLong);
void DbgDispKsVPESetVidFmt(DWORD dwDbgFilt,PULONG pLong);
void DbgDispRateChangeStep(DWORD dwDbgFilt,KS_AM_Step* pFmt);
void DbgDispRateChangeMaxFull(DWORD dwDbgFilt,KS_AM_MaxFullDataRate* pFmt);
void DbgDispRateChangeExact(DWORD dwDbgFilt,KS_AM_ExactRateChange* pFmt);
void DbgDispRateChangeSimple(DWORD dwDbgFilt,KS_AM_SimpleRateChange* pFmt);


void DbgDispKsDataFormat(DWORD dwDbgFilt,PKSDATAFORMAT pFmt) {
  DbgMsg(dwDbgFilt," Total Size: %08x \r\n",pFmt->FormatSize);
  DbgMsg(dwDbgFilt," Flags= %s\r\n",pFmt->Flags,Ident(ID_SRBOPT,pFmt->Flags));
  DbgMsg(dwDbgFilt," Sample Size: %08x\r\n",pFmt->SampleSize);
  DbgMsg(dwDbgFilt," MajorFormat: %s\r\n",Ident(ID_GUID_KS,(DWORD)(GUID*)&pFmt->MajorFormat));
  DbgMsg(dwDbgFilt," SubFormat: %s\r\n",Ident(ID_GUID_KS,(DWORD)(GUID*)&pFmt->SubFormat));
  DbgMsg(dwDbgFilt," Specifier: %s\r\n",Ident(ID_GUID_KS,(DWORD)(GUID*)&pFmt->Specifier));
  DbgMsg(dwDbgFilt," Alignment: %016x \r\n",pFmt->Alignment);
}

void DbgDispMpeg2AudioFormat(DWORD dwDbgFilt,KS_MPEGAUDIOINFO* pFmt) {
  DbgMsg(dwDbgFilt," dwFlags= %s \r\n",Ident(ID_KS_MPEG2AUDFLAG,pFmt->dwFlags));
}

void DbgDispMpeg2VideoFormat(DWORD dwDbgFilt,KS_MPEGVIDEOINFO2* pFmt) {
#ifdef DEBUG
  RECT rt;
  KS_BITMAPINFOHEADER bm;
  bm = pFmt->hdr.bmiHeader;
  DbgMsg(dwDbgFilt," StartTimeCode= %08x \r\n",pFmt->dwStartTimeCode);
  DbgMsg(dwDbgFilt," cbSequenceHeader= %08x \r\n",pFmt->cbSequenceHeader);
  DbgMsg(dwDbgFilt," MPEG2Profile= %08x \r\n",Ident(ID_KS_MPEG2PROFILE,pFmt->dwProfile));
  DbgMsg(dwDbgFilt," MPEG2Level= %s \r\n",Ident(ID_KS_MPEG2LEVEL,pFmt->dwLevel));
  DbgMsg(dwDbgFilt," Flags= %s \r\n",Ident(ID_KS_MPEG2VIDFLAG,pFmt->dwFlags));
  DbgMsg(dwDbgFilt," bSequenceHeader= %08x \r\n",*pFmt->bSequenceHeader);
  rt= pFmt->hdr.rcSource;
  DbgMsg(dwDbgFilt," Hdr.Source= %d,%d,%d,%d \r\n",rt.left,rt.top,rt.right,rt.bottom);
  rt= pFmt->hdr.rcTarget;
  DbgMsg(dwDbgFilt," Hdr.Target= %d,%d,%d,%d \r\n",rt.left,rt.top,rt.right,rt.bottom);
  DbgMsg(dwDbgFilt," BitRate= %d \r\n",pFmt->hdr.dwBitRate);
  DbgMsg(dwDbgFilt," BitErrorRate= %d \r\n",pFmt->hdr.dwBitErrorRate);
  DbgMsg(dwDbgFilt," AvgTimePerFRame= %d \r\n",pFmt->hdr.AvgTimePerFrame);
  DbgMsg(dwDbgFilt," InterlaceFlags= %s \r\n",Ident(ID_KS_AMINTERLACE,pFmt->hdr.dwInterlaceFlags));
  DbgMsg(dwDbgFilt," CopyProtectFlags= %08x \r\n",pFmt->hdr.dwCopyProtectFlags);
  DbgMsg(dwDbgFilt," AspectRatio= %d:%d \r\n",pFmt->hdr.dwPictAspectRatioX,pFmt->hdr.dwPictAspectRatioY);
  DbgMsg(dwDbgFilt," BitMap header Size= %d \r\n",bm.biSize);
  DbgMsg(dwDbgFilt," BM Width,Height= %d,%d \r\n",bm.biWidth,bm.biHeight);
  DbgMsg(dwDbgFilt," BM Planes= %d \r\n", bm.biPlanes);
  DbgMsg(dwDbgFilt," BM BitCount= %d \r\n",bm.biBitCount);
  DbgMsg(dwDbgFilt," BM Compression= %08x \r\n",bm.biCompression);
  DbgMsg(dwDbgFilt," BM SizeImage= %d \r\n",bm.biSizeImage);
  DbgMsg(dwDbgFilt," BM PelsPerMeter= %d(X),%d(Y) \r\n",bm.biXPelsPerMeter,bm.biYPelsPerMeter);
  DbgMsg(dwDbgFilt," BM ClrsUsed/Impor= %08x / %08x \r\n",bm.biClrUsed,bm.biClrImportant);
#endif
}

void DbgDispDataIntersectInfo(DWORD dwDbgFilt,PSTREAM_DATA_INTERSECT_INFO pFmt) {
  DbgMsg(dwDbgFilt," StreamNumber= %s \r\n",Ident(ID_PIN_ID,pFmt->StreamNumber));
  DbgMsg(dwDbgFilt," DataFormatBuffer= %08x \r\n",pFmt->DataFormatBuffer);
  DbgMsg(dwDbgFilt," SizeOfDataFormatBuffer= %08x \r\n",pFmt->SizeOfDataFormatBuffer);
  DbgDispKsDataFormat(dwDbgFilt,(PKSDATAFORMAT)pFmt->DataRange);
}

void DbgDispStreamExtension(DWORD dwDbgFilt,PSTREAM_EXTENSION pFmt) {
  DbgMsg(dwDbgFilt," Stream State= %d \r\n",pFmt->stream_state);
  DbgMsg(dwDbgFilt," SystemPTS= %016x \r\n",pFmt->SystemPTS);
  DbgMsg(dwDbgFilt," Internal ID= %s \r\n",Ident(ID_STRM,pFmt->internal_streamid));
}

void DbgDispAudioStruct(DWORD dwDbgFilt,struct audio_struct* pFmt) {
  DbgMsg(dwDbgFilt," OutputMode= %s \r\n",Ident(ID_HAL_AUDOUTPUT,pFmt->AudioOutputMode));
  DbgMsg(dwDbgFilt," Source= %s \r\n",Ident(ID_HAL_AUDTYPE,pFmt->AudioSource));
  DbgMsg(dwDbgFilt," SampleRate= %s \r\n",Ident(ID_HAL_AUDRATE,pFmt->AudioSampleRate));
  DbgMsg(dwDbgFilt," ClockOpens= %08x \r\n",pFmt->ClockOpens);
  DbgMsg(dwDbgFilt," PauseTime= %016x \r\n",pFmt->PauseTime);
  DbgMsg(dwDbgFilt," StartTime= %016x \r\n",pFmt->StartTime);
  DbgMsg(dwDbgFilt," CurrTime = %016x \r\n",pFmt->CurrentTime);
  DbgMsg(dwDbgFilt," TimeMark = %08x \r\n",pFmt->TimeMark);
  DbgMsg(dwDbgFilt," Interval = %08x \r\n",pFmt->TimeInterval);
  DbgMsg(dwDbgFilt," Ticking  = %08x \r\n",pFmt->ClockTicking);
}

void DbgDispKsPropertyVid(DWORD dwDbgFilt,PKSPROPERTY pFmt) {
  DbgMsg(dwDbgFilt," GuidSet= %s \r\n",Ident(ID_GUID_KS,(DWORD)(GUID*)&pFmt->Set));
  DbgMsg(dwDbgFilt," Id= %s \r\n",Ident(ID_KSPROP_VID,pFmt->Id));
  DbgMsg(dwDbgFilt," Flags= %s \r\n",Ident(ID_KSPROP_VIDF,pFmt->Flags));
  DbgMsg(dwDbgFilt," Alignment= %016x \r\n",pFmt->Alignment);
}

void DbgDispKsPropertyCss(DWORD dwDbgFilt,PKSPROPERTY pFmt) {
  DbgMsg(dwDbgFilt," GuidSet= %s \r\n",Ident(ID_GUID_KS,(DWORD)(GUID*)&pFmt->Set));
  DbgMsg(dwDbgFilt," Id= %s \r\n",Ident(ID_KSPROP_CSS,pFmt->Id));
  DbgMsg(dwDbgFilt," Flags= %s \r\n",Ident(ID_KSPROP_CSSF,pFmt->Flags));
  DbgMsg(dwDbgFilt," Alignment= %016x \r\n",pFmt->Alignment);
}

void DbgDispKsPropertyAud(DWORD dwDbgFilt,PKSPROPERTY pFmt) {
  DbgMsg(dwDbgFilt," GuidSet= %s \r\n",Ident(ID_GUID_KS,(DWORD)(GUID*)&pFmt->Set));
  DbgMsg(dwDbgFilt," Id= %s \r\n",Ident(ID_KSPROP_AUD,pFmt->Id));
  DbgMsg(dwDbgFilt," Flags= %s \r\n",Ident(ID_KSPROP_AUDF,pFmt->Flags));
  DbgMsg(dwDbgFilt," Alignment= %016x \r\n",pFmt->Alignment);
}

void DbgDispStrmTime(DWORD dwDbgFilt,ULONGLONG llTime,char* szPre,char* szPost) {
  ULONGLONG llSecs;
  if(szPre)
    DbgMsg(dwDbgFilt,"%s",szPre);
  llSecs=llTime/10000000;
  if(llSecs)
    DbgMsg(dwDbgFilt,"%d,",(int)llSecs);
  DbgMsg(dwDbgFilt,"%03d.%04dmS",(int)((llTime%10000000)/10000),(int)(llTime%10000));
  if(szPost)
    DbgMsg(dwDbgFilt,"%s",szPost);
}

void DbgDispKsStreamHeaders(DWORD dwDbgFilt,SRB *pSrb) {
  PKSSTREAM_HEADER pStrmHdr= pSrb->CommandData.DataBufferArray;
  KSTIME *Pts= &pStrmHdr->PresentationTime;
  DWORD dwPTS,dwSCR;
  int i= pSrb->NumberOfBuffers;

  if(pStrmHdr->OptionsFlags==0 && (pStrmHdr->TypeSpecificFlags&0x0000ffff)==0)
    dwDbgFilt|=DBG_HIFREQ;

  if(dwDbgFilt&DBG_MSGVID&0x0000ffff) {
    DbgMsg(dwDbgFilt,"Video - # of buf %d, Opt %08x, Typ %04x",pSrb->NumberOfBuffers,pStrmHdr->OptionsFlags,pStrmHdr->TypeSpecificFlags);
  } else if(dwDbgFilt&DBG_MSGAUD&0x0000ffff) {
    DbgMsg(dwDbgFilt,"Audio - # of buf %d, Flags %s",pSrb->NumberOfBuffers,Ident(ID_SRBOPT,pStrmHdr->OptionsFlags));
  } else if(dwDbgFilt&DBG_MSGSUB&0x0000ffff) {
    DbgMsg(dwDbgFilt,"SubPict - # of buf %d, Flags %s",pSrb->NumberOfBuffers,Ident(ID_SRBOPT,pStrmHdr->OptionsFlags));
  } else if(dwDbgFilt&DBG_MSGCC&0x0000ffff) {
    DbgMsg(dwDbgFilt,"CC - # of buf %d, Flags %s",pSrb->NumberOfBuffers,Ident(ID_SRBOPT,pStrmHdr->OptionsFlags));
  } else {
    DbgMsg(dwDbgFilt,"UNK Stream - # of buf %d, Flags %s",pSrb->NumberOfBuffers,Ident(ID_SRBOPT,pStrmHdr->OptionsFlags));
  }
  if(pStrmHdr->OptionsFlags&KSSTREAM_HEADER_OPTIONSF_TIMEVALID)
    DbgDispStrmTime(dwDbgFilt,Pts->Time," Pts=","\r\n");
  else
    DbgMsg(dwDbgFilt,"\r\n");

  while(i--) {
    if(dwDbgFilt==DBG_MSGVID && 0) {
      if(Pts->Time)
        DbgDispStrmTime(dwDbgFilt|DBG_HIFREQ,Pts->Time,"PTS from ClassDriver:","\r\n");
      dvHwParsePacket(pStrmHdr->Data,pStrmHdr->DataUsed,&dwSCR,&dwPTS);
      if(dwPTS || dwSCR)
        DbgMsg(dwDbgFilt|DBG_HIFREQ,"PTS from Stream     : %016dmS (%016dmS)\r\n",dwPTS/90,dwSCR/90);
    } else {
      //if(*(DWORD*)pStrmHdr->Data==0x000001b2)
      //  DbgMsg(DBG_CRIT,"User Data Received (%x) \r\n",dwDbgFilt);
      DbgMsg(dwDbgFilt|DBG_HIFREQ,"  Addr=%08x  Size=%08x  PTS=");
      DbgDispStrmTime(dwDbgFilt|DBG_HIFREQ,Pts->Time,0,0);
      DbgMsg(dwDbgFilt|DBG_HIFREQ,"  N/D=%x/%x \r\n",Pts->Numerator,Pts->Denominator);
    }
    pStrmHdr++;
  }
}

void DbgDispKsVPEDataInfo(DWORD dwDbgFilt,PKS_AMVPDATAINFO pFmt) {
  KS_AMVPDIMINFO* pAMVPDimInfo= &pFmt->amvpDimInfo;
  RECT* pRt= &pAMVPDimInfo->rcValidRegion;
  DbgMsg(dwDbgFilt," VPDataInfo Struct size %08x \r\n",pFmt->dwSize);
  DbgMsg(dwDbgFilt," uS per field = %08x (%d d) \r\n",pFmt->dwMicrosecondsPerField,pFmt->dwMicrosecondsPerField);
  DbgMsg(dwDbgFilt," Aspect Ratio = %d:%d \r\n",pFmt->dwPictAspectRatioX,pFmt->dwPictAspectRatioY);
  DbgMsg(dwDbgFilt," Enable Double Clock = %x \r\n",pFmt->bEnableDoubleClock);
  DbgMsg(dwDbgFilt," Enable ext VACT = %x \r\n",pFmt->bEnableVACT);
  DbgMsg(dwDbgFilt," Data Interlaced = %x \r\n",pFmt->bDataIsInterlaced);
  DbgMsg(dwDbgFilt," # of half lines in the odd  field = %08x \r\n",pFmt->lHalfLinesOdd);
  DbgMsg(dwDbgFilt," # of half lines in the even field = %08x \r\n",pFmt->lHalfLinesEven);
  DbgMsg(dwDbgFilt," Field polarity Invert = %x \r\n",pFmt->bFieldPolarityInverted);
  DbgMsg(dwDbgFilt," # of data lines in VREF = %08x \r\n",pFmt->dwNumLinesInVREF);
  DbgMsg(dwDbgFilt," Video Field HeightxWidth= %d x %d \r\n",pAMVPDimInfo->dwFieldWidth,pAMVPDimInfo->dwFieldHeight);
  DbgMsg(dwDbgFilt," VBI   Field HeightxWidth= %d x %d \r\n",pAMVPDimInfo->dwVBIWidth,pAMVPDimInfo->dwVBIHeight);
  DbgMsg(dwDbgFilt," Crop Rect (Valid Region) = %d,%d,%d,%d\r\n",pRt->left,pRt->top,pRt->right,pRt->bottom);
}

void DbgDispKsVPEMaxPixRate(DWORD dwDbgFilt,PKSVPMAXPIXELRATE pFmt) {
  DWORD dwW= pFmt->Size.dwWidth;
  DWORD dwH= pFmt->Size.dwHeight;
  DWORD dwMPR= pFmt->MaxPixelsPerSecond;
  DbgMsg(dwDbgFilt," Size= %x x %x (%d x %d) \r\n",dwW,dwH,dwW,dwH);
  DbgMsg(dwDbgFilt," MaxPixPerSec= %x (%d) \r\n",dwMPR,dwMPR);
}

void DbgDispKsCssPropertyInfo(DWORD dwDbgFilt,PVOID pFmt,ULONG pFmtID) {
  switch(pFmtID) {
    case KSPROPERTY_DVDCOPY_CHLG_KEY:           DbgDispKsCssChlgKey(dwDbgFilt,(PKS_DVDCOPY_CHLGKEY)pFmt); break;
    //case KSPROPERTY_DVDCOPY_DVD_KEY1:           DbgDispKsCssDVDKey1(dwDbgFilt,(
    //case KSPROPERTY_DVDCOPY_DEC_KEY2:
    case KSPROPERTY_DVDCOPY_TITLE_KEY:          DbgDispKsCssTitleKey(dwDbgFilt,(PKS_DVDCOPY_TITLEKEY)pFmt); break;
    case KSPROPERTY_COPY_MACROVISION:           DbgDispKsCssAPS(dwDbgFilt,(PKS_COPY_MACROVISION)pFmt); break;
    case KSPROPERTY_DVDCOPY_REGION:             DbgDispKsCssRegion(dwDbgFilt,(PKS_DVDCOPY_REGION)pFmt); break;
    case KSPROPERTY_DVDCOPY_SET_COPY_STATE:     DbgDispKsCssSetCpySt(dwDbgFilt,(PKS_DVDCOPY_SET_COPY_STATE)pFmt); break;
    case KSPROPERTY_DVDCOPY_DISC_KEY:           DbgDispKsCssDiscKey(dwDbgFilt,(PKS_DVDCOPY_DISCKEY)pFmt); break;
  }
}

void DbgDispKsVPEPropertyInfo(DWORD dwDbgFilt,PVOID pFmt,ULONG pFmtID) {
  switch(pFmtID) {
    case KSPROPERTY_VPCONFIG_NUMCONNECTINFO:    DbgDispKsVPENumCntInfo(dwDbgFilt,(PULONG)pFmt); break;
    case KSPROPERTY_VPCONFIG_SETCONNECTINFO:    DbgDispKsVPESetCntInfo(dwDbgFilt,(PULONG)pFmt); break;
    case KSPROPERTY_VPCONFIG_GETCONNECTINFO:    DbgDispKsVPEGetCntInfo(dwDbgFilt,(LPDDVIDEOPORTCONNECT)pFmt); break;
    case KSPROPERTY_VPCONFIG_VPDATAINFO:        DbgDispKsVPEDataInfo(dwDbgFilt,(PKS_AMVPDATAINFO)pFmt); break;
    case KSPROPERTY_VPCONFIG_MAXPIXELRATE:      DbgDispKsVPEMaxPixRate(dwDbgFilt,(PKSVPMAXPIXELRATE)pFmt); break;
    //case KSPROPERTY_VPCONFIG_INFORMVPINPUT:     
    case KSPROPERTY_VPCONFIG_NUMVIDEOFORMAT:    DbgDispKsVPENumVidFmt(dwDbgFilt,(PULONG)pFmt); break;
    case KSPROPERTY_VPCONFIG_SETVIDEOFORMAT:    DbgDispKsVPESetVidFmt(dwDbgFilt,(PULONG)pFmt); break;
    case KSPROPERTY_VPCONFIG_GETVIDEOFORMAT:    DbgDispKsVPEGetVidFmt(dwDbgFilt,(LPDDPIXELFORMAT)pFmt); break;
    //case KSPROPERTY_VPCONFIG_INVERTPOLARITY:
    case KSPROPERTY_VPCONFIG_DECIMATIONCAPABILITY: DbgDispKsVPEDecComp(dwDbgFilt,(PBOOL)pFmt); break;
    case KSPROPERTY_VPCONFIG_SCALEFACTOR:       DbgDispKsVPEScaleFactor(dwDbgFilt,(PKS_AMVPSIZE)pFmt); break;
    case KSPROPERTY_VPCONFIG_DDRAWHANDLE:       DbgDispKsVPEDDHandle(dwDbgFilt,(PULONG)pFmt); break;
    case KSPROPERTY_VPCONFIG_VIDEOPORTID:       DbgDispKsVPEVPID(dwDbgFilt,(PULONG)pFmt); break;
    case KSPROPERTY_VPCONFIG_DDRAWSURFACEHANDLE:DbgDispKsVPESurfHandle(dwDbgFilt,(PULONG)pFmt); break;
    case KSPROPERTY_VPCONFIG_SURFACEPARAMS:     DbgDispKsVPESurfParams(dwDbgFilt,(PKSVPSURFACEPARAMS)pFmt); break;
  }
}

void DbgDispKsVPESetVidFmt(DWORD dwDbgFilt,PULONG pLong) {
  DbgMsg(dwDbgFilt,"VP Set Video Format Index = %d \r\n",*pLong);
}

void DbgDispKsVPESetCntInfo(DWORD dwDbgFilt,PULONG pLong) {
  DbgMsg(dwDbgFilt,"VP Set Connect Info Index = %d \r\n",*pLong);
}

void DbgDispKsVidPropertyInfo(DWORD dwDbgFilt,PVOID pFmt,ULONG pFmtID) {
  switch(pFmtID) {
    //case KSPROPERTY_MPEG2VID_MODES:             DbgDispKsVidModes(dwDbgFilt,
    //case KSPROPERTY_MPEG2VID_CUR_MODE:          DbgDispKsCurrMode(dwDbgFilt,
    //case KSPROPERTY_MPEG2VID_4_3_RECT:          DbgDispKsVid_4x3_rect(dwDbgFilt,
    //case KSPROPERTY_MPEG2VID_16_9_RECT:         DbgDispKsVid_16x9_rect(dwDbgFilt,
    //case KSPROPERTY_MPEG2VID_16_9_PANSCAN:      DbgDispKsVid_16x9_panscan(dwDbgFilt,
  }
}


void DbgDispKsCssChlgKey(DWORD dwDbgFilt,PKS_DVDCOPY_CHLGKEY pFmt) {
//    BYTE ChlgKey[10];
//    BYTE Reserved[2];
//  DbgMsg(dwDbgFilt," Css ChlgKey = %010x \r\n",pFmt->ChlgKey);
}

void DbgDispKsCssTitleKey(DWORD dwDbgFilt,PKS_DVDCOPY_TITLEKEY pFmt) {
//    ULONG KeyFlags;
//    ULONG ReservedNT[2];
//    UCHAR TitleKey[6];
//    UCHAR Reserved[2];
  DbgMsg(dwDbgFilt," Css TitleKey Flags= %08x \r\n",pFmt->KeyFlags);
  DbgMsg(dwDbgFilt," Css TitleKey Key= %06x \r\n",pFmt->TitleKey);
}

void DbgDispKsCssAPS(DWORD dwDbgFilt,PKS_COPY_MACROVISION pFmt) {
  DbgMsg(dwDbgFilt," MacroVision Level = %x \r\n",pFmt->MACROVISIONLevel);
}

void DbgDispKsCssRegion(DWORD dwDbgFilt,PKS_DVDCOPY_REGION pFmt) {
  DbgMsg(dwDbgFilt," Region Data (Code) = %x \r\n",pFmt->RegionData);
}

void DbgDispKsCssSetCpySt(DWORD dwDbgFilt,PKS_DVDCOPY_SET_COPY_STATE pFmt) {
  DbgMsg(dwDbgFilt," Css Set Copy State = %08x \r\n",pFmt->DVDCopyState);
}

void DbgDispKsCssDiscKey(DWORD dwDbgFilt,PKS_DVDCOPY_DISCKEY pFmt) {
//    BYTE DiscKey[2048];
//  DbgMsg(dwDbgFilt," Css DiscKey = %08x \r\n",pFmt->DiscKey);
}

void DbgDispKsVPENumCntInfo(DWORD dwDbgFilt,PULONG pFmt) {
  ULONG ul= *pFmt;
  DbgMsg(dwDbgFilt," VP # of connection supported = %x \r\n",ul);
}

void DbgDispKsVPEGetCntInfo(DWORD dwDbgFilt,LPDDVIDEOPORTCONNECT pFmt) {
  DbgMsg(dwDbgFilt," Port Width = %08x \r\n",pFmt->dwPortWidth);
  DbgMsg(dwDbgFilt," Guid =  %s \r\n",Ident(ID_GUID_KS,(DWORD)(GUID*)&pFmt->guidTypeID));
  DbgMsg(dwDbgFilt," Connection Flags = %08x \r\n",pFmt->dwFlags);
}

void DbgDispKsVPENumVidFmt(DWORD dwDbgFilt,PULONG pFmt) {
  ULONG ul= *pFmt;
  DbgMsg(dwDbgFilt," VP # of video formats supported = %x \r\n",ul);
}

void DbgDispKsVPEGetVidFmt(DWORD dwDbgFilt,LPDDPIXELFORMAT pFmt) {
  DbgMsg(dwDbgFilt," Pix. Format Flags = %08x \r\n",pFmt->dwFlags);
  DbgMsg(dwDbgFilt," Fourcc = %08x \r\n",pFmt->dwFourCC);
  DbgMsg(dwDbgFilt," RGB/YUV BitCount= %08x \r\n",pFmt->dwRGBBitCount);
  DbgMsg(dwDbgFilt," R/Y BitMask = %08x \r\n",pFmt->dwRBitMask);
  DbgMsg(dwDbgFilt," G/U BitMask = %08x \r\n",pFmt->dwGBitMask);
  DbgMsg(dwDbgFilt," B/V BitMask = %08x \r\n",pFmt->dwBBitMask);
  DbgMsg(dwDbgFilt," RGB/YUV Alpha/Z chnl bitmask= %08x \r\n",pFmt->dwRGBAlphaBitMask);
}

void DbgDispKsVPEDecComp(DWORD dwDbgFilt,PBOOL pFmt) {
  BOOL bF= *pFmt;
  DbgMsg(dwDbgFilt," VP Is Decimation Supported = %x \r\n",bF);
}

void DbgDispKsVPEScaleFactor(DWORD dwDbgFilt,PKS_AMVPSIZE pFmt) {
  DbgMsg(dwDbgFilt," VP Scale Factor = %x x %x \r\n",pFmt->dwWidth,pFmt->dwHeight);
}

void DbgDispKsVPEDDHandle(DWORD dwDbgFilt,PULONG pFmt) {
  ULONG ul= *pFmt;
  DbgMsg(dwDbgFilt," VP DD Handle = %08x \r\n",ul);
}

void DbgDispKsVPEVPID(DWORD dwDbgFilt,PULONG pFmt) {
  ULONG ul= *pFmt;
  DbgMsg(dwDbgFilt," VP VideoPort ID = %08x \r\n",ul);
}

void DbgDispKsVPESurfHandle(DWORD dwDbgFilt,PULONG pFmt) {
  ULONG ul= *pFmt;
  DbgMsg(dwDbgFilt," VP Surface Handle = %08x \r\n",ul);
}

void DbgDispKsVPESurfParams(DWORD dwDbgFilt,PKSVPSURFACEPARAMS pFmt) {
  DbgMsg(dwDbgFilt," VP Surf. Pitch= %08x \r\n",pFmt->dwPitch);
  DbgMsg(dwDbgFilt," VP Surf. Origin X,Y= %08x, %08x \r\n",pFmt->dwXOrigin,pFmt->dwYOrigin);
}

void DbgDispKsRateChangeInfo(DWORD dwDbgFilt,PVOID pFmt,ULONG pFmtID) {
  switch(pFmtID) {
    case KS_AM_RATE_SimpleRateChange: DbgDispRateChangeSimple(dwDbgFilt,(KS_AM_SimpleRateChange*)pFmt); break;
    case KS_AM_RATE_ExactRateChange:  DbgDispRateChangeExact(dwDbgFilt,(KS_AM_ExactRateChange*)pFmt); break;
    case KS_AM_RATE_MaxFullDataRate:  DbgDispRateChangeMaxFull(dwDbgFilt,(KS_AM_MaxFullDataRate*)pFmt); break;
    case KS_AM_RATE_Step:             DbgDispRateChangeStep(dwDbgFilt,(KS_AM_Step*)pFmt); break;
  }
  return;
}

void DbgDispRateChangeSimple(DWORD dwDbgFilt,KS_AM_SimpleRateChange* pFmt) {
  DbgDispStrmTime(dwDbgFilt,pFmt->StartTime,"RateChangeSimple: StartTime=","\r\n");
  DbgMsg(dwDbgFilt,"                  Rate= %d\r\n",pFmt->Rate);
}

void DbgDispRateChangeExact(DWORD dwDbgFilt,KS_AM_ExactRateChange* pFmt) {
  DbgMsg(dwDbgFilt,"RateChangeExact:  OutputZeroTime= %d\r\n",(int)(pFmt->OutputZeroTime/1000),(int)(pFmt->OutputZeroTime%1000));
  DbgMsg(dwDbgFilt,"                  Rate= %d\r\n",pFmt->Rate); 
}

void DbgDispRateChangeMaxFull(DWORD dwDbgFilt,KS_AM_MaxFullDataRate* pFmt) {
  DbgMsg(dwDbgFilt,"RateChangeFull:   KS_AM_MaxFullDataRate= %d \r\n",*pFmt); 
}

void DbgDispRateChangeStep(DWORD dwDbgFilt,KS_AM_Step* pFmt) {
  DbgMsg(dwDbgFilt,"RateChangeStep:    KS_AM_Step= %d \r\n",*pFmt);
}


long dvHwParsePacket(LPBYTE lpData, DWORD nBytes, DWORD *pSCR, DWORD *pPTS) {
  LPDWORD lpPTS   = 0;
  DWORD   dwScr   = 0;
  BYTE    bGetPts = FALSE;
  BYTE    bGetScr = FALSE;
  WORD    wHeaderLen;
  long Err= 0;

  if(nBytes>=4 && lpData[3]==0xBA) {	        		//If pack start code
    lpData+= 4; 						//Skip packet start code prefix
    nBytes-= 4;
    if((*lpData&0xC0)==0x40 && nBytes>=5) {			//If Mpeg2
      dwScr = ((DWORD)(lpData[0]&0x38))<<27;			//Bits 31 & 30
      dwScr|= ((DWORD)(lpData[0]&0x03))<<28;			//Bits 29 & 28
      dwScr|= ((DWORD) lpData[1])<<20;			        //Bits 27 to 20
      dwScr|= ((DWORD)(lpData[2]&0xF8))<<12;			//Bits 19 to 15
      dwScr|= ((DWORD)(lpData[2]&0x03))<<13;			//Bits 14 & 13
      dwScr|= ((DWORD) lpData[3])<<5;			        //Bits 12 to 5
      dwScr|= ((DWORD)(lpData[4]&0xF8))>>3;			//Bits 4 to 2
      lpData+= 5;
      nBytes-= 5;
      if(nBytes>=4) {
        lpData+= 4;
        nBytes-= 4;
      }
      wHeaderLen= (*lpData&0x07);
      if(nBytes>= (DWORD)(1+wHeaderLen)) {
        lpData+= 1 + wHeaderLen;
        nBytes-= 1 + wHeaderLen;
      }
    } else if(nBytes>=5) {
      dwScr = ((DWORD)(lpData[0]&0x0E))<<29;
      dwScr|= ((DWORD) lpData[1])<<22;
      dwScr|= ((DWORD)(lpData[2]&0xFE))<<14;
      dwScr|= ((DWORD) lpData[3])<<7;
      dwScr|= (DWORD)( lpData[4]>>1);
      lpData+= 5;
      nBytes-= 5;
      if(nBytes>=3) {
        lpData+= 3;
        nBytes-= 3;
      }
    }
    if(dwScr)
      bGetScr = TRUE;
  }
  if(nBytes>=4 && lpData[3]==0xB3) {
    lpData+= 4; 						//Skip packet start code prefix
    nBytes-= 4;
    if(nBytes>=2) {
      wHeaderLen= lpData[0] + lpData[1];
      lpData+= 2;
      nBytes-= 2;
      if(nBytes>=wHeaderLen) {
        lpData+= wHeaderLen;
        nBytes-= wHeaderLen;
      }
    }
  }
  if(nBytes>=3) {
    lpData += 3;			 			//Skip packet start code prefix
    nBytes-= 3;
  }
//  if((*lpData&0xE0)==0xE0)					//Check for stream id is Video
//    lpPTS = &pHw->Time.Vid.Initial.dwPTS;
//  else if(((*lpData&0xE0)==0xC0)||(*lpData==0xBD))		//Check for stream id is Audio
//    lpPTS = &pHw->Time.Aud.Initial.dwPTS;

  if(pPTS) {
    if(nBytes>=3) {
      lpData+= 3;					        //Skip Packet Length
      nBytes-= 3;
      if(nBytes && (*lpData&0xC0)==0x80) {			//If MPEG2
        lpData++;
        nBytes--;
        if(*lpData&0xC0)					//If PTS_DTS flag set
          bGetPts = TRUE;
        if(nBytes>=2) {
          lpData+= 2;
          nBytes-= 2;
        }
      } else {
        while(nBytes && *lpData==0xFF) {			//Skip stuffing bytes
          lpData++;
          nBytes--;
        }
        if(nBytes>=2 && (*lpData & 0xC0)==0x40) {		//Skip STD bytes
          lpData += 2;
          nBytes-= 2;
        }
        if(nBytes && (*lpData & 0x30))
          bGetPts = TRUE;
      }
      if(bGetScr && pSCR)
        *pSCR= dwScr;
      if(nBytes>=5 && bGetPts) {
        *pPTS= ((DWORD)(lpData[0]&0x0E))<<29;
        *pPTS|= ((DWORD) lpData[1])<<22;
        *pPTS|= ((DWORD)(lpData[2]&0xFE))<<14;
        *pPTS|= ((DWORD) lpData[3])<<7;
        *pPTS|= (DWORD)( lpData[4]>>1);
        lpData+= 5;
        nBytes-= 5;
      }
    }
  }
  return(Err);
}

/** EOF : DBGOUT.C **/
