#include <StrmIni.h>
#include <mmsystem.h>
//#include <KS.h>
#include <KsMedia.h>

//#ifdef _WIN98_ONLY_
#include <vmm.h>
#pragma warning (disable:4229)  
#undef WANTVXDWRAPS
#include <shell.h>
#define WANTVXDWRAPS 1
#include <VxdWraps.h>
#include <ConfigMg.h>
#include "cardserv.h"
#include "margipnp.h"
//#endif

#include "DbgMsg.h"
#include "DbgFltr.h"
#include "Idents.h"
#include "Settings.h"

#include "Globals.h"
#include "MidasApi.h"
#include "log.h"
#include "IniNames.h"
#include "updtreg.h"
#include "../Common/Winver.h"
#include "DeviceId.h"
#include "ZvNt.h"

// This is available in Win98 but not in WDM.H
// Used to get DMA io space for WIn98 only
NTKERNELAPI
NTSTATUS
IoReportResourceUsage(
    IN PUNICODE_STRING DriverClassName OPTIONAL,
    IN PDRIVER_OBJECT DriverObject,
    IN PCM_RESOURCE_LIST DriverList OPTIONAL,
    IN ULONG DriverListSize OPTIONAL,
    IN PDEVICE_OBJECT DeviceObject,
    IN PCM_RESOURCE_LIST DeviceList OPTIONAL,
    IN ULONG DeviceListSize OPTIONAL,
    IN BOOLEAN OverrideConflict,
    OUT PBOOLEAN ConflictDetected
    );


static void LaunchThread(PDEVICE_EXTENSION pDevice);
static void DriverPagingOut(SRB* pSrb);
static void DeviceHandleIRP(SRB* pSrb);
//static void HandlePNPIrp(PIRP Irp);

static void Test(PPORT_CONFIGURATION_INFORMATION pCfgInfo);
static NTSTATUS MargiDeviceMargiPnP(PDEVICE_OBJECT pDO,PIRP pIrp);
static void ExecuteWinApp(char* szExeName,char *szArgs);
static void AutoLaunchSetup(PVOID Ptr);
static void DmaReset(PDMA_CONTROL p);

static void  __stdcall DeviceInitializeLowPriority(PHW_STREAM_REQUEST_BLOCK pSrb);
//static void  __stdcall DeviceChangePowerStateLowPriority(PHW_STREAM_REQUEST_BLOCK pSrb);
static DWORD __stdcall DeviceClaimIoSpace(PDEVICE_OBJECT pDevObj,DWORD dwSize);

static void  __stdcall IoRegWrByte(DWORD dwIoAddr,BYTE bDat);
static void  __stdcall IoRegWrWord(DWORD dwIoAddr,WORD wDat);
static BYTE  __stdcall IoRegRdByte(DWORD dwIoAddr);
static WORD  __stdcall IoRegRdWord(DWORD dwIoAddr);
static DWORD __stdcall IoChnWrWords(DWORD dwIoAddr,BYTE* pDat,DWORD dwWords,DWORD dwFlags);
static DWORD __stdcall MemChnWrWords(DWORD dwMemAddr,BYTE* pDat,DWORD dwWords,DWORD dwFlags);
static DWORD __stdcall DmaChnWrWords(DWORD dwMemAddr,BYTE* pDat,DWORD dwWords,DWORD dwFlags);

extern ULONG WinVersion;
DWORD gdwDmaIoAddr;

void DeviceInitialize (PHW_STREAM_REQUEST_BLOCK pSrb) {
  PDEVICE_EXTENSION pDevice= (PDEVICE_EXTENSION) pSrb->HwDeviceExtension;
  pSrb->Status= STATUS_PENDING;
#if KS_SYNC_OFF
  DeviceInitializeLowPriority(pSrb);
#else
  StreamClassCallAtNewPriority(0,pDevice,Low,DeviceInitializeLowPriority,pSrb);
#endif
}

static void DeviceConfigSocket(PDEVICE_EXTENSION pdx) 
{
  BYTE  bSetSocket,bDmaEnable;
  PDMA_CONTROL pDma=0;

  SettingFName(IniFName,IniSection);
  bSetSocket=(BYTE)SettingLoad(SET_DWORD,InitSetSocket,0,1);
  bDmaEnable= (BYTE)SettingLoad(SET_DWORD,IniDmaEnable,0,1);

  if(bSetSocket) {
    if(WinVersion==WIN98_VERSION) {
      pdx->dwWin98PnpDevNode=ConfigFindDevNode();
      GetSpecialSocket((WORD)pdx->dlIoAddr);
    } else {
      pdx->dwWin2kPnpDevNode=NTGetSocket((WORD)pdx->dlIoAddr);
    }

    if(pdx->dwWin2kPnpDevNode) {
      NTSetAudio(pdx->dwWin2kPnpDevNode);
      if(bDmaEnable && NTCheckDma(pdx->dwWin2kPnpDevNode)) {
        if(pdx->dlDmaIoAddr) {
          pDma=&pdx->DmaControl;
          pDma->dwCtrlIO=(DWORD)pdx->dlDmaIoAddr;
          NTConfigDma(pdx->dwWin2kPnpDevNode,pDma->dwCtrlIO);
        } else
          bDmaEnable=0;
      }
    }
    if(pdx->dwWin98PnpDevNode) {
      ConfigStart(pdx->dwWin98PnpDevNode);
      if(bDmaEnable && ConfigCheckDma(pdx->dwWin98PnpDevNode)) {
        if(!pdx->dlDmaIoAddr)
          pdx->dlDmaIoAddr=(ULONGLONG)DeviceClaimIoSpace(pdx->PhysicalDeviceObject,0x10);
        if(pdx->dlDmaIoAddr) {
          pDma=&pdx->DmaControl;
          pDma->dwCtrlIO=(DWORD)pdx->dlDmaIoAddr;
          ConfigSetupDma(pdx->dwWin98PnpDevNode,pDma->dwCtrlIO);
        } else
          bDmaEnable=0;
      }
    }
    if(bDmaEnable && pDma) {
      if(!pDma->dwBuffSize) {
        if(pDma->pBuffer=StreamClassGetDmaBuffer(pdx)) {
          pDma->dwBuffSize=DMA_BUFFER_SIZE*2;
          pDma->PhysAddr=StreamClassGetPhysicalAddress(pdx,NULL,pDma->pBuffer,DmaBuffer,&pDma->dwBuffSize);
          // allocated twice what we need
          // if 1st half straddles 128K boundary then use second half
          if((pDma->PhysAddr.LowPart&0x0001ffff) > (0x00020000-DMA_BUFFER_SIZE)) {
            pDma->PhysAddr.LowPart+=DMA_BUFFER_SIZE;
            pDma->pBuffer+=DMA_BUFFER_SIZE;
          }
          pDma->dwBuffSize=DMA_BUFFER_SIZE;   //StreamClassGetPhysicalAddress() works but returns 0 as length
        }
      }
      DmaReset(pDma);
    } else
      memset(&pdx->DmaControl,0,sizeof(pdx->DmaControl));
  }
}

static void DeviceInitializeLowPriority(PHW_STREAM_REQUEST_BLOCK pSrb) {
  PPORT_CONFIGURATION_INFORMATION ConfigInfo;
  PDEVICE_EXTENSION pdx;
  BYTE bMioEnable;
  MIDASCMD Cmd;
  MDS_HW_RESOURCE Resrc;
  ULONG u;

  // By default disable MEM I/O.  The DTG card is sometimes
  // configured with memory if ZV config fails.  This does not
  // guarantee mem access for channel.
  SettingFName(IniFName,IniSection);
  bMioEnable=(BYTE)SettingLoad(SET_DWORD,IniMioEnable,0,0);

  Cmd.u.HwResource= &Resrc;
  pSrb->Status = STATUS_NO_SUCH_DEVICE;
  ConfigInfo = pSrb->CommandData.ConfigInfo;
  pdx=(PDEVICE_EXTENSION)ConfigInfo->HwDeviceExtension;
  RtlZeroMemory(pdx, sizeof(DEVICE_EXTENSION));
  pdx->ClassDeviceObject   = ConfigInfo->ClassDeviceObject;
  pdx->PhysicalDeviceObject= ConfigInfo->PhysicalDeviceObject;

  Cmd.cmd=MDS_LOCATE_HARDWARE;
  pdx->dlMemAddr=0;
  pdx->dlIoAddr= 0;
  pdx->dlDmaIoAddr=0;
  pdx->dwRscFlags=0;
  memset(&pdx->DmaControl,0,sizeof(pdx->DmaControl));
  pdx->dwWin2kPnpDevNode=0;
  pdx->dwWin98PnpDevNode=0;

  for(u=0;u<ConfigInfo->NumberOfAccessRanges && (!pdx->dlMemAddr || !pdx->dlIoAddr);u++) {
    ULONGLONG dlAddr=ConfigInfo->AccessRanges[u].RangeStart.QuadPart;
    if(ConfigInfo->AccessRanges[u].RangeInMemory) {
      if(bMioEnable) {
        pdx->dlMemAddr=dlAddr;
        pdx->dwRscFlags|=RSRC_FLAG_MEMCH;
      }
    } else {
      pdx->dlIoAddr= dlAddr;
      pdx->dwRscFlags|=RSRC_FLAG_IO;
      // if the io space is not 0x20 bytes then
      // we don't have space for DMA
      if(ConfigInfo->AccessRanges[u].RangeLength==0x20)
        pdx->dlDmaIoAddr=pdx->dlIoAddr+0x10;
    }
  }
  Cmd.u.HwResource->dlMemBaseAddr=pdx->dlMemAddr;
  Cmd.u.HwResource->dlIOBaseAddr= pdx->dlIoAddr;
  Cmd.u.HwResource->dwFlags=      pdx->dwRscFlags;
  Cmd.u.HwResource->pfnRegWrByte=IoRegWrByte;
  Cmd.u.HwResource->pfnRegWrWord=IoRegWrWord;
  Cmd.u.HwResource->pfnRegRdByte=IoRegRdByte;
  Cmd.u.HwResource->pfnRegRdWord=IoRegRdWord;
  Cmd.u.HwResource->fDMAAvailable = pdx->fDmaAvailable = 0;
  if(pdx->dwRscFlags&RSRC_FLAG_MEMCH)
    Cmd.u.HwResource->pfnChnWrWords=MemChnWrWords;
  else
    Cmd.u.HwResource->pfnChnWrWords=IoChnWrWords;

  DeviceConfigSocket(pdx);
  if(pdx->DmaControl.PhysAddr.QuadPart) {
    Cmd.u.HwResource->pfnChnWrWords=DmaChnWrWords;
    Cmd.u.HwResource->dlDMABaseAddr=(DWORD)&pdx->DmaControl;
    Cmd.u.HwResource->dwFlags|=RSRC_FLAG_DMACH;
    Cmd.u.HwResource->dwFlags&=~RSRC_FLAG_MEMCH;
    Cmd.u.HwResource->fDMAAvailable = pdx->fDmaAvailable = 1;
  }

  if(MidasEntry(&Cmd)==MDS_Success) {
    // indicate the size of the structure necessary to describe all streams
    // that are supported by this hardware
    ConfigInfo->StreamDescriptorSize=NUMBER_OF_STREAMS*sizeof(HW_STREAM_INFORMATION)+sizeof(HW_STREAM_HEADER);
    pSrb->Status = STATUS_SUCCESS;
    pdx->hMidas=Cmd.hMidas;
    pdx->HwError=0;
  } 

  //Load the Crop value from the registry.
  //Save in case it didn't exist
  pdx->dwCropTop=SettingLoad(SET_DWORD,IniCropTop,0,14);
  SettingSave(SET_DWORD,IniCropTop,pdx->dwCropTop);
  
  SetDefaultsInTempRegistry(pdx);
#if KS_SYNC_OFF
  SignalDeviceRequestComplete(pSrb);
#else
  StreamClassCallAtNewPriority(0,pdx,LowToHigh,SignalDeviceRequestComplete,pSrb);
#endif
}


void SetDmaFunction(SRB *pSrb)
{
  MIDASCMD Cmd;
  MDS_HW_RESOURCE Resrc;

  PSTREAM_EXTENSION pStream= (PSTREAM_EXTENSION) pSrb->StreamObject->HwStreamExtension;
  PDEVICE_EXTENSION pdx = pSrb->HwDeviceExtension;
  

  Cmd.cmd=MDS_LOCATE_DMA;
  Cmd.u.HwResource = &Resrc;
  Cmd.u.HwResource->dwFlags =      pdx->dwRscFlags;
  if (pStream->fIsMpeg2Payload || !pdx->fDmaAvailable)
  {
    if(pdx->dwRscFlags&RSRC_FLAG_MEMCH)
      Cmd.u.HwResource->pfnChnWrWords = MemChnWrWords;
    else
      Cmd.u.HwResource->pfnChnWrWords = IoChnWrWords;
  }
  else
  {
    Cmd.u.HwResource->pfnChnWrWords = DmaChnWrWords;
    Cmd.u.HwResource->dwFlags |= RSRC_FLAG_DMACH;
    Cmd.u.HwResource->dwFlags &= ~RSRC_FLAG_MEMCH;
  }
  MidasEntry(&Cmd);
}

void DeviceClose(PHW_STREAM_REQUEST_BLOCK pSrb) {
  PDEVICE_EXTENSION pdx;
  pdx=pSrb->HwDeviceExtension;
  if(pdx->process_data) {
    pdx->process_data = 0;
  }
  if(pdx->process_ccdata) {
    pdx->process_ccdata = 0;
  }
  if(pdx->dwWin98PnpDevNode)
    ConfigReleaseDevNode(pdx->dwWin98PnpDevNode);
  if(pdx->dwWin2kPnpDevNode)
    NTReleaseSocket(pdx->dwWin2kPnpDevNode);

  pdx->dwWin98PnpDevNode=0;
  pdx->dwWin2kPnpDevNode=0;

  DrvDbgMsgInit(0);
  pSrb->Status=STATUS_SUCCESS;
}

int DeviceCheckHardware(PHW_STREAM_REQUEST_BLOCK pSrb) {
  int fOk=0;
  PDEVICE_EXTENSION pDevice;
  pDevice = pSrb->HwDeviceExtension;
  if(pDevice) {
    if(pDevice->HwError)
      pSrb->Status=STATUS_IO_DEVICE_ERROR;
    else
      fOk=1;
  }
  return fOk;
}

static GUID MY_KSEVENTSETID_VPNOTIFY = {STATIC_KSEVENTSETID_VPNotify};

void DevicePowerDown(SRB* pSrb) {
  PDEVICE_EXTENSION pDevice;
  MIDASCMD Cmd;
  pDevice = pSrb->HwDeviceExtension;
  if(!pDevice->nHardwareSleep) {
    CancelStream(pDevice->hMidas,STRM_VID);
    CancelStream(pDevice->hMidas,STRM_AUD);
    CancelStream(pDevice->hMidas,STRM_SUB);
    CancelStream(pDevice->hMidas,STRM_CC);

    Cmd.cmd= MDS_SAVE_STATE;
    Cmd.hMidas=pDevice->hMidas;                    
    MidasEntry(&Cmd);
    pDevice->nHardwareSleep=1;
    pDevice->ddLastStreamTime=0;
  }
  if(!TimerSetPowerState(pSrb)) {
    TimerStart(0,0);              // Stop the timer
    pSrb->Status=STATUS_SUCCESS;
  }
}

void DeviceSurpriseRemoval(SRB* pSrb) {
  DbgMsg(DBG_PNPLOAD,"Device: Surprise Removal.\r\n");
  DevicePowerDown(pSrb);
}


void DevicePowerUp(SRB* pSrb) {
  PDEVICE_EXTENSION pDevice;
  MIDASCMD Cmd;
  PHW_STREAM_OBJECT pVPEStreamObj;
  PSTREAM_EXTENSION pVPEStreamExt; 
  int i= 0;
  StreamQueue* pStrmQ= 0;
  pDevice = pSrb->HwDeviceExtension;
  if(pDevice->nHardwareSleep) {

    Cmd.cmd= MDS_RESTORE_STATE;
    Cmd.hMidas=pDevice->hMidas;                    
    MidasEntry(&Cmd);

    DeviceConfigSocket(pDevice);
    pDevice->nHardwareSleep=0;

    TimerStart(1,pDevice);  // Start the timer
    pDevice->ddLastStreamTime=0;

    pVPEStreamObj= pDevice->pStream[OutVideoPort];
    if(pVPEStreamObj) {
      pVPEStreamExt= (PSTREAM_EXTENSION)(pVPEStreamObj->HwStreamExtension);
      DbgMsg(DBG_MSGEVENT,"VidFmtChange: Sending VP notify event\r\n");
      DbgMsg(DBG_PNPPOWER,"WakeUp: Sending VP notify event for Renegotiation\r\n");
      //StreamClassStreamNotification(SignalMultipleStreamEvents,pVPEStreamObj,
      //                      &MY_KSEVENTSETID_VPNOTIFY,KSEVENT_VPNOTIFY_FORMATCHANGE);
    }
  }
  pSrb->Status= STATUS_SUCCESS;
}

void DeviceChangePowerState(SRB* pSrb) {
  DbgMsg(DBG_PNPLOAD,"Device: Change Power State: %d.\r\n",pSrb->CommandData.DeviceState);
  pSrb->Status=STATUS_PENDING;
  if(pSrb->CommandData.DeviceState!=PowerDeviceD0) { // if going to Power Down state
    DevicePowerDown(pSrb);
  } else
    DevicePowerUp(pSrb);
}

void DevicePrepareForPowerDown(PDEVICE_EXTENSION pdx) {
  //TimerStart(0,0);  // Stop the timer
}

#if(0)
void DeviceChangePowerStateLowPriority(SRB* pSrb) {
  PDEVICE_EXTENSION pDevice;
  MIDASCMD Cmd;
  PHW_STREAM_OBJECT pVPEStreamObj;
  PSTREAM_EXTENSION pVPEStreamExt; 
  int i= 0;
  StreamQueue* pStrmQ= 0;

  DbgMsg(DBG_PNPLOAD,"Device Low Priority: Change Power State: %d.\r\n",pSrb->CommandData.DeviceState);
  pSrb->Status= STATUS_SUCCESS;
  pDevice = pSrb->HwDeviceExtension;
  if(pSrb->CommandData.DeviceState==PowerDeviceD0) {  // Power up state
    if(pDevice->nHardwareSleep) {

      Cmd.cmd= MDS_RESTORE_STATE;
      Cmd.hMidas=pDevice->hMidas;                    
      MidasEntry(&Cmd);

      DeviceConfigSocket(pDevice);
      pDevice->nHardwareSleep=0;

      TimerStart(1,pDevice);  // Start the timer
      pDevice->ddLastStreamTime=0;

      pVPEStreamObj= pDevice->pStream[OutVideoPort];
      if(pVPEStreamObj) {
        pVPEStreamExt= (PSTREAM_EXTENSION)(pVPEStreamObj->HwStreamExtension);
        DbgMsg(DBG_MSGEVENT,"VidFmtChange: Sending VP notify event\r\n");
        DbgMsg(DBG_PNPPOWER,"WakeUp: Sending VP notify event for Renegotiation\r\n");
        //StreamClassStreamNotification(SignalMultipleStreamEvents,pVPEStreamObj,
        //                      &MY_KSEVENTSETID_VPNOTIFY,KSEVENT_VPNOTIFY_FORMATCHANGE);
      }
    }
#if KS_SYNC_OFF
    SignalDeviceRequestComplete(pSrb);
#else
    StreamClassCallAtNewPriority(0,pDevice,LowToHigh,SignalDeviceRequestComplete,pSrb);
#endif
  }
  else {
//    LARGE_INTEGER Interval;
    //for(i=0;i<NUMBER_OF_STREAMS;i++) {
    //  pStrmQ= &(((PSTREAM_EXTENSION)(pDevice->pStream[i]->HwStreamExtension))->queue);
    //  QueuePurge(pDevice,pStrmQ);
    //}
    //StreamClassAbortOutstandingRequests(pDevice,0,STATUS_REINITIALIZATION_NEEDED);
//    StreamClassAbortOutstandingRequests(pDevice,0,STATUS_CANCELLED);
    if(!pDevice->nHardwareSleep) {
      CancelStream(pDevice->hMidas,STRM_VID);
      CancelStream(pDevice->hMidas,STRM_AUD);
      CancelStream(pDevice->hMidas,STRM_SUB);
      CancelStream(pDevice->hMidas,STRM_CC);

      Cmd.cmd= MDS_SAVE_STATE;
      Cmd.hMidas=pDevice->hMidas;                    
      MidasEntry(&Cmd);
      pDevice->nHardwareSleep=1;
      pDevice->ddLastStreamTime=0;
    }
    TimerStart(0,0);  // Stop the timer
#if(0)
    while(!TimerStopComplete())
    {
      Interval.QuadPart=10000*10;
      KeDelayExecutionThread(KernelMode,0,&Interval);
    }
#endif

#if KS_SYNC_OFF
    SignalDeviceRequestComplete(pSrb);
#else
    StreamClassCallAtNewPriority(0,pDevice,LowToHigh,SignalDeviceRequestComplete,pSrb);
#endif
  }
}
#endif

void DevicePagingOut(SRB* pSrb) {
  //pSrb->Status= STATUS_SUCCESS;	//Return STATUS_SUCCESS to allow paging out, STATUS_DEVICE_BUSY to disallow.
  pSrb->Status= STATUS_DEVICE_BUSY;
  DbgMsg(DBG_PNPLOAD,"Device is paging out: %s.\r\n",Ident(ID_NTSTATUS,pSrb->Status));
}

void DeviceInitComplete(SRB* pSrb) {
  PDEVICE_EXTENSION pDevice= (PDEVICE_EXTENSION) pSrb->HwDeviceExtension;
  if(WinVersion==WIN98_VERSION)
    StreamClassCallAtNewPriority(0,pDevice,Low,AutoLaunchSetup,0);

  pSrb->Status= STATUS_SUCCESS;
  DbgMsg(DBG_PNPLOAD,"Msg %s returns Success.\r\n",Ident(ID_STRM_REQ,pSrb->Command));
}

static void DeviceHandleIRP(IN PHW_STREAM_REQUEST_BLOCK pSrb) {
  PIRP Irp = pSrb->Irp;
  PIO_STACK_LOCATION IrpStack = IoGetCurrentIrpStackLocation( Irp );
  DbgMsg(DBG_LOG,"IRP received. Major=%s, Minor=%s \r\n",Ident(ID_IRP,IrpStack->MajorFunction),
         Ident(ID_IRP_PNP,IrpStack->MinorFunction));
  if(IrpStack->MajorFunction==IRP_MJ_PNP && IRP_MN_QUERY_PNP_DEVICE_STATE)
    Irp->IoStatus.Status = STATUS_SUCCESS;
  return;
}

#if(0)
static void HandlePNPIrp(PIRP Irp) {
  PIO_STACK_LOCATION IrpStack = IoGetCurrentIrpStackLocation(Irp);
  DbgMsg(DBG_LOG,"IRP received. Major=%s, Minor=%s \r\n",Ident(ID_IRP,IrpStack->MajorFunction),
         Ident(ID_IRP_PNP,IrpStack->MinorFunction));
  if(IrpStack->MajorFunction==IRP_MJ_PNP && IrpStack->MinorFunction==IRP_MN_START_DEVICE) {
    Irp->IoStatus.Status = STATUS_SUCCESS;
    DbgMsg(DBG_LOG|DBG_SET,"PnP Start Irp is received. Acknowledging with Success\r\n");
  }
  return;
}
#endif

NTSTATUS DeviceHandlePNPIrp(PDEVICE_OBJECT pDevObj,PIRP pIrp) {
  int n;
  NTSTATUS Status=STATUS_SUCCESS;
  PIO_STACK_LOCATION pIrpStack=IoGetCurrentIrpStackLocation(pIrp);
  PIO_RESOURCE_REQUIREMENTS_LIST pIRRList;
  PIO_RESOURCE_LIST pIoRscList;
  PCM_RESOURCE_LIST pCmRscList;
  PIO_RESOURCE_DESCRIPTOR pIoRscDesc;
//  DbgDispIrp(pDevObj,pIrp);

  switch(pIrpStack->MinorFunction) {
    case IRP_MN_FILTER_RESOURCE_REQUIREMENTS:
      pIRRList=pIrpStack->Parameters.FilterResourceRequirements.IoResourceRequirementList;
      pIoRscList=&pIRRList->List[0];
      for(n=0;n<(int)pIoRscList->Count;n++) {
        pIoRscDesc=&pIoRscList->Descriptors[n];
        if(pIoRscDesc->Type==CmResourceTypePort) {
          IoCopyCurrentIrpStackLocationToNext(pIrp);
//          IoSetCompletionRoutine(pIrp,Margi_IRP_MJ_PNP_Complete,NULL,1,0,0);
          Status=IoCallDriver(pDevObj,pIrp);
          IoCompleteRequest(pIrp,IO_NO_INCREMENT );
        }
      }
      break;
    case IRP_MN_START_DEVICE:
      pCmRscList=pIrpStack->Parameters.StartDevice.AllocatedResources;
      break;
  }
  return Status;
}

// This is used for Win98 only - since modifying  PNP_FILTER doesn't work
// If this is used under Win2K then Standby and Hibernate are disabled
int DeviceClaimIoPort(PDEVICE_OBJECT pDevObj,DWORD dwIoAddr,DWORD dwSize) 
{
  int fOk=0;
  unsigned char Conflict;
  DWORD dwCount,dwListSize;
  PDEVICE_EXTENSION pdx;
  PCM_RESOURCE_LIST pCmRsrcList;
  PCM_FULL_RESOURCE_DESCRIPTOR pFullRd;
  PCM_PARTIAL_RESOURCE_DESCRIPTOR pPartRd;

  pdx=(PDEVICE_EXTENSION)pDevObj->DeviceExtension;
  dwCount=1;
  dwListSize=FIELD_OFFSET(CM_RESOURCE_LIST,List[0]);
  dwListSize+=sizeof(CM_FULL_RESOURCE_DESCRIPTOR)+((dwCount-1)*sizeof(CM_PARTIAL_RESOURCE_DESCRIPTOR));

  pCmRsrcList=(PCM_RESOURCE_LIST)ExAllocatePool(PagedPool,dwListSize);
  if(pCmRsrcList) {
    RtlZeroMemory(pCmRsrcList,dwListSize);
    pCmRsrcList->Count=1;
    pFullRd=&pCmRsrcList->List[0];
    pFullRd->DoNotUse1=0;//PCIBus;  //InterfaceType
    pFullRd->DoNotUse2=0;       //Bus Number
    pFullRd->PartialResourceList.Count=dwCount;
    pPartRd=&pFullRd->PartialResourceList.PartialDescriptors[0];
    pPartRd->Type=CmResourceTypePort;
    pPartRd->ShareDisposition=CmResourceShareDriverExclusive;
    pPartRd->Flags=CM_RESOURCE_PORT_IO;
    pPartRd->u.Port.Start.QuadPart=dwIoAddr;
    pPartRd->u.Port.Length=dwSize;
    Conflict=1;
    IoReportResourceUsage(NULL,pDevObj->DriverObject,pCmRsrcList,dwListSize,NULL,NULL,0,0,&Conflict);
    if(!Conflict) {
      fOk=1;
    }
    ExFreePool(pCmRsrcList);
  }
  return fOk;
}

DWORD DeviceClaimIoSpace(PDEVICE_OBJECT pDevObj,DWORD dwSize) {
  int n;
  DWORD dwIoAddr=0x1800;
  for(n=0;n<16;n++) {
    if(DeviceClaimIoPort(pDevObj,dwIoAddr,dwSize))
      return dwIoAddr;
    dwIoAddr+=0x0030;
  }
  return 0;
}

static const GUID ClassGUID= { /* c57875b1-4bf6-11d1-808b-006097298068 */
  0x4d36e96c,
  0xe325,
  0x11ce,
  { 0xbf, 0xc1, 0x08, 0x00, 0x2b, 0xe1, 0x03, 0x18 }
};

static void Test(PPORT_CONFIGURATION_INFORMATION pCfgInfo) {
  BYTE Buff[256];
  LONG Len;
  DEVICE_REGISTRY_PROPERTY xxxxx;
  PDEVICE_OBJECT pDO;
  STRING ansiStr;
  UNICODE_STRING uniStr;

  //HalGetBusDataByOffset(1,1,1,1,1);

  xxxxx= DevicePropertyDriverKeyName;
  for(pDO=pCfgInfo->PhysicalDeviceObject;pDO;pDO=pDO->NextDevice) {
    IoGetDeviceProperty(pDO,xxxxx,sizeof(Buff),Buff,&Len);
    Len= 0;
    if(pDO->AttachedDevice) {
      IoGetDeviceProperty(pDO->AttachedDevice,xxxxx,sizeof(Buff),Buff,&Len);
      Len= 0;
    } else {
      Len= 0;
    }
  }
  for(pDO=pCfgInfo->ClassDeviceObject;pDO;pDO=pDO->NextDevice) {
    IoGetDeviceProperty(pDO,xxxxx,sizeof(Buff),Buff,&Len);
    Len= 0;
  }
  IoGetDeviceInterfaces((GUID*)&ClassGUID,pCfgInfo->PhysicalDeviceObject,0,(PWSTR*)&ansiStr.Buffer);

  ansiStr.Length= strlen(ansiStr.Buffer);
  RtlAnsiStringToUnicodeString(&uniStr,&ansiStr,TRUE);
  IoSetDeviceInterfaceState(&uniStr,TRUE);
}

//#ifdef _WIN98_ONLY_

static struct S_PACK {
  SHEXPACKET hdr;
  char       szName[80];
  char       szArgs[80];
} SheXPack= {0};


static void ExecWinAppdummy(void* pVoid) {
  long Err=0 ;
  Err= ExecWinApp(pVoid);
  DbgMsg(DBG_CRIT,"Called At Appy time NOW. Setup is launched. (Err=0x%08x) \r\n",Err);
}

static void ExecuteWinApp(char* szExeName,char *szArgs) {
  long Err= 0;
  SheXPack.hdr.dwTotalSize = sizeof(SheXPack);
  SheXPack.hdr.dwSize      = sizeof(SHEXPACKET);
  SheXPack.hdr.ibOp        = 0;
  SheXPack.hdr.ibFile      = (DWORD)&SheXPack.szName-(DWORD)&SheXPack;
  SheXPack.hdr.ibParams    = (DWORD)&SheXPack.szArgs-(DWORD)&SheXPack;
  SheXPack.hdr.ibDir       = 0;
  SheXPack.hdr.dwReserved  = 0;
  SheXPack.hdr.nCmdShow    = 1;

  strcpy(SheXPack.szName,szExeName);
  strcpy(SheXPack.szArgs,szArgs);
//  strcpy(TmpStr,"Scheduling call to ExecWinApp...\n");
//  strcat(TmpStr,szExeName);
//  strcat(TmpStr," ");
//  strcat(TmpStr,szArgs);
//  DbgBox(TmpStr);

  Err= SHELL_CallAtAppyTime((APPY_CALLBACK)ExecWinAppdummy,(DWORD)&SheXPack,0);

  DbgMsg(DBG_CRIT,"Scheduling callback at Appy Time. %s %s (Err= 0x%08X)\r\n",szExeName,szArgs,Err);

}

void AutoLaunchSetup(PVOID Ptr) {
  DWORD dwTemp= 0;
  char TempBuf[256]= {0};  //Settings.c requires atleast 80 ?????
  SettingFName(IniFName,IniSection);
  //dwTemp= SettingLoad(SET_DWORD,IniInstalling,0,255);
  SettingLoad(SET_STR,IniInstalling,TempBuf,0);
  DbgMsg(DBG_CRIT,"Auto Launch Registry key value=0x%08x \r\n",*TempBuf);
  //if(dwTemp && dwTemp!=255) {
  if(*TempBuf==0x31) {
    SettingLoad(SET_STR,"InstallDirINF",TempBuf,0);
    ExecuteWinApp(TempBuf,"PNP-INSTALL");
    DbgPrint("Started Driver for the first time (%s)\r\n",TempBuf);
    RtlZeroMemory(TempBuf,sizeof(TempBuf));
    *TempBuf=0x30;
    SettingSave(SET_STR,IniInstalling,(DWORD)TempBuf);
  } else {
    DbgMsg(DBG_CRIT,"Init Complete: Install Done. No Auto Launch.\r\n");
  }
}
//#endif

// Default I/O and Memory access routines for X86 compile
static void __stdcall IoRegWrByte(DWORD dwIoAddr,BYTE bDat) {
   WRITE_PORT_USHORT((PUSHORT)dwIoAddr,(USHORT)bDat);
}

static void __stdcall IoRegWrWord(DWORD dwIoAddr,WORD wDat) {
   WRITE_PORT_USHORT((PUSHORT)dwIoAddr,wDat);
}

static BYTE __stdcall IoRegRdByte(DWORD dwIoAddr) {
  return (BYTE)READ_PORT_USHORT((PUSHORT)dwIoAddr);

}

static WORD __stdcall IoRegRdWord(DWORD dwIoAddr) {
  return (WORD)READ_PORT_USHORT((PUSHORT)dwIoAddr);
}

#if(1)
static DWORD __stdcall IoChnWrWords(DWORD dwIoAddr,BYTE* pDat,DWORD dwWords,DWORD dwFlags) {
  _asm {
    push esi
    mov edx,[dwIoAddr]
    mov esi,[pDat]
    mov ecx,[dwWords]
    shr ecx,1
    jz skipsd
    rep outsd
skipsd:
    mov eax,[dwWords]
    and eax,1
    jz  skipw
    outsw
skipw:
    mov [pDat],esi
    pop esi
  }
  return dwWords;
}
#else
static DWORD __stdcall IoChnWrWords(DWORD dwIoAddr,BYTE* pDat,DWORD dwWords,DWORD dwFlags) {
  if(dwWords/2)
    WRITE_REGISTER_BUFFER_ULONG((PULONG)dwIoAddr,(PULONG)pDat,dwWords/2);
  if(dwWords&1)
    WRITE_REGISTER_BUFFER_USHORT((PUSHORT)dwIoAddr,(PUSHORT)pDat+dwWords-1,1);
  return dwWords;
}

#endif
static DWORD __stdcall MemChnWrWords(DWORD dwMemAddr,BYTE* pDat,DWORD dwWords,DWORD dwFlags) {
  _asm {
    push esi
    push edi
    mov esi,[pDat]
    mov edi,[dwMemAddr]
    mov ecx,[dwWords]
    shr ecx,1
    jz skipsd
xfrloop:
    movsd
    sub edi,4
    dec ecx
    jnz xfrloop
skipsd:
    mov eax,[dwWords]
    and eax,1
    jz  skipw
    movsw
skipw:
    mov [pDat],esi
    pop edi
    pop esi
  }
  return dwWords;
}

#define NXT_BLK(b)  if(++b>=NUM_DMA_BLOCKS) b=0

static WORD DmaGetCount(PDMA_CONTROL p) {
  return IoRegRdWord(p->dwCtrlIO+4);
}

static void DmaXfrBlock(DWORD dwCtrlIO,DWORD dwPhys,DWORD dwBytes) {
  DWORD dwCount=(dwBytes/2)-1;
  WRITE_PORT_UCHAR((PUCHAR)dwCtrlIO+0,(BYTE)(dwPhys>>1));
  WRITE_PORT_UCHAR((PUCHAR)dwCtrlIO+1,(BYTE)(dwPhys>>9));
  WRITE_PORT_UCHAR((PUCHAR)dwCtrlIO+2,(BYTE)((dwPhys>>16)&0xfe));

  WRITE_PORT_USHORT((PUSHORT)(dwCtrlIO+4),(WORD)dwCount);

  WRITE_PORT_UCHAR((PUCHAR)dwCtrlIO+0x08,0x00);  // Set Command=Enable
  WRITE_PORT_UCHAR((PUCHAR)dwCtrlIO+0x0b,0x88);  // Set Mode = Block,Read
  WRITE_PORT_UCHAR((PUCHAR)dwCtrlIO+0x0f,0x00);  // Unmask
  WRITE_PORT_UCHAR((PUCHAR)dwCtrlIO+0x09,0xff);  // Software request
}

static void DmaXfrDisable(DWORD dwCtrlIO) {
  WRITE_PORT_UCHAR((PUCHAR)dwCtrlIO+0x08,0x04);  // Set Command=Disable
}

void __stdcall DmaTimer(PDEVICE_EXTENSION pDev) {
  MIDASCMD  Cmd;
  PDMA_CONTROL  p=&pDev->DmaControl;
  PDMA_BLOCK pBlk=&p->Block[p->nBlkOut];
//  DbgMsgCmd(DBGCMD_PROF_ENTER,DBGPRF_DMATIMER,0);
  // Check if current block has completed
  if(pBlk->State==BLK_STATE_XFR) {
    if(DmaGetCount(p)==0xffff) {
//      DbgMsgCmd(DBGCMD_PROF_EXIT,DBGPRF_DMAXFR,0);
      pBlk->State=BLK_STATE_EMPTY;
      NXT_BLK(p->nBlkOut);
      pBlk=&p->Block[p->nBlkOut];
    }
  }
  if(pBlk->State==BLK_STATE_READY) {
    if((pBlk->dwVidBytes>p->dwVidBytes) || (pBlk->dwAudBytes>p->dwAudBytes) || (pBlk->dwSubBytes>p->dwSubBytes)) {
      Cmd.cmd= MDS_GET_CHANNEL_LEVELS;
      Cmd.wCurrStream= 0;
      Cmd.hMidas=pDev->hMidas;
      MidasEntry(&Cmd);
      // Only transfer if room in channel for all streams contained in the block
      p->dwVidBytes=Cmd.u.ChnLevels.dwVidBytes;
      p->dwAudBytes=Cmd.u.ChnLevels.dwAudBytes;
      p->dwSubBytes=Cmd.u.ChnLevels.dwSubBytes;
    }

    if((pBlk->dwVidBytes<=p->dwVidBytes) && (pBlk->dwAudBytes<=p->dwAudBytes) && (pBlk->dwSubBytes<=p->dwSubBytes)) {
      pBlk->State=BLK_STATE_XFR;
//    DbgMsgCmd(DBGCMD_PROF_ENTER,DBGPRF_DMAXFR,0);
      DmaXfrBlock(p->dwCtrlIO,pBlk->Phys.LowPart,pBlk->dwTotalBytes);
      p->dwVidBytes-=pBlk->dwVidBytes;
      p->dwAudBytes-=pBlk->dwAudBytes;
      p->dwSubBytes-=pBlk->dwSubBytes;
    }
  }
//  DbgMsgCmd(DBGCMD_PROF_EXIT,DBGPRF_DMATIMER,0);
}

static void DmaReset(PDMA_CONTROL p) {
  STREAM_PHYSICAL_ADDRESS Phys;
  char* pBuff;
  DWORD dwSize;
  int n;

  DmaXfrDisable(p->dwCtrlIO);
  dwSize=p->dwBuffSize/NUM_DMA_BLOCKS;
  pBuff =p->pBuffer;
  Phys=p->PhysAddr;
  p->nBlkIn=0;
  p->nBlkOut=0;

  for(n=0;n<NUM_DMA_BLOCKS;n++) {
    p->Block[n].Phys=Phys;
    p->Block[n].pBase =pBuff;
    p->Block[n].dwSize=dwSize;
    p->Block[n].State=BLK_STATE_EMPTY;
    Phys.QuadPart+=dwSize;
    pBuff +=dwSize;
  }
}



static void DmaFlush(volatile PDMA_CONTROL p) {
  int n;
  ULONGLONG TimeOut=MargiGetTime()+010000;
  // Flag incomplete block as ready to transfer
  if(p->Block[p->nBlkIn].State==BLK_STATE_FILL) {
    p->Block[p->nBlkIn].State=BLK_STATE_READY;
    NXT_BLK(p->nBlkIn);
  }
  //Wait for all blocks to complete
  for(n=0;n<NUM_DMA_BLOCKS;n++)
    while(p->Block[n].State!=BLK_STATE_EMPTY){
      if(MargiGetTime()>TimeOut)
        DmaReset(p);
    }
}


static DWORD __stdcall DmaChnWrWords(DWORD dwDmaHandle,BYTE* pDat,DWORD dwWords,DWORD dwFlags) {
  PDMA_CONTROL p =(PDMA_CONTROL)dwDmaHandle;
  PDMA_BLOCK pBlk=&p->Block[p->nBlkIn];
  DWORD dwBytes=dwWords*2;
  if(dwFlags&MDS_XFR_FLAGS) {
    switch(dwFlags&MDS_XFR_FLAGS) {
      case MDS_XFR_FLAG_RESET: DmaReset(p); break;
      case MDS_XFR_FLAG_FLUSH: DmaFlush(p); break;
    }
    return 0;
  }
  if(pBlk->State==BLK_STATE_EMPTY) {
    pBlk->State=BLK_STATE_FILL;
    pBlk->pCur=pBlk->pBase;
    pBlk->dwTotalBytes=0;
    pBlk->dwVidBytes=0;
    pBlk->dwAudBytes=0;
    pBlk->dwSubBytes=0;
  }
  if(pBlk->State==BLK_STATE_FILL) {
    // if the data will fit then transfer to DMA block
    // else mark block as ready to go and try next block
    if(pBlk->dwTotalBytes+dwBytes <= pBlk->dwSize) {
      memcpy(pBlk->pCur,pDat,(int)dwBytes);
      pBlk->pCur+=dwBytes;
      pBlk->dwTotalBytes+=dwBytes;
      switch(dwFlags) {
         case STRM_VID:pBlk->dwVidBytes+=dwBytes;break;
         case STRM_AUD:pBlk->dwAudBytes+=dwBytes;break;
         case STRM_SUB:pBlk->dwSubBytes+=dwBytes;break;
      };
      return dwWords;
    } else {
      pBlk->State=BLK_STATE_READY;
      NXT_BLK(p->nBlkIn);
      return DmaChnWrWords(dwDmaHandle,pDat,dwWords,dwFlags);
    }
  }
  return 0;
}

/* EOF : DEVICE.C */
