#include <Strmini.h>
#include <KsMedia.h>
#include "globals.h"
#include "DbgMsg.h"
#include "DbgFltr.h"
#include "Idents.h"

#include "log.h"

int srbnumber=0;

#define PLOG_EXTENSION PSRB_EXTENSION

void logSrb(char *str, PHW_STREAM_REQUEST_BLOCK srb) {
  PLOG_EXTENSION logptr;
  logptr = (PLOG_EXTENSION) srb->SRBExtension;
  logptr->srbnumber = srbnumber++;
  logptr->nTimeoutCount=0;
  strcpy(logptr->szId,str);
  ((PSRB_EXTENSION)srb->SRBExtension)->Mdb.nSize=0;
  DbgMsg(DBG_LOG,">SRB %04d %s %s\r\n",logptr->srbnumber,str,Ident(ID_STRM_REQ,srb->Command));
}

void unlogSrb(char *str, PHW_STREAM_REQUEST_BLOCK srb) {
  PLOG_EXTENSION logptr;
  logptr = (PLOG_EXTENSION) srb->SRBExtension;
  DbgMsg(DBG_LOG,"<SRB %04d %s %s\r\n",logptr->srbnumber,str,Ident(ID_NTSTATUS,srb->Status));
}

void logEvent(char *str, PHW_EVENT_DESCRIPTOR EventDescriptor) {
  DbgMsg(DBG_LOG,">EVENT %s\n",str); 
}

void unlogEvent(char *str, int status) {
  DbgMsg(DBG_LOG,"<EVENT %s: %s\r\n",str,Ident(ID_NTSTATUS,status));
}

void logSetProperty(char *str, PHW_STREAM_REQUEST_BLOCK srb) {
  DWORD SetID= srb->CommandData.PropertyInfo->PropertySetID;
  DWORD PropID= srb->CommandData.PropertyInfo->Property->Id;
  DbgMsg(DBG_LOG,">SetProperty %s: Set %u, Index %u.\r\n",str,SetID,PropID);
}

void logGetProperty(char *str, PHW_STREAM_REQUEST_BLOCK srb) {
  DWORD SetID= srb->CommandData.PropertyInfo->PropertySetID;
  DWORD PropID= srb->CommandData.PropertyInfo->Property->Id;
  DbgMsg(DBG_LOG,">GetProperty %s: Set %u, Index %u.\r\n",str,SetID,PropID);
}

/**EOF: LOG.C**/
