#ifndef __UTIL_H__
#define __UTIL_H__ 0x0100

//Define UTIL_NO_INTRINSICS to include inp() and memcpy() functions.
//You will need to do this if you disable intrinsic function optimization.

#if defined(UTIL_NO_INTRINSICS) && UTIL_NO_INTRINSICS
extern __inline BYTE inp(WORD iobase);
extern __inline void outp(WORD iobase,BYTE val);
extern __inline WORD inpw(WORD iobase);
extern __inline void outpw(WORD iobase,WORD val);
extern __inline void memcpy(void *Dst, void *Src, int nBytes);
extern __inline void memclear(void *Dst, int nBytes);
extern __inline void strcpy(char *Dst, char *Src);
extern __inline void strcat(char *Dst, char *Src);
#endif

extern long ErrBox(long Err, char *Title, char *Text, ...);
extern int  strncompare(char* s1, char* s2p, int nBytes);
extern char *AppendHexStr(char *Dst, DWORD Val);
extern void GetVersionID(WORD *pVersionID);
extern void ErrorMessage(int Err);
extern WORD GetVMMVersion(void);
extern void ReportVersion(char* KeyName);

extern int  IsWin31(void);
extern DWORD EnterUnsafe(void);
extern DWORD ExitUnsafe(void);
extern int pciReadConfigDw(int nDevice, int nAddress, DWORD *pdwData);
extern int pciWriteConfigDw(int nDevice, int nAddress, DWORD dwData);
extern int pciFindDevice(WORD wDeviceId, WORD wVendorId, WORD wIndex, WORD* pwBus, WORD* pwDevice);
extern void WriteConfigReg(BYTE* pCisMem,BYTE value);

extern DWORD EssEnableAudio();
extern DWORD EssDisableAudio();

#endif
/**EOF: UTIL.H**/

